      SUBROUTINE BEND(M,V,PAR,IOP)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  3X3 MATRICES FOR RECTANGULAR,ZERO-GRADIENT MAGNET, MODIFIED TO ACT
C  ON OFF-MOMENTUM ORBITS.  TRANSFORMATION IS RELATIVE TO A RAY V,
C  GIVEN IN THE ORIGINAL COORDINATES, WHICH WILL BE TRACKED THROUGH
C  THE MAGNET.  THE RESULTING MATRIX IS TO BE USED BY CYX TO FIND
C  BETATRON FUNCTIONS RELATIVE TO A NEW CLOSED ORBIT.
C  IF IOP = 1, ACTS LIKE A MAG FOR THE SAME PARAMETERS.

C.......................................................................
C B    BEND         L         0.        BRHO      BZ        dol
C.......................................................................
      include 'ccc/dim.ccc'

      include 'ccc/const.ccc'

      DIMENSION V(*),PAR(*),TAR(6),ML(3),T(49),RW(3)
      COMPLEX(KIND(0D0)) R(6),Z,XI,XXI
      DOUBLE PRECISION L

      XI = (0, 1)
      IF (IOP.EQ.1) THEN
        CALL MAGNET(M,PAR)
        RETURN
      ENDIF
      DEGRAD = 90/PIO2

      S0 = PAR(1)
      BR0 = PAR(3)
      B0 = PAR(4)
      R0 = ABS(BR0/B0)
      PHI0 = S0 / (2*R0)
      SNPHI0 = SIN(PHI0)
      L = 2 * R0 * SNPHI0

      X0 = V(1)
      AL0 = V(2)
      IF (B0.LE.0)  THEN
         X0=-X0
         AL0=-AL0
      ENDIF
      DPP = V(6)
      FP = 1 + DPP
      BR = FP * BR0
      RHO = FP * R0

      ARG0 = PIO2 + PHI0
      XXI = XI*ARG0
      R(1) = X0 * EXP(XXI)

      ARG1 = PHI0 + AL0
      D1 = X0 * SNPHI0 / COS(ARG1)
      XXI = XI*ARG1
      R(2) = D1 * EXP(XXI)

      GAM0 = ASIN( (L/RHO) - SIN(ARG1))
      THETA = ARG1 + GAM0
      ARG2 = ARG1 - PIO2
      XXI = XI*ARG2
      R(3) = RHO * EXP(XXI)

      ARG3 = PIO2 - GAM0
      XXI = XI*ARG3
      R(4) = RHO * EXP(XXI)

      Z = R(1) + R(2) + R(3) + R(4)
      H = AIMAG(Z)
      COSPHG=COS(PHI0-GAM0)
      D4=H*SNPHI0/COSPHG
      X0F=H*COS(GAM0)/COSPHG
      AL0F = AL0 + 2*PHI0 - THETA
      S = RHO * THETA 

      TAR(1) = S
      TAR(2) = 0
      TAR(3) = BR
      TAR(4) = B0
      TAR(5) = ARG1 * DEGRAD
      TAR(6) = GAM0 * DEGRAD

      DO 1 I=1,3
 1    ML(I) = MEND - 2 - I
      CALL DRIFT(ML(1),D1)
      CALL MAGNET(ML(2),TAR)
      CALL DRIFT(ML(3),D4)
      CALL MMM(M,3,ML)

      CALL RTRV7(M,T,RW)
      CALL MXV7(T,V,V)
      V(1) = X0F
      V(2) = AL0F
      V(5) = V(5) - D1 - S - D4 + S0
      IF (B0.GE.0)  GO TO 4
      V(1) = -X0F
      V(2) = -AL0F
 4    RETURN

      END
