      SUBROUTINE BMLE(M)
C  REPLACE BEAM LINE
C     CREATES A NEW BEAM LINE IF BEAM LINE FUNCTION REFERENCE IS FBLE.
C  WHEN BEAM LINEA REFERENCE IS FBLI, THEN REPLACEMENTS ARE DONE AT
C  TIME THAT MILIST IS CREATED.
C .C    BML          QF   OO   QD   QD   OO   QF
C FX    FBLE   2      .C        QF   QD
C       BMLE   2      FX   .C1  QF1  QD1
C  CREATES
C .C1   BML           QF1  OO   QD1  QD1  OO  QF1

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=1000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=1000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/const.ccc'
C CONST.CCC
C      COMMON/CONST/PIO2,PI,TPI,PI2,RADEG,M99
C      COMMON/CHCON/ASTRK,IBLNK
C      CHARACTER ASTRK*5,IBLNK*5

      include 'ccc/files.ccc'
C      COMMON/FILES/INFILE,OUT3,IFILE,OFILE,PRFILE,PLFILE,
C     1    ORB1,JBIS,CYBO,FILE11
C      INTEGER OUT3,OFILE,PRFILE,PLFILE,ORB1,CYBO,FILE11

      PARAMETER (NPMAX=300)
      DIMENSION NPAR(NPMAX),NP1(NPMAX/2),NP2(NPMAX/2)
      DIMENSION IC(IFFSIZ),CIC(IFCSIZ)
      INTEGER OP
      EQUIVALENCE (OPNAME,CIC(1)),(NAME,CIC(2)),(OP,IC(3))
      EQUIVALENCE (KA,IC(4)),(KB,IC(5))

      CHARACTER(5) NP1,NP2,CHDAT,OLDBL,NPAR,NEWBL,CIC
      CHARACTER(5) OPNAME,NAME,NAMF,NAM

C  INITIALIZE ARRAYS IC AND CIC
      DO 1 I=1,IFCSIZ
 1    CIC(I) = IBLNK
      DO 2 I=1,IFFSIZ
 2    IC(I) = 0
C  GET M OF FUNCTION
      MFN = MDAT(M,1)
      KAF = INFF(4,MFN)
      KA = INFF(4,M)
      IF (KA.NE.KAF)  GO TO 130

C  RETRIEVE DATA.  MAKE PARALLEL ARRAYS
C  NP1 CONTAINS ELEMENTS TO BE REPLACED (FBLE DATA)
C  NP2 CONTAINS REPLACEMENT ELEMENTS (BMLE DATA)

      DO 10 I=1,KA
      NP1(I) = CHDAT(MFN,I+1)
 10   NP2(I) = CHDAT(M,I+2)
C  RETRIEVE OLD BEAM LINE
      OLDBL = CHDAT(MFN,1)
      NB1 = JELNUM(OLDBL)
      NI = INFF(17,NB1)
      IF (NI.GT.NPMAX)  GO TO 135

      CALL GETCH (NB1,1,NI,NPAR)
C  SEARCH NPAR FOR NAMES IN NP1.  WHEN FOUND, REPLACE WITH NP2.
      DO 20 I=1,NI
      IF (NPAR(I).EQ.IBLNK) GO TO 20
      DO 15 IB=1,KA
      IF (NP2(IB).EQ.IBLNK) GO TO 15
      IF (NPAR(I).EQ.NP1(IB))  NPAR(I) = NP2(IB)
 15   CONTINUE
 20   CONTINUE
      DO 25 I=1,24
 25   IC(I) = 0
C
C  IF NEW BML NAME FIELD IS BLANK, USE ORIGINAL NAME AND INFF.
      NEWBL = CHDAT(M,2)
      IF (NEWBL.EQ.'     ') NEWBL = OLDBL
      OPNAME = 'BML'
      NAME = NEWBL
      OP = INFF(3,M)
      KA = INFF(4,M)
      KB = INFF(5,M)
      IF (NEWBL.NE.OLDBL)  GO TO 125
C  NEW BEAM LINE REPLACES OLD ONE.
      CALL STOCH(NB1,1,NI,NPAR)
      GO TO 126
C  NEW BEAM LINE
125   IMIN = IMIN - 1
      CALL INFW(IMIN,8,M)
      M1 = IMIN
      CIC(5) = 'SNGL'
      CALL WTINF(IC,M1)
      CALL WTINFC(CIC,M1)
C  MAKE INFF SAME AS IF DATA HAD BEEN READ WITH INDEFINITE LOAD
      NI2 = NI*2
      CALL RESRV6(M1,0,0,NI2,2,0)
      CALL STOCH(M1,1,NI,NPAR)
C  RESET INFF
      INFF(17,M1) = INFF(18,M1)
      INFF(19,M1) = 0
      INFF(24,M1) = 0
C  WRITE CARD IMAGE
 126  NPR = 12
      IF (NPR.GT.NI) NPR = NI
      WRITE (OUT3,106) NAME,OPNAME,KA,KB,(NPAR(I),I=1,NPR)
 106  FORMAT ('  *** ',1X,A5,2X,A5,1X,I3,1X,I3,' //  ',12(A4,1X))
 50   IF (NPR.GE.NI)  GO TO 110
      II = NPR + 1
      NPR = NPR + 12
      IF (NPR.GT.NI)  NPR=NI
      WRITE (OUT3,107) (NPAR(I),I=II,NPR)
 107  FORMAT ('    * ',21X,' //  ',12(A4,1X))
      GO TO 50
C  READJUST M
 110  M = M1
      GO TO 120
 130  NAMF = CHDAT(M,1)
      NAM = CINFF(2,M)
      WRITE (OUT3,132) NAMF,NAM
 132  FORMAT (5X,'*** ERROR ***,NUMBER OF REPLACEMENTS IN FBLE ',A5,
     1  ' AND BMLE',A5,' SHOULD BE EQUAL.')
      STOP
 135  WRITE (OUT3,133)
 133  FORMAT (5X,'*** ERROR *** NUMBER OF ELEMENTS IN BML TOO LARGE
     1  FOR DIMENSION IN BMLE SUBROUTINE.'/ 5X,'ENLARGE PARAMETER
     2  NPMAX IN SUBROUTINE BMLE.')
      STOP

 120  RETURN
      END
