C **************************  RXYC  *********************************
      SUBROUTINE RXYC(M,MP,RX,RY,RW)
$$IF BITS32

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
$$ENDIF

C 7X7 to 2x3 conversion in case of x-y coupling
C M = matrix to be converted; MP = cyclical period in which
C  M is embedded
C
C  RETRIEVES X AND Y MATRICES. DIMENSIONS ARE (2,3) FOR EACH.
C  RETURN RX AND RY
C RX AND RY FOR DIAGONALIZED REPRESENTATION OF MATRIX M WHEN IT
C TRANSFORMS MP BY SIMILARITY TRANSFORMATION TO M*MP*Minv
C MP IS A 7X7 MATRIX, PRESUMABLY WITH X-Y COUPLING.

$$IF SUN
      include 'ccc/bstore.ccc'
$$ELSE
$$INCLUDE 'SYNCH_CCC:BSTORE.CCC /LIST'
$$ENDIF

$$IF SUN
      include 'ccc/binff.ccc'
$$ELSE
$$INCLUDE 'SYNCH_CCC:BINFF.CCC /LIST'
$$ENDIF

$$IF SUN
      include 'ccc/dim.ccc'
$$ELSE
$$INCLUDE 'SYNCH_CCC:DIM.CCC /LIST' 
$$ENDIF

$$IF SUN
      include 'ccc/swtch.ccc'
$$ELSE
$$INCLUDE 'SYNCH_CCC:SWTCH.CCC /LIST'
$$ENDIF

$$IF SUN
      include 'ccc/files.ccc'
$$ELSE
$$INCLUDE 'SYNCH_CCC:FILES.CCC /LIST'
$$ENDIF

$$IF SUN
      include 'ccc/cpl.ccc'
$$ELSE
$$INCLUDE 'SYNCH_CCC:CPL.CCC /LIST'
$$ENDIF

      LOGICAL INV
      DIMENSION RX(2,3),RY(2,3),AX(2,3),AY(2,3),BX(2,3),BY(2,3),
     1 RW(3),RWP(3)
      DIMENSION TT(49),T(7,7),RPQ(4),TP(7,7)
      EQUIVALENCE (T(1,1),TT(1))
      CHARACTER KIND*5,MN*5,MNAME*5

C
      INV = .FALSE.
      IF (M.LT.0) INV = .TRUE.
      CPLA = 0
      NN = ABS(M)
      NP=ABS(MP)
      DO 7 J=1,3
         DO 3 I=1,2
           RX(I,J) = 0
           RY(I,J) = 0
 3       CONTINUE
         RW(J) = 0
 7    CONTINUE
       CALL RTRV7 (NN,T,RW)
       CALL RTRV7 (NP,TP,RWP)
C Off-diagonal submatrices of T and TP
      CM11=TP(3,1)
      CM12=TP(3,2)
      CM21=TP(4,1)
      CM22=TP(4,2)
      CN11=TP(1,3)
      CN12=TP(1,4)
      CN21=TP(2,3)
      CN22=TP(2,4)
     
      DET=(CM11+CN22)*(CM22+CN11)-(CM12-CN12)*(CM21-CN21)
      TR=(TP(1,1)+TP(2,2)-TP(3,3)-TP(4,4))/2
      DSQ=DET+TR**2
      IF(DSQ.NE.0) THEN
         DEL=SQRT(DSQ)
         DDT=DEL+TR
         DB = SQRT(DDT/2/DEL)
         IF (DB.LE.1) THEN
           CPLA = ACOS(DB)
          ELSE
           CPLA = -LOG(DB+SQRT(DB**2-1))
          ENDIF
         TM11=T(3,1)
         TM12=T(3,2)
         TM21=T(4,1)
         TM22=T(4,2)
         TN11=T(1,3)
         TN12=T(1,4)
         TN21=T(2,3)
         TN22=T(2,4)
     
         AX(1,1)=T(1,1)+(TN11*(CM11+CN22)+TN12*(CM21-CN21))/DDT
         AX(1,2)=T(1,2)+(TN11*(CM12-CN12)+TN12*(CM22+CN11))/DDT
         AX(2,1)=T(2,1)+(TN21*(CM11+CN22)+TN22*(CM21-CN21))/DDT
         AX(2,2)=T(2,2)+(TN21*(CM12-CN12)+TN22*(CM22+CN11))/DDT
     
         AY(1,1)=T(3,3)-(TM11*(CN11+CM22)+TM12*(CN21-CM21))/DDT
         AY(1,2)=T(3,4)-(TM11*(CN12-CM12)+TM12*(CN22+CM11))/DDT
         AY(2,1)=T(4,3)-(TM21*(CN11+CM22)+TM22*(CN21-CM21))/DDT
         AY(2,2)=T(4,4)-(TM21*(CN12-CM12)+TM22*(CN22+CM11))/DDT
     
         DA=SQRT(AX(1,1)*AX(2,2)-AX(1,2)*AX(2,1))
         DO 10 I=1,2
           DO 10 J=1,2
             RX(I,J)=AX(I,J)/DA
             RY(I,J)=AY(I,J)/DA
 10      CONTINUE
         CC=SQRT(DDT/2/DEL)
         Q1=CC*T(5,1)-(T(5,3)*(CM11+CN22)+T(5,4)*(CM21-CN21))
         Q2=CC*T(5,2)-(T(5,3)*(CM12-CN12)+T(5,4)*(CM22+CN11))
         Q3=CC*T(5,3)+(T(5,1)*(CN11+CM22)+T(5,2)*(CN21-CM21))
         Q4=CC*T(5,4)+(T(5,1)*(CN12-CM12)+T(5,2)*(CN22+CM11))
         RX(1,3)= RX(1,1)*Q2-RX(1,2)*Q1
         RX(2,3)= RX(2,1)*Q2-RX(2,2)*Q1
         RY(1,3)= RY(1,1)*Q4-RY(1,2)*Q3
         RY(2,3)= RY(2,1)*Q4-RY(2,2)*Q3
      ELSE
           DO 11 I=1,2
             DO 111 J=1,2
                RX(I,J)=T(I,J)
                RY(I,J)=T(I+2,J+2)
 111          CONTINUE
             RX(I,3)=T(I,6)
             RY(I,3)=T(I+2,6)
  11      CONTINUE
         DA=SQRT(RX(1,1)*RX(2,2)-RX(1,2)*RX(2,1))
         DO 101 I=1,2
           DO 101 J=1,2
             RX(I,J)=RX(I,J)/DA
             RY(I,J)=RY(I,J)/DA
 101      CONTINUE
      END IF
      RW(3)=T(5,6)
      IF (.NOT.INV) RETURN
      INV = .FALSE.
      DO 25 J=1,3
         DO 25 I=1,2
            AX(I,J) = RX(I,J)
 25         AY(I,J) = RY(I,J)
      RX(1,1) = AX(2,2)
      RX(2,2) = AX(1,1)
      RX(1,2) = -AX(1,2)
      RX(2,1) = -AX(2,1)
      RX(1,3) = AX(1,2)*AX(2,3) - AX(2,2)*AX(1,3)
      RX(2,3) = AX(2,1)*AX(1,3) - AX(1,1)*AX(2,3)
      RY(1,1) = AY(2,2)
      RY(2,2) = AY(1,1)
      RY(1,2) = -AY(1,2)
      RY(2,1) =-AY(2,1)
      RY(1,3) = AY(1,2)*AY(2,3) - AY(2,2)*AY(1,3)
      RY(2,3) = AY(2,1)*AY(1,3) - AY(1,1)*AY(2,3)
      RW(1) = -RW(1)
      RW(2)=-RW(2)
      IF (BEND.NE.0) RW(3)= - RW(3)
      RETURN
C
      END
