      SUBROUTINE CONTOU

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        FINDS POINTS LYING ON CONTOURS OF A GIVEN FCN VALUE,
CC        AS A FUNCTION OF TWO VARIABLE PARAMETERS SPECIFIED BY THE
CC        CONTOUR COMMAND.   THE CONTOURS ARE THEN PLOTTED BY PLTCON.
CC
      include 'ccc/parext.ccc'

      include 'ccc/conpts.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/kard.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/variat.ccc'

      include 'ccc/const.ccc'

      include 'ccc/deriva.ccc'

      DIMENSION DIG(5)
      CHARACTER(1) ANEWMN,DIG,SYM
      DATA ANEWMN,DIG /  '*', '1', '2', '3', '4', '5' /
      DATA NSTMX,THMAX,MINPT,TEN,NPTDIM / 10, 0.4D0, 10, 100.D0, 298 /
      DATA D360 / 360.D0 /

      KE1 = INT(WORD7(1))
      KE2 = INT(WORD7(2))
      NCON = INT(WORD7(3))
      IF (NCON .LE. 0)  NCON = 2
      IF (NCON .GT. 5)  NCON=5
      SPT(1,1) = U(KE1)
      SPT(2,1) = U(KE2)
      CHSPT(1) = ' '
      NSPT = 1
      NEWMIN = 0
      KI1 = LCORSP(KE1)
      KI2 = LCORSP(KE2)
      IF (ISW(2) .LT. 2)  GO TO 40
      CALL UCOPY(V,VT,MAXINT**2)
      CALL VERMIN(VT,MAXINT,MAXINT,NPAR,IERR)
      IF (IERR .LE. 0)  GO TO 60
C             MATRIX NOT POSITIVE-DEFINITE
      WRITE (SVOUT,35)
   35 FORMAT ('0COVARIANCE MATRIX NOT POSITIVE-DEFINITE')
   40 WRITE (SVOUT,42)
   42 FORMAT ('0ONLY DIAGONAL ERRORS USED')
      A11 = V(KI1,KI1) * UP
      A22 = V(KI2,KI2) * UP
      A12 = 0
      GO TO 75
C        INVERT 2X2 SUBMATRIX BY HAND
   60 CONTINUE
      DETR = VT(KI1,KI1)*VT(KI2,KI2) - VT(KI1,KI2)**2
      IF (DETR .LE. 0)  GO TO 40
      DETR = UP/DETR
      A11 = VT(KI2,KI2) * DETR
      A22 = VT(KI1,KI1) * DETR
      A12 =-VT(KI1,KI2) * DETR
   75 CONTINUE
      RHO = A12/SQRT(A11*A22)
      XMIN = U(KE1)
      YMIN = U(KE2)
      IF (LCODE(KE1) .GT. 1)  GO TO 110
      ALIM(KE1) = XMIN - TEN*WERR(KE1)
      BLIM(KE1) = XMIN + TEN*WERR(KE1)
      EXIN1 = 1
      GO TO 115
  110 EXIN1 = (BLIM(KE1)-ALIM(KE1))*COS(X(KI1))/2
  115 CONTINUE
      IF (LCODE(KE2) .GT. 1)  GO TO 120
      ALIM(KE2) = YMIN - TEN*WERR(KE2)
      BLIM(KE2) = YMIN + TEN*WERR(KE2)
      EXIN2 = 1
      GO TO 125
  120 CONTINUE
      EXIN2 = (BLIM(KE2)-ALIM(KE2)) * COS(X(KI2))/2
  125 CONTINUE
      A11 = A11 * EXIN1**2
      A22 = A22 * EXIN2**2
      A12 = A12 * ABS(EXIN1*EXIN2)
      CIRCUM = 4*SQRT(A11 + A22)
      IFLAG = 4
C                                        . CALCULATE THE CONTOURS
      DO 800 ICON= 1, NCON
      SYM = DIG(ICON)
      ANP = 50 - 5*(NCON-ICON)
      DCA = PI2/ANP
      RAVE = ICON * CIRCUM / ANP
      RMAXAB = 3*RAVE
      RMIN = 0.1D0
      RMIN = RMIN*RAVE
      DIFF = UP * ICON**2
      AIM = AMIN + DIFF
      TOLERN = 0.05D0
      TOLERN = TOLERN*DIFF
      NPTMX = 200
      IF (NPTDIM-NSPT .LT. NPTMX)  NPTMX = NPTDIM-NSPT
      NPT = 0
      IF (NPTMX .LT. 1)  GO TO 810
      WRITE (SVOUT, 1000)  KE1, KE2, SYM,DIFF
C                                        . . SET UP FIRST POINT LONG ARM
      STEP2 = ICON * SQRT(A11*(1-RHO**2))
      U(KE1) = XMIN + STEP2
      IF ((U(KE1).GT.ALIM(KE1)).NEQV.(U(KE1).LT.BLIM(KE1)))  GO TO 731
      CALL FCN(NPAR, G, F2, U, IFLAG)
      NFCN = NFCN + 1
      IF (F2 .LE. AMIN)  GO TO 741
      IF (ISW(5) .GE. 2)  WRITE (SVOUT,900)
      THETB = PIO2 - A12/SQRT(A11**2 + A12**2)
      THET1 = THETB
      R = 10 * RMAXAB
      XPT = U(KE1) - R*COS(THET1)
      YPT = U(KE2) - R*SIN(THET1)
      SLOPE = 2 * (F2-AMIN) / (STEP2* SIN(THET1))
      TOLER = TOLERN
      NSTEP = 0
      RMAX = RAVE
      GO TO 407
C                                        . . . . . . . CUT STEP LENGTH R
  350 THET1 = (3*THETB + THET1)/4
      R = R / 2
      RMAX = R
      TOLER = TOLERN*R/RMAXAB
      SLOP = SLOPE
      NSTEP = 0
C                                        . . . . . . FIND NEXT POINT
  400 U(KE1) = XPT + R*COS(THET1)
      U(KE2) = YPT + R*SIN(THET1)
      IF (((U(KE1).GT.ALIM(KE1)).NEQV.(U(KE1).LT.BLIM(KE1)))
     $     .OR.((U(KE2).GT.ALIM(KE2)).NEQV.(U(KE2).LT.BLIM(KE2))))
     $     GO TO 731
      CALL FCN(NPAR,G,F2,U,IFLAG)
      NFCN = NFCN + 1
      IF (F2 .LE. AMIN)  GO TO 741
C                                        . CHECK IF TWO TRIES ARE NEEDED
      F1 = F2
      THET2 = THET1
      AFA = ABS(F2-AIM)
      IF (AFA .GT. 10*TOLER .AND. R .GT. RMIN)  GO TO 350
      IF (AFA .LT. TOLER/5)  GO TO 420
  407 DTHET = (F2-AIM) / (R*SLOPE)
      THMIN = 0.001D0
      THMIN = THMIN*RAVE/R
      IF (ABS(DTHET) .GT. THMAX)  DTHET = SIGN(THMAX,DTHET)
      IF (ABS(DTHET) .LT. THMIN)  DTHET = SIGN(THMIN,DTHET)
C                                        . SUBSEQUENT TRIALS FOR NEXT PT
  410 CONTINUE
      F1 = F2
      THET2 = THET1 + DTHET
      U(KE1) = XPT + R*COS(THET2)
      U(KE2) = YPT + R*SIN(THET2)
      IF (((U(KE1).GT.ALIM(KE1)).NEQV.(U(KE1).LT.BLIM(KE1)))
     $     .OR.((U(KE2).GT.ALIM(KE2)).NEQV.(U(KE2).LT.BLIM(KE2))))
     $     GO TO 731
      CALL FCN(NPAR,G,F2,U,IFLAG)
      NFCN = NFCN + 1
      IF (F2 .LE. AMIN)  GO TO 741
      SLOPE = (F1-F2)/(DTHET*R)
      IF (SLOPE .GT. 0)  GO TO 420
      IF (NPT .GT. 0)  GO TO 415
      SLOPE = 2 * (AMIN-F2) /(SIN(THET2) *(XMIN-U(KE1)))
      GO TO 420
  415 IF (R .GT. RMIN)  GO TO 350
      SLOPE = SLOP
  420 CHANG = (F2-AIM)/(SLOPE*R)
      IF (ABS(CHANG) .GT. THMAX)  CHANG = SIGN(THMAX, CHANG)
      THETA = THET2 + CHANG
C                   CHECK IF BEST TRIAL POINT IS ACCURATE ENOUGH
      DELF = MIN(ABS(F2-AIM), ABS(F1-AIM))
      IF (DELF .LT. TOLER)  GO TO 430
      IF (NPT .EQ. 0)  GO TO 425
      IF (NSTEP .EQ. 1 .AND. R .GT. RMIN)  GO TO 350
  425 NSTEP = NSTEP + 1
      IF (NSTEP .GT. NSTMX)  GO TO 751
      THET1 = THET2
      DTHET = THETA - THET1
      GO TO 410
C                                        . . .  ACCEPT NEW POINT
  430 XPT = XPT + R*COS(THETA)
      YPT = YPT + R*SIN(THETA)
      U(KE1) = XPT
      U(KE2) = YPT
      IF (((U(KE1).GT.ALIM(KE1)).NEQV.(U(KE1).LT.BLIM(KE1)))
     $     .OR.((U(KE2).GT.ALIM(KE2)).NEQV.(U(KE2).LT.BLIM(KE2))))
     $     GO TO 731
      THETAB = ABS(THETA-THETB)
      NSTEP = 0
  440 IF (NPT .GT. 1)  GO TO 445
      THBEG = THETA
      XBEG = XPT
      YBEG = YPT
  445 CONTINUE
      NPT = NPT + 1
      NSPT = NSPT + 1
      SPT(1,NSPT) = XPT
      SPT(2,NSPT) = YPT
      CHSPT(NSPT) = SYM
      XPM = XPT - XMIN
      YPM = YPT - YMIN
      IF (ISW(5) .LT. 2)  GO TO 450
      THDEG = THETA/RADEG
      THDEG = MOD(THDEG,D360)
      WRITE (SVOUT,901) NPT,XPT,YPT,XPM,YPM,DELF,R,THDEG,NFCN
  450 CONTINUE
C                                        .  TEST IF CONTOUR COMPLETED
      IF (NPT .LT. MINPT)  GO TO 500
      IF ((YPT-YBEG)**2 +(XPT-XBEG)**2 .GT. R**2)  GO TO 500
      IF (2*COS(THETA-THBEG) .GT. 1)  GO TO 600
  500 IF (NPT .GE. NPTMX)  GO TO 761
C                                        . . . . . ESTIMATE NEW POINT
      RINV = THETAB**2 / (R*DCA**2)
      IF (RINV .GT. 1/RMAX)  GO TO 522
      R2 = RMAX
      GO TO 540
  522 R2 = 1/RINV
      IF (R2 .LT. RMIN)  R2 = RMIN
  540 CHANG = R2*RINV*DCA
      IF (CHANG .GT. THMAX)  CHANG = THMAX
      IF (THETB .GT. THETA)  CHANG = -CHANG
      THET1 = THETA + CHANG
      THETB = THETA
      R = R2
      RMAX = MIN(2*R , RMAXAB)
      TOLER = TOLERN * R/RMAXAB
      SLOP = SLOPE
      GO TO 400
C                                        . CONTOUR COMPLETED NORMALLY
  600 WRITE (SVOUT,605)  SYM,NPT
  605 FORMAT ('0CONTOUR',A3,' IS COMPLETED WITH',I5,' POINTS'//)
      GO TO 790
C                                        . . . . . ERROR RETURNS
  731 WRITE (SVOUT, 735)  U(KE1), U(KE2)
  735 FORMAT ('0CONTOUR LEAVING ALLOWED REGION AT',2E16.7)
      GO TO 780
  741 WRITE (SVOUT, 745)
  745 FORMAT ('0NEW ABSOLUTE MINIMUM FOUND BY CONTOUR'/)
      NEWMIN = 1
      NSPT = NSPT + 1
      SPT(1,NSPT) = U(KE1)
      SPT(2,NSPT) = U(KE2)
      CHSPT(NSPT) = ANEWMN
      AMIN = F2
      CALL EXTOIN(X)
      CALL MPRINT(0,AMIN)
      GO TO 810
  751 WRITE (SVOUT, 755)
  755 FORMAT ('0TOO MANY ITERATIONS TO FIND NEXT POINT')
      GO TO 780
  761 WRITE (SVOUT, 765)
  765 FORMAT ('0MEMORY OVERFLOW.  TOO MANY POINTS IN CONTOUR')
  780 WRITE (SVOUT,1001)  NPT
  790 U(KE1) = XMIN
      U(KE2) = YMIN
  800 CONTINUE
C                                        . . . . . END MAIN LOOP . . . .
  810 CONTINUE
      WRITE (SVOUT,1002)  KE1,KE2,UP,KE2
      CALL PLTCON(NSPT,SPT,CHSPT)
      WRITE (SVOUT,1003)  KE1
      RETURN
  900 FORMAT ( 9X,'PT',9X ,'X',13X,'Y',10X,'X-XMIN', 6X,'Y-YMIN',
     1 7X,'ACCURACY',4X,'SEPARATION',5X,'THETA', 3X ,'CALLS')
  901 FORMAT (' ',I10,2F14.7,2X,2F12.7,F13.6,2X, F12.7,F10.1,I8)
 1000 FORMAT ('0PARAMETERS NO.',I4,' AND',I4,10X,'CONTOUR ',A3,
     1'  F = FMIN + ',F11.6)
 1001 FORMAT (' CONTOUR NOT COMPLETED BECAUSE OF ABOVE ERROR ',
     1 'CONDITION'/1X, 54('*'),I5,
     2  ' POINTS ON THE CONTOUR HAVE BEEN DETERMINED'//)
 1002 FORMAT('1  FUNCTION CONTOURS FOR PARAMETERS',2I4,20X,
     1'  CONTOUR 1 = FMIN + ',   F10.5/'0  PARAMETER.',  I3)
 1003 FORMAT ('+              PARAMETER ',    I3,','/)
      END
