      SUBROUTINE CYX(PROD)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  THIS ROUTINE...
C  1. COMPUTES K CYCLED PRODUCTS OF A MATRIX PRODUCT, PROD, WHOSE
C     FACTORS ARE STORED IN THE ARRAY, MI.
C  2. COMPUTES AND PRINTS OUT THE BETATRON FUNCTIONS OF THE CYCLED
C     PRODUCTS.

C JUNE 1990: With FXPT option, assume matrices have x-y coupling
C and compute orbit functions with Edwards-Teng formalism.
C Feb. 1993: Correct calculations of phase advances at each step
C to make them correct even in presence of coupling.
     
C  IF THE ORIGINAL INSTRUCTION WAS A CYB, THEN OPTIONAL OUTPUT MAY BE
C  OBTAINED ON CYBO, WHICH IS FILE NAME 20.
     
C  IF KA NEGATIVE, ONLY PRINT POSITIONS OF ELEMENTS WHOSE FIRST
C  CHARACTER IS # OR WHATEVER SPECIFIED BY PCYC
     
C  FOR CYA,CYC, BEST WRITE SECONDARY OPTIONS CONTROLLED BY KA AS FOLLOWS ---
C  ABS(KA) = 11,12 --- BETA FUNCTIONS ON JBIS (FILE15) IN BINARY:
C  ---- NPOS,POS,NAME,L,LP,LPP,THETA,FKV,KVP,KV2,BV,BH,AV,AH,QV,QH,X,XP
C  ABS(KA) = 13,14 --- XEQ,YEQ IN BCD on JBIS
C ABS(KA)=12,14,16 --- SUPPRESS PRINTING
C ABS(KA)=15,16 ---- POLARIZATION PARAMETERS ON FIL11
C  AB(KA)=98   WRITE TAPE 98 FOR PRINTER PLOTS --VESTIGAL
C FOR BEST PLOT PARAMETRS (BX, XEQ, BY, YEQ) ON PLFILE (TAPE 17)
C FOR FXPT BX, XCO, BY, YCO ON PLFILE AND POLARIZATION PARAMETERS ON FIL11
C if FIL11 has been opened by OPEN command

C  IF KB.LT.0, A MATRIX CORRESPONDING TO THE REFLECTION OF THE INPUT
C  BEAM LINE IS ADDED TO THAT BEAM LINE.  THUS ONLY HALF OF A SYMMETRIC
C  SUPERPERIOD NEED BE SPECIFIED.  TUNES AND CHROMATICITIES ARE
C  CALCULATED FOR THE COMPLETE SUPERPERIOD.

C June 1993: Correct phase advance calculation for CYA and for case with
C reflection added (negative KB)

C  **NOTE** ROUTINE USES ALL 7 SPECIAL 3X3 LOCATIONS, MEND THRU MEND-6.
C   AND M7END-5.

C************* NOTES ON FILES ********************
C   PLEASE REFER TO MANUAL FOR RELEVANT FILES.  MANY NOTES HERE ARE 
C   VESTIGAL AND ARE ONLY MENTIONED FOR BENEFIT OF FUTURE REJUVENATION.
C******************************************************************
C******************************************************************
C  NAMED FILES ARE IN COMMON BLOCK NAMED FILES.  THEIR VALUES ARE
C  SET IN INIT
C
C  OUT3    3  OUTPUT FILE
C  PLFILE 17  PLOT FILE FOR OFF LINE PLOTTING PROGRAM FOR FUTURE 
C             IMPLEMENTATION.  TURNED OFF AT PRESENT. 11/91
C  JBIS   15  FOR IBS AND KA=12 OPTION
C  CYBO   20  TO OUTPUT A FILE FROM CYB COMMAND  (VESTIGIAL)
C  FIL11 11  BINARY OUTPUT TAPE OF POLARIZATION PARAMETERS
C  ORB1   24  WRITTEN FOR ORBC
      COMPLEX(KIND(0D0)) TGAM,TGAM2
      COMPLEX(KIND(0D0)) II,ZG,ZCO,ZP

      include 'ccc/tsw.ccc'

      include 'ccc/bstore.ccc'

      include 'ccc/binff.ccc'

      include 'ccc/betpts.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/bmi1.ccc'

      include 'ccc/files.ccc'
      include 'ccc/slfil.ccc'

      include 'ccc/runver.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/swtch.ccc'

      include 'ccc/kinet.ccc'

      include 'ccc/match3.ccc'

      include 'ccc/const.ccc'

      include 'ccc/psym.ccc'

      include 'ccc/seed.ccc'

      include 'ccc/pagtog.ccc'
      include 'ccc/cpl.ccc'


      DIMENSION MI(24000)
      EQUIVALENCE (MI,MI1),(NELS,NELS1)

      DIMENSION GL(18),TAB(10)
      EQUIVALENCE (GL,TAB)
      EQUIVALENCE (GL(4),XNUX),(GL(5),YNUY),(GL(8),CHRX),
     1            (GL(9),CHRY),(GL(10),ALPHA),(GL(1),BXMX),
     2            (GL(2),BYMX),(GL(3),XQMX),(GL(11),YQMX),
     3            (GL(12),BXMN),(GL(13),BYMN),(GL(14),XQMN),
     6            (GL(15),YQMN),(GL(16),CIRC),(GL(17),THETH),
     5            (GL(18),THETY),(GL(7),TTGAM)

      DIMENSION RX(2,3),RY(2,3),BETX(9),BETY(9),ML(3)
      DIMENSION PRM(6),PAR(4),V0(6)
      DIMENSION T(49),TT(7,7),RW(3),VW(7),VP(7)
      DIMENSION MBX(2),MBY(2),MXQ(2),MYQ(2)
      DIMENSION MCXX(2),MCYY(2)
      DIMENSION BXP(6),BYP(6)
      DIMENSION ABX(2,2),ABXI(2,2),B(2),S(2),ISFD(2),XI(2)
      DIMENSION AS(1000),BS(1000),PSX(1000),PSY(1000),UU(3),LS(3)
      DIMENSION MSFD(2),SVAL(2),ICOM(12)

C From Courant's version
      LOGICAL SKSX(2)

      EQUIVALENCE (IX1,XI1),(IX2,XI2),(T(1),TT(1,1))
      INTEGER PROD,PR

      LOGICAL CHFLG, AMPFLG
      LOGICAL PFLAG,MVF,ISVPR
      LOGICAL PLOT,PRINT,FLG,BTABL,SKIP
 
      CHARACTER(5) MNAME,CHDAT,NBL,NCOM,ICOM
      CHARACTER(4) HNPOL,HZEQ,HTEQ
      CHARACTER(6) HMAX,HMIN
      CHARACTER(5) OPN,NMVAR,NAMPL,ISFD,NAMOP,MATI,MKN
      CHARACTER(5) MATJ,NAM,NOP
      CHARACTER(5) KCH,CNAM,C2,NNKIK,JOPNM
      CHARACTER(9) NBUF
      CHARACTER(8) NBUFF
      CHARACTER(3) LS
      DATA HNPOL,HZEQ,HTEQ/'NPOL','ZEQ','TEQ'/
      DATA HMAX,HMIN/'MAXIMA','MINIMA'/
      DATA CC/ 2.997925D8 /
      DATA ZE/0.D0/
      DATA II/(0.D0,1.D0)/
      DATA IV/2/

      ITER = 0
C  SAVE NO PRINT OPTION
      ISVPR = NOPR
 5    CONTINUE
      NBUF = IBLNK
      NBUFF = IBLNK
      FLG = .TRUE.
      SKIP = .FALSE.
      ABX(1,1)=0
      ABX(1,2)=0
      ABX(2,1)=0
      ABX(2,2)=0
      CHFLG=.FALSE.
      IF (NOPR.AND..NOT.GLOBAL)  SKIP = .TRUE.
      IF (ITER.EQ.1) THEN
           NOPR = .TRUE.
           CHFLG = .FALSE.
           IF (IAMPL.EQ.1) AMPFLG = .TRUE.
      END IF
      PRINT=.TRUE.
      PFLAG = .FALSE.
      MVF = .FALSE.
      BTABL = .FALSE.
      IF (NELS.GT.44)  PFLAG = .TRUE.
      KS=0
      ITP=0
      ITAPE = 0
      NRN = NRZZ
      LNUM=0

      IF(ERROR) RETURN
C     USES WORKING STORAGE MEND-1
      K = INFF(4,PROD)
      IF (K.GE.0) GO TO 1
      K=-K
      FLG = .FALSE.
 1    KA=K
C      PRPLOT = .FALSE.
C      IF (KA.EQ.98)  PRPLOT=.TRUE.
      KB = INFF(5,PROD)
      OPN = CINFF(1,PROD)
      IF (OPN.NE.'CYB') K=NELS
      IPP = INFF(6,PROD)
C   ZERO TAB
      DO 27 IC=1,10
 27   TAB(IC) = 0
      CHX=0
      CHY=0
      IA=0
      EL=0
      THETH = 0
      THETV = 0
      KK=K
      ISK=0
      NK=0
      ETAST = 0
C     FKK = KK
      PR = PROD
      NGO = 1
      DXCO=0
      DYCO=0
      YCO=0
      XCO = 0
      NMVAR = 'ZEQ'
      IF (KNFLAG) NMVAR = 'TEQ'
      IF (OPN.EQ.'CYB') GO TO 32
      IF(OPN.EQ.'FXPT') GO TO 33
      CALL GETCH(PR,3,2,ISFD)
C  SET CHFLG TRUE FOR SEXTUPOLE CHROM CORRECTION
      IF (ITER.GT.0)  GO TO 288
      AMPFLG = .FALSE.
      NAMPL = CHDAT(PROD,2)
      IAMPL = 0
      IF (NAMPL.EQ.'AMPL') IAMPL = 1
      IF (ISFD(1).NE.IBLNK.OR.ISFD(2).NE.IBLNK)  CHFLG=.TRUE.
      IF (.NOT.CHFLG) GOTO 273
      CALL GETFL(PR,1,2,XI)
C     Begin Courant's version
      DO 272 I=1,2
         SKSX(I) = .FALSE.
         MSFD(I) = JELNUM(ISFD(I))
         KASF = INFF(4,MSFD(I))
         KBSF = INFF(5,MSFD(I))
         IF (KBSF.NE.0) SKSX(I) = .TRUE.
 272  CONTINUE
C     End Courant's version
 273  IF (.NOT.CHFLG.AND.IAMPL.EQ.1) AMPFLG = .TRUE.
 288  IF (OPN.NE.'CYA' ) GO TO 29

C                  CYA
      IA=1
      NK = PR - K - 1
 29   MN = MNAME(PROD)
 30   IF (KA.GE.10) ITP=KA-10
      IR = PROD
      CALL MMM(PR,KK,MI)
      KWP = KK
      IF (KB.GE.0) GO TO 301
      IF (OPN.EQ.'CYA') NK=NK-1
      KK = KK+1
      MI(KK)=MEND-6
      CALL REF(MI(KK),PR)
      ML(1)=PR
      ML(2)=MI(KK)
      CALL MMM(PR,2,ML)
 301  CONTINUE
      IF (OPN.EQ.'CYA') PR = PROD - 1
      IF (OPN.EQ.'CYC'.OR.OPN.EQ.'IBS')  GO TO 26
      IF (OPN.EQ.'BEST') GO TO 28
 310  CALL BET(PR,BETX,BETY,1)
      VP(1) = BETX(5)
      VP(2) = BETX(6)
      VP(3) = BETY(5)
      VP(4) = BETY(6)
      VP(5) = 0
      VP(6) = 1
      VP(7) = 0
 31   KW=KK+1
      MI(KW)=MI(1)
      NBL = CHDAT(PROD,1)
      IF(ITP.EQ.2.OR.ITP.EQ.4.OR.ITP.EQ.6) PRINT=.FALSE.
C                  SET UP PLOT OPTION
      PLOT = .FALSE.
      IF (OPN.EQ.'BEST'.OR.(OPN.EQ.'FXPT'.AND.ITAPE.EQ.1)) GO TO 399
      GO TO 39
 399  CONTINUE
      IF (MN.EQ.IBLNK) GO TO 39
      PLOT = .TRUE.
      IF (PLOT.AND.SWPL) THEN
           WRITE(PLFILE,2001) MN,KW,IV
           WRITE (PLFILE,2005) BUF,BUFF
           WRITE (PLFILE,2007) NAMRUN,NRNCOM
      ENDIF
      GO TO 39
C                  CYB
 32   ITP=IDAT(PROD,1)
      MN=CHDAT(PROD,1)
      PR = JELNUM(MN)
      IR = PR
      GO TO 310
C                         CYC
 26   IF (KA.NE.21)  GO TO 28
      LQ3 = INFF(24,PR)
      LINE = LQ3
      BTABL = .TRUE.
C                      CYC AND BEST
 28   DO 271 I=1,12
 271  ICOM(I) = IBLNK
      IPG = 0
C  GET HEADER NAME FROM INPUT
      NCOM = CHDAT(PR,5)
      IF (NCOM.EQ.' ')GO TO 228
      MCOM = JELNUM(NCOM)
      JOPNM = CINFF(1,MCOM)
      IF (JOPNM.NE.'REM'.AND.JOPNM.NE.'PAGE'
     1                  .AND.JOPNM.NE.'RUN') GO TO 228
C  IF KA IS 1, PRINT DATE AND TIME ON EACH PAGE
      IIK = INFF(4,MCOM)
      IF (IIK.EQ.1) THEN
        NBUF = BUF
        NBUFF = BUFF
       ENDIF
C  USE OF HEADER FORCES TABLE TO BEGIN ON A NEW PAGE
      PFLAG = .TRUE.
      CALL GETCH(MCOM,1,12,ICOM)
 228  CALL RXYX(PR,PR,RX,RY,RW)
      PR=MEND-1
      CALL STXY(PR,RX,RY,RW)
C  INITIALIZE FOR PLOT TAPE AT FIRST POSITION
      NAMOP = IBLNK
      MATI = IBLNK
      GO TO 310
C                  FXPT
 33   ISK = 1
      NGO = 2
      CPL = .TRUE.
      KAF=INFF(4,PR)
      IF (KAF.LT.0)  FLG = .FALSE.
      KAF =  ABS(KAF)
      CALL GETQQ(PR,7,1,7,VW)
      IRAYS = IDAT(PR,4)
      ITAPE=IDAT(PR,5)
      FAC = 1
      IF (IRAYS.EQ.0.OR.IRAYS.EQ.2)  FAC = 1000
      X0 = VW(1)
      XP0 = VW(2)
      Y0=VW(3)
      YP0=VW(4)
      DPP=VW(6)
      CALL GETQQ(PR,8,1,7,VP)
      EX0=VP(1)
      EXP0=VP(2)
      EY0=VP(3)
      EYP0=VP(4)
      MN = MNAME(PROD)
      ITP = 0
      IF( (KA.LE.1).OR.(KA.EQ.3) ) PRINT=.FALSE.
      IR = PROD
      GO TO 31
 39   PSIX = 0
      PSIY = 0
      DELX = 0
      DELY = 0
      I = 1
      SLENI=0
      THETI=0
      CALL RXYX(PR,PR,RX,RY,RW)
C                  COMPUTE TRACE
      TRX = RX(1,1) + RX(2,2)
      TRY = RY(1,1) + RY(2,2)
 35   CONTINUE
C     Modified to match Courant
      IF ((ABS(TRX).GE.2).AND.(ABS(TRY).GE.2)) GO TO 125
      IF (IPP.GT.0) GO TO 75
      IF ((ISK.EQ.0).AND.(MODE.EQ.1).AND..NOT.NOPR)  CALL DASH1
      IF (NGO.EQ.1) GOTO 40
 41   IF (.NOT.PRINT) GO TO 75
C    WRITE FXPT HEADING
      NBL = CHDAT(PROD,2)
      IF (PFLAG.AND..NOT.NOPR)  WRITE(OUT3,1035) NBL
      IF (.NOT.PFLAG)  WRITE (OUT3,1029)  NBL
      WRITE(OUT3,1020)
      IF (IRAYS.NE.0.AND.IRAYS.NE.2)  GO TO 75
      WRITE(OUT3,1022)
      GO TO 75
C   WRITE CYX HEADING
C    NOPR MEANS NO PRINT.
C    PFLAG IS TRUE IF PAGING IS CALLED FOR.
C    PTOG IS TRUE WHEN PAGE COMMAND WAS ISSUED BEFORE CYC OR BEST.  DO 
C  NOT RESTORE FIRST PAGE.

 40   IF (.NOT.NOPR) THEN
        IF (PFLAG) THEN
         IPG = IPG + 1
         IF (.NOT.PGTOG) WRITE (OUT3,1030)
         WRITE(OUT3,1036) ICOM,IPG,NBL
        ENDIF
         WRITE(OUT3,1000) NMVAR
       ENDIF
      GO TO 75
C***********************************************************************

C                  ITERATES FROM STATEMENTS 50 TO 90
 50   NI=MI(I)
      NISAVE=NI
      MKN = CINFF(4,NI)
      IF (NGO.EQ.1) GOTO 505
 506  NF = M7END - 5
      XCO = VW(1)*FAC
      DXCO = VW(2)*FAC
      YCO = VW(3)*FAC
      DYCO = VW(4)*FAC
      EX=VP(1)
      EXP=VP(2)
      EY=VP(3)
      EYP=VP(4)

      IF(I.GT.1) NRZZ = NRR
      ANGIN = VW(2)
      V5 = VW(5)
      CALL REVMAT(NF,NI,VW)
      ANGOUT = VW(2)
      W5 = VW(5)
      NRR = NRZZ
      NI = NF
C CORRECT CALCULATION OF TRANSITION GAMMA
 505  IF (I.EQ.KW)  GO TO 5051
      CALL RTRV7(NI,T,RW)
      CALL MXV7(TT,VP,VP)
      EST = -VP(5)
      IF (KNFLAG) EST = EST - (EL/(GAM*GAM))
 5051 CALL RXYX(NI,PR,RX,RY,RW)
      IF ( ( KB .GE.0).OR.(I.LT.KW) ) GO TO 507
      PSIX = 2*PSIX
      PSIY = 2*PSIY
      IPOS = I - 1
      MATI = 'REFL'
      IF (NGO.EQ.1) GOTO 52
 508  XCO = X0*FAC
      DXCO = -XP0*FAC
      YCO = Y0*FAC
      DYCO = -YP0*FAC
      EX=EX0
      EXP=-EXP0
      EY=EY0
      EYP=-EYP0
      GO TO 52
 507  CONTINUE
      IPOS = I-1
      IF (IPOS.NE.0) GO TO 51
      MATI = IBLNK
      BXMX = BETX(2)
      BYMX = BETY(2)
      XQMX = BETX(5)
      YQMX = BETY(5)
      BXMN = BETX(2)
      BYMN = BETY(2)
      XQMN = BETX(5)
      YQMN = BETY(5)
      IF(NGO.EQ.1) GO TO 511
      XCMX=XCO
      XCMN=XCO
      YCMX=YCO
      YCMN=YCO
 511  CONTINUE
      DO 510 LI = 1,2
C     Begin modified to match Courant
      MCXX(LI)=0
      MCYY(LI)=0
      MBX(LI) = 0
      MBY(LI) = 0
      MYQ(LI) = 0
 510  MXQ(LI) = 0
C     End modified to match Courant
      GO TO 52
 51   MK = MI(IPOS)
      MATI = CINFF(2,MK)
C     Courant
      IF (IPOS.EQ.0) MATI = 'Start'
      NAMOP = CINFF(1,MK)
      GG = FLDAT(MK,2)
      IF (NAMOP.EQ.'DRF') GG = 0
      MATJ = MATI(1:1)
C  CHECK MATJ FOR DESIRED SYMBOL FOR PRINTING.  CKSYMB WILL
C  TURN ON SBFLG IF WANT TO PRINT.  (COMMON BLOCK PSYM.CCC)
      CALL CKSYMB(MATJ)
      IF (NGO.EQ.1) GO TO 52
      BETX(5)=EX
      BETY(5)=EY
 52   IF (IPOS.EQ.0)  GO TO 522
      IF (.NOT.CHFLG)  GO TO 522
C           CALCULATE SUMS FOR CHROM CORRECTION
      IF (MATI.NE.ISFD(1))  GO TO 521
C CORRECTION FOR FINITE SEXTUPOLES
      FF=FLDAT(JELNUM(MATI),1)
      BXC=BETX(2)+FF*(BETX(3)+FF*BETX(4)/4)
      BYC=BETY(2)+FF*(BETY(3)+FF*BETY(4)/4)
      ETC=BETX(5)-FF*BETX(6)/2
C     Courant's version
      IF (SKSX(1)) ETC = -(BETY(5)-FF*BETY(6)/2)
      ABX(1,1) = ABX(1,1) + BXC*ETC
      ABX(2,1) = ABX(2,1) + BYC*ETC
 521  IF (MATI.NE.ISFD(2))  GO TO 522
      FF=FLDAT(JELNUM(MATI),1)
      BXC=BETX(2)+FF*(BETX(3)+FF*BETX(4)/4)
      BYC=BETY(2)+FF*(BETY(3)+FF*BETY(4)/4)
      ETC=BETX(5)-FF*BETX(6)/2
C     Courant's version
      IF (SKSX(1)) ETC = -(BETY(5)-FF*BETY(6)/2)
      ABX(1,2) = ABX(1,2) + BXC*ETC
      ABX(2,2) = ABX(2,2) + BYC*ETC
 522  IF (.NOT.PRINT)  GO TO 53
      IF (IPP.GT.0) GO TO 53

C***********************************************************************
C                PRINT BETATRON FUNCTIONS
      IF (.NOT.FLG.AND..NOT.SBFLG) GO TO 53
      IF (.NOT.PFLAG.OR.(MOD(LNUM,45).NE.0.OR.LNUM.EQ.0)) THEN
         IF (NGO.EQ.1) GOTO 571
         IF (NGO.EQ.2) GOTO 58
      ENDIF
C  NEW PAGE.  WRITE HEADING.
      IF (NGO.EQ.2) GOTO 59
 57   IF (.NOT.NOPR) THEN
         IPG = IPG + 1
         WRITE(OUT3,1040) ICOM,NBUF,NBUFF,IPG,NBL,NMVAR
       ENDIF
 571  CONTINUE
      IF (.NOT.BTABL)  GO TO 573
      QLIB(LINE) = PSIX
      QLIB(LINE+6) = PSIY
      QLIB(LINE+12) = EL
      QLIB(LINE+13) = THETH
      LST=LINE
      DO 572 ICY=2,6
      LST = LST+1
      QLIB(LST) = BETX(ICY)
 572  QLIB(LST+6) = BETY(ICY)
      LINE = LINE + 14
 573  IF (NOPR) GO TO 574
      WRITE (OUT3,1001)  IPOS,MATI,EL,PSIX,PSIY,BETX(2),BETY(2),
     1  BETX(5),BETY(5),ETAST,BETX(3),BETY(3),BETX(6),BETY(6)
      LNUM=LNUM+1
      IF (MOD(LNUM,5).EQ.0.AND.MOD(LNUM,45).NE.0) WRITE (OUT3,1006)
 574  ETAST = EST
      GO TO 53
 59    IF (IPOS.EQ.0)  GO TO 58
      IF (LNUM.NE.45)  GO TO 591
C  SKIP PAGE RESTORE THIS TIME
C  UNIQUE PAGING WITH FIRST PAGE OF FXPT.
C  EXTRA LINE AT TOP OF 1ST PAGE CAUSES AUTOMATIC PAGE RESTORE HERE.
      WRITE (OUT3,1020)
      GO TO 592
 591  WRITE (OUT3,1030)
      WRITE (OUT3,1020)
 592  IF (IRAYS.NE.0.AND.IRAYS.NE.2)  GO TO 58
      WRITE (OUT3,1022)
C  CPLDG = COUPLING ANGLE IN DEGREES
 58   CPLDG = CPLA/RADEG
C     Begin Courant's version
      WRITE(OUT3,1021) 
     1 ipos,mati,EL,PSIX,BETX(2),BETX(3),CPLDG,EX,EXP,XCO,DXCO,
     2              PSIY,BETY(2),BETY(3)      ,EY,EYP,YCO,DYCO
C     End Courant's version
      LNUM=LNUM+1
      IF (MOD(LNUM,5).EQ.0.AND.MOD(LNUM,45).NE.0)  WRITE (OUT3,1006)
 53   CONTINUE
C      IF (PRPLOT)  WRITE (PRFILE,2000) IPOS,EL,PSIX,PSIY,BETX(2),
C     1   BETY(2),BETX(5),BETY(5)
C  ADDITION FROM E.COURANT 6/90
      IF(ITAPE.GE.1) THEN
         FKV=0.
         IF (NAMOP.EQ.'MAG'.OR.NAMOP.EQ.'MAGV') FKV=-GK
         WRITE(ORB1) KK,IPOS,MATI,SS,ZE,ZE,THETI,FKV,DKV,ZE,
     1   BETY(2),BETX(2),BETY(3),BETX(3),PSIY,PSIX,A,AP,AV,AVP
         WRITE(ORB1) EX,EXP,EY,EYP,XCO,DXCO,YCO,DYCO
      END IF
      IF (IPOS.EQ.0) GO TO 54
      IF (SKIP)  GO TO 54
      CALL MAXMIN (BXMX,BXMN,BETX(2),MBX,IPOS)
      CALL MAXMIN (BYMX,BYMN,BETY(2),MBY,IPOS)
      CALL MAXMIN(XQMX,XQMN,BETX(5),MXQ,IPOS)
      CALL MAXMIN(YQMX,YQMN,BETY(5),MYQ,IPOS)
      IF(NGO.EQ.1) GO TO 54
      CALL MAXMIN(XCMX,XCMN,XCO,MCXX,IPOS)
      CALL MAXMIN(YCMX,YCMN,YCO,MCYY,IPOS)
      IF (.NOT.PLOT.OR.I.GT.PLTSIZ) GO TO 54
      XX(I)=EL
      Y1(I)=BETX(2)
      Y2(I)=XCO
      Y3(I)=BETY(2)
      Y4(I)=YCO
          Y5(I)=BETX(3)
          Y6(I)=BETY(3)
          Y7(I)=BETX(6)
          Y8(I)=BETY(6)
          Y9(I)=PSIX
          Y10(I)=PSIY
 54   ELL = EL
      IF(NGO.EQ.2) GO TO 622

C                  STORE FOR PLOT FILE ON OPTION
      IF (.NOT.PLOT) GO TO 56
      IF (IPOS.EQ.0) GG = 0
      IF (I.LE.PLTSIZ) THEN
          XX(I) = EL
          Y1(I) = BETX(2)
          Y2(I) = BETX(5)
          Y3(I) = BETY(2)
          Y4(I) = BETY(5)
          Y5(I)=BETX(3)
          Y6(I)=BETY(3)
          Y7(I)=BETX(6)
          Y8(I)=BETY(6)
          Y9(I)=PSIX
          Y10(I)=PSIY
          IF (SWPL) THEN
           WRITE (PLFILE,2050) NAMOP,MATI,GG,XX(I),Y1(I),Y2(I),Y3(I),
     1                        Y4(I)
      ENDIF
      ENDIF
      GO TO 55
 56   CONTINUE
      IF (ITP.EQ.0) GO TO 55
      IF(ITP.GT.2) GO TO 62
      FKV=0
      IF (NAM.EQ.'MAG') FKV=-GK
      DKV=0
      IF(NAM.EQ.'SXTP') DKV=-GK2
      IF(NGO.EQ.2) GO TO 63
      A = BETX(5)
      AP = BETX(6)
      AV = BETY(5)
      AVP = BETY(6)
      GO TO 64
 63   A = VW(1)/DPP
      AP = VW(2)/DPP
 64   CONTINUE
      SSLEN=SLENI
      IF (OPN.EQ.'IBS') SSLEN=EL
      WRITE(JBIS) KK,IPOS,MATI,SSLEN,ZE,ZE,THETI,FKV,DKV,ZE,
     1          BETY(2),BETX(2),BETY(3),BETX(3),PSIY,PSIX,A,AP
     2         ,AV,AVP
      IF(.NOT.FLG.AND..NOT.SBFLG) GO TO 55
      IF (OPN.EQ.'IBS'.OR..NOT.PRINT)  GO TO 55
      WRITE(OUT3,2)KK,IPOS,MATI,SLENI,ZE,ZE,THETI,FKV,DKV,ZE,
     1          BETY(2),BETX(2),BETY(3),BETX(3),PSIY,PSIX,A,AP
     2         ,AV,AVP
      GO TO 55
 62   IF(ITP.GE.5) GO TO 622
      IF(I.EQ.KW) GO TO 55
      WRITE (CYBO,1002) MN,IPOS,KK,EL,BETX(5),BETY(5),BETX(7),
     X       BETY(7)
      GO TO 55
C WRITE POLARIZATION PARAMETERS ON  FIL11 IF SW11 IS TRUE
 622  RHOI = 0
      GK=0
      XI1=0
      XI2=0
      IF(IPOS.EQ.0) GO TO 3333
      NAM=CINFF(1,MK)
      IF (NAM.EQ.'MOVE')  GO TO 3335
      IF(NAM.EQ.'MAG') GO TO 3336
      GO TO 3333
 3335 MMK=MDAT(MK,1)
      IF(CINFF(1,MMK).NE.'MAG' ) GO TO 3333
      MK=MMK
 3336 CONTINUE
      CALL GETFL(MK,1,6,PRM)
      RHOI=PRM(4)/PRM(3)
      GK=-PRM(2)/PRM(3)
      XI1=PRM(5)
      XI2=PRM(6)
C   FIX THIS WHEN $ SIGN RESOLVED
C      IF(IX1.EQ.1H$.OR.IX2.EQ.1H$) GO TO 3334
      IOBJ = INFF(6,MK)
      IF (IOBJ.EQ.1) GO TO 3334
      XI1=XI1*RADEG
      XI2=XI2*RADEG
      GO TO 3333
 3334 XI1=PRM(1)*RHOI/2
      XI2=XI1
 3333 CONTINUE
      IF(I.EQ.1.AND.SW11) WRITE(FIL11) KW
      IF (NGO.EQ.2)  THEN
         ZZ = YCO/FAC
         ZZP=DYCO/FAC
      ELSE
         ZZ = 0
         ZZP =0
      END IF
      IF (SW11)WRITE (FIL11) ELL,PSIY,BETY(2),RHOI,GK,XI1,XI2,ZZ,ZZP
C                            COMPUTE LENGTH
 55   EL = EL + RW(1)
 60   I = I + 1
      IF (I.GT.KW)  GO TO 90
      SLENI = RW(1)
      THETI = RW(2)
      NAM = CINFF(1,NI)
      IF ((I.EQ.KW).AND.(KB.LT.0))  GO TO 65
      IF (NAM.NE.'MAGV')  THETH = THETH + RW(2)
      IF (NAM.EQ.'MAGV')  THETV = THETV + RW(2)
      GO TO 66
 65    THETH = THETH + THETH
      THETV = 2*THETV
 66    CONTINUE

C  COMPUTE BETATRON FUNCTIONS FOR THE I-TH CYCLED MATRIX

C  IN CYA CASE, DO SIMILARITY TRANSFORMATION AND CALL BET
C     IN OTHER CASES, COMPUTE NEW BETA FUNCTIONS DIRECTLY
C  In CPL case do similarity trsf but compute beta functions directly
      IF (OPN.EQ.'CYA')  THEN
         ML(1) = -NI
         ML(2) = PR + IA
         ML(3) = NI
         IF (PR.EQ.NK) PR=MEND-1
         CALL MMM (PR,3,ML)
      END IF
      IF (CPL)  THEN
         ML(1) = -NI
         ML(2) = PR
         ML(3) = NI
         CALL MMM (PR,3,ML)
      END IF
      DO 555 JJ=1,6
      BXP(JJ)=BETX(JJ)
 555  BYP(JJ)=BETY(JJ)
      AXS=BETX(3)
      AYS=BETY(3)
      SS=RW(1)
 75   IF (I.EQ.1)  CALL BET(PR,BETX,BETY,1)
      IF(I.EQ.1) GO TO 775
      IF (SKIP)  GO TO 775
C      IF (OPN.EQ.'CYA')  GO TO 7501
      IF (BXP(2).EQ.0)  GO TO 7502

      BETX(3) = (1+2*RX(1,2)*RX(2,1))*BXP(3)-RX(1,1)*RX(2,1)
     1*BXP(2)-RX(1,2)*RX(2,2)*BXP(4)
      BETX(2) = (RX(1,2)**2+(RX(1,1)*BXP(2)-RX(1,2)*BXP(3))**2)
     1   /BXP(2)
      BETX(4) = (1+BETX(3)**2)/BETX(2)
      BETX(5) = RX(1,1)*BXP(5)+RX(1,2)*BXP(6)+RX(1,3)
      BETX(6) = RX(2,1)*BXP(5)+RX(2,2)*BXP(6)+RX(2,3)
 7502 IF (BYP(2).EQ.0)  GO TO 7501
      BETY(3) = (1+2*RY(1,2)*RY(2,1))*BYP(3)-RY(1,1)*RY(2,1)
     1*BYP(2)-RY(1,2)*RY(2,2)*BYP(4)
      BETY(2) = (RY(1,2)**2+(RY(1,1)*BYP(2)-RY(1,2)*BYP(3))**2)
     1/BYP(2)
      BETY(4) = (1+BETY(3)**2)/BETY(2)
      BETY(5) = RY(1,1)*BYP(5)+RY(1,2)*BYP(6)+RY(1,3)
      BETY(6) = RY(2,1)*BYP(5)+RY(2,2)*BYP(6)+RY(2,3)
C In reflection case, don't add phase advance for second half
C (the phase advance for the first half has already been doubled)
      if(i.eq.kw.and.kb.lt.0) go to 7501
      DELX = atan2(rx(1,2),bxp(2)*rx(1,1)-bxp(3)*rx(1,2))
      IF (DELX.LT.0.AND.RW(1).GT.0) DELX= DELX + PI2
      PSIX = PSIX + DELX/PI2
      dely = atan2(ry(1,2),byp(2)*ry(1,1)-byp(3)*ry(1,2))
      IF (DELY.LT.0.AND.RW(1).GT.0)  DELY = DELY + PI2
      PSIY = PSIY + DELY/PI2
 7501 CONTINUE
 
      NI = NISAVE
      NAM=CINFF(1,NI)
C     Courant's version
      IF(NAM.EQ.'SXTP'.OR.NAM.EQ.'NPOL') GO TO 785
 760  CONTINUE
      IF (NAM.NE.'KICK'.AND.NAM.NE.'MOVE') GO TO 765
      NNKIK = CHDAT(NI,1)
      IF (NNKIK.EQ.IBLNK) GO TO 775
      NKIK=MDAT(NI,1)
      NOP=CINFF(1,NKIK)
      IF (NOP.NE.'MAG'.AND.NOP.NE.'MAGV') GO TO 765
      IF (MKN.EQ.'MAP')  GO TO 775
      CALL GETFL(NKIK,1,6,PRM)
      GK=PRM(2)/PRM(3)
      IF(NOP.EQ.'MAGV') MVF=.TRUE.
      GO TO 770
 765  IF(NAM.NE.'MAG' .AND.NAM.NE.'MAGV') GO TO 775
      CALL GETFL(NI,1,6,PRM)
      GK=PRM(2)/PRM(3)
      IF(NAM.EQ.'MAGV') MVF=.TRUE.
 770  CONTINUE
      NZ=NI
      IF (NAM.EQ.'KICK'.OR.NAM.EQ.'MOVE') NZ=NKIK
      RI=PRM(4)/PRM(3)
      XI1=PRM(5)
      XI2=PRM(6)
C  FIX THIS WHEN $ SIGN IS RESOLVED
C      IF (IX1.EQ.1H$.OR.IX2.EQ.1H$) GO TO 7701
      IOBJ = INFF(6,NZ)
      IF (IOBJ.EQ.1) GO TO 7701
      TH1=XI1*RADEG
      TH2=XI2*RADEG
      GO TO 7702
 7701 TH1=PRM(1)*RI/2.D0
      TH2=TH1
 7702 IF(NGO.EQ.2) THEN
         IF(MVF) THEN
            TH1=TH1-ANGIN
            TH2=TH2+ANGOUT
           ELSE
            TH1=TH1+ANGIN
            TH2=TH2-ANGOUT
         END IF
         GK=GK/(1.+VW(6))
         SS=PRM(1)+V5-W5
         RI=(RI*PRM(1)-ANGOUT+ANGIN)/SS
       END IF
      TAN1=TAN(TH1)
      TAN2=TAN(TH2)
      IF(MVF) GO TO 7703
      CALL       CHRM(GK,RI,SS,TAN1,TAN2,BETX,BETY,BXP,BYP,CRX,CRY)
      GO TO 786
 7703 MVF = .FALSE.
      CALL CHRM(GK,RI,SS,TAN1,TAN2,BETY,BETX,BYP,BXP,CRY,CRX)
      GO TO 786
 785  CALL GETFL(NI,1,4,PRM)
      SXLEN=PRM(1)
      GK2=PRM(2)/PRM(3)
      IF (.NOT.AMPFLG)  GO TO 5601
      IF(NAM.NE.'SXTP') GO TO 5601
C STORE PARAMETERS FOR NONLINEAR AMPLITUDE CALCULATION
      DKV=-GK2
      KS=KS+1
      AF=DKV*SQRT(BETX(2))
      IF(SLENI.NE.0) AF=AF*SLENI
      AS(KS)=AF*BETX(2)
      BS(KS)=AF*BETY(2)
      PSX(KS)=PSIX
      PSY(KS)=PSIY
 5601 CONTINUE
      KAS=INFF(4,NI)
      KBS = INFF(5,NI)
C     Removed in Courant's version
C      IF (KAS.EQ.0) KBS= 0
C      IF (KAS.EQ.0)  KAS=3
      MP=KAS-3
C     Courant's version
      IF (KAS.EQ.0) MP=0
      IF(MP.LT.0) GO TO 786
      ZCO = ((XCO + SXLEN*DXCO/2) + II*(YCO + SXLEN*DYCO/2))
     1   /1000
      ZP= BETX(5)-SXLEN*BETX(6)/2+ II*(BETY(5)-SXLEN
     1   *BETY(6)/2)
      BXC = BETX(2) + SXLEN*(BETX(3)+BETX(4)*SXLEN/4)
      BYC = BETY(2) + SXLEN*(BETY(3)+BETY(4)*SXLEN/4)
      ZG=-2*ZP*GK2
C     Courant's version
      IF (KBS.NE.0) ZG=II*ZG
      IF(SXLEN.NE.0) ZG=ZG*SXLEN
      IF(MP.GT.0) THEN
         DO 7851 MM=1,MP
 7851    ZG=ZG*ZCO/MM
        END IF
      CRX = +REAL(ZG)*BXC    
      CRY = -REAL(ZG)*BYC
 786  CHX = CHX + CRX
      CHY = CHY + CRY
 775  CONTINUE
C  CHANGE INDEX TO SAVE CYCLED MATRICES IF CYA INSTRUCTION.
      IF (OPN.NE.'CYA'.OR.I.EQ.KW) GO TO 50
      PR=PR-1
      GO TO 50

C               COMPLETES LOOP FROM STATEMENTS 50 TO 90
C***********************************************************************
 90   CONTINUE
      NRZZ = NRN
      CPL = .FALSE.
C      IF (SKIP)  GO TO 201
      BXX = BXMX
      BYX = BYMX
 91   CONTINUE
      TKB = ABS(KB)
      IF(KB.EQ.0) TKB=1
      XNUX=TKB*PSIX
      YNUY=TKB*PSIY
      THETH = THETH * TKB
      THETV=THETV*TKB
      RLEN=ELL/PI2
      RLEN = RLEN * TKB
      CIRC = ELL*TKB
      STOTI = 1/ELL
      ETSTOT = ETAST*STOTI
      ALPHA = -VP(5)*STOTI
C    IPP.GT.0 PRINTS ONLY TABULAR VALUES.
      IF (IPP.GT.0)  GO TO 100
      IF (.NOT.NOPR)  WRITE (OUT3,1006)
      CHM =-TKB/(8*PI)
      IF (KB.LT.0)  CHM = 2*CHM
      CHRX = CHM*CHX
      CHRY = CHM*CHY
         IF (ITER.EQ.1) WRITE (OUT3,1075) CHRX,CHRY
 1075 FORMAT (//2X,'CHROMATICITY AFTER SEXTUPOLE CORRECTIONS --',
     1    'DUNX(DPP/P) = ',F10.5,5X,'DUNY(DPP/P) = ',F10.5)
      IF (SKIP) GO TO 201
      IF (.NOT.CHFLG)  GO TO 100
C                 CALCULATE CHROM CORRECTIONS
      ABINV = 1/(ABX(1,1)*ABX(2,2) - ABX(1,2)*ABX(2,1))
      ABXI(1,1) =  ABX(2,2)*ABINV
      ABXI(2,1) = -ABX(2,1)*ABINV
      ABXI(1,2) = -ABX(1,2)*ABINV
      ABXI(2,2) =  ABX(1,1)*ABINV

      SPN = ABS(KB)
      IF (SPN.EQ.0)  SPN = 1
      IF (KB.LT.0)  SPN = SPN*2
      CON = 2*PI2/SPN

      B(1) = CON*(XI(1) - CHRX)
      B(2) = CON*(-XI(2) + CHRY)

      DO 99 I=1,2
      S(I) = 0
      DO 99 J=1,2
 99   S(I) = S(I) + ABXI(I,J)*B(J)

C       APPLY CHROM CORRECTIONS TO 2ND PARAMETER OF SEXTUPOLES
      DO 95 I=1,2
C     Removed in Courant's version
C     MSFD(I) = JELNUM(ISFD(I))
      IF (FLDAT(MSFD(I),1).NE.0)  S(I)=S(I)/FLDAT(MSFD(I),1)
      SVAL(I) = FLDAT(MSFD(I),2)
      SVAL(I) = SVAL(I) + S(I)*FLDAT(MSFD(I),3)
C  REPLACE VALUE IN SXTP OR ITS SYMBOLIC EQUIVALENT
      CALL GETSF(MSFD(I),2,1,KCH)
      IF (KCH.EQ.IBLNK) THEN
         CALL STOFL(MSFD(I),2,1,SVAL(I))
         GO TO 95
        ENDIF
       IJJ = JELNUM(KCH)
       CNAM = CINFF(1,IJJ)
       IF (CNAM.EQ.'=') THEN
         C2 = CHDAT(IJJ,1)
         IF (C2.EQ.IBLNK) CALL STOFL(IJJ,1,1,SVAL(I))
        ENDIF
       CALL STOQ(IJJ,1,1,SVAL(I))
 95   CONTINUE
 100   IF (BEND.EQ.0)  GO TO 101
C   COMPUTE TRANSITION GAMMA
      IF (ALPHA.EQ.0)  GO TO 101
      TGAM2 = 1/ALPHA
      TGAM = SQRT(TGAM2)
      TTGAM = DIMAG(TGAM)
      IF (TTGAM.NE.0) TAB(6) = -TTGAM
      TTGAM = DREAL(TGAM)
      IF (TTGAM.NE.0) TAB(6) = TTGAM
      GO TO 102
 101  TGAM = 0
 102  IF (IPP.GT.0)  GO TO 103
      IF (NOPR)  GO TO 104
      WRITE(OUT3,1008) CIRC,THETH,XNUX,CHRX,RLEN,THETV,YNUY,CHRY
      IF (BEND.NE.0)  WRITE (OUT3,1026) ALPHA,TGAM
      IF (BEND.EQ.0)  WRITE (OUT3,1025) ALPHA
  104 IF (.NOT.KNFLAG)  GO TO 105
      IF (.NOT.KNFLAG) GO TO 105
      CCBET = CC * BETT
      T0 = 0
      IF (CCBET.NE.0)  T0 = ELL/CCBET
      ETA = ALPHA - (1/(GAM*GAM))
      IF (NOPR)  GO TO 201
       WRITE (OUT3,1028) ETSTOT,T0,ETA
 105  IF (NOPR)  GO TO 201
      WRITE (OUT3,1005)
      WRITE (OUT3,1007) HMAX,MBX(1),BXMX,MBY(1),BYMX,MXQ(1),XQMX,
     1  MYQ(1),YQMX
      WRITE (OUT3,1007) HMIN,MBX(2),BXMN,MBY(2),BYMN,MXQ(2),XQMN,
     1    MYQ(2),YQMN
      IF(NGO.EQ.2)WRITE(OUT3,1051) MCXX(1),XCMX,MCYY(1),YCMX,
     1  MCXX(2),XCMN,MCYY(2),YCMN
      IF (CHFLG) WRITE(OUT3,1045) SVAL(1),SVAL(2)
 201  IF (.NOT.AMPFLG)  GO TO 210
      IF(KS.EQ.0) GO TO 210
      IF(KB.GE.0) GO TO 410
      DO 411 I=1,KS
         KT=KS+KS+1-I
         AS(KT)=AS (I)
         BS(KT)=BS(I)
         PSX(KT)=PSIX-PSX(I)
 411     PSY(KT)=PSIY-PSY(I)
      KS=KS+KS
 410  CONTINUE
      PX=PI*PSIX
      PY=PI*PSIY
      PX3=3*PX
      PCP=PY+PY+PX
      PCM=PY+PY-PX
      SX1=SIN(PX)
      SX3=SIN(PX3)
      SP=SIN(PCP)
      SM=SIN(PCM)
      H11=0
      H22=0
      H12=0
      DO 402 I=1,KS
         DO 402 J=1,KS
            PHX=PX-PI2*ABS(PSX(I)-PSX(J))
            PHY=PY-PI2*ABS(PSY(I)-PSY(J))
            C1=COS(PHX)/SX1
            C3=COS(3*PHX)/SX3
            CP=COS(2*PHY+PHX)/SP
            CM=COS(2*PHY-PHX)/SM
            AA=AS(I)*AS(J)
            AB=AS(I)*BS(J)
            BB=BS(I)*BS(J)
            H11=H11-AA*(C3+3*C1)
            H12=H12-BB*(CP+CM)+2*AB*C1
 402        H22=H22-BB*(CP-CM+4*C1)
      UU(1)=TKB*H11/PI2/64
      UU(2)=TKB*H12/PI2/32
      UU(3)=TKB*H22/PI2/64
      DO 420 I=1,3
         LS(I)=' - '
         IF(UU(I).GE.0) LS(I)=' + '
 420     UU(I)=ABS(UU(I))
      IF (ITER.EQ.0)  WRITE (OUT3,405)
      WRITE(OUT3,404) XNUX,LS(1),UU(1),LS(2),UU(2),CHRX,
     1   YNUY,LS(2),UU(2),LS(3),UU(3),CHRY
      GO TO 210
C  PRINT TAB VALUES
 103  IF (NOPR)  GO TO 210
      WRITE (OUT3,1112) TAB(1),TAB(3),TAB(4),TAB(2),TAB(5),TGAM
 210  IF (ISK.EQ.0)  CALL DASH1
      KNFLAG = .FALSE.
      IF (.NOT.BTABL) GO TO 216
      LINE = LINE - 1
      DO 215 ICY = 1,18
 215  QLIB(LINE+ICY) = GL(ICY)
 216  IF (NGO.EQ.2)  RETURN
      CALL STOQQ(PROD,7,1,10,TAB)
C  RESTORE NOPR
      IF (ITER.EQ.1)  THEN
          NOPR = ISVPR
          RETURN
       ELSE
          IF (.NOT.CHFLG)  RETURN
       END IF
C  RECALCULATE SXTP WITH NEW VALUES AND REPEATE CYX CALCULATION
      DO 130 IVX=1,2
      CALL GETFL (MSFD(IVX),1,4,PAR)
      PAR(4) = 0
      DO 131 IVV=1,6
 131  V0(IVV) = 0
 130  CALL SXTP(MSFD(IVX),V0,PAR)
      ITER = 1
      GO TO 5

C   ERROR EXIT
 125   CONTINUE
      ERROR = .TRUE.
      IF (IPP.GT.0)  GO TO 210
      WRITE (OUT3,1009) MN,TRX,TRY
C   COMPUTE AND PRINT LENGTH
      KE = KW - 1
      EL = 0
      DO 127 IK=1,KE
      M1 = MI(IK)
      CALL GETQ(M1,1,1,FL)
      EL = EL + FL
 127  CONTINUE
      WRITE (OUT3,1010) EL
      STOP
C      GO TO 210

C***********************************************************************
C                  FORMATS
 2    FORMAT (1X,2I4,1X,A5,1X,17F6.2)
 404  FORMAT(//' AMPLITUDE DEPENDENCE OF TUNES DUE TO SEXTUPOLES'/
     1 ' NU-X = ',F10.6,A3,E9.3,'EX ',A3,E9.3,'EY',
     2 5X,'DNUX/(DPP/P) = ',F10.5/
     3 ' NU-Y = ',F10.6,A3,E9.3,'EX ',A3,E9.3,'EY',
     4 5X,'DNUY/(DPP/P) = ',F10.5)
 405  FORMAT (' ')
 1009 FORMAT (//5X,4X,' ***** BETATRON FUNCTIONS UNSTABLE THROUGH ',
     1  A5/5X,'X TRACE = ',E12.5,10X,'Y TRACE = ',E12.5)
 1010  FORMAT (10X,'TOTAL BEAM LENGTH = ',F13.5)
C     Begin Courant's modified version
 1000 FORMAT (
     1  3X,'POS ','Name',4x,'S(M) ',5X,'NUX',6X,'NUY',6X,'BETAX(M)',
     2  4X,'BETAY(M)',4X,'XEQ(M)',4X,'YEQ(M)',2X,A4,6X,'ALPHAX',
     3 4X,'ALPHAY',5X,'DXEQ',5X,'DYEQ'/1X,131('-'))
C     End Courant's modified version
 1001 FORMAT (1X,I5,1X,A5,F11.4,2F9.5,2F12.5,2F10.5,F9.4,2F10.5,
     1 2F9.5)
 1002 FORMAT(A5,2I3,5F14.8)
 1005 FORMAT ('  ')
 1006 FORMAT (1X)
 1007 FORMAT (2X,A6,4X,'---',1X,'BETX(',I5,') =',F12.5,4X,'BETY(',
     1I5,') =',F12.5,5X,'XEQ(',I5,') =',F12.5,5X,'YEQ(',I5,
     2  ') =',F12.5)
C     Begin Courant's modified version
 1008 FORMAT (/
     1   2X,'CIRCUMFERENCE = ',F14.8,1X,'M',10X,'THETX = ',F12.8,
     2   1X,'RAD',6X,'NUX = ',F10.5,6X,'DNUX/(DP/P) = ',F10.5/
     3   9X,'RADIUS = ',F10.4,' M',11X,'THETY = ',F12.8,
     4   1X,'RAD',6X,'NUY = ',F10.5,6X,'DNUY/(DP/P) = ',F10.5)
C     End Courant's modified version
 1111 FORMAT (15X,'TGAM=(',F10.5,',',F10.5,')')
 1112 FORMAT (5X,'BETATRON FUNCTIONS',7X,'MAX BETX = ',F10.5,4X,'MAX XEQ
     1 = ',F10.5,4X,'NUX = ',F10.5/30X,'MAX BETY = ',F10.5,28X,'NUY = ',
     2  F10.5/30X,'TRANSITION GAMMA = (',F10.5,',',F10.5,')')
 1900 FORMAT (2X,'CHROMATICITIES FROM QUADRUPOLES EXPLICITLY APPEARING'
     1 ,' IN ',A5, ' --- DNUX/(DP/P) =',F10.4,3X,'DNUY/(DP/P) =',F10.4)
C     Begin Courant's version
 1020 FORMAT ('   Pos Name',t19,'S',t31,'phase',t39,'beta',t51,
     1  'alpha',T61,'Cpl_ang',T77,'eta',T87,'etap',
     2  t95,'orbit',T109,'slope')
 1021 FORMAT(i5,1x,a5,' X',t16,F11.6,t28,f8.5,t36,f12.6,
     1   t48,f10.5,t58,f12.7,t74,f9.4,t84,f7.4,
     2   t92,f13.7,t106,f10.6/
     3   t14,'Y',t29,f8.5,t37,f12.6,
     4   t49,f10.5,          t75,f9.4,t85,f7.4,
     5   t93,f13.7,t107,f10.6)
 1022 FORMAT(t18,       '(M)',t30,'2pi',t38,'(M)',
     1 t53,'_',T60,'(deg)',T76,'(M)',t86,'rd',
     2 t94,'(mm)',T108,'(mr)')
C     End Courant's version
 1025  FORMAT ('   (DS/S)/(DP/P)= ',F10.7)
 1026  FORMAT ('   (DS/S)/(DP/P)= ',F10.7,
     1          14X,'TGAM=(',F10.5,',',F10.5,')')
 1028  FORMAT (2X,'(DT/T)/(DP/P) = ',F10.5,14X,'T0 = ',E12.5, 'SEC',
     1  6X,'ETA =  1/TGAMSQ  -  1/GAMSQ   = ',F10.5)
 1029   FORMAT (/1X,'BETATRON FUNCTIONS THRU ',A5/)
C     Begin Courant's version
 1030  FORMAT (' ')
 1035  FORMAT (' BETATRON FUNCTIONS THRU ',A5)
C     End Courant's version
 1036  FORMAT (5X,12A5,47X,'PAGE ',I3/1X,
     1         'BETATRON FUNCTIONS THRU ',A5)
C     Begin Courant's version
 1040 FORMAT (6X,12A5,23X,A9,2X,A8,6X,'PAGE ',I3/1X,
     1   'BETATRON FUNCTIONS THRU ',A5,//
     2  3X,'POS',10X,'S(M) ',4X,'NUX',5X,'NUY',6X,'BETAX(M)',4X,
     3 'BETAY(M)',5X,'XEQ(M)',5X,'YEQ(M)',3X,A4,'(M)',3X,'ALPHAX',
     4 4X,'ALPHAY',5X,'DXEQ',4X,'DYEQ'/1X,131('-'))
C     End Courant's version
 1045 FORMAT (//2X,'SEXTUPOLE STRENGTHS -----  ' ,
     1  'KSF =',E15.8,4X,'KSD =',E15.8)
 1051 FORMAT(' MAXIMA',6X,'XCO(',I5,')=',F10.5,5X,'YCO(',I5,')=',F10.5/
     1       ' MINIMA',6X,'XCO(',I5,')=',F10.5,5X,'YCO(',I5,')=',F10.5)
 2000 FORMAT(1X,I4,1X,7F18.10)
 2001 FORMAT (1X,A5,1X,I10,1X,I1,1X,'*****')
 2005 FORMAT (1X,A9,1X,A8)
 2007 FORMAT (1X,A5,1X,A60)
 2050 FORMAT (1X,2A5,1P,6E13.5)
      END
