      SUBROUTINE DIFEQ(NN,V,DERI)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'ccc/binff.ccc'

      include 'ccc/cderiv.ccc'

      include 'ccc/trkint.ccc'

      include 'ccc/files.ccc'
      include 'ccc/const.ccc'

      DIMENSION V(7,1),W(28),DW(28)
      DIMENSION T(8,28)
      LOGICAL SWPR,OUT
      EXTERNAL DERI
      CHARACTER(5) NAMOP,NAMEL

C  INTEGRATE   FIRST ORDER DIFFERENTIAL EQUATIONS USING ZAM.
C  S=INDEPENDENT VARIABLE, GOES FROM 0 TO SMAX.
C  H0=MAXIMUM INTEGRATION STEP SIZE (WILL BE ADJUSTED TO BE AN INTGRAL
C  FRACTION OF SMAX).
C  NPR=NUMBER OF INTERVALS H0 BETWEEN PRINTING OF S,W.
C  W= DEPENDENT VARIABLE VECTOR, DW=DERIVATIVE VECTOR.
C  DERI IS THE NAME OF THE SUBROUTINE THAT CALCULATES DW(I).
C  ITS FORM IS --- SUBROUTINE DERI(S,W,DW)

      NDAT=INFF(4,NN)
      NF = INFF(15,NN)
      NAMEL = CINFF(2,NN)
      MN = MR*NR
      CALL GETFL(NN,1,NF,DAT)
      NAMOP = CINFF(1,NN)
      IF (NAMOP.NE.'DRF')  GO TO 1
      DAT2(2) = 0
      DAT2(3) = 1
      DAT2(4) = 0
 1    SMAX = DAT(1)
      H0 = DAT(6)
      IF (NAMOP.EQ.'ELQ')  CALL SETALF(NN)
      IF (MP2FLG.EQ.1)  H0 = DAT2(7)
      IF (H0.EQ.0)  H0 = .01D0

      DO 2 J=1,NR
       JV=NV(J)
       JM = MR*(J-1)
      DO 2 I=1,MR
 2      W(I+JM) = V(I,JV)

      JV1=NV(1)
      DP = V(6,JV1)

      S = 0
      ISTEP=0
      IOSTP=0
      TMP = .000001D0
      NSTP=INT(SMAX/H0+TMP)
      FTPFL = NSTP
      H=SMAX/FTPFL
      OUT=.FALSE.
      IF (NPR.GT.0) OUT=.TRUE.
C  NPR IS STEP PRINT FREQUENCY FROM CDERIV.CCC.  INPUT OF TRK.
C IF DPR(IN TRKINT.CCC) IS TRUE, DELETE PRINT. SET BY TRK.
C DO NOT WANT TO PRINT STEPS OF NEIGHBORING RAYS.
      IF (DPR) OUT=.TRUE.
      IFLAG=-IFLAG
      UZ = 0
      CALL DERI(S,W,DW)
      W(2) = W(2) + UZ
      IFLAG = -IFLAG
      CALL ZAM0(MN,S,DERI,W,DW,T,H)

      IF (.NOT.OUT)  GO TO 3
      WRITE (OUT3,103)
      WRITE(OUT3,101) ISTEP,S, (W(I),I=1,MN)
 3    CALL ZAM(S,DERI,W,DW,T,SWPR)
       ISTEP=ISTEP+1
      IF (SWPR)  GO TO 4
       GO TO 5

 4    IF (.NOT.OUT)  GO TO 5
      IOSTP=IOSTP+1
      IF (IOSTP.LT.NPR)  GO TO 5
      WRITE(OUT3,101) ISTEP,S, (W(I),I=1,MN)
      IOSTEP=0

 5    CONTINUE
      TMP = 1.D-10
      IF (S.LT.SMAX-TMP)  GO TO 3
      W(2) = W(2) - UZ
      IF (.NOT.OUT)  GO TO 7
C PRINT LAST STEP UNLESS IT HAS ALREADY BEEN PRINTED
      IF (IOSTEP.NE.0) WRITE(OUT3,101) ISTEP,S, (W(I),I=1,MN)
      WRITE (OUT3,103)
 7      DO 6 J=1,NR
       JV=NV(J)
       JM = MR*(J-1)
       DO 6 I=1,MR
 6      V(I,JV) = W(I+JM)

      RETURN
 101  FORMAT(14X,I5,7X,F10.4,9(1X,F12.8))
C 102  FORMAT (5X,A5,5X,I5,10F11.6/(20X,10F11.6))
 104  FORMAT (5X,A5,4X,I5,7X,F10.4,9(1X,F12.8))
 103  FORMAT (1X)
      END
