      SUBROUTINE DRIFT(M,EL)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C  SETS UP DRIFT SPACE MATRICES RX AND RY,DIMENSIONED (2,3)  RY=RX
C  THERE ARE 3 WAYS TO DEFINE DRIFTS ---

C -STANDARD METHOD, EXAMPLES ---
C 2--- 8--- -15 -19 21---*----31---*----41---*----51---*----61---*----71
C D4   DRF          3.85
C------------------------------------------------------------------------
C LD4  =            3.85
C D4   DRF          LD4
C------------------------------------------------------------------------
C  D4 IS THE NAME OF A DRIFT OF LENGTH 3.85

C -METHOD 2, CREATE A SET OF DRIFTS ---
C 2--- 8--- -15 -19 21---*----31---*----41---*----51---*----61---*----71
C L    VEC          .54       2.14      3.85      22.67     25.
C D    DRF          L
C-------------------------------------------------------------------------
C  5 DRIFTS ARE CREATED. D1,D2,D3,D4,D5 OF LENGTHS = .54, 2.14, ---25.

C -METHOD 3 IS USED TO ADJUST THE LENGTH OF THE DRIFT TO MAINTAIN THE
C  SUM OF A SET OF DRIFTS AND/OR MAGNETS AT CONSTANT LENGTH.
C 2--- 8--- -15 -19 21---*----31---*----41---*----51---*----61---*----71
C DDD  DRF       KB LDDD      LTOT      D1   D2   ---  DKB
C------------------------------------------------------------------------
C  IF LTOT .NE. 0, LDDD IS ADJUSTED TO MAKE LDDD+LD1+...+LDKB = LTOT
C  IF LTOT .EQ. 0, LTOT IS STORED AS LTOT = LDDD+LD1+...+LDKB
C  ON SUBSEQUENT CALLS, LDDD WILL BE ADJUSTED TO MAINTIAN CONSTANT LTOT.

      DIMENSION RX(2,3),RY(2,3),RW(3)
      EQUIVALENCE (RX(1,1), RY(1,1))
      DATA RW(2),RW(3)/2*0.0/
C  SETS UP DRIFT SPACE MATRICES RX AND RY,DIMENSIONED (2,3)  RY=RX
      DO 1 I=1,2
      DO 1 J=1,3
      RX(I,J)=0
 1    CONTINUE
      RX(1,1)=1
      RX(1,2)=EL
      RX(2,2)=1
      RW(1) = EL
      CALL STXY(M,RX,RY,RW)
      RETURN
      END
