      SUBROUTINE FITT(MSR,MC,MV1,IV1,PHI,KA,KB)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C      FITTING ROUTINE CALLED BY FITQ, FITB, FITR, FITV

C   FITS   FITQ  --PHASE ADVANCE OVER 2PI
C          FITB --BETATRON FUNCTIONS WHOSE INDECES ARE KA AND KB.
C          FITR --MATRIX ELEMENTS INDEXED BY KA AND KB.
C          FITV --VECTOR ELEMENTS INDEXED BY KA AND KB.

C  INPUT --  NAME   FITX    KA  KB  SUB  C QF  QD  I1  I2  A1  A2  DEL
C                  WHERE FITX MAY BE FITQ, FITB,FITR,FITV
C                  SUB IS NAME OF SUBROUTINE TO EXECUTE.
C     VARY THE I1-TH PARAMETER OF QF AND I2-TH OF QD, COMPUTE C,
C  COMPARE THE RESULTS ACCORDING TO X OF FIT INSTRUCTION (PHASE ADVANCE
C  OR BETATRON FUNCTIONS IF FITQ OR FITB.  MATRIX ELEMENTS OR VECTORS
C  NAMED IN KA AND KB IF FITR OR FITV.) WITH A1 AND A2.
C       ITERATE UNTIL THEY MATCH (WITHIN DEL), BUT NOT MORE THAN 100 TIMES.
C  IF KB IS NEGATIVE, ONLY FIT TO A1 VALUE, USING FIRST VARIABLE ONLY

      include 'ccc/files.ccc'

      include 'ccc/grr.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/const.ccc'

      include 'ccc/swtch.ccc'

      DIMENSION H(2),D(2),A(2,2),B(2,2),RX(2,3),RY(2,3),S(2),PHI(3)
      DIMENSION MV1(2),IV1(6),V(2),U(2),W(2),VAR(2),FC(2),F(2),G(2)
      DIMENSION RW(3),TW(49)
      DIMENSION VC(7),BXBY(20)
      DIMENSION Q(2)
      INTEGER P1,P2
      CHARACTER(5) MV1
      LOGICAL SINGL
C
C  FIT ONE FUNCTION WITH ONE VARIABLE IF KB NEGATIVE
      SINGL=.FALSE.
      IF(KB.GE.0) GO TO 99
      SINGL=.TRUE.
      KB=KA
      MV1(2)=MV1(1)
      IV1(2)=IV1(1)
      PHI(2)=PHI(1)
 99   CONTINUE
      Q(1) = PHI(1)
      Q(2) = PHI(2)
      DEL  = PHI(3)
      IF (DEL.NE.0) GOTO 98
      IF(QSW) DEL=1.0D-6
      IF(.NOT.QSW) DEL=1.0D-8
 98   HSTEP = .01D0
      XLAM = .9D0
C  RESET PARAMETERS IF INPUT
      IF (RSW) THEN
         I1 =IV1(3)
         I2 =IV1(4)
         J1 =IV1(5)
         J2 =IV1(6)
         KK1 = 7*(I2-1) + I1
         KK2 = 7*(J2-1) + J1

C        CALL PRSINT(KA,I1,I2,I3)
C        CALL PRSINT(KB,J1,J2,J3)
C  THE   NEXT COMMENTED STATEMENTS NEED STUDY--FOR FITR,FITV
C        K1 = I1*6 + (I3-1) *2 +I2
C        K2 = J1*6 +(J3-1)*2 + J2
      ENDIF
      K1 = KA
      K2 = KB
      M1 = JELNUM(MV1(1))
      M2 = JELNUM(MV1(2))
      P1 = IV1(1)
      P2 = IV1(2)
C  LOOK UP INPUT GUESS FOR VARIABLES
      VAR(1) = FLDAT(M1,P1)
      VAR(2) = FLDAT(M2,P2)
C  SAVE ORIGINAL INPUT VARIABLES
      VR1=VAR(1)
      VR2=VAR(2)
      IF (QSW) THEN
C  FIT    Q CASE
C         TMP = 10.
C         PHI(1) = COS(PI2 * PHI(1)) + SIGN(TMP,SIN(PI2 * PHI(1)))
C         PHI(2) = COS(PI2 * PHI(2)) + SIGN(TMP,SIN(PI2 * PHI(2)))
C 9/29   /88:
         PHI(1) = COS(PI2 * PHI(1)) 
         PHI(2) = COS(PI2 * PHI(2)) 
      ENDIF
      K=0
C  SET MAXIMUM ITERATIONS
      KI = 100
 75   DO 100 I=1,2
      U(I)=VAR(I)
      V(I)=VAR(I)
 100  W(I)=VAR(I)
      V(1) = V(1) + HSTEP
      IF(SINGL) V(2)=V(1)
      W(2) = W(2) + HSTEP
      DO 115 I=1,3
      IF (I.EQ.1) THEN
         VC1 = V(1)
         VC2 = V(2)
      ELSE IF (I.EQ.2) THEN
         VC1 = W(1)
         VC2 = W(2)
      ELSE IF (I.EQ.3) THEN
         VC1 = U(1)
         VC2 = U(2)
      ENDIF
 104  CALL STOFL(M1,P1,1,VC1)
      CALL STOFL(M2,P2,1,VC2)
      CALL DOIT(MSR)
      IF (ERROR) RETURN
      IF(BSW) GO TO 105
      IF (VSW) GO TO 110
      IF (RSW) GO TO 112
C  FITQ
       CALL RXY(MC,RX,RY,RW)
C      TMP = 10.
C      FC(1) = (RX(1,1) + RX(2,2)) * .5 + SIGN(TMP,RX(1,2))
C      FC(2) = (RY(1,1) + RY(2,2)) * .5 + SIGN(TMP,RY(1,2))
C 9/29/88:
      FC(1) = (RX(1,1) + RX(2,2))/2
      FC(2) = (RY(1,1) + RY(2,2))/2
      GO TO 106
 105  CALL BET(MC,BXBY(1),BXBY(11),0)
      BXBY(1)=BXBY(1)/TPI
      BXBY(11)=BXBY(11)/TPI
      FC(1)=BXBY(K1)
      FC(2) = BXBY(K2)
      GO TO 106
 110  CALL GETQ(MC,1,7,VC)
      FC(1) = VC(K1)
      FC(2)=VC(K2)
      GO TO 106
 112  CALL RTRV7(MC,TW,RW)
      FC(1)=TW(KK1)
      FC(2)=TW(KK2)
 106  IF (I.EQ.1) THEN
         G(1) = FC(1)
         G(2) = FC(2)
      ELSE IF (I.EQ.2) THEN
         H(1) = FC(1)
         H(2) = FC(2)
      ELSE IF (I.EQ.3) THEN
         F(1) = FC(1)
         F(2) = FC(2)
      ENDIF
 115  CONTINUE
      D(1) = PHI(1) - F(1)
      D(2) = PHI(2) - F(2)
      IF(SINGL) THEN
        IF (ABS(D(1)).LE.DEL) GO TO 120
       ELSE         
        IF (ABS(D(1)).LE.DEL.AND.ABS(D(2)).LE.DEL) GO TO 120
       ENDIF
C  FIT NOT CLOSE ENOUGH.  ITERATE AGAIN UNLES LIMIT HAS BEEN REACHED
      K = K + 1
      IF (K.EQ.KI) GO TO 125
C  SET UP NEXT GUESS
      HD = 1/HSTEP
      A(1,1) = (G(1) - F(1))*HD
      A(1,2) = (H(1) - F(1))*HD
      A(2,1) = (G(2) - F(2))*HD
      A(2,2) = (H(2) - F(2))*HD
      IF(SINGL) GO TO 999
      DET = (A(1,1)*A(2,2)) - (A(1,2) * A(2,1))
      IF (DET.EQ.0) THEN
         WRITE (OUT3,500)K,VAR 
   
 500  FORMAT (2X,'****** DETERMINANT IS ZERO  ***'/
     1    10X,'ITERATION = ',I5, 2X, 'VARIABLES = ',2(1X,F12.5)/
     2    10X,' MATRIX ELEMENTS ARE ')
      IF (BEND.EQ.0) THEN
         WRITE (OUT3,12) (RX(1,J),J=1,3),(RY(1,J),J=1,3)
         WRITE (OUT3,13) (RX(2,J),J=1,3),(RY(2,J),J=1,3)
       ELSE
         WRITE (OUT3,22) (RX(1,J),J=1,3),(RY(1,J),J=1,2)
         WRITE (OUT3,23) (RX(2,J),J=1,3),(RY(2,J),J=1,2)
       ENDIF
         WRITE (OUT3,24) A(1,1),A(2,2),A(1,2),A(2,1)
 24   FORMAT (2X,'DETERMINANT ELEMENTS ARE ',4(2X,F12.5))
 12   FORMAT (27X,3F13.8,8X,3F13.8)
 13   FORMAT (10X,5X,12X,3F13.8,8X,3F13.8/30X,'0.',11X,'0.',11X,'1.',
     1 19X ,'0.',11X,'0.',11X,'1.'/)
 22   FORMAT (27X,2F13.8,3X,'0.',8X,F13.8,3X,2F13.8)
 23   FORMAT (10X,5X,12X,2F13.8,3X,'0.',8X,F13.8,3X,2F13.8)
     
         STOP
       ENDIF
      B(1,1) = A(2,2)/DET
      B(1,2) = -A(1,2)/DET
      B(2,1) = -A(2,1) /DET
      B(2,2) = A(1,1) /DET
      S(1) = B(1,1)*D(1) + B(1,2)*D(2)
      S(2)=B(2,1)*D(1) + B(2,2) *D(2)
      VAR(1) = VAR(1) + (S(1)*XLAM)
      VAR(2) = VAR(2) + (S(2)*XLAM)
      GO TO 75
 999  VAR(1)=VAR(1)+XLAM*D(1)/A(1,1)
      VAR(2)=VAR(1)
      GO TO 75

C  FIT SATISFIED.  LEAVE NEW VARIABLES IN STORAGE
 120  IF (SINGL) THEN
          WRITE (OUT3,5) P1,MV1(1),VAR(1)
        ELSE
          WRITE (OUT3,1) P1,MV1(1),VAR(1),P2,MV1(2),VAR(2)
        ENDIF
C  SET CORRESPONDING SYMBOLIC FLOATING POINT TO BLANK
       CALL STOSF(M1,P1,1,IBLNK)
       IF (.NOT.SINGL) CALL STOSF(M2,P2,1,IBLNK)
      RETURN
 1    FORMAT (//' PARAMETER REPLACEMENTS MADE BY FITTING'/5X,I5,1X,
     1' OF ',A5,' = ',F20.12,10X,I5,1X,' OF ',A5,' = ',F20.12)
 5    FORMAT (//' PARAMETER REPLACEMENTS MADE BY FITTING'/5X,I5,1X,
     1' OF ',A5,' = ',F20.12)

C   ITERATION LIMIT REACHED.  FIT FAILED.
 125  WRITE (OUT3,7) K,VAR
      GO TO 135
  7    FORMAT (' NUMBER OF ITERATIONS REACHED LIMIT OF ',I5/'  CURRENT',
     1 'VARIABLES ARE VAR1 = ',F14.8,' VAR2 = ',F14.8/5X,'ORIGINAL ',
     2  'VARIABLES RESTORED.' )
C  RESTORE OLD VALUES
 135  CALL STOFL(M1,P1,1,VR1)
      IF (.NOT.SINGL) CALL STOFL(M2,P2,1,VR2)
C  SET CORRESPONDING SYMBOLIC FLOATING POINT TO BLANK
      CALL STOSF(M1,P1,1,IBLNK)
      IF (.NOT.SINGL) CALL STOSF(M2,P2,1,IBLNK)

C   IF FITQ, TRY OTHER FIT ROUTINE
C      IF (QSW) CALL FITE(MSR,MC,MV1,IV1,Q,KA,KB)
      RETURN
      END
