      SUBROUTINE FIXPAR(I2,KODE,ILAX)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        REMOVES PARAMETER I2 FROM THE INTERNAL (VARIABLE) PARAMETER
CC        LIST, AND ARRANGES THE REST OF THE LIST TO FILL THE HOLE.
CC        IF KODE=0, I2 IS AN EXTERNAL NUMBER, OTHERWISE INTERNAL.
CC        ILAX IS RETURNED AS THE EXTERNAL NUMBER OF THE PARAMETER.
CC
      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/fix.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/sfile.ccc'

      DIMENSION YY(15), V1(2)
      EQUIVALENCE (V(1,1) , V1(1))

      IF (KODE.LT.0) GOTO 250
      IF (KODE.GT.0) GOTO 150
C                                        . EXT PARAM NO. SPECIFIED
      I = I2
      IF (I .GT. NU)  GO TO 70
      IF (I .LT. 1)  GO TO 70
   60 IF (LCORSP(I).GT.0)  GOTO 80
C                               ERROR RETURN   PARAM ALREADY FIXED
   70 ILAX = 0
      WRITE (SVOUT,500)  I
      GO TO 300
   80 LC = LCORSP(I)
      IT = LC
      LCORSP(I) = 0
      ILAX = I
      NPAR = NPAR - 1
      NPFIX = NPFIX + 1
      IPFIX(NPFIX) = I
      XS(NPFIX) = X(LC)
      XTS(NPFIX) = XT(LC)
      EPS = ABS(DIRIN(LC)) * 10
      IF (ISW(2) .GE. 1)  EPS = EPS + SQRT(ABS(V(LC,LC))*UP)
      TMP  = 1.D-10
      TMP1 = 1.D-8
      IF (EPS .LT. TMP*ABS(X(LC)))  EPS = TMP1*X(LC)
      TMP = .1D0
      WTS(NPFIX) = EPS*TMP
      DO 100  IK= I, NU
      IF (LCORSP(IK).LE.0)  GOTO 100
      LC = LCORSP(IK) - 1
      LCORSP(IK) = LC
      X(LC) = X(LC+1)
      XT(LC) = XT(LC+1)
      DIRIN(LC) = DIRIN(LC+1)
  100 CONTINUE
      IF (ISW(2) .GT. 1)  GO TO 250
      ISW(2) = 0
      GO TO 300
C                                        . INT PARAM NO. SPECIFIED
  150 CONTINUE
      DO 200  IQ= 1, NU
      IF (LCORSP(IQ) .NE. I2)  GO TO 200
      I = IQ
      GO TO 60
  200 CONTINUE
      GO TO 70
C         REMOVE ONE ROW AND ONE COLUMN FROM VARIANCE MATRIX
  250 KON = 0
      IF (NPAR .LE. 0)  GO TO 300
      KON2 = 0
      MPAR = NPAR + 1
      DO 260 I= 1, MPAR
  260 YY(I)=V(I,IT)
      DO 294 I= 1, MPAR
      IF (I.EQ.IT)  GO TO 294
      KON2 = KON2 + 1
      DO 292 J= 1, MPAR
      IF (J .EQ. IT)  GO TO 292
      KON = KON + 1
      V1(KON)=V(J,I) - YY(J)*YY(I)/YY(IT)
  292 CONTINUE
      KON = MAXINT*KON2
  294 CONTINUE
C         CHECK FOR WELL-BEHAVED FINAL MATRIX
      DO 295 I= 1, NPAR
      IF (V(I,I) .LE. 0)  GO TO 296
      DO 295 J= 1, NPAR
      IF (I .EQ. J)  GO TO 295
      IF (V(I,J)**2 .GE. V(I,I)*V(J,J))  V(I,J) = 0
  295 CONTINUE
      GO TO 300
  296 ISW(2) = 0
      WRITE (SVOUT, 501)
  300 RETURN
  500 FORMAT (  '0ERROR IN FIXPAR.  PARAMETER',I3,
     1  ' WAS NOT VARIABLE.'/)
  501 FORMAT (  '0COVARIANCE MATRIX WAS ILL-CONDITIONED ',
     1    ' AND HAS BEEN DESTROYED BY FIXPAR.'/)
      END
