      SUBROUTINE FXPT(M)


      IMPLICIT NONE

C  WRITES INTEGER WORD IA INTO INFF(J,M)
C  EQUILIBRIUM ORBITS UNDER LINEAR AND/OR ARBITRARY EXTERNAL TRANSFOR-
C  MATIONS, LINEARIZED 4X4 MATRIX NEAR FIXED POINT (M4), EIGENVALUES
C  AND EIGENVECTORS OF M4, ETC.
C
C  S   FXPT  KA  KB//P   BLIN/NSTR ISAV/ITERS IFLAG/ITAPE
C                   /E1       E2        D1        D2        D3

C      KA = OUTPUT OPTION ---
C      KA = 0   MATRIX,EIGENVALUES,CLOSED ORBIT,ETA-ORBIT AT POSITION 0
C      KA = 1   OPTION 0 AND EIGENVECTORS AT POSITION 0
C      KA = 2   OPTION 1 AND TRACK VCO, ETA
C      KA = 3   OPTION 1 AND TRACK EIGENVECTORS
C      KA = 4   OPTIONS 2 AND 3 TOGETHER
C       IF KA  IS NEGATIVE, PRINT OF ORBITS IS SUPPRESSED
C       AT ALL POSITIONS EXCEPT THOSE OF ELEMENTS WHOSE
C       FIRST CHARACTER IS  # or whatever was specified by PCYC

C      KB = NUMBER OF SUPERPERIODS
C       P  = PREV. DEF. PART. WHOSE INPUT CONTAINS INITIAL REF. RAY
C              X   DX   Y   DY   DS   DP/P   1.
C      BLIN = BEAM LINE DEFINED BY BML INSTRUCTION
C      IF KB IS NEGATIVE, THEN
C       THE REFLECTION OF BLIN IS ADDED TO BLIN TO FORM COMPLETE SP.
C       THIS FEATURE WILL NOT WORK IF  NSTR .GT. 1

C    NSTR = NUMBER OF SUPERPERIODS FOR FIXED POINT ORBIT TO CLOSE
C      ISAV = 0,1 --- DONT SAVE, SAVE CALCULATED EQ.ORBIT IN P
C  ITERS = MAXIMUM NUMBER OF ITERATIONS
C  IFLAG = 0     CLOSED ORBIT RAY ONLY
C  IFLAG = 1    PLUS 9 NEIGHBORING RAYS.
C  IFLAG = 2   PLUS 4 RAYS OF LINEARIZED EQUATIONS.

C  IFLAG = 3   PLUS 4 RAYS OF LINEARIZED EQUATIONS,
C              FIRST FOR THE ENVELOPE AND SECOND FOR THE IONS OF A BEAM.
C  ITAPE = 0,1,2 DO NOT, DO, DO WRITE ETA & CLOSED ORBITS ON ORB1
C    (for use by orbit correction program MICADO)
C    if itape=1 reset correctors to 0; itape=2 - keep correctors
C    to enable further correction in another iteration of MICADO
C      E1, E2 = CONVERGENCE CRITERIA FOR DISPLACEMENTS, SLOPES
C               D1,D2 =  DISP. FROM REF. RAY OF NEIGHBOR  RAYS FOR
C                        CALCULATING M4.
C      D3 = DISP IN DP/P FOR CALCULATING LINEARIZED 3XO MATRICES
C                  OUT = OUTPUT OPTION IN BCD

C  IF D1=0, NEIGHBORING RAYS NOT CALCULATED, LINEARIZATION WITH REVMAT.
C  IF OUT IS BLANK, EIGENVECTORS NOT CALCULATED, NO TRACKING.
C  IF OUT = 4HETRK, EIGENVECTOR ORBITS ARE TRACKED.
C  LINEARIZED 7X7 MATRIX STORED AT LQ+KADD OF FXPT INSTRUCTION
C  LINEARIZED 4X4 MATRIX STORED AT LQ+KADD+53
C  EIGENVALUES  STORED AT  AT LQ3, EIGENVECTORS AT LQ3+8
C  LQ2 = LQ++KADD+49+16,  LQ3 = LQ2+7,  KADD = 3.  KIND IS 2HR7

      include 'ccc/binff.ccc'

      include 'ccc/bmi1.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/const.ccc'

      include 'ccc/files.ccc'

      include 'ccc/corb.ccc'

      include 'ccc/cderiv.ccc'

      include 'ccc/mh.ccc'
 
      include 'ccc/seed.ccc'

      INTEGER M
      EQUIVALENCE (MI,MI1),(NELS,NELS1)
C  NOTE (89/01/31): Declared names CABS, CSQRT have been removed from the
C     following declaration list. They should not be declared unless you
C     are defining the routines yourself.
      COMPLEX(KIND(0D0)) CTR,CSQ,LAM(4),BLAM(4),CM(3,3),X(4,4),EX1,EX3
      DOUBLE PRECISION C1,C3
      DOUBLE PRECISION D,DELP,DELT,DELW,DLRLA,DLRLB,DN,DX,DY
      DOUBLE PRECISION EPST,EPSW
      DOUBLE PRECISION FAC
      INTEGER I,IBET,II,IOP,IQ,ISTR,ITAPE,ITERS,IVSV,IWR
      INTEGER J,JP,JQ
      INTEGER K,KA,KB
      INTEGER L
      INTEGER MB,MBML,ME,ML1,ML2,MM,MN,MT
      INTEGER N,NDAT,NELS,NGO,NITP,NITS,NL,NLF,NP,NRN,NRS,NSTR
      DOUBLE PRECISION RHO1,RHO3,RT
      INTEGER SPER
      DOUBLE PRECISION TRX,TRY,TX,TY
      DOUBLE PRECISION C(4),E(4),EMOD(4,2),EPHI(4,2),F(7)
      INTEGER MI(MI1SIZ)
      DOUBLE PRECISION MU(4)
      DOUBLE PRECISION P(5)
      DOUBLE PRECISION Q(4)
      DOUBLE PRECISION R7(7,7),RM(4,4),RMI(4,5),RW(3),RX(2,3)
      DOUBLE PRECISION V(7,16),VP(7),VV(7),VW(112),VZ(7,7)
      EXTERNAL FLDAT,IDAT,MDAT
      DOUBLE PRECISION FLDAT
      INTEGER IDAT,MDAT
      EQUIVALENCE (V(1,1),VW(1)),(VV(1),VW(78)),(VZ(1,1),VW(85))
      LOGICAL ITERSW
      INTEGER TRKR,R5J
      CHARACTER(5) NPM,NAM,CKIND,MATL
      CHARACTER(8) LABELA(4),LABELB(4),LBL(6)
      DATA RW /3*0.0D0/
c     DATA NV/1,2,3,4,5,6*0/
      DATA LABELA /'0X...',' ','0Y...',' '/
      DATA LABELB /'LMD1','1/LMD1','LMD3','1/LMD3'/
      DATA LBL /'REAL(X1)','IMAG(X1)','REAL(X3)','IMAG(X3)',
     2              'EQ ORBIT','ET ORBIT'/
C
      NRN = NRZZ
      IIH = 1
      IIV = 1

      VP(5)=0
      VP(6)=1
      VP(7)=0
      KA = INFF(4,M)
      KA = IABS(KA)
      KB = INFF(5,M)
      SPER = IABS(KB)
      IF (KB.EQ.0) SPER = 1
      NSTR = IDAT(M,1)
      IF (NSTR.EQ.0) NSTR=1
      IVSV = IDAT(M,2)
      ITERS=IDAT(M,3)
      IFLAG = IDAT(M,4)
      ITAPE = IDAT(M,5)
C  EDC 1/21/93 RESET CORRECTORS TO ZERO IF MICADO IS TO BE INVOKED
C  for the first iteration
      IF (ITAPE.eq.1) THEN
        DO 444 I = 1,JC
        TH(I) = 0
  444   TV(I) = 0
       ENDIF
C  RETRIEVE FLOATING POINT INPUT E1,E2,D1,D2
      CALL GETFL(M,1,5,P)
      EPSW = P(1)
      EPST = P(2)
      DELW = P(3)
      DELT = P(4)
      DELP = P(5)
      IF (EPSW.EQ.0) EPSW=1.D-08
      IF (EPST.EQ.0) EPST=1.D-08
      IF (DELP.EQ.0) DELP=1.D-08
      NGO = 2
      IF (IFLAG.EQ.0) GO TO 2
      NGO=1
      IF (DELW.EQ.0)  DELW=1.D-08
      IF (DELT.EQ.0)  DELT=1.D-08
 2    MLFX(1)=M7END-3
      MLFX(2)=M7END-4
C      WRITE (3,5020) IFLAG,NGO
 5020 FORMAT (5X,'IFLAG,NGO',2X,2I7)

C  SET UP BEAM SYSTEM ARRAY MI
      MBML = MDAT(M,2)
      NDAT = INFF(17,MBML)
      CALL MIFILL(MBML,1,NDAT,NELS,MI,MI1SIZ)
      IF (ERROR) RETURN
C  OPTIONS ON ITERATIONS AND PRINT
C  SET UP ARRAY FOR PREVIOUSLY DEFINED PARTICLE
C  SET UP INITIAL REFERENCE RAY
C  ZERO VW ARRAY
      DO 3 I=1,112
      VW(I) = 0
 3    CONTINUE
      NP = MDAT(M,1)
      CALL GETFL(NP,1,7,VW)
      NV(1) = 1
 33   MB=1
      ME = NELS
      NITS = 0
      IF( ITERS.EQ.0 )ITERS = 25
      ITERSW = .FALSE.
C
      E(1) = EPSW
      E(2) = EPST
      E(3) = EPSW
      E(4) = EPST
      F(1) = DELW
      F(2) = DELT
      F(3) = DELW
      F(4) = DELT
      CALL HED
      NPM = CINFF(2,NP)
      NAM = CINFF(2,M)
      WRITE(OUT3,1018)
      WRITE(OUT3,1000) NAM,NPM,(VW(I),I=1,7)
      MM = 1
      IOP = IFLAG
      IF (NGO.EQ.1) GOTO 31
 32   MN = 1
 391  CALL RTRV7(MUNIT,R7,RW)
      CALL STOR7(M,R7,RW)
C      WRITE (3,5050) R7
 5050 FORMAT (5X,'MUNIT MATRIX',/5X,7F15.8)
      GO TO 4
 31   MN=9
      MR = 4
      NR = 1
      NRS = 1
      IF (IFLAG.EQ.1)  GO TO 800
      NR=5
      MN=1
      GO TO 802
 39   IF (IFLAG.NE.1) GO TO 802
      GO TO 800
C  SAVE INITIAL CONDITIONS OF THE REFERENCE RAY.
 4    DO 5  I=1,7
    5 VV(I) = VW(I)
      IF (IFLAG.EQ.4)  CALL GETQQ(M,7,1,7,V(1,8))
C  TRACK PARTICLES MM TO MN THROUGH BEAMLINE ELEMENTS MB TO ME.
      TRKR = 6
      ISTR = 1
 1    CONTINUE
      NRZZ = NRN
      GO TO 900
 510  CONTINUE
      ISTR = ISTR + 1
      IF (ISTR .LE. NSTR) GO TO 1
      IF (NGO.EQ.2) GOTO 52
C CALCULATE THE 4X4 MATRIX, M.
 51   IF (IFLAG.EQ.1) GO TO 511
      DO 512 J=1,4
      DO 512 I=1,4
 512  RM(I,J) = V(I,J+1)
      GO TO 513
 511  DO 55 J = 1 , 4
      N = J + 1
      DN=1/(2*F(J))
      DO 55 I=1,4
 55   RM(I,J) = ( V(I,N) - V(I,N+4) ) * DN
 513  IF (KB.GE.0)  GO TO 56
      RX(1,1) = RM(2,1)
      RX(2,1) = RM(4,1)
      RX(1,2) = RM(2,3)
      RX(2,2) = RM(4,3)
      RX(1,3) = -V(2,1)
      RX(2,3) = -V(4,1)
      GO TO 56
 52   CALL RTRV7(M,R7,RW)
C      WRITE (3,5051) R7
 5051 FORMAT (5X,'M MATRIX AT #52'/5X,7F15.8)
      IF (KB.GE.0) GO TO 57
      RX(1,1)=R7(2,1)
      RX(2,1)=R7(4,1)
      RX(1,2)=R7(2,3)
      RX(2,2)=R7(4,3)
      RX(1,3)=- V(2,1)
      RX(2,3)= -V(4,1)
 57   DO 53 J=1,4
      DO 53 I=1,4
 53   RM(I,J) = R7(I,J)
 56   CONTINUE
      IF (KB.GE.0) GO TO 58
C      WRITE (3,5000) RX
 5000 FORMAT (5X,'BEFORE MXDIV--RX'/2X,6F15.8)
      CALL MXDIV(RX,2,1,D,2)
C      WRITE (3,5025) D,RX
 5025 FORMAT (5X,'AFTER MXDIV --D',2X,F15.8 / 5X,'RX',2X,5F15.8)
      V(1,1)=RX(1,3)+VV(1)
      V(3,1)=RX(2,3)+VV(3)
      DX=V(2,1)
      DY=V(4,1)
      V(2,1)=0
      V(4,1)=0
      NITS = NITS + 1
      IF ( (ABS(DX).LT.E(2)).AND.(ABS(DY).LT.E(2)) ) GO TO 146
C      WRITE (3,5001) DX,DY,E(2)
 5001 FORMAT (5X,'CONVERGENCE CRITERIA '/
     1        5X,'DX,DY,E(2)',2X,3F15.8)
      IF (NITS.GT.ITERS) GO TO 146
      IF (NGO.EQ.1) GOTO 39
      IF (NGO.EQ.2) GOTO 391
 146  IF (NITS.GT.ITERS) ITERSW = .TRUE.
      IF (ITERSW) STOP
      IF (NGO.EQ.1) GOTO 141
      IF (NGO.EQ.2) GOTO 142
 58   CONTINUE
C  SET UP N - I AND REF RAY JUMP (RHS).
      DO 7 I = 1, 4
      DO 6 J = 1,4
    6 RMI(I,J) = RM(I,J)
    7 RMI(I,I) = RMI(I,I) - 1
      DO 61 I=1,4
 61   RMI(I,5) = VV(I)-V(I,1)
C  SOLVE FOR EQ.-ORBIT-INITIAL CONDITIONS ( IN TERMS OF REF. RAY ).
C      WRITE (3,5026) D,RMI
 5026 FORMAT (5X,'BEFORE MXDIV--D',2X,F15.8/5X,'RMI',2X,5F15.8)
      CALL MXDIV( RMI, 4, 1, D, 4 )
C      WRITE (3,5027) D,RMI
 5027 FORMAT (5X,'AFTER MXDIV--D',2X,F15.8/5X,'RMI',2X,5F15.8)
      IF( D.NE.0 ) GO TO 75
      WRITE(OUT3, 1006 )
      WRITE (OUT3,1001) ((RM(I,J),J=1,4),I=1,4)
 1001 FORMAT (/10X,4F16.8)
      CALL HED
      RETURN
C  CALCULATE EQ.-ORBIT-INITIAL-CONDITIONS.
 75   DO 8 I=1,4
 8    V(I,1) = RMI(I,5) + VV(I)
C  CHECK FOR CONVERGENCE.
      NITS = NITS + 1
      IF (KA.LT.2) GO TO 14
      WRITE (OUT3,1013) NITS,(V(I,1),I=1,4)
 14   CONTINUE
      DO 9 I = 1, 4
      IF( ABS( RMI(I,5) ).LT.E(I) ) GO TO 9
      IF (NITS.GT.ITERS) GO TO 9
      IF (NGO.EQ.1) GOTO 39
      IF (NGO.EQ.2) GOTO 391
 9    CONTINUE
      IF (NGO.EQ.2) GOTO 142
 141   CALL RTRV7(MUNIT,R7,RW)
      IOP = 1
      DO  200 J=1,4
      DO  200 I=1,4
 200  R7(I,J)=RM(I,J)
      MM = 10
      MN = 11
      NR=1
      IF (IFLAG.EQ.1) GO TO 138
      IF (IFLAG.EQ.4) GO TO 142
      MM = 6
      MN = 7
 138  DO 143 I=1,7
      V(I,MM) = VW(I)
 143  V(I,MN) = VW(I)
      V(6,MM) = VW(6) + DELP
      V(6,MN) = VW(6) - DELP
      TRKR = 5
      GO TO 900
 144  DO 145 I=1,5
 145  R7(I,6) = (V(I,MM)-V(I,MN))/(2*DELP)
      R5J = 1
      GO TO 805
 142  IOP = IFLAG
      CALL ROW5(R7)
      IF (KB.GE.0) GO TO 149
      ML1=MLFX(1)
      ML2=MLFX(2)
      CALL STOR7(ML1,R7,RW)
      CALL REF(ML2,ML1)
      CALL MMM(ML1,2,MLFX)
      CALL RTRV7(ML1,R7,RW)
      DO 139 J=1,4
      DO 139 I=1,4
 139  RM(I,J) = R7(I,J)
 149  IF(NGO.EQ.2) GO TO 1400
      DO 151 I=1,7
 151  VV(I) = VW(I)
      CALL MXV7(R7,VV,VV)
      DO 152 I=1,5
 152  R7(I,7) = VW(I) - VV(I)
 1400 CONTINUE
      ML1 = MLFX(1)
      CALL STOR7(ML1,R7,RW)
C  CALCULATE OFF-MOMENTUM ORBIT VP AND STORE AT LQ3
 140  DO 148 I=1,4
      RMI(I,5)=-R7(I,6)
      DO 147 J=1,4
 147  RMI(I,J)=R7(I,J)
 148  RMI(I,I)=RMI(I,I)-1
      CALL MXDIV(RMI,4,1,D,4)
CC      WRITE (3,5026) D,RMI
      DO 150 I=1,4
 150  VP(I)=RMI(I,5)
      CALL STOQQ(M,8,1,7,VP)
C  REPLACE INITIAL CONDITIONS OF PARTICLE WITH COMPUTED VALUES
      IF ((IVSV.NE.0).AND.(IFLAG.NE.4))
     1    CALL STOFL(NP,1,4,VW)
C  STORE CLOSED ORBIT VECTOR AT LQ2
      VW(5)=0
      IF (IFLAG.NE.4)  CALL STOQQ(M,7,1,7,VW)
      NITP = NITS - 1
      IF (ITERSW) WRITE (OUT3,1019) NITP
      IF (.NOT.ITERSW)  WRITE (OUT3,1020) NITP
      WRITE (OUT3,1007) NAM, ( (R7(I,J),J=1,7) , I = 1,7)
C  CALCULATE THE EIGENVALUES OF M.
      TX = RM(1,1) + RM(2,2)
      TY = RM(3,3) + RM(4,4)
      CTR = TX + TY
      CSQ = SQRT( ( TX - TY )**2 + 4*( ( RM(1,3) + RM(4,2))
     1       *( RM(2,4) + RM(3,1) ) - ( RM(1,4) - RM(3,2) )
     2       *( RM(2,3) - RM(4,1) ) ) )
      BLAM(1) = ( CTR + CSQ )/2
      BLAM(2) = ( CTR - CSQ )/2
      IF( TX.GE.TY ) GO TO 41
C  SWITCH BLAM(1) AND BLAM(2) IF TX.LT.TY .
      LAM(1) = BLAM(1)
      BLAM(1) = BLAM(2)
      BLAM(2) = LAM(1)
   41 LAM(1) = ( BLAM(1) + SQRT( BLAM(1)*BLAM(1) - 4D0))/2
      LAM(2) = 1/LAM(1)
      LAM(3) = ( BLAM(2) + SQRT( BLAM(2)*BLAM(2) - 4D0))/2
      LAM(4) = 1/LAM(3)
C  WRITE OUT THE EIGENVALUES...BOTH IN CARTESIAN AND POLAR FORMS.
      DO 42 I = 1, 4
      C(I) = ABS(LAM(I))
      DLRLA = AIMAG(LAM(I))
      DLRLB = REAL(LAM(I))
      MU(I) = ATAN2(DLRLA,DLRLB)
      Q(I) = SPER*MU(I)/TPI
      Q(I) = MOD(Q(I),1D0)
      IF (Q(I).LT.0) Q(I)=Q(I)+1
 42   CONTINUE
C  STORE EIGENVALUES AT LQ3+7
      CALL STOQQ(M,8,8,8,LAM)
      WRITE( OUT3, 1004 )
   43 WRITE( OUT3, 1005 ) ( LABELA(I), LABELB(I), LAM(I), I, C(I), I,
     1                   MU(I), I, Q(I), I = 1, 4 )
      IF (KA.EQ.0) GO TO 93

C  COMPUTE EIGENVECTORS.
C  FIRST AND SECOND EIGENVECTORS.
C  FIRST COMPONENTS.
 35   DO 45 L=1,3
      DO 44 J = 1, 3
      RT = RM(L+1,J+1)
 44   CM(L,J) = RT
   45 CM(L,L) = CM(L,L) - LAM(1)
      CALL DET( CM, X(1,1) )
C  SECOND THROUGH FOURTH COMPONENTS.
      D = -1
      DO 50 L = 2, 4
      I = L - 1
      DO 46 J = 1, 3
      RT = RM(J+1,I)
 46   CM(J,I) = RT
      IF( L.EQ.3 ) CM(1,2) = CM(1,2) - LAM(1)
      IF( L.EQ.4 ) CM(2,3) = CM(2,3) - LAM(1)
      CALL DET( CM, X(L,1) )
      X(L,1) = D*X(L,1)
      D = -D
 50   CONTINUE
      C1 = ABS( X(1,1) )
      EX1 = X(1,1)/C1
      DO 536 I=1,4
 536  X(I,1) = X(I,1)/EX1
      RHO1 = AIMAG( CONJG(X(1,1))*X(2,1) + CONJG(X(3,1))*X(4,1) )
      FAC = 1
      IF (RHO1.NE.0) FAC = 1/SQRT(ABS(RHO1))
      DO 537 I=1,4
      X(I,1) = FAC * X(I,1)
 537  X(I,2) = CONJG(X(I,1))
      L = 1
      IWR = 1
      GO TO 998
  467 L = 2
      IWR = 2
      GO TO 998
C  THIRD AND FOURTH EIGENVECTORS.
C  FIRST COMPONENTS.
  468 DO 531 I = 1, 2
      DO 531 J = 2, 4
      RT = RM(I,J)
 531  CM(I,J-1) = RT
      DO 532 J = 2, 4
      RT = RM(4,J)
 532  CM(3,J-1) = RT
      CM(2,1) = CM(2,1) - LAM(3)
      CM(3,3) = CM(3,3) - LAM(3)
      CALL DET( CM, X(1,3) )
      X(1,4) = CONJG( X(1,3) )
C  SECOND THROUGH FOURTH COMPONENTS.
      D = -1
      DO 533 L = 2, 4
      I = L - 1
      CM(1,I) = RM(1,I)
      CM(2,I) = RM(2,I)
      CM(3,I) = RM(4,I)
      IF(L.EQ.2 ) CM(1,1) = CM(1,1) - LAM(3)
      IF( L.EQ.3 ) CM(2,2) = CM(2,2) - LAM(3)
      CALL DET( CM, X(L,3) )
      X(L,3) = D*X(L,3)
      D = -D
 533  CONTINUE
      C3 = ABS( X(3,3) )
      EX3 = X(3,3)/C3
      DO 546 I=1,4
 546  X(I,3) = X(I,3)/EX3
      RHO3 = AIMAG( CONJG(X(1,3))*X(2,3) + CONJG(X(3,3))*X(4,3) )
      FAC = 1
      IF (RHO3.NE.0) FAC = 1/SQRT(ABS(RHO3))
      DO 547 I=1,4
      X(I,3) = FAC * X(I,3)
 547  X(I,4) = CONJG(X(I,3))
      L = 3
      IWR = 3
      GO TO 998
  534 L = 4
      IWR = 4
      GO TO 998
C  1. TRACE EQUILIBRIUM ORBIT AND EIGENVECTOR PARTS THROUGH SYSTEM,
C  2. LINEARIZE INDIVIDUAL NLT@S.
 535  CONTINUE
C  SET UP EIGENVECTOR INITIAL CONDITIONS.
      DO 91 I = 1, 3, 2
      DO 91 J=1,4
      VZ(J,I) = REAL( X(J,I) )
      VZ(J,I+1) = AIMAG( X(J,I) )
 91   CONTINUE

C  STORE 4 EIGENVECTORS AT LQ2+7, 7 COMPONENTS EACH.
C  ORDER--- REAL X1, IMAG X1, REAL X3, IMAG X3.

      DO 92 I=1,4
      DO 92 J=5,7
 92   VZ(J,I) = 0
      DO 97 I=5,7
      DO 97 J=1,7
 97   VZ(J,I) = 0
      IQ=8
      DO 90 I=1,4
      CALL STOQQ(M,7,IQ,7,VZ(1,I) )
      IQ=IQ+7
 90   CONTINUE
C  WRITE CLOSED AND OFF-MOMENTUM ORBITS AT POSITION  0
 93   WRITE(OUT3,1017)
      WRITE(OUT3,1014) LBL(5),(V(I,1),I=1,7)
      WRITE(OUT3,1014) LBL(6),(VP(I),I=1,7)
      IF (KA.EQ.0)  GO TO 94
      WRITE(OUT3, 1002 )
C  WRITE INITIAL CONDITIONS.
      L=0
      MATL = IBLNK
      IBET = 1
      GO TO 599
 600  IF (IFLAG.EQ.0) CALL STOR7(M,VZ,RW)
      IF (IFLAG.EQ.4)  CALL GETQQ(M,7,1,7,V(1,8))
 94   II = 0
      NRZZ= NRN
100   II = II + 1
      L = L + 1
      MB = II
      ME = II
C  SAVE INITIAL CONDITIONS.
      DO 101  J=1,7
 101  VV(J) = VW(J)
      IF (IFLAG.NE.4) GO TO 103
      DO 104 J=1,7
 104  VP(J) = V(J,8)
 103  TRKR = 1
      MM = 1
      MN = 1
      NR=1
      GO TO 900
 102  CONTINUE
      IF (KA.LT.3.OR.IFLAG.NE.0)  GO TO 604
      CALL RTRV7(M,VZ,RW)
      IBET = 2
      GO TO 599
 604  CONTINUE
      IF (NGO.EQ.2) GOTO 40

 95   IF( NL.EQ.0 )  GO TO 40
C  LINEARIZE NON-LIN. TRANS
C  FORM 3X3 MATRICES
C  RESTORE INITIAL CONDITIONS.
      DO 111  J=1,7
      F(J) = VW(J)
 111  VW(J) = VV(J)
      IF (IFLAG.NE.4)  GO TO 105
      DO 106 J=1,7
 106  V(J,8) = VP(J)
 105  NRS = 2
      TRKR = 4
      MM=1
      MN=11
      JP=10
      JQ=11
      IF (IFLAG.EQ.1)  GO TO 800
      MN=1
      JP=6
      JQ=7
      NR=5
      IF (IFLAG.NE.4)  TRKR = 2
      GO TO 802
 112  DO 113 I=1,7
      V(I,JP) = VW(I)
 113  V(I,JQ) = VW(I)
      V(6,JP) = VW(6) + DELP
      V(6,JQ) = VW(6) - DELP
      GO TO 900
 114  MM=6
      MN=7
      NR=1
      IOP = 1
      TRKR = 3
      GO TO 900
 115  IOP = IFLAG
C  PUT LINEARIZED 3X3 MATRIX REPRESENTING AN EXT IN ITS STORAGE
 116  CALL RTRV7(MUNIT,R7,RW)
      IF (IFLAG.EQ.1)  GO TO 15
      DO 16 J=1,4
      DO 16 I=1,4
 16   R7(I,J) = V(I,J+1)
      IF (IFLAG.EQ.2) GOTO 17
      IF (IFLAG.EQ.3) GOTO 17
      IF (IFLAG.EQ.4) GOTO 18
 15   D=DELW
      DO 11 J=1,4
      D=DELW*2
      IF (J.EQ.2.OR.J.EQ.4)  D=DELT*2
      DO 11 I=1,4
 11   R7(I,J) = ( V(I,J+1) - V(I,J+5) ) / D
 17   DO 12 I=1,4
 12   R7(I,6) = ( V(I,JP) - V(I,JQ) ) / (2*DELP)
      R5J = 2
      GO TO 805
 18   CALL MXV7(R7,VV,VV)
      DO 13 I=1,5
 13   R7(I,7) = VW(I) - VV(I)
      DO 19 I=1,7
 19   VW(I) = F(I)
      RW(1)=FLDAT(NL,1)
      CALL STOR7(NL,R7,RW)
 40   IF (II.LT.NELS) GO TO 100

 402  CONTINUE

C  TRACK BETA FUNCTIONS, ETA AND CLOSED ORBITS THROUGH BEAM SYSTEM.
C   TRACKING DONE IN CYX, WHICH CALLS TRKCN FOR ORBIT TRACKING.
C   BETA FUNCTIONS FORMED FROM 2X2 SUBMATRICES ARE ONLY APPROXIMATE
C   IF THERE IS COUPLING.

C  TEST TRACE
      TRX = RM(1,1) + RM(2,2)
      TRY = RM(3,3) + RM(4,4)
      IF ( (ABS(TRX).LT.2) .AND. (ABS(TRY).LT.2) )  GO TO 405
C      WRITE (3,1016)
 1016 FORMAT (5X,'X OR Y BETATRON MOTION UNSTABLE.')
 405  CONTINUE
      IF (KB.GE.0) GO TO 406
      NELS=NELS+1
      MI(NELS) = M7END - 4
 406  CONTINUE
      ML1 =MLFX(1)
      CALL RTRV7(ML1,R7,RW)
      CALL STOR7(M,R7,RW)
      IF (IFLAG.NE.4)  GO TO 409
      CALL GETQQ(M,7,1,7,V(1,8))
      CALL STOQQ(M,7,1,7,VW)
 409  NRZZ = NRN
      CALL CYX(M)
      NRZZ = NRN
      CALL HED
      IF (IFLAG.NE.3) RETURN
      IF (KB.LT.0)  NELS=NELS-1
      DO 408 I=1,6
 408  VW(I) = 0
      IFLAG = 4
      NV(1)=8
      GO TO 33

C  SET UP THE EIGHT NEIGHBORING RAYS
 800  DO 801 J=8,63
 801  VW(J)=VW(J-7)
      V(1,6)=V(1,6)-DELW
      V(2,7)=V(2,7)-DELT
      V(3,8)=V(3,8)-DELW
      V(4,9)=V(4,9)-DELT
      V(1,2) = V(1,2) + DELW
      V(2,3) = V(2,3) + DELT
      V(3,4) = V(3,4) + DELW
      V(4,5) = V(4,5) + DELT
      IF (NRS.EQ.1) GOTO 4
      IF (NRS.EQ.2) GOTO 112
 802  DO 803 J=8,35
 803  VW(J) = 0
      DO 804 I=1,4
 804  V(I,I+1) = 1
      CALL STOR7(M,V(1,2),RW)
      IF (NRS.EQ.1) GOTO 4
      IF (NRS.EQ.2) GOTO 112
 805  DO 806 J=1,4
 806  R7(5,J) = R7(2,J) * R7(1,6) - R7(1,J) * R7(2,6)
     1        + R7(4,J) * R7(3,6) - R7(3,J) * R7(4,6)
      IF (R5J.EQ.1) GOTO 142
      IF (R5J.EQ.2) GOTO 18
C  TRACK PARTICLES MM THROUGH MN THROUGH BEAM ELEMENTS MB THROUGH ME.
  900 NLF = 0
      DO 950 J = MB, ME
      NL = MI(J)
      MATL = CINFF(2,NL)
      DO 950  MT = MM,MN
C      WRITE (3,5021) MATL,MLFX,NL,MT,NP,IOP
 5021 FORMAT (5X,'MATL,MLFX,NL,MT,NP,IOP',2X,A5,6I7)
C      WRITE (3,5022) (V(ITZ,MT),ITZ=1,7)
 5022 FORMAT (2X,'BEFORE TRKCN--V(I,MT)'/5X,7F15.8)
      CALL TRKCN( M, NL, V(1,MT), NP, IOP )
C      WRITE (3,5021) MATL,MLFX,NL,MT,NP,IOP
C      WRITE (3,5023) (V(ITZ,MT),ITZ=1,7)
 5023 FORMAT (2X,'AFTER TRKCN--V(I,MT)'/5X,7F15.8)
      CKIND = CINFF(4,NL)
      IF (CKIND.EQ.'PRD'.OR.CKIND.EQ.'MAP') NLF = NL
  950 CONTINUE
      NL = NLF
      IF (TRKR.EQ.1) GOTO 102
      IF (TRKR.EQ.2) GOTO 114
      IF (TRKR.EQ.3) GOTO 115
      IF (TRKR.EQ.4) GOTO 116
      IF (TRKR.EQ.5) GOTO 144
      IF (TRKR.EQ.6) GOTO 510
C  WRITE OUT AN EIGENVECTOR.
 998  IF (KA.NE.0) WRITE (OUT3,1008) LAM(L),(X(J,L),J=1,4)
      IF (IWR.EQ.1) GOTO 467
      IF (IWR.EQ.2) GOTO 468
      IF (IWR.EQ.3) GOTO 534
      IF (IWR.EQ.4) GOTO 535
C
C  PRINT EIGENFUNCTIONS IN POLAR FORM
 599  CONTINUE
      DO 601 K=1,2
      DO 601 I=1,4
      J = 2 * K - 1
      IF ( (VZ(I,J).NE.0) .OR. (VZ(I,J+1).NE.0) )  GO TO 602
      EMOD(I,K) = 0
      EPHI(I,K) = 0
      GO TO 601
 602  EMOD(I,K) = SQRT ( VZ(I,J)*VZ(I,J) + VZ(I,J+1)*VZ(I,J+1) )
      EPHI(I,K) = ATAN2 ( VZ(I,J+1),VZ(I,J) )
 601  CONTINUE
      WRITE (OUT3,1003) L,MATL, ( EMOD(I,1),EPHI(I,1),I=1,4 ) ,
     1                       ( EMOD(I,2),EPHI(I,2),I=1,4 )
      IF (IBET.EQ.1) GOTO 600
      IF (IBET.EQ.2) GOTO 604

 1000 FORMAT('0CALCULATION OF THE EQUILIBRIUM ORBIT AND BETATRON ',
     1 'FUNCTIONS OF ',A5,'.'/
     2 ' INITIAL REFERENCE RAY DEFINED BY ',A5/'   X = ',
     2  F11.8,3X,'DX = ',F11.8,3X,'Y = ',F11.8,3X,'DY = ',F11.8,
     3 5X,'DS = ',F11.8,3X,'DP/P = ',F11.8,3X,F11.8)
 1002 FORMAT ( '1','EIGENVECTORS 1 AND 3 IN POLAR COORDINATES'/
     1  1X,'POS',23X,'X1 ',22X,'DX1',22X,'Y1 ',22X,'DY1'/
     2        27X,'X3 ',22X,'DX3',22X,'Y3 ',22X,'DY3'/ )
 1003 FORMAT ( 1X,I4,1X,A5,1X, 4(2F11.6,3X) / 12X, 4(2F11.6,3X) / )
 1004 FORMAT ('0EIGENVALUES OF THE 4X4 SUBMATRIX')
 1005 FORMAT(2A6,' = (',2F12.8,5X,' ), C(',I1,') = ',F12.8,
     1 ', MU(',I1,') = ',F12.8,' RAD,     Q(',I1,') = ',F12.8 )
 1006 FORMAT(21H0SINGULAR 4X4 MATRIX.)
 1007 FORMAT ('07X7 MATRIX FOR ',A5/(/10X,7F16.8))
 1008 FORMAT('0EIGENVALUE = ( ',F16.8,', ',F16.8,
     1   ' ),  EIGENVECTOR = (',
     2F16.8,', ',F16.8,' )'/(69X,'( ',F16.8,', ',F16.8,' )'))
 1013 FORMAT(' ITERATION =',I4,' XO=',F16.8,' DXO=',
     1  F16.8,' YO=',F16.8,' DYO=',F16.8)
 1014 FORMAT (/1X,A10,7F15.8)
 1018 FORMAT ( '1')
 1017 FORMAT(/15X,7X,' X',13X,'DX',13X,' Y',13X,'DY',
     1  13X,'DS',13X,'DP/P')
 1019 FORMAT (2X,'CONVERGENCE CRITERIA NOT REACHED AFTER MAXIMUM ',
     1  'ITERATIONS OF ', I4,  '.')
 1020 FORMAT (1X,'CLOSED ORBIT FOUND AFTER ', I4, ' ITERATIONS.')
C
      END
