      Subroutine Helix(M,par)
C Helical snake (or wiggler). Length L, twist from angle Ang1 to Ang2
C (entered in degrees); Field B0, rigidity BR

C Format:
CNAME   HELIX        L                   BR        B0        ANG1      ANG2      
C....;,,,,1....;....2....;....3....;....4....;....5....;....6....;....7....;....8
      implicit DOUBLE PRECISION (a-h,o-z)
      include 'ccc/const.ccc'
      include 'ccc/files.ccc'
      DOUBLE PRECISION K, L, LAM
      Dimension T(7,7),par(6),rw(3),U(4,4),v0(4),v1(4)

      do 11 i=1,7
      do 11 j=1,7
         t(i,j)=0
         t(j,j)=1
 11   Continue
      do 12 i=1,3
 12   rw(i)=0

      L = par(1)
      BR=par(3)
      B0=par(4)
      Angin=par(5)*radeg
      If (par(6).eq.par(5)) par(6)=par(5)+360
      Angout=par(6)*radeg
C      write (out3,101) par(1),par(3),par(4),par(5),par(6)
 101  format(' Length ',f8.3,', Br ',f10.3,'B ',f8.3,', angles ',2f10.3)
      RHO = BR/B0
      K=(angout-angin)/L
      r0=1/rho/k**2
      del=k*r0/rho/2
      lam=sqrt(.5/rho**2+del**2)
      ad=del*l
      al = lam*l
      cd=cos(ad)
      cl=cos(al)
      sd=sin(ad)
      sl=sin(al) 
      u(1,1)=cl
      u(1,2)=sl/lam
      u(2,1)=-lam*sl
      u(2,2)=cl
      do 20 i=1,2
      do 20 j=1,2
         t(i,j)=cd*u(i,j)
         t(i,j+2)=-sd*u(i,j)
         t(i+2,j)=sd*u(i,j)
         t(i+2,j+2)=cd*u(i,j)
 20   continue
      v0(1)=r0*cos(angin)
      v0(2)=-r0*k*sin(angin)
      v0(3)=r0*sin(angin)
      v0(4)=r0*k*cos(angin)

      v1(1)=r0*cos(angout)
      v1(2)=-r0*k*sin(angout)
      v1(3)=r0*sin(angout)
      v1(4)=r0*k*cos(angout)

       do 30 i=1,4
          t(i,7)=v1(i)
          do 30 j =1,4
          t(i,7)=t(i,7)-t(i,j)*v0(j)
 30    continue
       do 40 i=1,4
 40    T(i,6)=-t(i,7)
       call row5(t)
       rw(1)=L
       call stor7(M,T,RW)
       RETURN
       END
