      SUBROUTINE HESSE

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        CALCULATES THE FULL SECOND-DERIVATIVE MATRIX OF FCN
CC        BY TAKING FINITE DIFFERENCES.   INCLUDES SOME SAFEGUARDS
CC        AGAINST NON-POSITIVE-DEFINITE MATRICES, AND IT MAY SET
CC        OFF-DIAGONAL ELEMENTS TO ZERO IN ATTEMPT TO FORCE POSITIVENESS
CC
      include 'ccc/hessflg.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/deriva.ccc'

      include 'ccc/sfile.ccc'

      DIMENSION YY(15),GY(30)

      DATA DFWANT,DFZERO,DFMIN,DFMAX/.01D0,1.D-8,.001D0,.1D0/
      HESSBUG = .FALSE.
      WRITE (SVOUT, 500)
      IFLAG = 4
      NPFN = NFCN
      NPARD = NPAR
C                                        . . . . . . DIAGONAL ELEMENTS .
      MDIAG = 0
      DO 100 ID= 1, NPARD
      I = ID + NPAR - NPARD
      TMP = .02D0
      D = TMP*ABS(DIRIN(I))
      IF (ISW(2) .GE. 1)  D = TMP*SQRT(ABS(V(I,I))*UP)
      TMP = 1.0D-8
      IF (D .LT.  TMP*ABS(X(I)))  D = TMP  * ABS(X(I))
      DO 20 J= 1, NPAR
   20 V(I,J) = 0
      ICYC = 0
   40 DIRIN(I) = D
      XTF = X(I)
      X(I) = XTF + D
      CALL INTOEX(X)
      CALL FCN(NPAR, GY, FS1, U, IFLAG)
      NFCN = NFCN + 1
      X(I) = XTF - D
      CALL INTOEX(X)
      CALL FCN (NPAR, GY, FS2, U, IFLAG)
      NFCN = NFCN + 1
      X(I) = XTF
C                                        CHECK IF STEP SIZES APPROPRIATE
      ICYC = ICYC + 1
      IF (ICYC .GE. 4)  GO TO 55
      DF = MAX(ABS(FS1-AMIN),ABS(FS2-AMIN))/UP
      IF (DF .GT. DFMIN)  GO TO 45
      IF (DF .GT. DFZERO)  GO TO 50
      D = D*1000
      GO TO 40
   45 IF (DF .LT. DFMAX)  GO TO 55
   50 CHAN = SQRT(DFWANT/DF)
      TMP = .001D0
      IF (CHAN .LT. TMP)  CHAN = TMP
      D = D*CHAN
      GO TO 40
   55 CONTINUE
C                                        GET FIRST AND SECOND DERIVATIVE
      G(I) = (FS1-FS2)/(2 * D)
      G2(I) = (FS1 + FS2 - 2*AMIN) / D**2
      YY(I) = FS1
      TMP = 1.D-30
      IF (ABS(G(I))+ ABS(G2(I)).GT. TMP)  GO TO 80
C                                     FIX A PARAMETER IF  G = G2 = 0.0 .
      IF (ITAUR .GE. 1)  GO TO 85
      ISW(2) = 0
      CALL FIXPAR(I, 1, IFIX)
      WRITE (SVOUT, 460) IFIX, NAM(IFIX), G(I), G2(I)
      IF (NPAR .EQ. 0)  MDIAG = 1
      GO TO 100
   80 TMP = 1.D-30
      IF (G2(I) .GT. TMP)  GO TO 90
   85 MDIAG = 1
      WRITE (SVOUT,510)  I
   90 V(I,I) = G2(I)
  100 CONTINUE
      CALL INTOEX(X)
      IF (MDIAG .EQ. 1)  GO TO 390
      ISW(2) = 1
C                                        . . . .  OFF-DIAGONAL ELEMENTS
      IF (NPAR .EQ. 1)  GO TO 214
      NPARM1 = NPAR - 1
      DO 200 I= 1, NPARM1
      IP1 = I + 1
      DO 180 J= IP1, NPAR
      IF (NFCNMX-NFCN+NPFN .LT. NPAR)  GO TO 210
      XTI = X(I)
      XTJ = X(J)
      X(I) = XTI + DIRIN(I)
      X(J) = XTJ + DIRIN(J)
      CALL INTOEX(X)
      CALL FCN(NPAR, GY, FS1, U, IFLAG)
      NFCN = NFCN + 1
      X(I) = XTI
      X(J) = XTJ
      ELEM = (FS1+AMIN-YY(I)-YY(J)) / (DIRIN(I)*DIRIN(J))
      IF (ABS(ELEM).GT.1.E18) THEN
         HESSBUG = .TRUE.
         RETURN
       ENDIF
      IF (ELEM**2 .LT. G2(I)*G2(J)) GO TO 170
      ELEM = 0
      WRITE (SVOUT, 470)  I,J
  170 V(I,J) = ELEM
      V(J,I) = ELEM
  180 CONTINUE
  200 CONTINUE
      GO TO 214
  210 J = J - 1
      WRITE (SVOUT, 490)  I,J
  214 CALL INTOEX(X)
      CALL VERMIN(V,MAXINT,MAXINT,NPAR,IFAIL)
      IF (IFAIL .LT. 1)  GO TO 222
      WRITE (SVOUT,520)
C                                        . . DIAGONAL MATRIX ONLY . . .
  216 WRITE (SVOUT,540)
      ISW(2) = 1
      DO 220 I= 1, NPAR
      DO 218 J= 1, NPAR
  218 V(I,J) = 0
  220 V(I,I) = 1/G2(I)
      MDIAG = 0
      GO TO 223
  222 WRITE (SVOUT, 480)
      ISW(2) = 2
C                                        . . . . . . .  CALCULATE  E D M
  223 DO 225 I= 1, NPAR
      DO 225 J= 1, NPAR
  225 V(I,J) = 2 * V(I,J)
      SIGMA = 0
      DO 250 I= 1, NPAR
      IF (V(I,I) .GT. 0)  GO TO 228
      WRITE (SVOUT,510)  I
      MDIAG = 1
  228 R = 0
      DO 240 J= 1, NPAR
      IF (I .EQ. J)  GO TO 230
      IF (V(I,J)**2 .LT. ABS(V(I,I)*V(J,J)))  GO TO 230
      WRITE (SVOUT, 470)  I,J
      V(I,J) = 0
      V(J,I) = 0
  230 CONTINUE
  240 R = R + V(I,J) * G(J)
  250 SIGMA = SIGMA + R *G(I)/2
      IF (MDIAG .EQ. 1)  GO TO 390
      IF (SIGMA .GT. 0)  GO TO 400
      WRITE (SVOUT,530)
      GO TO 216
  390 ISW(2) = 0
  400 RETURN
  460 FORMAT('0PARAMETER ',I3,', ',A10,  ', HAS BEEN FIXED',9X,
     1'FIRST DERIVATIVE IS ',E11.3/
     2 1X,40('*'),8X,'SECOND DERIVATIVE IS ',E11.3/)
  470 FORMAT (' COVARIANCE MATRIX NOT POSITIVE-DEFINITE.',
     1'    FAULTY ELEMENT IN POSITION ',2I3)
  480 FORMAT (  ' SECOND DERIVATIVE MATRIX INVERTED ')
  490 FORMAT (  '0CALL LIMIT IN HESSE.  OFF-DIAGONAL',
     1' ELEMENTS CALCULATED  ONLY UP TO POSITION2',I3/)
  500 FORMAT ( ' START SECOND DERIVATIVE CALCULATION ')
  510 FORMAT (  ' DIAGONAL ELEMENT ',I5,' IS ZERO OR NEGATIVE')
  520 FORMAT (  ' MATRIX INVERSION FAILS')
  530 FORMAT (  ' MATRIX NOT POSITIVE-DEFINITE')
  540 FORMAT (  ' ONLY DIAGONAL MATRIX PRODUCED')
      END
