      SUBROUTINE IMPROV

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        ATTEMPTS TO IMPROVE ON A GOOD LOCAL MINIMUM BY FINDING A
CC        BETTER ONE.   THE QUADRATIC PART OF FCN IS REMOVED BY CALFCN
CC        AND THIS TRANSFORMED FUNCTION IS MINIMIZED USING THE SIMPLEX
CC        METHOD FROM SEVERAL RANDOM STARTING POINTS.
CC        REF. -- GOLDSTEIN AND PRICE, MATH.COMP. 25, 569 (1971)
CC
      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/kard.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/casc.ccc'

      include 'ccc/deriva.ccc'

      include 'ccc/simvec.ccc'

      include 'ccc/variat.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/seed.ccc'

      DATA ALPHA,BETA,GAMMA / 1.0D0, 0.5D0, 2.0D0 /

      IF (NPAR .LE. 0)  RETURN
      ITAUR = 1
      EPSI = UP / 10
      IR = NRZZ
      NPFN=NFCN
      NLOOP = INT(WORD7(2))
      IF (NLOOP .LE. 0)  NLOOP = NPAR + 4
      NPARP1=NPAR+1
      WG = NPAR
      WG = 1/WG
      IFLAG=4
      SIGSAV = SIGMA
      APSI = AMIN
      DO 2 I= 1, NPAR
      XT(I) = X(I)
      G2(I) = SQRT(V(I,I)*UP)
      DO 2 J= 1, NPAR
    2 VT(I,J) = V(I,J)
      CALL VERMIN(VT,MAXINT,MAXINT,NPAR,IFAIL)
      IF (IFAIL .GE. 1)  GO TO 280
      LOOP = 0
    3 DO 4 I= 1, NPAR
      DIRIN(I) = 2 * G2(I)
    4 X(I)= XT(I)+DIRIN(I)*(2*RANSYN(IR)-1)
      LOOP = LOOP + 1
      REG = 2
      WRITE (SVOUT, 1040) LOOP
    5 AMIN = CALFCN(X)
C                                        . . . . SET UP  RANDOM SIMPLEX
      JL = NPARP1
      JH = NPARP1
      Y(NPARP1) = AMIN
      AMAX = AMIN
      DO 15 I= 1, NPAR
      XI = X(I)
      TMP = 0.5D0
      X(I)= XI-DIRIN(I)*(RANSYN(IR)-TMP)
      Y(I) = CALFCN(X)
      IF (Y(I) .GE. AMIN)  GO TO 7
      AMIN = Y(I)
      JL = I
    7 IF (Y(I) .LE. AMAX)  GO TO 8
      AMAX = Y(I)
      JH = I
    8 CONTINUE
      DO 10 J= 1, NPAR
   10 P(J,I) = X(J)
      P(I,NPARP1) = XI
   15 X(I) = XI
      SIGMA = AMIN
      SIG2 = SIGMA
C                                        . . . . . . .  START MAIN LOOP
   50 CONTINUE
      IF (AMIN .LT. 0)  GO TO 95
      IF (ISW(2) .LT. 2)  GO TO 280
      EP = AMIN / 10
      IF (SIG2 .LT. EP   .AND. SIGMA.LT.EP  )     GO TO 100
      SIG2 = SIGMA
      IF ((NFCN-NPFN) .GT. NFCNMX)  GO TO 300
C         CALCULATE NEW POINT * BY REFLECTION
      DO 60 I= 1, NPAR
      PB = 0
      DO 59 J= 1, NPARP1
   59 PB = PB + WG * P(I,J)
      PBAR(I) = PB - WG * P(I,JH)
   60 PSTAR(I)=(1+ALPHA)*PBAR(I)-ALPHA*P(I,JH)
      YSTAR = CALFCN(PSTAR)
      IF(YSTAR.GE.AMIN) GO TO 70
C         POINT * BETTER THAN JL, CALCULATE NEW POINT **
      DO 61 I=1,NPAR
   61 PSTST(I)=GAMMA*PSTAR(I)+(1-GAMMA)*PBAR(I)
      YSTST = CALFCN(PSTST)
   66 IF (YSTST .LT. Y(JL))  GO TO 67
      CALL RAZZIA(YSTAR,PSTAR)
      GO TO 50
   67 CALL RAZZIA(YSTST,PSTST)
      GO TO 50
C         POINT * IS NOT AS GOOD AS JL
   70 IF (YSTAR .GE. Y(JH))  GO TO 73
      JHOLD = JH
      CALL RAZZIA(YSTAR,PSTAR)
      IF (JHOLD .NE. JH)  GO TO 50
C         CALCULATE NEW POINT **
   73 DO 74 I=1,NPAR
   74 PSTST(I)=BETA*P(I,JH)+(1-BETA)*PBAR(I)
      YSTST = CALFCN(PSTST)
      IF(YSTST.GT.Y(JH)) GO TO 5
C     POINT ** IS BETTER THAN JH
      IF (YSTST .LT. AMIN)  GO TO 67
      CALL RAZZIA(YSTST,PSTST)
      GO TO 50
C                                        . . . . . .  END MAIN LOOP
   95 WRITE (SVOUT,1000)
      REG = 0.1D0
C                                        . . . . . ASK IF POINT IS NEW
  100 CALL INTOEX(X)
      CALL FCN(NPAR,G,AMIN,U,4)
      NFCN = NFCN + 1
      DO 120 I= 1, NPAR
      DIRIN(I) = REG*G2(I)
      IF (ABS(X(I)-XT(I)) .GT. DIRIN(I)) GO TO 150
  120 CONTINUE
      GO TO 230
  150 NFCNMX = NFCNMX + NPFN - NFCN
      NPFN = NFCN
      CALL smplxx
      IF (AMIN .GE. APSI)  GO TO 325
      DO 220 I= 1, NPAR
      DIRIN(I) = G2(I) / 10
      IF (ABS(X(I)-XT(I)) .GT. DIRIN(I)) GO TO 250
  220 CONTINUE
  230 IF (AMIN .LT. APSI)  GO TO 350
      GO TO 325
C                                        . . . . . . TRULY NEW MINIMUM
  250 NEWMIN = 1
      ISW(2) = 0
      ITAUR = 0
      NFCNMX = NFCNMX + NPFN - NFCN
      WRITE (SVOUT,1030)
      RETURN
C                                        . . . RETURN TO PREVIOUS REGION
  280 WRITE (SVOUT,1020)
      ISW(2) = 0
      GO TO 325
  300 ISW(1) = 1
  325 DO 330 I= 1, NPAR
      DIRIN(I) = G2(I) / 100
  330 X(I) = XT(I)
      AMIN = APSI
      SIGMA = SIGSAV
  350 CALL INTOEX(X)
      WRITE (SVOUT,1010)
      IF (ISW(2) .LT. 2)  GO TO 380
      IF (LOOP .LT. NLOOP .AND. ISW(1) .LT. 1)  GO TO 3
      ISW(2) = 3
  380 CALL MPRINT (1,AMIN)
      RETURN
 1000 FORMAT (' AN IMPROVEMENT ON THE PREVIOUS MINIMUM HAS ',
     1 'BEEN FOUND')
 1010 FORMAT (' IMPROVE HAS RETURNED TO REGION OF ORIGINAL MINIMUM')
 1020 FORMAT ('0COVARIANCE MATRIX WAS NOT POSITIVE-DEFINITE')
 1030 FORMAT ('0IMPROVE HAS FOUND A TRULY NEW MINIMUM'/
     1 1X,37('*')/)
 1040 FORMAT ('0START ATTEMPT NO. ',I2,' TO FIND NEW MINIMUM')
      END
