      SUBROUTINE INCR(M,KA)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  CARD IMAGE     INCR    K  L // Q    TYPE    DELTA
C  IF L=0,INCREMENT THE KTH PARAMETER OF Q BY DELTA
C  IF L NOT 0, MULTIPLY THE KTH PARAMETER OF Q BY DELTA
C  TYPE MAY BE F, I, KA OR KB.
C  DELTA WILL BE FL. PT. IF TYPE IS F OR OMITTED.
C   IT WILL BE INTEGER IF I, KA OR KB.
C    IF MODE=1,THE NEW VALUE REMAINS IN DATA STORAGE
C    IF MODE=3,THE ORIGINAL VALUE IS REPLACED AFTER REQUIRED ITERATIONS
C     HAVE BEEN COMPLETED.

      include 'ccc/binff.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/const.ccc'

      include 'ccc/files.ccc'

      CHARACTER(5) NM,CHDAT,ITP,IPN,ICH

C
C   FIND NAME AND INDEX OF ELEMENT WHOSE DATA IS TO BE INCREMENTED.
C   DETERMINE TYPE OF DATA TO BE CHANGED -- FL. PT., INTEGER, KA OR KB.
      NM =CHDAT(M,1)
      N = JELNUM(NM)
      ITP = CHDAT(M,2)
      KK = INFF(5,M)
      IF ((ITP.EQ.'F').OR.(ITP.EQ.IBLNK))IGO = 1
      IF (ITP.EQ.'I') IGO = 2
      IF (ITP.EQ.'KA') IGO = 3
      IF (ITP.EQ.'KB') IGO = 4
C        IPP NOT EQUAL TO 0, SUPPRESSES PRINT
      IPP = INFF(6,N)
      IF (MODE.EQ.1) GO TO 30
C   MS IS M OF THE SUBROUTINE THAT INCR IS IN.
      MS = INFF(19,M)
C  DETERMINE IF THIS IS FIRST AND/OR LAST ITERATION THROUGH SUBROUTINE.
      IF (IDAT(MS,1).EQ.1) GO TO 50
 20   IF (IDAT(MS,2).EQ.1) GO TO 60
C                  INCREMENT PARAMETER, RETURN NEW VALUE TO DATA STORE
 30   CONTINUE
      IF (IGO.EQ.2) GOTO 32
      IF (IGO.EQ.3) GOTO 33
      IF (IGO.EQ.4) GOTO 34
C  FLOATING POINT
 31   DF = FLDAT(M,1)
      IF (KK.EQ.0) THEN
         CALL AFD(N,KA,DF)
       ELSE
         CALL MFD(N,KA,DF)
       ENDIF
      F = FLDAT(N,KA)
C  IF INCREMENTING A SIMPLE = OR A PARA, ALSO STORE IN Q.
      IPN = CINFF(1,N)
      IF (IPN.EQ.'=') THEN
         ICH = CHDAT(N,1)
         IF (ICH.NE.IBLNK) GO TO 40
      ELSE
         IF (IPN.NE.'PARA') GO TO 40
      ENDIF
      CALL STOQ(N,1,1,F)
      GO TO 40
C                  INTEGER
 32   IDF = IDAT(M,1)
      INDAT=IDAT(N,KA)
      INEW = IDF + INDAT
      CALL STOIN(N,KA,1,INEW)
      GO TO 40
C        INCREMENT KA OR KB
 33   JI = 4
      GO TO 35
 34   JI = 5
 35   IDF = IDAT(M,1)
      INDAT = INFF(JI,N)
      INEW = IDF + INDAT
      INFF(JI,N) = INEW
 40   KO = KA
      IF (IPP.GT.0) RETURN
      IF (IGO.EQ.2) THEN
         WRITE (OUT3,2) KO,NM,IDF,INEW
      ELSE IF (IGO.EQ.3) THEN
         WRITE (OUT3,3) NM,IDF,INEW
      ELSE IF (IGO.EQ.4) THEN
         WRITE (OUT3,4) NM,IDF,INEW
      ELSE IF (KK.EQ.0) THEN
         WRITE (OUT3,1) KO,NM,DF,F
      ELSE
         WRITE (OUT3,8) KO,NM,DF,F
      ENDIF
      RETURN
C        SAVE ORIGINAL PARAMETER
 50   CONTINUE
      IF (IGO.EQ.2) THEN
         ISF = IDAT(N,KA)
         CALL STOIN(M,2,1,ISF)
      ELSE IF (IGO.EQ.3) THEN
         ISF = INFF(4,N)
         CALL STOIN(M,2,1,ISF)
      ELSE IF (IGO.EQ.4) THEN
         ISF = INFF(5,N)
         CALL STOIN(M,2,1,ISF)
      ELSE
         SF = FLDAT(N,KA)
         CALL STOFL(M,2,1,SF)
      ENDIF
      GO TO 20
C        ITERATIONS COMPLETED.  RESTORE ORIGINAL PARAMETER.
 60   CONTINUE
      IF (IGO.EQ.2.OR.IGO.EQ.3.OR.IGO.EQ.4) GOTO 62
 61   SF = FLDAT(M,2)
      CALL STOFL(N,KA,1,SF)
      F = SF
C  IF INCREMENTING A SIMPLE = OR A PARA, ALSO STORE IN Q.
      IPN = CINFF(1,N)
      IF (IPN.EQ.'=') THEN
         ICH = CHDAT(N,1)
         IF (ICH.NE.IBLNK) GO TO 70
      ELSE
         IF (IPN.NE.'PARA') GO TO 70
      ENDIF
      CALL STOQ(N,1,1,F)
      DF = 0
      GO TO 70
 62   ISF = IDAT(M,2)
      IF (IGO.EQ.3) GOTO 64
      IF (IGO.EQ.4) GOTO 65
C  SHOULD NOT GET HERE
 63   WRITE (OUT3,5) NM,IGO
      ERROR = .TRUE.
      STOP
 64   JI = 4
      GO TO 66
 65   JI = 5
 66   INFF(JI,N) = ISF
      INEW = ISF
      IDF = 0
C  WRITE STATEMENTS OF RESTORING ORIGINAL VALUES
 70   KO = KA
      IF (IPP.GT.0) RETURN
      IF (IGO.EQ.2) THEN
         WRITE (OUT3,11) KO,NMF,INEW
      ELSE IF (IGO.EQ.3) THEN
         WRITE (OUT3,12) NM,INEW
      ELSE IF (IGO.EQ.4) THEN
         WRITE (OUT3,13) NM,INEW
      ELSE IF (KK.EQ.0) THEN
         WRITE (OUT3,9) KO,NM,F
      ELSE
         WRITE (OUT3,10) KO,NM,F
      ENDIF
      RETURN
C*********************************FORMATS*******************************
 1    FORMAT ('  *** ',8X,'INCR ',1X,I3,4X,' //  ',A5,5X,F10.6,5X,
     1 ' VALUE = ',F14.6)
 9    FORMAT ('  *** ',5X,'RESTORE ',1X,I3,4X,' //  ',A5,7X,'WITH',
     1 ' ORIGINAL VALUE = ',F14.6)
 2    FORMAT ('  *** ',8X,'INCR ',1X,I3,4X,' //  ',A5,2X,I10,5X,
     1 ' VALUE = ',I10)
 11   FORMAT ('  *** ',5X,'RESTORE ',1X,I3,4X,' //  ',A5,4X,'WITH',
     1 ' ORIGINAL VALUE = ',I10)
 3    FORMAT ('  *** ',8X,'INCR ',2X,'KA',4X,' //  ',A5,5X,I10,5X,
     1  ' VALUE = ',I10)
 12   FORMAT ('  *** ',5X,'RESTORE ',2X,'KA',4X,' //  ',A5,7X,'WITH',
     1  ' ORIGINAL VALUE = ',I10)
 4    FORMAT ('  *** ',8X,'INCR ',2X,'KB',4X,' //  ',A5,5X,I10,5X,
     1  ' VALUE = ',I10)
 13   FORMAT ('  *** ',5X,'RESTORE ',2X,'KB',4X,' //  ',A5,7X,'WITH',
     1  ' ORIGINAL VALUE = ',I10)
 5    FORMAT ('  *** ERROR IN INCREMENTING ',A5,/
     1    I10,'IS INVALID COMPUTED GO TO.')
 8    FORMAT ('  *** ',8X,'MULT ',1X,I3,4X,' //  ',A5,5X,F10.6,5X,
     1 ' VALUE = ',F14.6)
 10   FORMAT ('  *** ',5X,'RESTORE ',1X,I3,4X,' //  ',A5,7X,'WITH',
     1 ' ORIGINAL VALUE = ',F14.6)
      END
