      SUBROUTINE MAGMAT(M,KA)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C       FORM KA NUMBER OF MAGNET MATRICES. USE VECTORS AS
C   LENGTHS AND/OR GRADIENTS.
C  NAME OF VECTORS ARE IN LENGTH OR GRADIENT MAG INPUT POSITIONS
 
      include 'ccc/bstore.ccc'
C BSTORE.CCC
C  IFLMAX=LFSIZ,IMAX=LISIZ,IQMAX=LQSIZ INSIDE PROGRAM
C      PARAMETER (LFSIZ=5000,LISIZ=200,LQSIZ=10000)
C      COMMON /BSTORE/ FLIB(LFSIZ),ILIB(LISIZ),QLIB(LQSIZ)

      include 'ccc/cstore.ccc'
C CSTORE.CCC
C  ICHMAX=LCHSIZ, ISFMAX=LSFSIZ INSIDE PROGRAM
C      PARAMETER (LCHSIZ=1000,LSFSIZ=1000)
C      COMMON/CSTORE/CHLIB(LCHSIZ),SFLIB(LSFSIZ)
C      CHARACTER CHLIB*5,SFLIB*5

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=1000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=1000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/files.ccc'
C      COMMON/FILES/INFILE,OUT3,IFILE,OFILE,PRFILE,PLFILE,
C     1    ORB1,JBIS,CYBO,FILE11
C      INTEGER OUT3,OFILE,PRFILE,PLFILE,ORB1,CYBO,FILE11

      include 'ccc/const.ccc'
C CONST.CCC
C      COMMON/CONST/PIO2,PI,TPI,PI2,RADEG,M99
C      COMMON/CHCON/ASTRK,IBLNK
C      CHARACTER ASTRK*5,IBLNK*5

       DIMENSION NVC(2),PAR(6),FLST1(99),FLST2(99),NVOP(2)
       CHARACTER(5) NR,NVC,NVOP
       CHARACTER(5) NTV
C        RETRIEVE VECTOR NAMES FROM MAG INPUT.  CHECK FOR VECTOR WITH
C        AT LEAST KA ELEMENTS.

C  INITIALIZE
      DO 10 I=1,2
      NVC(I) = IBLNK
 10   NVOP(I) = IBLNK
C  RETRIEVE SYMBOLIC FL. PT. INPUT.
C  IF IT EXISTS, GET ITS M AND OPNAME
      CALL GETSF(M,1,2,NVC)
      IF (NVC(1).NE.IBLNK) THEN
        MV1 = JELNUM(NVC(1))
        NVOP(1) = CINFF(1,MV1)
       ENDIF
      IF (NVC(2).NE.IBLNK) THEN
        MV2 = JELNUM(NVC(2))
        NVOP(2) = CINFF(1,MV2)
       ENDIF
C  IF NEITHER ONE IS AVEC, THEN CANNOT FORM MULTIPLE MATRICES
      IF (NVOP(1).NE.'VEC'.AND.NVOP(2).NE.'VEC') GO TO 550
      NR = NVOP(1)
      IF (NR.EQ.IBLNK.OR.NR.NE.'VEC') GO TO 25
      NK = INFF(4,MV1)
      NTV = NVC(1)
      IF (KA.GT.NK) GO TO 500
C  FILL IN FLST1 WITH LENGTHS
      DO 20 I=1,KA
 20   FLST1(I) = FLDAT(MV1,I)
      GO TO 30
C  USE INPUT LENGTH FOR ALL OF MATRICES
 25   FLST1(1) = FLDAT(M,1)
      DO 26 I=2,KA
 26   FLST1(I) = FLST1(1)
C  LOOK AT GRADIENT
 30   NR = NVOP(2)
      IF (NR.EQ.IBLNK.OR.NR.NE.'VEC') GO TO 35
      NK = INFF(4,MV2)
      NTV = NVC(2)
      IF (KA.GT.NK) GO TO 500
      DO 31 I=1,KA
 31   FLST2(I) = FLDAT(MV2,I)
      GO TO 40
 35   FLST2(1) = FLDAT(M,2)
      DO 36 I=2,KA
 36   FLST2(I) = FLST2(1)

C  STORE PARAMETERS FOR KA MAGNETS AND COMPUTE MATRICES
 40   CONTINUE
      M1 = M - 1
      CALL GETFL (M,3,4,PAR(3))
      DO 50 I=1,KA
      PAR(1) = FLST1(I)
      PAR(2) = FLST2(I)
      CALL STOFL(M1,1,6,PAR)
      CALL MAGNET (M1,PAR)
      M1 = M1 - 1
 50   CONTINUE

      RETURN
 500  WRITE (OUT3,501) KA,NTV
 501  FORMAT (5X,'CANNOT MAKE ',I5,'MATRICES.',
     1 'VECTOR ',A5,' IS NOT LARGE ENOUGH.')
      STOP

 550  WRITE (OUT3,551) KA
 551  FORMAT (5X,'CANNOT MAKE ',I5,'MATRICES.',
     1 ' NO VECTOR REFERENCED FOR LENGTHS OR GRADIENTS.')
      STOP

      END
