      SUBROUTINE MAGNET(M,PAR)
C  SET UP MAGNET MATRICES.

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=1000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=1000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/swtch.ccc'
C SWTCH.CCC
C      COMMON/SWTCH/BEND,MSIZE,CYCSWT,VCSW,PV,MSSW,VPR,MHS,MODS,MINZER
C      LOGICAL CYCSWT,MSSW,VCSW,PV,VPR,MHS,MODS

      include 'ccc/magbnd.ccc'
C  MAGBND.CCC
C      COMMON/MAGBND/RBEND
C      LOGICAL RBEND

      include 'ccc/const.ccc'
C CONST.CCC
C      COMMON/CONST/PIO2,PI,TPI,PI2,RADEG,M99
C      COMMON/CHCON/ASTRK,IBLNK
C      CHARACTER ASTRK*5,IBLNK*5

      DIMENSION RX(2,3),RY(2,3),F(2,3),D(2,3),A(2,3),PAR(*),RW(3)
      EQUIVALENCE (C,CH),(S,SH),(RW(1),EL),(RW(2),THETA),
     1              (RW(3),PL),
     2              (F(1,1),D(1,1),A(1,1))
      EQUIVALENCE (ALPHA,E1),(BETA,E2)
      LOGICAL STXX
      DATA IVERT/0/

C   KB=1:  VERTICAL PART OF MATRIX SET EQUAL TO HORIZONTAL PART
      KB = INFF(5,M)
      STXX = .FALSE.
      IF (KB.NE.0) STXX = .TRUE.

C IN MISALIGNMENT MODE IF BEND = 0.
      IF (PAR(1).LT.0)  THEN
         IVERT = 1
         PAR(1) = -PAR(1)
      END IF
      EL = PAR(1)
      PROF = PAR(2)
      RHO = PAR(3)
      OMEGA = PAR(4)
      RHOI = 1/RHO
C  CURV = OMEGA/RHO = CURVATURE OF REFERENCE ORBIT
C  OMEGA IS POSITIVE IF CENTER OF CURVATURE HAS A NEGATIVE X VALUE
C  RELATIVE TO REFERENCE ORBIT.

      CURV = OMEGA*RHOI
C  GAMMA, THE MAGNET WEDGE ANGLE , IS POSITIVE IF THE MAGNET FACES
C  INTERSECT ON THE SIDE OF THE REFERENCE ORBIT OPPOSITE TO THE CENTER
C  OF CURVATURE.

C  THETA = EL*OMEGA/RHO
      THETA = EL*CURV
      IF (CURV.EQ.0) GO TO 100
C  PAR(5) AND (6) ARE ENTRANCE AND EXIT ANGLES IN DEGREES.
C    IF EITHER OR BOTH ARE $ SIGN, MAGNETS ARE RECTANGULAR.
      ANG1 = PAR(5)
      ANG2 = PAR(6)
C    IF $ SIGN, THEN OBJA IN INFF(6,M) = 1
      IF (INFF(6,M).EQ.1) RBEND = .TRUE.
      IF (RBEND) GO TO 4
      E1 = PAR(5) * RADEG
      E2 = PAR(6)*RADEG
      GO TO 40
C  E1,E2 (EQUIVALENCED TO ALPHA AND BETA) ARE ANGLES IN RADIANS
C  RECTANGULAR MAGNET
C  RESET RBEND
 4    RBEND = .FALSE.
      IF (PROF.EQ.0.AND.EL.NE.0)  GO TO 200
      E1 = ABS(THETA)/2
      E2 = E1
 40   CONTINUE
      EFIN = SIN(ALPHA)*ABS(CURV)/COS(ALPHA)
      EFOUT = SIN(BETA)*ABS(CURV)/COS(BETA)
      ID = 1
      FC = 1
C  PK = FFK + OMEGA/RHO
 1    PK = FC * PROF + CURV * OMEGA
      IF (PK.EQ.0) GO TO 7
      FFK = SQRT(ABS(PK*RHOI))
      PHI = FFK*EL
      IF (PK.LT.0) GO TO 3
C  FOCUSSING MATRIX
 2    S = SIN(PHI)
      C = COS(PHI)
      F(1,1) = C
      F(1,2) = S/FFK
      F(1,3) = (CURV*(1-C)/(FFK*FFK))*BEND
      F(2,1) = -FFK*S
      F(2,2) = C
      F(2,3) = (CURV*S/FFK)*BEND
      IF (ID.EQ.1)  PL = -(PHI-S)*CURV*CURV/(FFK*FFK*FFK)
      GO TO 10
C  DEFOCUSSING MATRIX
 3    E = EXP(PHI)
      EI = 1/E
      CH = (E+EI)/2
      SH = (E-EI)/2
      D(1,1) = CH
      D(1,2) = SH/FFK
      D(2,1) = SH*FFK
      D(1,3) = (CURV*(CH-1)/(FFK*FFK))*BEND
      D(2,2) = CH
      D(2,3) = (CURV*SH/FFK)*BEND
      IF (ID.EQ.1)  PL = -(SH-PHI)*CURV*CURV/(FFK*FFK*FFK)
      GO TO 10
C  PK = 0 CASE
 7    A(1,1) =1
      A(1,2) = EL
      A(1,3) = (CURV*EL*EL/2)*BEND
      A(2,1) = 0
      A(2,2) = 1
      A(2,3) = (CURV*EL)*BEND
      IF (ID.EQ.1)  PL = -EL*EL*EL*CURV*CURV/6
C  CORRECT FOR EDGE FOCUSSING.
 10   A(1,1)=A(1,1)+A(1,2)*EFIN
      A(2,1) = A(1,1)*EFOUT + A(2,1) + A(2,2)*EFIN
      A(2,2) = A(1,2)*EFOUT + A(2,2)
      A(2,3) = A(1,3)*EFOUT + A(2,3)
      IF (ID.EQ.2) GO TO 20
C  SET UP RADIAL TRANSFER MATRIX.
      DO 15 I=1,2
      DO 15 J=1,3
      RX(I,J)=A(I,J)
 15   CONTINUE
      IF (IVERT.EQ.0)  GO TO 16
      IVERT = 0
      GO TO 26
 16   CURV = 0
      ID = 2
      EFIN=-EFIN
      EFOUT=-EFOUT
      FC=-1
      GO TO 1
C  SET UP VERTICAL TRANSFER MATRIX.
 20   DO  25 I=1,2
      DO  25 J=1,3
      RY(I,J)=A(I,J)
 25   CONTINUE
 26   IF (.NOT.STXX) THEN
         CALL STXY(M,RX,RY,RW)
      ELSE
         CALL STXY(M,RX,RX,RW)
      ENDIF
      RETURN
C QUADRUPOLE
 100  PHSQ=PROF*EL**2/RHO
      PHI = SQRT(ABS(PHSQ))
      IF(PHSQ.NE.0) GO TO 101
      CALL DRIFT(M,EL)
      RETURN
 101  C= COS(PHI)
      S = SIN(PHI)
      PL=0
      RX(1,1)=C
      RX(2,2)=C
      RX(1,2)=EL*S/PHI
      RX(2,1) = -S*PHI/EL
      RX(1,3)=0
      RX(2,3)=0
      E = EXP(PHI)
      CH=(E +1/E)/2
      SH= E - CH
      RY(1,1) = CH
      RY(2,2) = CH
      RY(1,2)=EL*SH/PHI
      RY(2,1)=SH*PHI/EL
      RY(1,3)=0
      RY(2,3)=0
      IF(PHSQ.GT.0) CALL STXY(M,RX,RY,RW)
      IF(PHSQ.LT.0) CALL STXY(M,RY,RX,RW)
       RETURN
C RECTANGULAR ZERO-GRADIENT DIPOLE
 200  C = COS(THETA)
      S = SIN(THETA)/THETA
      T = THETA*TAN(THETA/2)
      RX(1,1)=1
      RX(2,2)=1
      RX(1,2)=EL*S
      RX(2,1) = 0
      RX(1,3)=EL*(1-C)*BEND/THETA
      RX(2,3)=2*T*BEND/THETA
      PL=RX(1,2)-EL

      RY(1,1)=1-T
      RY(2,2)=1-T
      RY(1,2)=EL
      RY(2,1)=T*(T-2)/EL
      RY(1,3)=0
      RY(2,3)=0
      GO TO 26
      END
