      SUBROUTINE MATOUT(TRACE,KODE)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        PRINTS THE COVARIANCE MATRIX V.     CALCULATES AND PRINTS THE
CC        INDIVIDUAL CORRELATION COEFFICIENTS AND GLOBAL CORRELATIONS.

      include 'ccc/minima.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/simvec.ccc'

      DIMENSION VLINE(15)

      IF (ISW(2) .LT. 2)  RETURN
      WRITE (SVOUT,600)
      IF (TRACE .NE. 0)  WRITE (SVOUT,610)  TRACE
      IF (NPAR .EQ. 0)  GO TO 250
      ISWTR = ISW(5) - ITAUR
      IF (ISWTR .LT. 2)  GO TO 120
C                                       . . INTERNAL COVARIANCE MATRIX
      DO 100 I= 1, NPAR
  100 WRITE (SVOUT,620)  (V(I,J), J=1,I)
      WRITE (SVOUT,630)
  120 CONTINUE
C                                       . . . . . CORRELATION COEFFS. .
      IF (KODE .LT. 1)  GO TO 500
      IF (NPAR .LE. 1)  GO TO 500
      WRITE (SVOUT, 650)
      NPARM = MIN0(NPAR-1, 18)
      WRITE (SVOUT,690)  (ID,ID=1,NPARM)
  150 DO 200 I= 2, NPAR
      IM = I-1
      DO 170 J= 1, IM
      SQRAVV = SQRT(ABS(V(I,I)*V(J,J)))  
C  6/21/92 -- MODIFICATION TO AVOID BOMBING WHEN SQRT IS ZERO
      IF (SQRAVV.EQ.0) GO TO 210
  170 VLINE(J) = V(I,J)/SQRAVV
  200 WRITE (SVOUT,660)  I,(VLINE(IZ),IZ=1,IM)
      GO TO 250
  210 WRITE (SVOUT,700)
      DO 211 I=1,NPAR
      DO 211 J=1,I
  211 V(I,J) = 1.E10*V(I,J)
      GO TO 150
  250 CONTINUE
      WRITE (SVOUT, 630)
C                                       GLOBAL CORRELATION COEFFS . . .
      CALL UCOPY(V,P,MAXINT**2)
      CALL VERMIN(P,MAXINT,MAXINT,NPAR,IERR)
      IF(IERR .GT. 0)  RETURN
      WRITE (SVOUT,670)
      DO 400 I= 1, NU
      L = LCORSP(I)
      IF (L .EQ. 0)  GO TO 400
      GCC = 1 - 1/(V(L,L)*P(L,L))
      WRITE(SVOUT,680)  I, NAM(I), GCC
  400 CONTINUE
  500 RETURN
  600 FORMAT(/11X,'INTERNAL COVARIANCE MATRIX')
  610 FORMAT ('+',43X,' LAST FRACTIONAL CHANGE WAS ',F10.6)
  620 FORMAT (10X,11E10.3)
  630 FORMAT (1X )
  650 FORMAT (11X, 'CORRELATION COEFFICIENTS')
  660 FORMAT (8X,I3,18F6.3/(20F6.3))
  670 FORMAT (64X,'GLOBAL CORRELATION'/
     1 54X,  'PARAMETER     COEFFICIENT')
  680 FORMAT (47X,I5,2X,A10,F13.5)
  690 FORMAT (8X,'INT.',I4,17I6)
  700 FORMAT (/11X,'PRODUCT OF A PAIR OF DIAGONAL ELEMENTS IS TOO '
     1             ,'SMALL TO EVALUATE COEFFICIENTS,'
     2        /11X,'SO V(I,J) HAS BEEN MULTIPLIED BY 1.E10.')
      END
