      SUBROUTINE  MIGRAD

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        PERFORMS A LOCAL FUNCTION MINIMIZATION USING BASICALLY THE
CC        METHOD OF DAVIDON-FLETCHER-POWELL AS MODIFIED BY FLETCHER
CC        REF. -- FLETCHER, COMP.J. 13,317 (1970)   'SWITCHING METHOD'
CC
      include 'ccc/hessflg.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/deriva.ccc'

      DIMENSION GS(30),R(15),XXS(15),FLNU(15),VG(15),VII(15)
      DATA SLAMIN,SLAMAX,TLAMIN,TLAMAX/0.2D0, 3.0D0, 0.05D0, 6.0D0/

      IF (NPAR .LE. 0)  RETURN
      ISWTR = ISW(5) - ITAUR
      NPFN = NFCN
      PARN=NPAR
      RHO2 = 10*APSI
      ROSTOP = 1.0D-5
      ROSTOP = ROSTOP * APSI
      TRACE=1
      IFLAG=4
      IF (ISW(3) .EQ. 1)  IFLAG = 2
      FS = AMIN
      IF (ITAUR .LT. 1)  WRITE (SVOUT,470)  ROSTOP, APSI, VTEST
      GO TO 2
    1 WRITE (SVOUT,520)
C                                        . . . . STEP SIZES DIRIN . . .
    2 NPARD = NPAR
      TMP1 = 0.02D0
      TMP2 = 1.0D-8
      DO  3 I= 1, NPAR
      D = TMP1 * ABS(DIRIN(I))
      IF (ISW(2) .GE. 1)  D = TMP1 * SQRT(ABS(V(I,I))*UP)
      IF (D .LT. TMP2*ABS(X(I)))  D = TMP2 * X(I)

C KLUDGE ON 9 FEB. 1989:
      IF (D .LT.1.0D-10 )  D = 1.0D-10

    3 DIRIN(I) = D
C                                        . . . . . . STARTING GRADIENT
      NTRY = 0
    4 NEGG2 = 0
      DO 10  ID= 1, NPARD
      I = ID + NPAR - NPARD
      D = DIRIN(I)
      XTF = X(I)
      X(I) = XTF + D
      CALL INTOEX(X)
      CALL FCN(NPAR,G,FS1,U,4)
      NFCN = NFCN + 1
      X(I) = XTF - D
      CALL INTOEX(X)
      CALL FCN(NPAR,G,FS2,U,4)
      NFCN = NFCN + 1
      X(I) = XTF
      GS(I) = (FS1-FS2)/(2 * D)
      G2(I) = (FS1 + FS2 - 2*AMIN) / D**2
      TMP = 1.0D-30
      IF (G2(I) .GT. TMP)  GO TO 10
C                                        . . . SEARCH IF G2 .LE. 0. . .
      WRITE (SVOUT,520)
      NEGG2 = NEGG2 + 1
      NTRY = NTRY + 1
      IF (NTRY .GT. 4)  GO TO 230
      D = 50*ABS(DIRIN(I))
      XBEG = XTF
      IF (GS(I) .LT. 0)  DIRIN(I) = -DIRIN(I)
      KG = 0
      NF = 0
      NS = 0
    5 X(I) = XTF + D
      CALL INTOEX(X)
      CALL FCN(NPAR,G,F,U,4)
      NFCN = NFCN + 1
      IF (F .LE. AMIN)  GO TO 6
C         FAILURE
      IF (KG .EQ. 1)  GO TO 8
      KG = -1
      NF = NF + 1
      D = -2*D/5
      IF (NF .LT. 10)  GO TO 5
      D = 1000*D
      GO TO 7
C         SUCCESS
    6 XTF = X(I)
      D = 3*D
      AMIN = F
      KG = 1
      NS = NS + 1
      IF (NS .LT. 10)  GO TO 5
      IF (AMIN .LT. FS)  GO TO 8
      D = D / 1000
    7 XTF = XBEG
      G2(I) = 1
      NEGG2 = NEGG2 - 1
    8 X(I) = XTF
      DIRIN(I) = D / 10
      FS = AMIN
   10 CONTINUE
      IF (NEGG2 .GE. 1)  GO TO 4
      NTRY = 0
      MATGD = 1
C                                        . . . . . . DIAGONAL MATRIX
      IF (ISW(2) .GT. 1)  GO TO 15
   11 NTRY = 1
      MATGD = 0
      DO 13 I= 1, NPAR
      DO 12 J= 1, NPAR
   12 V(I,J) = 0
   13 V(I,I) = 2/G2(I)
C                                        . . . GET SIGMA AND SET UP LOOP
   15 SIGMA = 0
      DO 18 I= 1, NPAR
      IF (V(I,I) .LE. 0)  GO TO 11
      RI = 0
      DO 17 J= 1, NPAR
      XXS(I) = X(I)
   17 RI= RI+ V(I,J) * GS(J)
   18 SIGMA = SIGMA + GS(I) *RI /2
      IF (SIGMA .GE. 0)  GO TO 20
      WRITE (SVOUT,520)
      IF (NTRY.EQ.0)  GO TO 11
      ISW(2) = 0
      GO TO 230
   20 ISW(2) = 1
      ITER = 0
      CALL INTOEX(X)
      IF (ISWTR .GE. 1)  CALL MPRINT(0,AMIN)
      TMP = 0
      IF (ISWTR .GE. 2)  CALL MATOUT(TMP, 1)
C                                        . . . . .  START MAIN LOOP
   24 CONTINUE
      GDEL = 0
      DO 30  I=1,NPAR
      RI = 0
      DO 25 J=1,NPAR
   25 RI = RI + V(I,J) *GS(J)
      DIRIN(I) = -RI/2
      GDEL = GDEL + DIRIN(I)*GS(I)
C                                        .LINEAR SEARCH ALONG -VG  . . .
   30 X(I) =XXS(I) + DIRIN(I)
      CALL INTOEX(X)
      CALL FCN (NPAR, G, F, U, 4)
      NFCN=NFCN+1
C                                        . QUADR INTERP USING SLOPE GDEL
      DENOM = 2*(F-AMIN-GDEL)
      IF (DENOM .LE. 0)  GO TO 35
      SLAM = -GDEL/DENOM
      IF (SLAM .GT. SLAMAX)  GO TO 35
      IF (SLAM .LT. SLAMIN)  SLAM=SLAMIN
      GO TO 40
   35 SLAM = SLAMAX
   40 TMP = 0.1D0
      IF (ABS(SLAM-1) .LT. TMP)  GO TO 70
      DO 45 I= 1, NPAR
   45 X(I) =XXS(I) + SLAM*DIRIN(I)
      CALL INTOEX(X)
      CALL FCN(NPAR,G,F2,U,4)
      NFCN = NFCN + 1
C                                        . QUADR INTERP USING 3 POINTS
      AA = FS/SLAM
      BB = F/(1-SLAM)
      CC = F2/ (SLAM*(SLAM-1))
      DENOM = 2*(AA+BB+CC)
      IF (DENOM .LE. 0)  GO TO 48
      TLAM = (AA*(SLAM+1) + BB*SLAM + CC)/DENOM
      IF (TLAM .GT. TLAMAX)  GO TO 48
      IF (TLAM .LT. TLAMIN)  TLAM=TLAMIN
      GO TO 50
   48 TLAM = TLAMAX
   50 CONTINUE
      DO 51 I= 1, NPAR
   51 X(I) = XXS(I)+TLAM*DIRIN(I)
      CALL INTOEX(X)
      CALL FCN(NPAR,G,F3,U,4)
      NFCN = NFCN + 1
      IF (F.GE.AMIN .AND. F2.GE.AMIN .AND. F3.GE.AMIN) GO TO 200
      IF (F .LT. F2 .AND. F .LT. F3)  GO TO 61
      IF (F2 .LT. F3)  GO TO 58
   55 F = F3
      SLAM = TLAM
      GO TO 65
   58 F = F2
      GO TO 65
   61 SLAM = 1
   65 DO 67 I= 1, NPAR
      DIRIN(I) = DIRIN(I)*SLAM
   67 X(I) = XXS(I) + DIRIN(I)
   70 AMIN = F
      ISW(2) = 2
      IF (SIGMA+FS-AMIN .LT. ROSTOP)  GO TO 170
      IF (SIGMA+RHO2+FS-AMIN .GT. APSI)  GO TO 75
      IF (TRACE .LT. VTEST)  GO TO 170
   75 CONTINUE
      IF (NFCN-NPFN .GE. NFCNMX)  GO TO 190
      ITER = ITER + 1
      IF (ISWTR.GE. 3 .OR.(ISWTR.EQ. 2 .AND. MOD(ITER,10) .EQ.1))
     *      CALL MPRINT(0,AMIN)
C                                        . . . GET GRADIENT AND SIGMA .
      IF (ISW(3) .NE. 1)  GO TO 80
      CALL INTOEX(X)
      CALL FCN(NPAR,G,AMIN,U,IFLAG)
      NFCN = NFCN + 1
   80 CALL DERIVE(G,G2)
      RHO2 = SIGMA
      SIGMA = 0
      GVG = 0
      DELGAM = 0
      DO 100 I= 1, NPAR
      RI = 0
      VGI = 0
      DO 90 J= 1, NPAR
      VGI = VGI + V(I,J)*(G(J)-GS(J))
   90 RI = RI + V(I,J) *G (J)
      R(I) = RI / 2
      VG(I) = VGI/2
      GAMI = G(I) - GS(I)
      GVG = GVG + GAMI*VG(I)
      DELGAM = DELGAM + DIRIN(I)*GAMI
  100 SIGMA = SIGMA + G(I)*R(I)
      IF (SIGMA .LT. 0)  GO TO 1
      IF (GVG .LE. 0)  GO TO 105
      IF (DELGAM .LE. 0)  GO TO 105
      GO TO 107
  105 IF (SIGMA .LT. ROSTOP/10)  GO TO 170
      GO TO 1
  107 CONTINUE
C                                        .  UPDATE COVARIANCE MATRIX
      TRACE=0
      DO 120 I= 1, NPAR
      VII(I) = V(I,I)
      DO  120  J=1,NPAR
      D = DIRIN(I)*DIRIN(J)/DELGAM - VG(I)*VG(J)/GVG
  120 V(I,J) = V(I,J) + 2*D
      IF (DELGAM .LE. GVG)  GO TO 135
      DO 125 I= 1, NPAR
  125 FLNU(I) = DIRIN(I)/DELGAM - VG(I)/GVG
      DO 130 I= 1, NPAR
      DO 130 J= 1, NPAR
  130 V(I,J) = V(I,J) + 2*GVG*FLNU(I)*FLNU(J)
  135 CONTINUE
      DO 140 I= 1, NPAR
  140 TRACE = TRACE + ((V(I,I)-VII(I))/(V(I,I)+VII(I)))**2
      TRACE = SQRT(TRACE/PARN)
      IF (ISWTR .GE. 4)  CALL MATOUT(TRACE, 0)
      CALL UCOPY(X,XXS,NPAR)
      CALL UCOPY(G,GS,NPAR)
      FS = F
      GO TO 24
C                                        . . . . .  END MAIN LOOP
  170 WRITE(SVOUT,500)
      ISW(2) = 3
      IF(ISWTR .GE. 0)  CALL MPRINT(1-ITAUR,AMIN)
      ISWTR = ISWTR - 3*ITAUR
      IF (ISWTR .GT. 0)  CALL MATOUT(TRACE,1)
      IF (ITAUR .GT. 0)  GO TO 435
      IF (MATGD .GT. 0)  GO TO 435
      NPARGD = NPAR*(NPAR+5)/2
      IF (NFCN-NPFN .GE. NPARGD)  GO TO 435
      WRITE (SVOUT,180)
  180 FORMAT (' COVARIANCE MATRIX INACCURATE.',
     1 '  MINUIT WILL RECALCULATE')
      CALL HESSE
      IF (HESSBUG) GO TO 230
      CALL MPRINT(1,AMIN)
      TMP = 0
      CALL MATOUT(TMP, 1)
      IF (ISW(2) .GE. 2)  ISW(2) = 3
      GO TO 435
  190 ISW(1) = 1
      GO TO 230
  200 WRITE (SVOUT,650)
      CALL UCOPY(XXS,X,NPAR)
      ISW(2) = 1
      IF (SIGMA .LT. ROSTOP)  GO TO 170
      IF (MATGD .GT. 0)  GO TO 2
  230 WRITE (SVOUT,510)
      CALL  INTOEX(X)
      CALL MPRINT(1-ITAUR, AMIN)
      ISWTR = ISW(5) - ITAUR*3
      IF (ISWTR .LT. 1)  GO TO 435
      IF (ISW(2) .LE. 1)  GO TO 435
      CALL MATOUT(TRACE,1)
  435 RETURN
  470 FORMAT (' START MIGRAD MINIMIZATION.',19X,'CONVERGENCE CRITERIA',
     1' --  ESTIMATED DISTANCE TO MINIMUM (EDM) .LT.',E9.2/
     2 45X,  'OR EDM .LT. ',E9.2,
     3 ' AND FRACTIONAL CHANGE IN VARIANCE MATRIX .LT. ',E9.2)
  500 FORMAT (' MIGRAD MINIMIZATION HAS CONVERGED ')
  510 FORMAT (' MIGRAD TERMINATED WITHOUT CONVERGENCE ')
  520 FORMAT (11X,'COVARIANCE MATRIX IS NOT POSITIVE-DEFINITE.')
  650 FORMAT (' MIGRAD FAILS TO FIND IMPROVEMENT ')
      END
