      SUBROUTINE MINOS

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        PERFORMS A MINOS ERROR ANALYSIS ON THOSE PARAMETERS FOR
CC        WHICH IT IS REQUESTED ON THE MINOS COMMAND CARD.
CC        THE PARAMETER IN QUESTION IS VARIED, AND THE MINIMUM OF THE
CC        FUNCTION WITH RESPECT TO THE OTHER PARAMETERS IS FOLLOWED
CC        UNTIL IT CROSSES THE VALUE FMIN+UP.
CC
      include 'ccc/kard.ccc'

      include 'ccc/conpts.ccc'

      include 'ccc/const.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/deriva.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/minerr.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/varian.ccc'

      include 'ccc/variat.ccc'

      DIMENSION W(30)
      DIMENSION LMI(30), KIRSCH(5),XDEV(15)
      CHARACTER(4) APOS,ANEG,ASIG
      CHARACTER(1) ADOT,ASTAR
      DATA APOS,ANEG,ADOT,ASTAR / 'POSI','NEGA','.', '*' /

      IF (NPAR .LE. 0)  GO TO 700
C                                        . . UNPACK PARAMETER REQUESTS .
      MARC = 0
      DO 5 I=1,30
    5 LMI(I)=0
      KNT = 0
      DO  20 I= 2, 7
      LIME = INT(WORD7(I) + 0.5D0)
      IF (LIME .EQ. 0)  GO TO  20
      DO  10 K= 1, 5
      K2 = 6 - K
      LEMON = MOD(LIME,100)
      KIRSCH(K2) = LEMON
   10 LIME = LIME/100
      DO  15 J= 1, 5
      LEMON = KIRSCH(J)
      IF (LEMON .GT. MAXEXT)  GO TO  14
      IF (LEMON .EQ. 0)  GO TO  15
      IF (LCORSP(LEMON) .EQ. 0)  GO TO  14
      KNT = KNT + 1
      LMI(KNT) = LEMON
      GO TO  15
   14 MARC = 1
   15 CONTINUE
   20 CONTINUE
      IF (KNT .GT. 0)  GO TO  40
      DO  30 I= 1, MAXEXT
      IF (LCORSP(I) .LT. 1)  GO TO  30
      KNT = KNT + 1
      LMI(KNT) = I
      IF (KNT .EQ. 30)  GO TO  40
   30 CONTINUE
   40 CONTINUE
      IF (MARC .EQ. 1)  WRITE (SVOUT,811)
      WRITE (SVOUT, 810)  (LMI(IZ3),IZ3=1,KNT)
C                                        . . SAVE AND PREPARE START VALS
      SIGSAV = SIGMA
      TOLER = EPSI
      APSI = EPSI/2
      ITAUR = 1
      ABEST=AMIN
      AIM = AMIN + UP
      NSAVE = NFCNMX
      MPAR=NPAR
      DO 130 I= 1, MPAR
      XT(I) = X(I)
      DO 125 J= 1, MPAR
  125 VT(I,J) = V(I,J)
  130 CONTINUE
      DO 135 I= 1, NU
      ERP(I) = 0
      ERN(I) = 0
  135 W(I) = WERR(I)
      KNT = 0
C                                        . . . . . START MAIN LOOP . . .
  150 KNT = KNT + 1
      ISW(1) = 0
      NLIMIT = NFCN + NSAVE
      IF (KNT .GT. 30)  GO TO 590
      IF (LMI(KNT) .LT. 1)  GO TO 590
      ILAX = LMI(KNT)
      ERP(ILAX) = 0
      IT = LCORSP(ILAX)
      XTIT = XT(IT)
      CALL INTOEX(XT)
      UT = U(ILAX)
      SPT(1,1) = UT
      SPT(2,1) = AIM
      CHSPT(1) = ' '
      SPT(1,2) = UT
      SPT(2,2) = ABEST
      CHSPT(2) = ASTAR
      SPT(1,3) = UT
      SPT(2,3) = AIM + (AIM-ABEST)/5
      CHSPT(3) = ADOT
      NSPT = 3
      IF (LCODE(ILAX) .GT. 1)  GO TO 160
      ALIM(ILAX) = UT -100*W(ILAX)
      BLIM(ILAX) = UT +100*W(ILAX)
  160 CONTINUE
      XUNIT = SQRT(UP/VT(IT,IT))
      MARC = 0
      DO 162 I= 1, MPAR
      IF (I .EQ. IT)  GO TO 162
      MARC = MARC + 1
      XDEV(MARC) = XUNIT*VT(IT,I)
  162 CONTINUE
      CALL FIXPAR (IT,1,ILAX)
      SIG = 1
      ASIG = APOS
      DULIM = BLIM(ILAX) - UT
      IF(ISW(2).LT.1) GO TO 460
C                                        . SIG=SIGN OF ERROR BEING CALCD
  165 WRITE (SVOUT,806)  ASIG,ILAX,NAM(ILAX)
      ITER = 0
      LIMSET = 0
      DU1 = SIG*W(ILAX)
      IF (ABS(DU1) .LE. DULIM)  GO TO 180
      LIMSET = 1
      DU1 = SIG * DULIM
      IF (DULIM .LT. W(ILAX)/1000)    GO TO 440
  180 U(ILAX) = UT + DU1
      IF (NPAR .EQ. 0)  GO TO 205
      FAC = DU1/W(ILAX)
      DO 185 I= 1, NPAR
  185 X(I) = XT(I) + FAC*XDEV(I)
  200 CALL INTOEX (X)
  205 WRITE (SVOUT,801)  ILAX,UT,DU1,U(ILAX)
      CALL FCN(NPAR,G,AMIN,U,4)
      NFCN = NFCN + 1
      NFCNMX = NLIMIT - NFCN
      CALL MIGRAD
      IF (AMIN .LT. ABEST)  GO TO 650
      IF (ISW(1) .GE. 1)  GO TO 450
      IF (ISW(2) .GE. 2)  GO TO 240
      NFCNMX = NLIMIT - NFCN
      CALL SMPLXX
      IF (AMIN .LT. ABEST)  GO TO 650
      IF (ISW(1) .GE. 1)  GO TO 450
      NFCNMX = NLIMIT - NFCN
      CALL MIGRAD
      IF (AMIN .LT. ABEST)  GO TO 650
      IF (ISW(1) .GE. 1)  GO TO 450
      IF (ISW(2) .LT. 2)  GO TO 460
  240 CREM = AMIN - ABEST
      NSPT = NSPT + 1
      SPT(1,NSPT) = U(ILAX)
      SPT(2,NSPT) = AMIN
      CHSPT(NSPT) = ASIG(1:1)
      IF (CREM .LE. 0)  GO TO 650
      SQUC = SQRT(UP/CREM)
      IF (ABS(AMIN-AIM) .LT. TOLER)  GO TO 400
C                                        . . ANOTHER ITERATION NECESSARY
      ITER = ITER + 1
      IF (ITER .GT. 6)  GO TO 430
      IF (ITER .EQ. 1)  GO TO 270
C       CHECK PREVIOUS ITERATION TO AVOID OSCILLATING
      SQUC2 = SQUC
      IF ((SQUC2-1) * (SQUC1-1) .GT. 0)  GO TO 270
      TMP  = 0.65D0
      TMP1 = 0.35D0
      SQUC = TMP*SQUC2 + TMP1
      SQUC11 = 1/SQUC1
      IF ((SQUC11-SQUC)*(SQUC-1) .GT. 0)  GO TO 270
      WRITE (SVOUT,260)
  260 FORMAT (  ' MINOS IS HAVING TROUBLE WITH THIS PARAMETER')
      TMP = 0.5D0
      SQUC = TMP*SQUC11 + TMP
  270 CONTINUE
      SQUC1 = SQUC
      DU1 = DU1 * SQUC
      IF (ABS(DU1) .LE. DULIM)  GO TO 280
      IF (LIMSET .EQ. 1)  GO TO 440
      LIMSET = 1
      DU1 = SIG*DULIM
  280 U(ILAX) = UT + DU1
      DO 290 I= 1, NPAR
  290 X(I) = XT(I) + SQUC*(X(I)-XT(I))
      GO TO 200
C                                        . ERROR SUCCESSFULLY CALCULATED
  400 EROS = DU1 * SQUC
      WRITE (SVOUT,808)  ASIG,ILAX,NAM(ILAX),EROS
  410 WRITE (SVOUT,812)
      IF (SIG .GT. 0)  GO TO 420
      ERN(ILAX) = EROS
      GO TO 500
  420 ERP(ILAX) = EROS
      SIG = -1
      ASIG = ANEG
      DULIM = UT - ALIM(ILAX)
      GO TO 165
C                                        . . . . . . . . FAILURE RETURNS
  430 WRITE (SVOUT, 809)
      EROS = 0
      GO TO 410
  440 WRITE (SVOUT, 807)  ASIG,ILAX,NAM(ILAX),DULIM
      EROS = 0
      GO TO 410
  450 WRITE (SVOUT, 802)  NSAVE
      GO TO 500
  460 WRITE (SVOUT, 805)
C                                        . . PARAMETER FINISHED. RESET V
  500 CONTINUE
      CALL RESTOR(1)
      ISW(2) = 3
      DO 560 I= 1, MPAR
      DO 550 J= 1, MPAR
  550 V(I,J) = VT(I,J)
  560 CONTINUE
      IF (NSPT .LT. 9)  GO TO 150
      NSPT3 = NSPT - 3
      WRITE (SVOUT,813)  ILAX,NAM(ILAX),NSPT3
      CALL PLTCON(NSPT,SPT,CHSPT)
      WRITE(SVOUT,814)  ILAX
      GO TO 150
C                                        . . . . PRINTOUT FINAL VALUES .
  590 CALL UCOPY(XT,X,MPAR)
      CALL INTOEX (XT)
      SIGMA = SIGSAV
      AMIN = ABEST
      CALL MPRINT(2,AMIN)
      TMP = 0
      CALL MATOUT(TMP, 1)
      GO TO 700
C                                        . . . NEW MINIMUM FOUND . . . .
  650 NEWMIN = 1
      ISW(2) = 0
      CALL RESTOR(1)
      CALL EXTOIN(X)
      DO 670 I= 1, NPAR
  670 DIRIN(I) = SQRT(VT(I,I)*UP)
  700 RETURN
  801 FORMAT ('0PARAMETER ',I4,' SET TO',E11.3,' + ',E10.3,' = ',E12.3)
  802 FORMAT ('0CALL LIMIT EXCEEDED.  CALCULATION OF MINOS ERROR FOR',
     1' THIS PARAMETER REQUIRES MORE THAN',I5,' FCN CALLS.'/)
  805 FORMAT (/45X, 'MINOS ERROR NOT CALCULATED FOR THIS PARAMETER.')
  806 FORMAT ('0DETERMINATION OF ',A4,
     1  'TIVE MINOS ERROR FOR PARAMETER ',I3, 2X,A10)
  807 FORMAT (/45X,'THE ',A4,'TIVE MINOS ERROR OF PARAMETER',I3,', ',
     1 A10, ', EXCEEDS ',E12.4)
  808 FORMAT (/45X,'THE ',A4,'TIVE MINOS ERROR OF PARAMETER',I3,', ',
     1 A10,' IS ',E12.4)
  809 FORMAT (/45X,'TOO MANY ITERATIONS. SEE PLOT BELOW FOR DETAILS.')
  810 FORMAT (' MINOS ERRORS REQUESTED FOR PARAMETERS',30I3//)
  811 FORMAT (' THERE ARE MISTAKES IN THE MINOS COMMAND CARD JUST',
     1 ' READ')
  812 FORMAT (45X, 75('*'))
  813 FORMAT ('1MINOS FINDS NON-PARABOLIC BEHAVIOR FOR PARAMETER ',I3,
     12X,A10/' ERROR CALCULATION REQUIRED ',I3,' MINIMIZATIONS.',
     2 ' A SUMMARY OF POINTS FOUND IS PLOTTED BELOW.'/
     3'0   FCN VALUE ')
  814 FORMAT ('+         PARAMETER  ',I3,','/)
      END
