      SUBROUTINE MOVE(M,N,V)

C Revised by EDC 5/11/93 so as to treat elements other than MAG and SXTP
C correctly (previous versions were wrong)


      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'ccc/binff.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/const.ccc'

      include 'ccc/seed.ccc'

      DOUBLE PRECISION L,K

      DIMENSION T(7,7),RW(3),RW1(3),PAR(10),ML(7),V(7)
      EQUIVALENCE (PAR(1),HX),(PAR(2),DHX),(PAR(3),HY),(PAR(4),DHY),
     1            (PAR(5),HZ),(PAR(6),THETZ)
     2           ,(PAR(7),XIN),(PAR(8),YIN),(PAR(9),XOUT),(PAR(10),YOUT)

      DIMENSION PARR(6)
      DIMENSION PP(6)
      DIMENSION W(7),PAT(4)
      LOGICAL QDSW,SXSW,magsw
      CHARACTER(5) KIND,NOPQ,CHDAT,NAVEC,NAPAR
      DATA RW1/3*0.0D0/

C  MISALIGNMENT OF ELEMENTS ---SIX DEGREES OF FREEDOM.
C  USES 7X7 FORMALISM IN CONJUNCTION WITH FXPT, TRK AND CYEM.
C  CLOSED ORBIT FOUND BY FXPT RATHER THAN CYX WHICH NEEDS MAGS.  EXAMPLE
C.......................................................................
C  QF   MAG      //L      /G       /BRHO
C  H    VEC  6   //HX     /DHX     /HY      /DHY     /HZ      /THETZ
C  ---FORMAT 1-----
C  QF*  MOVE     //QF     /H
C.........................................................................
C  ---FORMAT 2 ------
C  QF*  MOVE     //QF   V /       /HX     /DHX     /HY       /DHY
C..............................................................................
C   M = INDEX OF MOVE COMMAND.  N=INDEX OF ELEMENT AT WHICH MATRIX
C                                 FOR M TO BE STORED.
C   V = ORBIT MAPPED.  MQ=INDEX OF ELEMENT MOVED.  MPAR=INDEX OF VEC.
C   KB.GE.1 -- PARAMETERS RANDOM.  KB.GE.2--RANDOM SEED RESET SO NEXT
C  SET IS THE SAME (USEFUL FOR SPLIT QUADS)
C  HX,HY,HZ ARE TRANSLATIONS ALONG X,Y,Z AXES,
C  DHX, DHY ARE ROTATIONS ABOUT THE Y,X AXES, I.E. TILTS IN X-Z, Y-Z
C  THETZ IS ROTATION ABOUT Z AXIS.  Z = BEAM DIR., X = HOR., Y = VERT.
C  ORDER OF MISALIGNMENTS---LONGITUDINAL(Z), TRANSVERSE(X,Y), Z-ROTATION
C  M IS THE INDEX OF THE MOVE COMMAND.
C  N IS THE INDEX OF THE ELEMENT AT WHICH THE MATRIX CORRESPONDING
C     TO M IS TO BE STORED.
C  V IS THE ORBIT TO BE MAPPED BY THE MATRIX T CORRESPONDING TO M.
C  MQ IS THE INDEX OF THE ELEMENT TO BE MOVED.
C  If it is a MAG, momentum modified by (1+dp/p), and field modified by
C  gradient*(initial x + dx*L/2).
C  MPAR IS THE INDEX OF THE VEC COMMAND THAT CONTAINS THE MISALIGNMENTS.
C  KB GE.1 -- PARAMETERS RANDOM
C  KB GE.2 - RANDOM SEED RESET SO NEXT PASS IS SAME

      MQ=MDAT(M,1)
      KB=INFF(5,M)
      IF (KB.GE.2) NRN = NRZZ
 10   QDSW = .FALSE.
      KIND = CINFF(4,M)
      IF (KIND.EQ.'MAP')  GO TO 3
      NOPQ=CINFF(1,MQ)
      magsw = .false.
      SXSW = .FALSE.
      IF (NOPQ.NE.'MAG')  GO TO 12
      magsw = .true.
      CALL GETFL(MQ,1,6,PAR)
      IF (PAR(4).EQ.0) QDSW = .TRUE.
      L=PAR(1)
      GO TO 11
 3    SXSW = .TRUE.
      CALL GETFL(MQ,1,4,PAT)
      L = PAT(1)
      GO TO 11
 12   CALL RTRV7 (MQ,T,RW)
      L=RW(1)
      K = 0
 11   IF (M.NE.N)  GO TO 7
      NAVEC = CHDAT(M,2)
      IF (NAVEC.EQ.IBLNK) GO TO 7
      MVEC = MDAT(M,2)
      CALL GETQ(MVEC,1,7,V)
 7    NAPAR = CHDAT(M,3)
      MPAR = M
      HZ = 0
      THETZ = 0
      NVARS = 4
      IF (NAPAR.EQ.IBLNK) GO TO 1
      NVARS = 6
      MPAR = MDAT(M,3)
 1    CALL GETFL(MPAR,1,NVARS,PARR)
      DO111 I=1,NVARS
      PAR(I)=PARR(I)
      TMP = 0.5D0
      IF(KB.GE.1) PAR(I)=PAR(I)*(RANSYN(NRZZ)-TMP)
 111  CONTINUE
      TLX=L*DHX/2
      HX1=HX-TLX
      HX2=HX+TLX
      TLY=L*DHY/2
      HY1=HY-TLY
      HY2=HY+TLY

 2    ML(1)=M7END-1
      ML(2)=M7END-2
      ML(3)=M7END-6

      CALL DRIFT(M7END-1,HZ)
      CALL RTRV7(MUNIT,T,RW)
      T(1,7)=-HX1
      T(2,7)=-DHX
      T(3,7)=-HY1
      T(4,7)=-DHY
      CALL STOR7(M7END-2,T,RW1)

      IF (HZ.EQ.0.AND.THETZ.EQ.0)  GO TO 201
      CALL DRIFT(M7END-1,HZ)
      CALL ROTZ(THETZ,T)
      CALL STOR7(M7END-6,T,RW1)

      CALL MMM(M7END-2,3,ML)

 201  CONTINUE
      CALL RTRV7(M7END-2,T,RW)
      CALL MXV7(T,V,V)
      IF (.NOT.QDSW)  GO TO 20
      CALL MODQ (MQ,N,V,W)
      GO TO 8
 20   IF (.NOT.SXSW)  GO TO 21
      CALL SXTP(N,V,PAT)
      GO TO 14
 21   if  (magsw) then
C If element is MAG, correct for momentum and displaced field center
         CALL GETFL(MQ,1,6,PP)
         PP(3) = PP(3)*(1+V(6))
         PP(4) = PP(4)+PP(2)*(V(1)+V(2)*L/2)
C  .........INSERTION FROM E. COURANT 6/90
         IF(INFF(6,MQ).EQ.1) THEN
            PP(5)=ABS(PP(1)*PP(4)/PP(3))/2./RADEG
            PP(6)=PP(5)
         END IF
         CALL MAGNET(N,PP)
         CALL RTRV7(N,T,RW)
C VERTICAL DEFLECTION FOR ROTATED DIPOLE
         IF(NVARS.EQ.6.AND.THETZ.NE.0) THEN
            ELM=PP(1)
            RM =PP(3)/PP(4)
            THM=ELM/RM
            CM=1-COS(THM)
            SM=SIN(THM)
            CZ=1-COS(THETZ)
            SZ=SIN(THETZ)
            T(1,7)=-RM*CZ*CM
            T(2,7)=-CZ*SM
            T(3,7)=-RM*SZ*CM
            T(4,7)=-SZ*SM
            CALL STOR7 (N,T,RW)
         END IF
C ................END INSERTION ....................
      else
C Element other than MAG or SXTP
         call rtrv7(mq,t,rw)
         call stor7(n,t,rw)
      end if
      CALL MXV7(T,V,W)

 8    XIN=V(1)
      YIN=V(3)
      XOUT=W(1)
      YOUT=W(3)
      DO 112 I=1,NVARS
 112  PAR(I)=PARR(I)
C  CORRECTION 5/9/89 FROM EDC
C      CALL STOFL(M,5,6,PAR(5))
      CALL STOFL(M,1,10,PAR)

      DO 9 I=1,7
 9    V(I) = W(I)

 14   CALL RTRV7 (MUNIT,T,RW)
      T(1,7)=-HX2
      T(2,7)=-DHX
      T(3,7)=-HY2
      T(4,7)=-DHY
      CALL STOR7(M7END-7,T,RW)

      ML(1)=-(M7END-6)
      ML(2) = -(M7END-7)
      ML(3)=-(M7END-1)
      IF (HZ.EQ.0.AND.THETZ.EQ.0) ML(1) = MUNIT
      IF (ML(1).EQ.MUNIT) ML(3) = MUNIT
      CALL MMM(M7END-7,3,ML)

      ML(1)=M7END-2
      ML(2)=N
      ML(3) = M7END - 7

      CALL RTRV7(M7END-7,T,RW)
      CALL MXV7(T,V,V)
      IF(N.EQ.0) GO TO 113
      CALL MMM(N,3,ML)
      IF(M.NE.N) GO TO 113
      CALL RTRV7(N,T,RW)
      CALL ROW5(T)
      CALL STOR7(N,T,RW)

 113  IF (KB.GE.2)  NRZZ = NRN
      RETURN
      END
