      SUBROUTINE MPRINT  (IKODE,FVAL)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        PRINTS THE VALUES OF THE PARAMETERS AT THE TIME OF THE CALL.
CC        ALSO PRINTS OTHER RELEVANT INFORMATION SUCH AS FUNCTION VALUE,
CC        ESTIMATED DISTANCE TO MINIMUM, PARAMETER ERRORS, STEP SIZES.
CC        ACCORDING TO THE VALUE OF IKODE,THE PRINTOUT IS LONG FORMAT,
CC        SHORT FORMAT, OR MINOS FORMAT (0,1,2)
CC

      include 'ccc/const.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/minerr.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/varian.ccc'

      CHARACTER(8) TIME

C                                        . GET TIME AND PRINT HEADINGS .
      CALL DTSTMP( DATE, TIME )
      IF (IKODE .EQ. 2)  GO TO 10
      WRITE (SVOUT,1000)
      GO TO 18
C                  IKODE = 2        MINOS PRINTOUT HAS SPECIAL HEADINGS.
   10 WRITE (SVOUT,1006)  TITLE,DATE
   18 E = SIGMA
      KOUNT = 0
C                                        . . . LOOP OVER PARAMETERS . .
      DO 200 I= 1, NU
      IF (NAM (I).EQ.IBLNK) GO TO 200
   20 L = LCORSP(I)
      IF (L .EQ. 0)  GO TO 55
C              VARIABLE PARAMETER.  CALCULATE EXTERNAL ERROR IF V EXISTS
      IF (ISW(2) .LT. 1)  GO TO 27
      DX = SQRT(ABS(V(L,L)*UP))
      IF (LCODE(I) .LE. 1)  GO TO 26
      AL = ALIM(I)
      BA = BLIM(I) - AL
      DU1 = AL + (SIN(X(L)+DX) +1) * BA / 2 - U(I)
      DU2 = AL + (SIN(X(L)-DX) +1) * BA / 2 - U(I)
      IF (DX .GT. 1)  DU1 = BA
      DX = (ABS(DU1) + ABS(DU2))/2
   26 WERR(I) = DX
   27 X1 = X(L)
      X2 = DIRIN(L)
      IF (IKODE .LT. 2)  GO TO 29
      X1 = ERP(I)
      X2 = ERN(I)
   29 IF (KOUNT.GT.0)  GOTO 40
      KOUNT = 1
      WRITE (SVOUT,1001) FVAL,NFCN,TIME,E, L,I,NAM(I),NMIND(I),U(I),
     1            WERR(I) ,X1,X2
      GO TO 45
   40 WRITE (SVOUT,1002)   L,I,NAM(I),NMIND(I),U(I),WERR(I),X1,X2
   45 IF (LCODE(I) .LE. 1)  GO TO 200
      TMP = .001D0
      IF (ABS(COS(X(L))) .LT. TMP)  WRITE (SVOUT,1004)
      GO TO 200
C                           FIXED PARAMETER.  PRINT ONLY IF IKODE .GT.0
   55 IF (IKODE .EQ. 0)  GO TO 200
      IF (KOUNT.GT.0)  GOTO 70
      KOUNT = 1
      WRITE (SVOUT,1001) FVAL,NFCN,TIME,E, L,I,NAM(I),NMIND(I),U(I)
      GO TO 200
   70 WRITE (SVOUT,1003)                   I,NAM(I),NMIND(I),U(I)
  200 CONTINUE
      IF (IKODE.GE.1 .AND.ISW(2).GE.1)  WRITE (SVOUT,1005)  UP
      RETURN
 1000 FORMAT(/ 4X,'FCN VALUE',5X,'CALLS',4X,'TIME',4X,
     1   ' EDM  ', 4X,  'INT.EXT.',
     2 ' PARAMETER     VALUE         ERROR      INTERN.',
     3 'VALUE  INT.STEP SIZE')
 1001 FORMAT (   E15.7,I7,1X,A8, E11.2,   I6,I4,1X,A5,A5,4E14.5)
 1002 FORMAT (42X,I6,I4,1X,A5,A5,4E14.5)
 1003 FORMAT (48X, I4,1X,A5,A5,4E14.5)
 1004 FORMAT (53X,  'WARNING -   - ABOVE PARAMETER IS AT LIMIT.')
 1005 FORMAT (/45X,'ERRORS CORRESPOND TO FUNCTION CHANGE OF ',
     1 F10.4)
 1006 FORMAT ('1',40X,'RESULTS OF FULL MINOS ERROR ANALYSIS'/
     1 41X,36('*')//20X,13A5, A8//
     2 80X,'PARABOLIC',4X,'...... MINOS ERRORS ......'/
     3 4X,'FCN VALUE',5X,'CALLS',4X,'TIME',4X,' EDM  ',4X,'INT.EXT.',
     4' PARAMETER     VALUE         ERROR        POSITIVE      ',
     5'NEGATTIVE')
      END
