      SUBROUTINE MXDIV(V,IN,IM,DET,IDIM)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C                      MATRIX DIVISION
C     REPLACES B BY (A INVERSE)*B.  DESTROYS A.
C     A IS N BY N, B IS N BY M.  A AND B ARE STORED IN V(N,N+M).
C     N MUST NOT EXCEED 4 .
      INTEGER PERM,P
      DIMENSION PERM(4)
      DIMENSION V(IDIM,1)
      N=IN
      M=MAX0(IM,0)
C
      NM1=N-1
      NP1=N+1
      NPM=N+M
  200 DO 201 I=1,N
      PERM(I)=I
  201 CONTINUE
      DETERM=1
      P=1
  202 CONTINUE
      IMIN=P+1
C                          FIND PIVOT
      PIVOT=0
      DO 209 I=P,N
      DO 208 J=P,N
      SAVE=ABS(V(I,J))
      IF (SAVE .LE. PIVOT) GO TO 208
      PIVOT=SAVE
      IBIG=I
      JBIG=J
  208 CONTINUE
  209 CONTINUE
      IF (PIVOT .GT. 0) GO TO 210
      DETERM=0
      GO TO 290
C                          ROW EXCHANGE AND ROW REDUCTION
  210 PIVOT=V(IBIG,JBIG)
      DETERM=DETERM*PIVOT
      DO 219 J=P,NPM
      SAVE=V(IBIG,J)/PIVOT
      V(IBIG,J)=V(P,J)
      V(P,J)=SAVE
  219 CONTINUE
      IF(IBIG .NE. P) DETERM=-DETERM
  220 CONTINUE
      IF (P .GE. N) GO TO 250
C                          COLUMN EXCHANGE
      IF (JBIG .EQ. P) GO TO 230
      ISAVE=PERM(P)
      PERM(P)=PERM(JBIG)
      PERM(JBIG)=ISAVE
      DO 229 I=1,N
      SAVE=V(I,P)
      V(I,P)=V(I,JBIG)
      V(I,JBIG)=SAVE
  229 CONTINUE
      DETERM=-DETERM
  230 CONTINUE
      V(P,P)=1
C                          BLOCK REDUCTION
      DO 239 I=IMIN,N
      DO 238 J=IMIN,NPM
      V(I,J)=V(I,J)-V(I,P)*V(P,J)
  238 CONTINUE
      V(I,P)=0
  239 CONTINUE
      P=P+1
  249 GO TO 202
C                          BACK SUBSTITUTION
  250 CONTINUE
      IF (M .LE. 0) GO TO 290
      DO 259 K=NP1,NPM
      V(N,1)=V(N,K)
      DO 253 P=1,NM1
      I=N-P
      V(I,1)=V(I,K)
      DO 252 J=I,NM1
      V(I,1)=V(I,1)-V(J+1,1)*V(I,J+1)
  252 CONTINUE
  253 CONTINUE
      DO 256 J=1,N
      P=PERM(J)
      V(P,K)=V(J,1)
  256 CONTINUE
  259 CONTINUE
C
  290 CONTINUE
      DET=DETERM
      RETURN
       END
