      SUBROUTINE NPOL(M,V,PAR)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  Q   NPOL   N   J     L       CM     BRHO
C   N = ORDER OF PERTURBATION IN HAMILTONIAN, M=N-1
C   J =0,1  FOR NORMAL OR SKEW N-POLE LENS
C   L = EEFFECTIVE LENGTH
C   CM = TAYLOR EXPANSION COEFFICIENT OF MEDIAN-PLANE EXPRESSION OF FIELD.

C J=0   BY + I*BX = SUM(CM/M!) Z**M     (Z = X+I*Y)
C J=1   BX - I*BY = SUM(CM/M!) Z**M
C      PARTICLE  V(I) = X,PX,Y,PY,O,O,DPP
C      N =2   QUAD,  N=3  SEXT,   N=4 OCT,   N=5,DEC

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=1000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=1000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/dim.ccc'
C DIM.CCC
C      COMMON /DIM/ LEND,MEND,ISAV,ISAV7,M7END,KADD,KADDR,MUNIT,MSYMPL,
C     1             INFMAX,IFLMAX,IMAX,ICHMAX,ISFMAX,IQMAX,IMIN


      DIMENSION V(*),PAR(*),R(7,7),RW(3),ML(3),PR(3),W(6)
      DOUBLE PRECISION L,LH
      COMPLEX(KIND(0D0)) II,Z,DP,Q
      DATA II/(0.D0,1.0D0)/

      EQUIVALENCE (PR(1),L),(PR(2),CM),(PR(3),BRHO),(W(1),X),
     1            (W(2),PX),(W(3),Y),(W(4),PY),(W(6),DPP)

      NN=M
      DO 5 I=1,3
 5    PR(I) = PAR(I)
      DO 6 I=1,6
 6    W(I) = V(I)
      BR = (1+DPP)*BRHO
      UM = CM/BR
      IF (L.NE.0)  THEN
        LH = L/2
        X = X + PX*LH
        Y = Y + PY*LH
        UM=L*UM
      ENDIF
      NP = INFF(4,NN)
      IF (NP.EQ.0) NP = 3
      JP = INFF(5,NN)
      MP = NP - 1
      MPM=NP-2
      Z=X+II*Y
      CALL RTRV7(MUNIT,R,RW)

      Q=UM
      IF(JP.NE.0)Q=II*Q
      IF(MPM.GT.0) THEN
         DO 11 I=1,MPM
 11      Q=Q*Z/I
      ENDIF
      DP=Q*Z/MP
      R(2,1) = REAL(-Q)
      R(2,3) = REAL(-II*Q)
      DPX    = REAL(-DP)
      DPY    = REAL(-II*DP)

      R(4,3) = -R(2,1)
      R(4,1) = R(2,3)
      V(2) = PX + DPX
      V(4) = PY + DPY
      IF (L.NE.0)  THEN
        V(1) = X + V(2) *LH
        V(3)=Y+V(4)*LH
      ENDIF
      R(2,6) = -DPX
      R(2,7) = -DPX
      R(4,6) = -DPY
      R(4,7) = -DPY
      R(5,1) = DPX
      R(5,3) = DPY
      RW(2)=-DPX
      IF (L.NE.0)  THEN
        ML(1) = MEND - 3
        ML(2) = M
        ML(3) = MEND - 3
        CALL DRIFT(MEND-3,LH)
        CALL STOR7(M,R,RW)
        CALL MMM(M,3,ML)
        RETURN
      ENDIF
      CALL STOR7(M,R,RW)
      RETURN
      END
