      SUBROUTINE ORBIT(MM)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)


C****NOTE*****     9-17-91
C        FILES ORB1 IS IN COMMON BLOCK FILES.
C        FILE ORB1 IS MADE BY CYX.  ITS NUMBER IS SET IN BLOCK DATA.

C  ORBIT PROGRAM USES MICADO TO CALCULATE OPTIMIZED CORRECTORS
C   FOR GIVEN ORBIT WITH FIELD ERRORS.
C   FORMAT IS

C      ORBC  KA   KB FX        MON  COR  DELM     DELY

C  WHERE KA=0 FOR HORIZONTAL, 1 FOR VERTICAL CORRECTION
C  FX = NAME OF A FXPT INSTRUCTION DEFINING THE INITIAL ORBIT
C  (FX DATA RECORD   MUST HAVE A 1 IN COLUMN 55)
C  MON IS NAME OF ELEMENTS IN BEAM LINE WHERE DISPLACEMENETS ARE
C  ASSUMED TO BE MEASURED
C  COR IS NAME OF CORRECTION ELEMENTS IN BEAM LINE
C  MAXIMUM NUMBER MC OF EACH IS NORMALLY SET AT 150.
C  (THERE SHOULD BE MANY IDENTICAL MON-S AND COR-S IN BEAM LINE)
C  DELM = ASSUMED MEASUREMENT ERROR (+-DELM/2)
C  DELY = TOLERABLE RANGE OF FINAL RESIDUAL ORBIT ERRORS
C  (ITERATIONS WILL STOP WHEN THIS LEVEL IS REACHED)
C  ABS(KB) = MAX NO. OF ITERATIONS.  IF KB NEGATIVE, ALL INTER-
C  MEDIATE ITERATIONS AS WELL AS THE MATRIX RELATING ORBIT
C  DISPLACEMENTS TO CORRECTORS ARE WRITTEN OUT.
C  IF KB POSITIVE, ONLY FIRST AND LAST ITERATIONS ARE WRITTEN
C  AND MATRIX WRITE IS SUPPRESSED.

      include 'ccc/const.ccc'

      include 'ccc/corb.ccc'

      include 'ccc/binff.ccc'

      include 'ccc/bmi1.ccc'

      include 'ccc/files.ccc'

      include 'ccc/seed.ccc'

C AAA.CCC
      INTEGER MC
      PARAMETER (MC=150)
      DOUBLE PRECISION BETA(2,MC),ALPHA(MC),AP(MC),B(MC),R(MC),X(MC)
      DOUBLE PRECISION RHO(3*MC),XA,XX(MC),A(MC,MC),AA(MC,MC),BB(MC)
      DOUBLE PRECISION DUM(7)
      INTEGER NB(MC),NA,NC,NX(MC),NV(MC)

      DOUBLE PRECISION MX,MY,MU(2,MC),NU,K(MC),L(MC),M11,M12
      LOGICAL KPR,KPP
      CHARACTER(5) CHDAT,MON,NACOR,NAME
C Save old correctors to enable successive iterations 1/21/93
      dimension thz(mc),tvz(mc)
      do 222 i=1,mc
         thz(i)=th(i)
 222     tvz(i)=tv(i)      
      NRR=NRZZ
      MFXP = MDAT(MM,1)
      KA = INFF(4,MM)
      KB = INFF(5,MM)
      MBML=MDAT(MFXP,2)
      NDAT=INFF(17,MBML)
      CALL MIFILL(MBML,1,NDAT,NELS1,MI1,MI1SIZ)
      MON = CHDAT(MM,3)
      LM1 = LOCC(MON,1,NELS1,MI1,NB,NMON)
      M=NMON
      KPR = .FALSE.
      IF (KB.LE.0)  KPR = .TRUE.
      ITER = ABS(KB)
      IF (KB.EQ.0) ITER = 1
      KPP = KPR
      IFLAG=KA
      EPS = FLDAT(MM,1)
      EPSB = FLDAT(MM,2)
      EPSZ = EPS
      NACOR = CHDAT(MM,4)
      LCOR = LOCC(NACOR,1,NELS1,MI1,NX,N)
      IF (KA.EQ.1) GO TO 9
      NAMONH = MON
      NACORH = NACOR
      NNH = N
      GO TO 26
 9    NAMONV = MON
      NACORV = NACOR
      NNV = N
 26   CONTINUE
 
      WRITE ( OUT3,3)
    3 FORMAT('1')
      WRITE(OUT3,106) EPSB,EPS
  106 FORMAT(1X,'DISPERSION DE MESURE  (mm)',F10.5/
     .       1X,'C.A.C. RESIDUEL (m)  ',F10.5/)
      WRITE (OUT3,100)
  100 FORMAT(1X,'CORRECTEURS'/)
      WRITE (OUT3,1)(NX(I),I=1,N)
      WRITE (OUT3,101)
  101 FORMAT(1X,'STATIONS'/)
      WRITE (OUT3,1)(NB(I),I=1,M)
 1    FORMAT (10I5)
      IB=1
      IC=1
      REWIND ORB1
   11 READ(ORB1) IEL
      READ (ORB1)
      ICC=0
        DO 12 I=1,IEL
        READ(ORB1)IE ,NO,NAME,DUM,BY,BX,AY,AX,MY,MX
        READ(ORB1) EX,EXP,EY,EYP,XP,DXP,Y,DYP
        IF(NO.EQ.NB(IB)) GO TO 13
        IF(NO.EQ.NX(IC)) GO TO 14
        GO TO 12
   13   IA=1
        IX=IB
        IB=IB+1
        IF(IFLAG.EQ.0) ZZ=XP
        IF(IFLAG.NE.0) ZZ=Y
        B  (IX)=ZZ+(2*RANSYN(NRZZ)-1)/2*EPSB
        AP(IX) = 0
        GO TO 15
   14   IF(ICC.NE.0) GO TO 21
        NX(IC)=NX(IC)+1
        ICC=1
        IA=2
        IX=IC
        L(IX)=DUM(1)
        IF(IFLAG.EQ.0) THEN
          K(IX)=-DUM(5)
          ALPHA(IX)=AX
        ELSE
          K(IX)=DUM(5)
          ALPHA  (IX)=AY
        END IF
   15   IF(IFLAG.EQ.0) THEN
           BETA(IA,IX)=BX
           MU  (IA,IX)=MX
        ELSE
           BETA(IA,IX)=BY
           MU  (IA,IX)=MY
        END IF
        IF(NO.EQ.NX(IC)) GO TO 14
        GO TO 12
   21   ICC=0
        IX=IC
        IC=IC+1
   12 CONTINUE
C   (EDC) REWIND SO AS TO RESET FOR NEXT PASS
      REWIND ORB1
      NRZZ=NRR
      NU=MX*PI
      IF(IFLAG.NE.0) NU=MY*PI
       IMAX = MXMIN(B,M,1)
       IMIN = MXMIN(B,M,0)
      DB = (B(IMAX)-B(IMIN))/1000
      WRITE(OUT3,203)DB
 203  FORMAT ('0BEFORE CORRECTIONS RMAX-RMIN = ',E13.4)
      WRITE (OUT3,102)
 102  FORMAT(' ORBITE AVANT CORRECTION(MM)'/)
      WRITE (OUT3,7) (B(I),I=1,M)
    7 FORMAT(7F10.5)
      SP=2*SIN(NU)
      DO 118 I=1,M
         SBI = SQRT(BETA(1,I))
         DO 118 J=1,N
            DM=(MU(1,I)-MU(2,J))*2*PI+NU
            IF(MU(2,J).LT.MU(1,I)) DM=DM-2*NU
            SB=SQRT(BETA(2,J))
            CM=COS(DM)
            IF(I.LE.1) NX(J)=NX(J)-1
            IF (L(J).EQ.0) GO TO 116
            SM=SIN(DM)
            IF (K(J).EQ.0) GOTO 18
            IF (K(J).GT.0) GOTO 19
            AK=ABS(K(J))
            SK=SQRT(AK)
            M11=SINH(SK*L(J))/SK
            M12=(COSH(SK*L(J))-1)/AK
            GO TO 16
   18       M11=L(J)
            M12=L(J)*L(J)/2
            GO TO 16
   19       SK=SQRT(K(J))
            M11=SIN(SK*L(J))/SK
            M12=(1-COS(SK*L(J)))/K(J)
   16       A(I,J)
     1       =SQRT(BETA(1,I))*(SB*CM*M11+(SM-ALPHA(J)*CM)*M12/SB)/SP
            GO TO 118
 116        A(I,J) = SBI*SB*CM/SP
 118  CONTINUE
      IF (.NOT.KPP)  GO TO 1181
      WRITE (OUT3,103)
  103 FORMAT( ' MATRICE A'/)
      WRITE (OUT3,8)((A(I,J),J=1,N),I=1,M)
    8 FORMAT(6(1X,12F10.4/)/)
 1181 CONTINUE
      DO 22 J=1,ITER
         DO 23 I1=1,M
            BB(I1)=B(I1)/1000
         DO 23 I2=1,N
   23          AA(I1,I2)=A(I1,I2)
         JB=J
         JTER=J
         CALL MICADO(AA,BB,MC,M,N,AP,0.,0 ,0 ,0 ,EPS,JTER,DP,X,NV,R,RHO)
         IF (J.EQ.1.OR.J.EQ.ITER.OR.EPS.LT.EPSZ)  KPP = .TRUE.
         IF(JTER.LT.JB) RETURN
         IF (KPP)  WRITE (OUT3,104)
  104 FORMAT( ' CORRECTIONS    MRAD   MRAD,MM'/)
         DO 20 I=1,J
            X(I)=X(I)*1000
            XX(I)=X(I)
            NK=NV(I)
            IF(K(NK).NE.0) XX(I)=X(I)/K(NK)
            IF (KPP) THEN
              WRITE (OUT3,5) NK,NX(NK),X(I),XX(I)
           ENDIF
            IF(IFLAG.EQ.0) TH(NK)=THZ(NK)-X(I)/1000
            IF(IFLAG.EQ.1) TV(NK)=TVZ(NK)+X(I)/1000
   20    CONTINUE
    5 FORMAT(2I5,2F10.5)
         DO 24 I=1,M
   24    R(I)=R(I)*1000
         IMAX = MXMIN(R(1),M,1)
         IMIN = MXMIN(R(1),M,0)
         EPS1=(R(IMAX)-R(IMIN))
         EPS1 = EPS1/1000
         WRITE (OUT3,201) J,EPS1
  201 FORMAT('0','AFTER',I3,' ITERATIONS,RMAX-RMIN=',E13.4)
         IF (.NOT.KPP) GO TO 22
         WRITE (OUT3,105)
  105 FORMAT( ' ORBITE CORRIGEE (MM)'/)
         WRITE (OUT3,7) (R(I) ,I=1,M)
 22   KPP = KPR
    6 FORMAT(7(I5,F10.5))
      RETURN
      END
