c
c    copyright, 1965, the regents of the university of california.
c
c    this software was produced under a us government  dept. of energy
c    contract (DE-AC03-76SF00098) by the lawrence Berkeley laboratory,
c    which is operated by the university of california for
c    the us department of energy.  the us government is licensed to use,
c    reproduce, and distribute this software.
c    permission is granted to the public to copy and use this software
c    provided that this notice and any statement of authorship are reproduced
c    on all copies.  neither the government nor the university makes any
c    warranty, express or implied, or assumes any liability or responsibility
c    for the use of this software.
c

c********************** pltbgk **************************************
      subroutine pltbgk(m)
C  THIS ROUTINE SETS UP PLOTTING ON GKS
      implicit double precision (a-h,o-z)
c****************************************************************
c nam   bep   ka   kb   ncy  mode  ip1   ip2  bmax  qmin  qmax  iop1  iop2
c*******************************************************************
c  plot betax,betay,xeq,yeq. these were computed and written to a file by
c  a best instruction,named ncy.
c    all 4 curves are plotted if iop2 is blank or zero. (default)
c if ka or kb is blank or 0, tick intervals are chosen by code.
c     ka = number of tick mark intervals for left y axis (betas)
c     if ka is 0 or positive, plot betax, betay
c     if ka is negative, plot square root of betax, betay
c     kb = number of tick mark intervals for right y axis (dispersions)
c     ncy is name of element that computed the betatron functions.
c  if mode is term, run interactively and have it appear on terminal.
c  if mode is zeta, prepare graph file for zeta. (it must
c                  be sent, using plotsend, by the user to the zeta.)
c  if mode field is blank, the default is interactive graph.
c  if mode is imag, create file for imagen
c     iop1 = 1,   labels omitted, but numbers on axes appear
 
c     iop1 = 2, in addition to above, axis numbers are omitted
c     iop2 = 1,2,3,4  plot only betax, betay, etax, etay respectively
c  if only one curve is being plotted, then tick marks will be identical
c  on both y axes.   if plotting only one curve, as when iop2.ne.0, then
c  plot single curve in black.
      include 'ccc/bstore.ccc'
      include 'ccc/binff.ccc'
      include 'ccc/betpts.ccc'
      include 'ccc/bmi.ccc'
      include 'ccc/files.ccc'
      include 'ccc/trkint.ccc'
      include 'ccc/const.ccc'
      include 'ccc/gkspar.ccc'
      dimension iprs(2),pmx(3),flt(3),par(3),itik(3),pd1(3),pd2(3)
      dimension iflt(3),mop(8)
c
      real    xpl(pltsiz), ypl(pltsiz), xmin, xmax, ymin, ymax
      REAL XBEG
      real                          vxmin,vxmax,vymin,vymax
      integer ccolor,cstyle
      real cwidth
      real bxtk,bytk,brtk,bxlab,bylab,brlab
      real rx1,rx2,ry1,ry2
C
C NEED BOTH X/Y AND Y/X  TO ALWAYS DISPLAY GRAPHICS SO THAT
C ASPECT RATIO IS ALWAYS .GE. 1     TCB  3/92
C
      REAL VPY(2)
      save vpy,mcall
c
      real    pathx, pathy, px, py, ftk
      logical drsw,xflg,limsw
      character(5)  mop,nc,mode,namop,nm,chdat,NAMOPOLD
      common/rlhcolor/bkgrnd,forgrnd,red,green,blue,cyan,magenta,yellow
      integer bkgrnd,forgrnd,red,green,blue,cyan,magenta,yellow
      data mcall/0/
 
      data mop/'DRF','MAG','MAGV','MAGS','REF','INV','SHF','EQU'/

C replacement for data statement, setting up color values
      BKGRND  = 0
      FORGRND = 1
      RED     = 2
      GREEN   = 3
      BLUE    = 4
      CYAN    = 5
      MAGENTA = 6
      YELLOW  = 7
C
C CHECK FOR END OF RUN
C
C     PRINT *,' ----------mcall ',M,LNFSIZ,MCALL
      if(m.gt.lnfsiz) then
C         IF (MCALL.GT.0) CALL JSBFIN
        return
      endif
c** computed variables
c       xx = length s    y1=betax,  y2=xeq, y3=betay, y4 = yeq
c   pmx = max of beta, max of xeq,yeq, and min of xeq,yeq
c   flt = radjusted max of betax,betay, the readjusted max of xeq, and
c  the readjusted min of xeq
c***
      limsw = .false.
      drsw = .false.
      se = 0
      bxmx = bxx
      bymx = byx
      do 15 i=1,3
      pd1(i) = 0
 15   pd2(i) = 0
c                  get input data
      ka = inff(4,m)
      kb = inff(5,m)
      icl = idat(m,3)
      icp = idat(m,4)
      nc = chdat(m,1)
      mode = chdat(m,2)
      xflg = .false.
      if (mode.ne.'imag'.and.mode.ne.'zeta'.and.mode.ne.iblnk) then
         read (mode,101)indx
 101     format (i5)
         mode = iblnk
         if(indx.eq.1 .or. indx.eq.2) xflg = .true.
       endif
      nam = mdat(m,1)
      ko = 2
      call geti (m,1,2,iprs)
      call getfl(m,1,3,par)
c                  set up mi list of beam
      ndat=1
      call mifill(nam,1,ndat,nels,mi,misiz)
      nk=nels
      if (mn.eq.nc) go to 36
      write(out3,35)
   35 format(/' bep and best donot match'//)
      stop 77
 36   npt = kw
      nz = kw - 1
 
      if (ka.lt.0) then
        bxmx = sqrt(bxmx)
        bymx = sqrt(bymx)
      endif
c
c*******************************************************************
c     find maximums and minimums.  put betax and betay on same scale.
c        minimum of betas is 0. xeq,yeq may be negative
 
c       compute maximum limits of betas and eqs.  then check input.
c   if any are input, all should be there
      pmx(1) = bxmx
      if (bymx.gt.pmx(1))  pmx(1) = bymx
      qmx = y2(1)
      qmn = y2(1)
      do 40 i=1,npt
      if (y4(i).gt.qmx)  qmx = y4(i)
      if (y2(i).gt.qmx) qmx = y2(i)
      if (y4(i).lt.qmn)  qmn = y4(i)
      if (y2(i).lt.qmn) qmn = y2(i)
 40   continue
      pmx(2) = qmx
      pmx(3) = qmn
c        check on input maximums
      if (par(1).ne.0) go to 41
      if (par(3).eq.0) go to 42
c        use input limits, unless max is 0.
 41   if (par(1).ne.0)  pmx(1) = par(1)
      if (par(3).ne.0) pmx(2) = par(3)
      pmx(3) = par(2)
      limsw = .true.
  42  continue
c        round limits and set tick intervals
      do 55 i=1,2
      call plpar(pmx(i),fm,itk)
      flt(i) = fm
      itik(i) = itk
 55   continue
c        round for negative scale of xeq.
c          if less than 10, round to next integer
c          if greater than 10, round to next factor of 10.
      if (pmx(3).ge.0) go to 63
      abp = abs(pmx(3))
      if (limsw) go to 57
c     if negative quantity is less than 1 percent of maximum, set
c  minimum to zero.
      onep = .01d0
      onep = onep*qmx
      if (abp.le.onep)  go to 63
 57   if (abp.gt.10) go to 62
      ip = INT(abp)
      app = ip
      if (abp.gt.app)  ip = ip + 1
      flt(3) = -ip
      go to 65
 62   ip = INT(abp/10)
      abp = (ip+1)*10
      flt(3) = -abp
      go to 65
 63   flt(3) = 0
      pmx(3) = 0
 65   continue
      do 66 i=1,3
      iflt(i) = INT(flt(i))
 66   continue
 
c                  initial plotting device, parameters and
c                  determine limits in x scale
      if (iprs(1).gt.iprs(2))  go to 205
c  let iprs(2) default to nz if 0.  leave iprs(1) as it was input.
      if (iprs(2) .eq.0.0) iprs(2) = nz
c  comment out old coding of more restrictive limits.        
c  default -- entire beam line
c      if (iprs(2) .eq.0.0) then
c       iprs(1) = 0
c       iprs(2) = nz
c      endif

      CALL JSBINIT(6,VPY,MCALL)
 
c********************************************************************
c     originally set up to loop from here to 200 to plot multiple frames
c     input changed to require card input for each frame.
c*******************************************************************
 70   do 200 kk=1,ko,2
      n1 = iprs(kk) + 1
      nbt = iprs(kk+1) + 1
      nbe = nbt - 1
      np = nbt - n1 + 1
c                  limits of x from s1 to snd
      s1 = xx(n1)
      snd = xx(nbt)
      szero = 0
      if (.not.xflg) go to 71
c  option to set beginning point to 0
        if (indx.eq.1) then
         szero = xx(n1)
         s1 = 0
         snd = xx(nbt) - szero
        else
c  assumes indx = 2.  let x-axis be symmetrical about 0
         sdif = xx(nbt) - xx(n1)
         ssh = sdif/2
         s1 =  - ssh
         snd = + ssh
         szero = xx(n1) + ssh
 
        endif
 71   j1 = n1
 
c                  set up physical plot area
      vymin = .1
      vymax = vpy(2) -.1
      vxmin = .1
      vxmax = VPY(1)-.1
c
      ymax = REAL(pmx(1))
      ymin = 0.0
      xmax = REAL(snd)
      xmin = REAL(s1)
c
      CALL JSBVPWN(1,0.07,0.07,XMIN,XMAX,YMIN,YMAX,
     $     VXMIN,VXMAX,VYMIN,VYMAX)
C      CALL JSBRECT(8,1,XMIN,YMIN,XMAX,YMAX)
      call JSBRECT(forgrnd,ghollo,xmin,ymin,xmax,ymax)
 
      if(icl.eq.0) call rlh_letr(vxmin,vxmax,vymin,vymax,ka,icp)
      call gselnt(1)
c
c*******************************************************************
 
c                  set ticks for betax and betay on left y axis
 
      ftk = REAL(flt(1))
      itk = ( INT(ftk) + itik(1) - 1 )/itik(1)
      if (icp.ge.3.and.icp.ne.5) then
         if (kb.gt.0) itk = kb
        else
      kkab = iabs(ka)
      if (kkab.gt.0) itk = kkab
        endif
      itkk = itk
      bytk = (YMAX-YMIN)/FLOAT(ITK)
 
c                  determine tick intervals for x axis and set them
 
      ds = ( snd - s1 )/2
      if (xflg.and.indx.eq.2) then
        pt = .5d0
        ds=ds*pt
        xbeg = 0
      else
        xbeg = xmin
      endif
      call plpar( ds, fm, itk )
      if (xflg.and.indx.eq.2) then
        xbeg = 0
      else
        xbeg = xmin
      endif
      ftk = itk
      bxtk = ftk
      bxlab = bxtk
      bylab = ymax-ymin
c
      IF(ICL.LT.2) THEN
         CALL GSELNT(1)
         CALL JSBXTICK(XMIN,XMAX,XBEG,BXTK,YMIN,
     $        0.01*(YMAX-YMIN)/(VYMAX-VYMIN))
         CALL JSBXLAB(XMIN,XMAX,XBEG,BXLAB,VXMIN,VXMAX,VYMIN,VYMAX,
     *        0.015,0)
         IF(ICP.LT.3.or.icp.eq.5) THEN
            CALL GSELNT(1)
            CALL JSBYTICK(YMIN,YMAX,YMIN,BYTK,XMIN,
     $           0.01*(XMIN-XMAX)/(VXMAX-VXMIN))
            CALL JSBXLAB(YMIN,YMAX,YMIN,BYLAB,VYMIN,VYMAX,VXMIN,VXMAX,
     $           0.015,-1)
         ENDIF
      ENDIF
 
      CALL GSELNT(1)
        
      S = S1
      SE = S
      DPT = 0.8D0
      NAMOPOLD = ' '
      DRSW = .FALSE.
      DO 300 K=N1,NBE
         NN = MI(K)
         NAMOP = CINFF(1,NN)
         CALL GETQ(NN,1,1,EL)
         IF (NAMOP.EQ.'MAG'.OR.NAMOP.EQ.'MAGV'.OR.NAMOP.EQ.'SOL') THEN
            CALL GETMGP(NN,NAMOP,PD2)
            IF (DRSW.AND.(NAMOP.NE.NAMOPOLD.OR.PD1(1).NE.PD2(1).OR.
     $           PD1(2).NE.PD2(2).OR.PD1(3).NE.PD2(3)))
     $           CALL DRAWMG(NAMOPOLD,PD1,S,SE,DBLE(YMAX))
            PD1(1) = PD2(1)
            PD1(2) = PD2(2)
            PD1(3) = PD2(3)
            DRSW = .TRUE.
            SE = SE+EL
            IF (K.EQ.NBE) CALL DRAWMG(NAMOP,PD1,S,SE,DBLE(YMAX))
            NAMOPOLD = NAMOP
         ELSE IF (NAMOP.NE.'DRF'.OR.EL.GT.0D0) THEN
            IF (DRSW) THEN
               CALL DRAWMG(NAMOPOLD,PD1,S,SE,DBLE(YMAX))
               DRSW = .FALSE.
            ENDIF
            IF (NAMOP.EQ.'MAGS'.OR.NAMOP.EQ.'REF'.OR.
     $           NAMOP.EQ.'INV'.OR.NAMOP.EQ.'SHF'.OR.NAMOP.EQ.'EQU')
     $           THEN
               NN = MDAT(NN,1)
               NAMOP = CINFF(1,NN)
               CALL GETMGP(NN,NAMOP,PD1)
            ENDIF
            SE = SE+EL
            CALL DRAWMG(NAMOP,PD1,S,SE,DBLE(YMAX))
            NAMOPOLD = NAMOP
         ENDIF
 300  CONTINUE

      nn=np
 
c***********************************************************************
c                find coordinates of maximum points
 
      m1 = j1
      m2 = j1
      m3 = j1
      m4 = j1
      jj = j1 + 1
      y1mx = y1(j1)
      y2mx = y2(j1)
      y3mx = y3(j1)
      y4mx = y4(j1)
      jn = j1 + nn - 1
      do 184 j=jj,jn
      if (y1(j).le.y1mx)  go to 178
      y1mx = y1(j)
      m1 = j
 178  if (y2(j).le.y2mx) go to 179
      y2mx = y2(j)
      m2 = j
 179  if (y3(j).le.y3mx) go to 182
      y3mx = y3(j)
      m3 = j
 182  if (y4(j).le.y4mx)  go to 184
      y4mx = y4(j)
      m4 = j
 184  continue
c***********************************************************************
 
c                  set up plot
 
      nn = np
      do 172 i=1,kw
 172  xpl(i)=REAL(xx(i) - szero)
c
      cstyle = 1
      ccolor = forgrnd
      cwidth = 3
c
      if(icp.gt.1.and.icp.ne.5) go to 181
c                                        plot betax
      if(ka.lt.0) then
        do i=1,kw
        ypl(i) = REAL(sqrt(y1(i)))
        enddo
      else
        do i=1,kw
        ypl(i) = REAL(y1(i))
        enddo
      endif
c
      if(icp.eq.0.or.icp.eq.5) then
                ccolor = red
c      ccolor = forgrnd
                cstyle = 1
      endif
c
      CALL JSBCURV(CCOLOR,CSTYLE,CWIDTH,NN,XPL(J1),YPL(J1))
c
 181  continue
      if(icp.ne.0 .and.icp.ne.2.and.icp.ne.5) go to 191
c                                        plot betay
      if(ka.lt.0) then
        do i=1,kw
        ypl(i) = REAL(sqrt(y3(i)))
        enddo
      else
        do i=1,kw
        ypl(i) = REAL(y3(i))
        enddo
      endif
c
c
      if(icp.eq.0.or.icp.eq.5) then
                ccolor = green
c      ccolor = forgrnd
                cstyle = 2
      endif
c
      CALL JSBCURV(CCOLOR,CSTYLE,CWIDTH,NN,XPL(J1),YPL(J1))
c
  191 continue
c
c
      ymin = REAL(pmx(3))
      ymax = REAL(pmx(2))
      IF (YMIN.EQ.YMAX) YMAX = YMIN+1
      CALL JSBVPWN(2,0.07,0.07,XMIN,XMAX,YMIN,YMAX,
     $     VXMIN,VXMAX,VYMIN,VYMAX)
      brlab = ymax-ymin
C
      ftk = REAL(flt(2))
      itk = ( INT(ftk) + itik(2) - 1 )/itik(2)
      if (kb.gt.0) itk = kb
      if (icp.eq.1.or.icp.eq.2) itk = itkk
      brtk = (YMAX -YMIN)/FLOAT(ITK)
C
      IF(ICL.LT.2 .AND.(ICP.EQ.0 .OR. ICP.GE.3)) THEN
         CALL JSBYTICK(YMIN,YMAX,YMIN,BRTK,XMAX,
     $        (XMAX-XMIN)*0.01/(VXMAX-VXMIN))
         CALL JSBXLAB(YMIN,YMAX,YMIN,BRLAB,VYMIN,VYMAX,VXMIN,VXMAX,
     *        0.015,+1)
      ENDIF
C
      CALL GSELNT(2)
c                                                       plot xeq
      if(icp.ne.0 .and. icp.ne.3.and.icp.ne.5) GO TO 195
      do  i=1,kw
      ypl(i)=REAL(y2(i))
      enddo
c
c
      if(icp.eq.0.or.icp.eq.5) then
                ccolor = blue
c      ccolor = forgrnd
                cstyle = 4
                cwidth = 3
      endif
c
      CALL JSBCURV(CCOLOR,CSTYLE,CWIDTH,NN,XPL(J1),YPL(J1))
c
      dmx = pmx(2)-pmx(3)
      py = REAL(y2(m2))
      px = REAL(xx(m2))
      dpt = .08d0
      dpq = .15d0
      if (m2.eq.j1)  px = px + REAL(dpt)
      if (m2.eq.jn)  px = px - REAL(dpq)
c      call rlmess( 'dx$', 100, px, py )
  195 continue
 
c                                               plot yeq
      if(icp.ne.0 .and. icp.ne.4) GO TO 200
      do  i=1,kw
      ypl(i)=REAL(y4(i))
      enddo
c
c
      if(icp.eq.0) then
                ccolor = forgrnd
                cstyle = 3
                cwidth = 3
      endif
c
      CALL JSBCURV(CCOLOR,CSTYLE,CWIDTH,NN,XPL(J1),YPL(J1))
c
 200  continue
 
      CALL JSBFIN

      return
c        error in input plot positions
 205  print 10,iprs
 1    format (8a10)
 2    format (a4)
 3    format (f8.2)
 4    format (6a10)
 8    format (i3)
 9    format (i5)
 10   format (5x,'ERROR.  Cannot plot from position ',i5,' to position',
     1  i5)

      CALL JSBFIN

      return
      end
 
      SUBROUTINE JSBINIT(IUNITO,VPYI,MCALL)

      IMPLICIT NONE

      INTEGER IUNITO,MCALL
      INTEGER KERROR,JDUNIT,KSIZEX,KSIZEY
      INTEGER NCOL,NPCOLI
      REAL SIZEX,SIZEY
      REAL VPYI(2)
      REAL MM(6)
      CHARACTER(11) FN
      INTEGER JASF(13)

      INTEGER KWKID,KCONID,KWTYPE,KSEGNM
      PARAMETER(KWKID=1,KCONID=30,KWTYPE=62,KSEGNM=11)

      INTEGER JCOLAV
      LOGICAL USESEG
      REAL VPY(2)
      COMMON /JSB/USESEG,JCOLAV,VPY

      DATA JASF/13*1/

      IF (MCALL.EQ.0) CALL GOPKS(IUNITO,0)
      WRITE(FN,'(''SYNCH'',I3.3,''.PS'')') MCALL
      MCALL = MCALL+1
      OPEN(KCONID,FILE=FN)
      CALL GOPWK(KWKID,KCONID,KWTYPE)
      CALL GACWK(KWKID)
      CALL GSASF(JASF)
      CALL GQDSP(KWTYPE,KERROR,JDUNIT,SIZEX,SIZEY,KSIZEX,KSIZEY)
      IF (SIZEY.GT.SIZEX) THEN
         VPY(1) = SIZEX/SIZEY
         VPY(2) = 1.0
         MM(1) = 0.0
         MM(2) = -SIZEY/SIZEX
         MM(3) = SIZEX/SIZEY
         MM(4) = 0.0
         MM(5) = 0.0
         MM(6) = 1.0
         USESEG = .TRUE.
         CALL GCRSG(KSEGNM)
         CALL GSSGT(KSEGNM,MM)
      ELSE
         USESEG = .FALSE.
         VPY(1) = 1.0
         VPY(2) = SIZEY/SIZEX
      ENDIF
      VPYI(1) = VPY(1)
      VPYI(2) = VPY(2)
      CALL GSWKWN(KWKID,0.0,VPYI(1),0.0,VPYI(2))
      CALL GQCF(KWTYPE,KERROR,NCOL,JCOLAV,NPCOLI)
      CALL GSCR(KWKID,0,1.0,1.0,1.0)
      CALL GSCR(KWKID,1,0.0,0.0,0.0)
      IF (JCOLAV.EQ.1) THEN
         CALL GSCR(KWKID,2,0.9,0.0,0.0)
         CALL GSCR(KWKID,3,0.0,0.9,0.0)
         CALL GSCR(KWKID,4,0.0,0.0,0.9)
         CALL GSCR(KWKID,5,0.0,0.8,0.8)
         CALL GSCR(KWKID,6,0.8,0.0,0.8)
         CALL GSCR(KWKID,7,0.8,0.6,0.0)
         CALL GSCR(KWKID,8,0.9,0.9,0.9)
      ENDIF
      END

      SUBROUTINE JSBFIN

      IMPLICIT NONE

      INTEGER KWKID,KCONID,KWTYPE,KSEGNM
      PARAMETER(KWKID=1,KCONID=30,KWTYPE=62,KSEGNM=11)

      INTEGER JCOLAV
      LOGICAL USESEG
      REAL VPY(2)
      COMMON /JSB/USESEG,JCOLAV,VPY

      IF (USESEG) CALL GCLSG
      
      CALL GDAWK(KWKID)
      CALL GCLWK(KWKID)
      CLOSE(KCONID)
C     CALL GCLKS

      RETURN
      END

      SUBROUTINE JSBVPWN(KTNR,DX,DY,
     $     XMIN,XMAX,YMIN,YMAX,VXMIN,VXMAX,VYMIN,VYMAX)

      IMPLICIT NONE
      INTEGER KTNR
      REAL DX,DY,XMIN,XMAX,YMIN,YMAX,VXMIN,VXMAX,VYMIN,VYMAX

      CALL GSVP(KTNR,VXMIN-DX,VXMAX+DX,VYMIN-DY,VYMAX+DY)
      CALL GSWN(KTNR,
     $     ((VXMAX-VXMIN+DX)*XMIN-DX*XMAX)/(VXMAX-VXMIN),
     $     ((VXMAX-VXMIN+DX)*XMAX-DX*XMIN)/(VXMAX-VXMIN),
     $     ((VYMAX-VYMIN+DY)*YMIN-DY*YMAX)/(VYMAX-VYMIN),
     $     ((VYMAX-VYMIN+DY)*YMAX-DY*YMIN)/(VYMAX-VYMIN))
      CALL GSELNT(KTNR)

      RETURN
      END

      SUBROUTINE JSBRECT(KCOL,JSTYLE,XMIN,YMIN,XMAX,YMAX)

      IMPLICIT NONE

      INTEGER KCOL,JSTYLE
      REAL XMIN,YMIN,XMAX,YMAX
      REAL X(6),Y(6)

      CALL GSFAIS(JSTYLE)
      X(1) = XMIN
      Y(1) = YMIN
      X(2) = XMIN
      Y(2) = YMAX
      X(3) = XMAX
      Y(3) = YMAX
      X(4) = XMAX
      Y(4) = YMIN
      X(5) = XMIN
      Y(5) = YMIN
      X(6) = XMIN
      Y(6) = YMAX
C ARE THE LINE ATTRIBUTES RESPECTED BY HOLLOW FILL STYLES?
      IF (XMAX-XMIN.LT.1E-5.OR.JSTYLE.GT.3) THEN
         CALL GSPLCI(KCOL)
         CALL GSLN(1)
         IF (JSTYLE.GT.3) THEN
            CALL GSLWSC(JSTYLE-3.0)
         ELSE
            CALL GSLWSC(1.0)
         ENDIF
         CALL GPL(6,X,Y)
      ELSE
         CALL GSFACI(KCOL)
         CALL GFA(4,X,Y)
      ENDIF

      RETURN
      END

      SUBROUTINE JSBCURV(KPLCOL,LNTYPE,WIDTH,N,X,Y)

      IMPLICIT NONE

      INTEGER KPLCOL,LNTYPE
      REAL WIDTH
      INTEGER N
      REAL X(N),Y(N)

      INTEGER JCOLAV
      LOGICAL USESEG
      REAL VPY(2)
      COMMON /JSB/USESEG,JCOLAV,VPY

      IF (JCOLAV.EQ.0) THEN
         CALL GSLN(LNTYPE)
         CALL GSPLCI(1)
      ELSE
         CALL GSLN(1)
         CALL GSPLCI(KPLCOL)
      ENDIF
      CALL GSLWSC(WIDTH)
      CALL GPL(N,X,Y)

      RETURN
      END

      SUBROUTINE JSBXTICK(XMIN,XMAX,XBEG,XD,YVL,YLEN)

      IMPLICIT NONE
      REAL XMIN,XMAX,XBEG,XD,YVL,YLEN
      INTEGER ILOW
      REAL X(2),Y(2)

      CALL GSPLCI(1)
      CALL GSLN(1)
      CALL GSLWSC(1.0)
      IF (XBEG.GE.XMIN) THEN
         ILOW = INT((XBEG-XMIN)/XD+1E-5)
         X(1) = XBEG - FLOAT(ILOW)*XD
         Y(1) = YVL
         Y(2) = YVL-YLEN
 10      X(2) = X(1)
         CALL GPL(2,X,Y)
         X(1) = X(1)+XD
         IF (X(1).LE.XMAX) GOTO 10
      ENDIF
      RETURN
      END

      SUBROUTINE JSBYTICK(YMIN,YMAX,YBEG,YD,XVL,XLEN)

      IMPLICIT NONE
      REAL YMIN,YMAX,YBEG,YD,XVL,XLEN
      INTEGER ILOW
      REAL X(2),Y(2)

      INTEGER JCOLAV
      LOGICAL USESEG
      REAL VPY(2)
      COMMON /JSB/USESEG,JCOLAV,VPY

      CALL GSPLCI(1)
      CALL GSLN(1)
      CALL GSLWSC(1.0)
      IF (YBEG.GE.YMIN) THEN
         ILOW = INT((YBEG-YMIN)/YD+1E-5)
         Y(1) = YBEG - FLOAT(ILOW)*YD
         X(1) = XVL
         X(2) = XVL+XLEN
 10      Y(2) = Y(1)
         CALL GPL(2,X,Y)
         Y(1) = Y(1)+YD
         IF (Y(1).LE.YMAX) GOTO 10
      ENDIF
      RETURN
      END

      SUBROUTINE JSBXLAB(XMIN,XMAX,XBEG,XD,VXMIN,VXMAX,VYMIN,VYMAX,HH,
     $     IFL)

      IMPLICIT NONE

      REAL XMIN,XMAX,XBEG,XD,VXMIN,VXMAX,VYMIN,VYMAX,HH
      INTEGER IFL

      INTEGER NLAB
      PARAMETER (NLAB=8)

      INTEGER K1,ILOW,IDECIMAL,I,IJ
      REAL X,VX,VXD,VY,CZ,VVY,VXT
      CHARACTER(8) LFORMAT
      CHARACTER(NLAB) LABEL

      INTEGER IRT,KFIRST
      EXTERNAL IRT,KFIRST

      INTEGER FROMAN,FGREEK
      PARAMETER (FROMAN=-105,FGREEK=-113)

      CALL GSELNT(0)
      CALL GSTXCI(1)
C     IN THE ORIGINAL, H WAS SET TO 0.75*HH AND SUBSEQUENTLY USED
C     EVERYWHERE HERE.  THIS SEEMS SILLY.
C     FORCE FONT SIZE
      CALL GSCHH(0.015)
      CALL GSCHUP(0.0,1.0)
      CALL GSTXFP(FROMAN,0)
      IF (XMAX.LE.XMIN) THEN
         WRITE(*,*) 'XLABEL BAD RANGE ',IFL,XMIN,XMAX
         RETURN
      ENDIF
      IF (XD.LT.0.05*(XMAX-XMIN)) THEN
         WRITE(*,*) 'TOO MANY INTERVALS TO LABEL ',IFL,XD,XMIN,XMAX
         RETURN
      ENDIF
      IF (XBEG.GE.XMIN) THEN
         ILOW = INT((XBEG-XMIN)/XD+1E-5)
         X = XBEG - FLOAT(ILOW)*XD
         VX = ((XMAX-X)*VXMIN + (X-XMIN)*VXMAX)/(XMAX-XMIN)
         VXD = (VXMAX-VXMIN)*XD/(XMAX-XMIN)
C        OK, I THINK THE LOGIC IS THIS:
C        IFL =  0 : TICK LABELS BELOW HORIZONTAL AXIS
C        IFL = -1 : TICK LABELS TO THE LEFT OF THE VERTICAL AXIS
C        IFL =  1 : TICK LABELS TO THE RIGHT OF THE VERTICAL AXIS
         IF (IFL.NE.1) THEN
            VY = VYMIN - HH
         ELSE
            VY = VYMAX + HH
         ENDIF
         IF (IFL.EQ.0) THEN
            IDECIMAL = 0
         ELSE
            IDECIMAL = MIN(MAX(IRT(XBEG),IRT(XD)),2)
         ENDIF
         IF (IDECIMAL.EQ.0) THEN
            WRITE(LFORMAT,'(''(I'',I2,'')'')') NLAB
         ELSE
            WRITE(LFORMAT,'(''(F'',I2,''.'',I2,'')'')') NLAB,IDECIMAL
         ENDIF
         CZ = 0.75*HH
         IF (IFL.EQ.0) THEN
            CALL GSTXAL(2,2)
         ELSE IF (IFL.EQ.-1) THEN
            CALL GSTXAL(3,3)
         ELSE
            CALL GSTXAL(1,3)
         ENDIF
 10      LABEL = ' '
         IF (IDECIMAL.EQ.0) THEN
            IF (X.LT.0) THEN
               I = INT(X-0.5)
            ELSE
               I = INT(X+0.5)
            ENDIF
            WRITE(LABEL,LFORMAT) I
         ELSE
            WRITE(LABEL,LFORMAT) X
         ENDIF
         K1 = KFIRST(LABEL,8)
         IF (IFL.EQ.0) THEN
            CALL GTX(VX,VY,LABEL(K1:NLAB))
         ELSE
            CALL GTX(VY,VX,LABEL(K1:NLAB))
         ENDIF
         X = X + XD
         VX = VX + VXD
         IF (X.LE.XMAX+0.5*VXD) GOTO 10
      ENDIF
      RETURN
      END

      SUBROUTINE GETMGP(NN,NAM,P)

      IMPLICIT NONE

      INTEGER NN
      CHARACTER(5) NAM
      DOUBLE PRECISION P(3)

      IF (NAM.EQ.'SOL') THEN
         CALL GETFL(NN,3,2,P(2))
         P(1) = 0D0
      ELSE
         CALL GETFL(NN,2,3,P)
      ENDIF

      RETURN
      END

      SUBROUTINE DRAWMG(NAM,P,SI,SF,YMAX)

      IMPLICIT NONE

      CHARACTER(5) NAM
      DOUBLE PRECISION P(3),SI,SF,YMAX
      DOUBLE PRECISION PB,PT
      INTEGER COL,BOXTYP
      DOUBLE PRECISION DY0,DYBX,DYBY,DYQ,DYU
      PARAMETER (DY0=1D0/15)
      PARAMETER (DYBX=0.35D0*DY0,DYBY=0.75D0*DYBX,DYQ=2*DYBX)
      PARAMETER (DYU=0.1D0*DY0)
      
      BOXTYP = 1
      IF (NAM.EQ.'MAG'.OR.NAM.EQ.'MAGV') THEN
         IF (P(1).LT.0D0) THEN
            PT = YMAX
            PB = YMAX*(1-DYQ)
            COL = 3
         ELSE IF (P(1).EQ.0D0) THEN
            IF (NAM.EQ.'MAGV') THEN
               PT = YMAX*(1+DYBY)
               PB = YMAX*(1-DYBY)
            ELSE
               PT = YMAX*(1+DYBX)
               PB = YMAX*(1-DYBX)
            ENDIF
            COL = 4
         ELSE
            PT = YMAX*(1+DYQ)
            PB = YMAX
            COL = 2
         ENDIF
      ELSE IF (NAM.EQ.'SOL') THEN
         PT = YMAX*(1+DYQ)
         PB = YMAX*(1-DYQ)
         IF ((P(2).GE.0D0).EQV.(P(3).GE.0D0)) THEN
            COL = 7
         ELSE
            COL = 6
         ENDIF
      ELSE
         PT = YMAX*(1+DYU)
         PB = YMAX*(1-DYU)
         COL = 1
      ENDIF

      IF (NAM.NE.'DRF')
     $     CALL JSBRECT(COL,BOXTYP,REAL(SI),REAL(PB),REAL(SF),REAL(PT))

      SI = SF

      RETURN
      END

      subroutine rlh_letr(vxmin,vxmax,vymin,vymax,ka,icp)
C     parameter (iwkid=5,iconid=10)
      common/rlhcolor/bkgrnd,forgrnd,red,green,blue,cyan,magenta,
     *                  yellow
      integer bkgrnd,forgrnd,red,green,blue,cyan,magenta,yellow
      common/rlh1/vpy
C     real vpy
      REAL VPY(2)
      logical vert
      CHARACTER(85) KTITL
      REAL CPX,CPY,TXEXPX,TXEXPY
      data vert/.false./
 
c select transformation
      call gselnt(0)
c select character color
      call gstxci(forgrnd)
c set character height in world coordinates
      call gschh(.015)
c set character up vector
      call gschup (0.0,1.0)
c set character font & precision
      call gstxfp(-105,0)
c set line type
      call gsln(1)
c set line width
      call gslwsc(2.0)
c set stroke text linewidth
C no guesc; non-standard; not in Sun GKS    TCB  2/92
      CALL GSTXAL(2,2)
      call gtx(0.5*(VXMIN+VXMAX),VYMIN-0.035,'path length (m)')
      READ (8,'(a84)',END=9123)ktitl
      BACKSPACE 8
      IF(KTITL(1:4).EQ.'CTIT')THEN
        CALL GSTXAL(2,5)
        CALL GTX(0.5*(VXMAX+VXMIN),VYMAX+0.07,KTITL(6:85))
      END IF
 9123  CONTINUE
c set font & precision
       IF (ICP.LT.3) THEN
          
          CALL GSTXFP(-105,0)
          CALL GSTXAL(3,3)
          CALL GTX(VXMIN-0.015,0.5*(VYMIN+VYMAX),'(m)')
          CALL GSTXFP(-113,0)
          CALL GTX(VXMIN-0.07,0.5*(VYMIN+VYMAX),'b')
       ENDIF
       IF (ICP.EQ.0.OR.ICP.GE.3) THEN
          CALL GSTXFP(-105,0)
          CALL GSTXAL(1,3)
          CALL GTX(VXMAX+0.015,0.5*(VYMIN+VYMAX),'D (m)')
       ENDIF
       CALL GSTXFP(-105,0)
      if(ka.lt.0 .and. icp.lt.3) then
        call rlh_sym(x1-.5*h1,y,h1)
      endif
      return
      end
 
      subroutine rlh_sym(x,y,s)
      dimension  xs(4),ys(4)
      dimension xp(4),yp(4)
      common/rlhcolor/bkgrnd,forgrnd,red,green,blue,cyan,magenta,
     *                  yellow
      integer bkgrnd,forgrnd,red,green,blue,cyan,magenta,yellow
      data xs / 0.0, .2,  .3, 1.0/
     *     ys/  .75, .1, 1.2, 1.2/
 
      do i=1,4
      xp(i) = x + xs(i)*s
      yp(i) = y + ys(i)*s
      enddo
      CALL JSBCURV(FORGRND,1,1.0,4,XP,YP)
      return
      end
 
      integer function kfirst(s,n)
      character(*) s
      kfirst = 1
      do i=n-1,2,-1
      if(s(i:i) .eq. ' ') then
         kfirst=i+1
         return
      endif
      enddo
      return
      end

      integer function ititln(kchar,ilen)
      character(*) kchar
c
      iq=(ilen+1)/2
      inc=iq
      iend=ilen
c     ibeg=iq
      iab=ilen+1
      inab=0
10    continue
      inc=(inc+1)/2
      if(kchar(iq:iend).eq.' ')then
        iab=iq
        iq=iq-inc
      else
        inab=iq
        iq=iq+inc
      end if
      if(iq.eq.0)iq=1
      if(iq.eq.ilen+1)iq=ilen
      if(inab.ne.ilen.and.iab.ne.1.and.(iab-inab).ne.1)
     1go to 10
      ititln=iab-1
      return
      end

      integer function irt(f)
      save small
      data small/.000001/
      x=abs(f)
      irt=0
   10 continue
      if(x-float(int(x)) .lt. small) return
      x=x*10.
      irt = irt+1
      go to 10
      end
