      SUBROUTINE PLTCON(NSPT,SPT,CHSPT)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        PLOTS POINTS IN ARRAY SPT ONTO ONE PAGE WITH LABELLED AXES
CC        NSPT IS THE NUMBER OF POINTS TO BE PLOTTED
CC        SPT(1,I) = X-COORD. OF ITH POINT
CC        SPT(2,I) = Y-COORD. OF ITH POINT
CC        SPT(3,I) = CHARACTER TO BE PLOTTED AT THIS POSITION
CC
      include 'ccc/const.ccc'

      include 'ccc/sfile.ccc'

C     Restore when working to resolvethe intermix of fl pt and
C     character data.
C      DIMENSION SPT(2,2) , ALINE(100), SAV(3),CHSPT(2)
      DIMENSION SPT(2,2) , ALINE(100), CHSPT(2)

      character(6) fmt(6)
      character(4) fmtin(12)
      CHARACTER(1) DOT,SLASH,AI,CHBEST,ALINE,CHSPT

      DATA DOT,SLASH,AI/'.', '/', 'I'/
      DATA MAXNX,MAXNY/ 98, 56/
      DATA FMT /'(5X,','F15.7,',' ','F15.7,',' ','F15.7)'/
      DATA FMTIN /' ',' 5X,','10X,','15X,','20X,',
     *      '25X,','30X,','35X,','40X,','45X,','50X,','55X,'/

      IF (NSPT .LE. 1)  RETURN
      XBEST = SPT(1,1)
      YBEST = SPT(2,1)
      CHBEST = CHSPT(1)
C         ORDER THE POINTS BY DECREASING Y
      KM1 = NSPT - 1
      DO 150 I= 1, KM1
      IQUIT = 0
      NI = NSPT - I
      DO 140 J= 1, NI
      IF (SPT(2,J).GE.SPT(2,J+1))  GOTO 140
      CONTINUE
C  RESOLVE THE INTERMIX OF FL. PT. AND CHARACTERS LATER
C  120   DO 130 I3= 1, 3
C        SAV(I3) = SPT(I3,J)
C        SPT(I3,J) = SPT(I3,J+1)
C  130   SPT(I3,J+1) = SAV(I3)
C      IQUIT = 1
  140 CONTINUE
      IF (IQUIT.LE.0)  GOTO 160
  150 CONTINUE
  160 CONTINUE
C         FIND EXTREME VALUES
      XMAX = SPT(1,1)
      XMIN = XMAX
      DO 200 I= 1, NSPT
        IF (SPT(1,I) .GT. XMAX)  XMAX = SPT(1,I)
        IF (SPT(1,I) .LT. XMIN)  XMIN = SPT(1,I)
  200 CONTINUE
      CALL BINSIZ(XMIN,XMAX,MAXNX,XMIN,XMAX,NX,BWIDX)
      ANX = NX
      YMAX = SPT(2,1)
      YMIN = SPT(2,NSPT)
      IF (YMAX .EQ. YBEST)  YMAX=YBEST + 1
      CALL BINSIZ(YMIN,YMAX,MAXNY,YMIN,YMAX,NY,BWIDY)
      ANY = NY
      IF (CHBEST .EQ. IBLNK)  GO TO 50
      XBEST = (XMAX+XMIN)/2
      YBEST = (YMAX+YMIN)/2
   50 CONTINUE
C         FIND SCALE CONSTANTS
      AX = 1/BWIDX
      AY = 1/BWIDY
      BX = -AX*XMIN + 2
      BY = -AY*YMIN - 2
C         CONVERT POINTS TO GRID POSITIONS
      DO 300 I= 1, NSPT
      SPT(1,I) = AX*SPT(1,I) + BX
  300 SPT(2,I) = ANY-AY*SPT(2,I) - BY
      NXBEST = INT(AX*XBEST + BX)
      NYBEST = INT(ANY  - AY*YBEST - BY)
C         PRINT THE CONTOURS
      NY = INT(ANY + 1)
      NX = INT(ANX + 2)
      ISP1 = 1
      LINODD = 1
      DO 400 I= 1, NY
      DO 310 IBK= 1, NX
  310 ALINE (IBK) = ' '
      ALINE(1) = DOT
      ALINE(NX) = DOT
      ALINE(NXBEST) = DOT
      IF (I.NE.1 .AND. I.NE.NYBEST .AND. I.NE.NY)  GO TO 320
      DO 315 J= 1, NX
  315 ALINE(J) = DOT
  320 CONTINUE
      YPRT = YMAX - (I-1)*BWIDY
      IF (ISP1 .GT. NSPT)  GO TO 350
        DO 340 K= ISP1,NSPT
      KS = INT(SPT(2,K))
      IF (KS .GT. I)  GO TO 345
      IX = INT(SPT(1,K))
  340 ALINE(IX) = CHSPT(K)
        ISP1 = NSPT + 1
        GO TO 350
  345   ISP1 = K
  350 CONTINUE
      IF (LINODD .EQ. 1 .OR. I .EQ. NY)  GO TO 380
      LINODD = 1
      WRITE (SVOUT, 1007)       (ALINE(IW),IW=1,NX)
      GO TO 400
  380 WRITE (SVOUT, 1001) YPRT, (ALINE(IW),IW=1,NX)
      LINODD = 0
  400 CONTINUE
      DO 410 IBK= 1, NX
  410 ALINE (IBK) = ' '
      ALINE(1) = SLASH
      ALINE(NXBEST) = AI
      ALINE(NX-1) = SLASH
      WRITE (SVOUT, 1007)       (ALINE(IW),IW=1,NX)
      N1 = NXBEST/5 - 1
      IF (N1 .LT. 1)  N1 = 1
      IF (N1 .GT. 12)  N1 = 12
      N2 = NX/5 - N1 - 3
      IF (N2 .GT. 0)  GO TO 420
      IF (N1 .GT. 1)  N1= N1-1
      N2 = 1
  420 IF (N2 .GT. 12)  N2 = 12
      FMT(3) = FMTIN(N1)
      FMT(5) = FMTIN(N2)
      WRITE (SVOUT,FMT(1)//FMT(2)//FMT(3)//FMT(4)//FMT(5)//FMT(6) )
     $     XMIN,XBEST,XMAX
      WRITE (SVOUT,1002)  BWIDX
  500 RETURN
 1001 FORMAT (F15.7,3H ..,100A1)
 1002 FORMAT (40X,'ONE COLUMN =  ',F13.7)
 1003 FORMAT (5X,A10)
 1007 FORMAT (18X , 100A1)
      END
