      SUBROUTINE PRBL(M)
C  Write a file  of betatron functions.
C  This file (10) is to be used for a plotting routine, namely one 
C   written by Dave Johnson.  It meets his format specifications.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      include 'ccc/binff.ccc'

      include 'ccc/bmi1.ccc'

      include 'ccc/files.ccc'

      include 'ccc/betpts.ccc'

      DIMENSION CNAM(5),ZERO(12)
      CHARACTER(5) MNAME,MNM,MNAM,OPN,PNAM

      DATA ZERO/12*0.D0/

      IZ = 0
      NN = MDAT(M,1)
      MNM = MNAME(NN)
      NDAT = INFF(17,NN)
      CALL MIFILL(NN,1,NDAT,NELS1,MI1,MI1SIZ)

      WRITE (10,1) MNM

      ELT = 0
      K1 = IDAT(M,1)
      K2 = IDAT(M,2)
      IF (K1.EQ.0) K1 = 1
      IF (K1.EQ.1.AND.K2.EQ.0) THEN
         JB = 1
         JEND = NELS1
       ELSE
         JB = K1
         JEND = K2
       ENDIF
      DO 110 J=JB,JEND
      JJ = MI1(J)
      MNAM = MNAME(JJ)
      EL = FLDAT(JJ,1)
      ELT = ELT + EL
      OPN = CINFF(1,JJ)
      IF (OPN.NE.'DRF') THEN
         PAR2 = FLDAT(JJ,2)
         BRHO = FLDAT(JJ,3)
         PAR4 = FLDAT(JJ,4)
         ELSX = EL
         IF (ELSX.EQ.0) ELSX = 1
         DG = ELSX * PAR2
         IF (BRHO.EQ.0) THEN
          FKL = 0
          RI = 0
          DK = 0
         ELSE
          FKL = PAR2/BRHO
          RI = PAR4/BRHO
          DK = DG/BRHO
         ENDIF
       ENDIF
C DRIFT
      IF (OPN.EQ.'DRF') THEN
             IT = 1
             WRITE (10,10) MNAM,IT,IZ,EL,EL,ELT
             GO TO 110
         ENDIF
C SXTP
       IF (OPN.EQ.'SXTP') THEN
              IT = 7
              WRITE (10,14) MNAM,IT,IZ,DK,EL,ELT,DG
              GO TO 110
          ENDIF
C  VERTICAL BEND
       IF (OPN.EQ.'MAGV') THEN
            IT = 5
            WRITE (10,14)MNAM,IT,IZ,RI,EL,ELT,PAR4
            GO TO 110
          ENDIF

C  QUAD
       IF (OPN.EQ.'MAG'.AND.PAR4.EQ.0) THEN
            IT = 6
            WRITE (10,14) MNAM,IT,IZ,FKL,EL,ELT,PAR2
            GO TO 110
          ENDIF
C  BEND
       IF (OPN.EQ.'MAG'.AND.PAR4.NE.0) THEN
            IT = 4
            WRITE (10,14) MNAM,IT,IZ,RI,EL,ELT,PAR4
          ENDIF          
C NONE OF THE ABOVE
        WRITE (10,2) MNAM,EL,ELT


 110  CONTINUE
      ITOT = JEND - JB + 1
      WRITE (10,11) ELT,ITOT
      WRITE (10,7) ZERO
      WRITE (10,8)

      JEND = JEND + 1
      DO 15 J=JB,JEND
      IF (J.EQ.JB) THEN 
          PNAM = 'BEGN'
        ELSE
      JJ = MI1(J-1)
      MNAM = MNAME(JJ)
      PNAM = MNAM
      OPN = CINFF(1,JJ)
      PAR4 = FLDAT(JJ,4)
       ENDIF
      IF (J.EQ.JB) THEN
          PSIX = 0
          PSIY = 0
        ELSE
          PSIX = Y9(J)*360
          PSIY = Y10(J)*360
        ENDIF

      WRITE (10,12)PNAM,Y1(J),Y5(J),Y2(J),Y7(J),PSIX,
     1             Y3(J),Y6(J),Y4(J),Y8(J),PSIY

 15    CONTINUE
          
     
 1    FORMAT ('1',5X,'ELEMENTS THROUGH BEAM LINE ',A5//
     1     ' LEAST SQUARE F= 0.0'//4X,'ITEM',1X,'IVAR',4X,'CHAR. VALUE',
     2     6X,'LENGTH',8X,'LTOTAL',8X,'VALUE')
 2    FORMAT (6X,A5,2X,F15.8,2X,F15.8)
 10   FORMAT (2X, A5,I1,3X,I1,1X,E17.9, 2(F10.4,4X))
 14   FORMAT (2X, A5,I1,3X,I1,1X,E17.9, 3(F10.4,4X))
 11   FORMAT (' TOTAL LENGTH=',F12.4,5X,'TOTAL ITEMS=',I5)
 7    FORMAT (/1X,'MATRIX ELEMENTS'//1X,'X11 X12 X13',1X,3E15.7/
     1      1X,'X21 X22 X23',1X,3E15.7/1X,'Y11 Y12 Y13',1X,3E15.7/
     2      1X,'Y12 Y22 Y23',1X,3E15.7/)
 8    FORMAT (1X,'ITEM',9X,'BETA',8X,'ALPHA',10X,'ETA',9X,
     1      'ETAP',10X,'PSI')
 12   FORMAT (1X,A5,F12.7,4F13.7,1X,'X'/6X,F12.7,4F13.7,1X,'Y')

      RETURN
      END
