      SUBROUTINE RESTOR(K)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CC        RESTORES A FIXED PARAMETER TO VARIABLE STATUS
CC        BY INSERTING IT INTO THE INTERNAL PARAMETER LIST AT THE
CC        APPROPRIATE PLACE.
CC
      include 'ccc/fix.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

C--       K = 0 MEANS RESTORE ALL PARAMETERS
C--       K = 1 MEANS RESTORE THE LAST PARAMETER FIXED
C--       K = -I MEANS RESTORE EXTERNAL PARAMETER I (IF POSSIBLE)
C--       IQ = FIX-LOCATION WHERE INTERNAL PARAMETERS WERE STORED
C--       IR = EXTERNAL NUMBER OF PARAMETER BEING RESTORED
C--       IS = INTERNAL NUMBER OF PARAMETER BEING RESTORED

      IF (K .GT. 1)  WRITE (SVOUT,510)
      IF (NPFIX .LT. 1)  WRITE (SVOUT,500)
      IF (K.EQ.1 .OR. K.EQ.0)  GO TO 50
C                   RELEASE PARAMETER WITH SPECIFIED EXTERNAL NUMBER
      KA = IABS(K)
      IF (LCORSP(KA) .EQ. 0)  GO TO 15
      WRITE (SVOUT,540)
  540 FORMAT ('0ERROR.  PARAMETER SPECIFIED IS ALREADY VARIABLE.'/)
      RETURN
   15 IF (NPFIX .LT. 1)  GO TO 21
      DO 20 IK= 1, NPFIX
      IF (IPFIX(IK) .EQ. KA)  GO TO 24
   20 CONTINUE
   21 WRITE (SVOUT,530)
  530 FORMAT ('0ERROR.  PARAMETER SPECIFIED HAS NEVER BEEN VARIABLE.'/)
      RETURN
   24 IF (IK .EQ. NPFIX)  GO TO 50
C                   MOVE SPECIFIED PARAMETER TO END OF LIST
      IPSAV = IPFIX(IK)
      XSSAV = XS(IK)
      XTSSAV = XTS(IK)
      WTSSAV = WTS(IK)
      IKP1 = IK + 1
      DO 30 I= IKP1,NPFIX
      IPFIX(I-1) = IPFIX(I)
      XS(I-1) = XS(I)
      XTS(I-1) = XTS(I)
   30 WTS(I-1) = WTS(I)
      IPFIX(NPFIX) = IPSAV
      XS(NPFIX) = XSSAV
      XTS(NPFIX) = XTSSAV
      WTS(NPFIX) = WTSSAV
C                   RESTORE LAST PARAMETER IN LIST  -- IPFIX(NPFIX)
   50 CONTINUE
      IF (NPFIX .LT. 1)  GO TO 300
      IR = IPFIX(NPFIX)
      IS = 0
      DO 100 IJ= IR, NU
      IK = NU + IR - IJ
      IF (LCORSP(IK).LE.0)  GOTO 100
      LC = LCORSP(IK) + 1
      IS = LC - 1
      LCORSP(IK) = LC
      X(LC) = X(LC-1)
      XT(LC) = XT(LC-1)
      DIRIN(LC) = DIRIN(LC-1)
  100 CONTINUE
      NPAR = NPAR + 1
      IF (IS .EQ. 0)   IS = NPAR
      LCORSP(IR) = IS
      IQ = NPFIX
      X(IS) = XS(IQ)
      XT(IS) = XTS(IQ)
      DIRIN(IS) = WTS(IQ)
      NPFIX = NPFIX - 1
      ISW(2) = 0
      IF (ITAUR .LT. 1)  WRITE(SVOUT,520) IR,NAM(IR)
      IF (K.EQ.0)  GO TO 50
  300 RETURN
  500 FORMAT ('0ERROR IN CALL TO RESTOR.  THERE ARE NO MORE FIXED ',
     1 'PARAMETERS'/)
  510 FORMAT ('0ERROR IN CALL TO RESTOR.  ARGUMENT GREATER THAN ',
     1 'ONE'/)
  520 FORMAT (20X,   'PARAMETER',I4,', ',A10, 
     1  ' RESTORED TO VARIABLE.')
      END
