             SUBROUTINE REVMAT(N,M,V)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c  Version  of July 13, 2004
c  RW(2) angle adjusted to actual deflection angle
c  Old version OK for zero-gradient magnets
C  MAPS PARTICLE VECTOR V BY ELEMENT WITH INDEX M.
C  ELEMENT MAY BE ANY LINEAR ELEMENT OR SEXTUPOLE.
C  IF THE ELEMENT IS NOT COMPOSITE (E.G. AN MMM), LINEARIZED MATRICES
C  THAT GIVE THE TRANSFORMATION RELATIVE TO V ARE CALCULATED AND
C  STORED AT INDEX N.
C  IF M IS A COMPOSITE ELEMENT, A NEW MATRIX IS NOT CALCULATED,
C  THE OLD ONE IS STORED AT N.

C  ELEMENTS DEFINED BY MAG AND SXTP and NPOL WILL BE RECALCULATED BY REVMAT,
C  INCLUDING BR=BR*(1+DP/P).
c  Parameters of off-momentum bending magnets adjusted to correct for 
c  changes in orbit length 
 

C  **NOTE**  THIS ROUTINE USES MEND-3, MEND-4, AND MEND-5 (3X3 LOCS)

      include 'ccc/binff.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/corb.ccc'

      include 'ccc/const.ccc'

      include 'ccc/magbnd.ccc'



      DIMENSION ML(3)
      DIMENSION PAR(6),T(7,7),RW(3),V(*),V0(7),W(7),U(7),pp(6)
      EQUIVALENCE (ANG1,IANG1),(ANG2,IANG2),(BR,PAR(3))
      
      CHARACTER(5) NOP,NAKICK
      DOUBLE PRECISION nz,np,ksd,ks

      NOP = CINFF(1,M)
C  MOVE
      IF (NOP.NE.'MOVE')  GO TO 100
      CALL MOVE(M,N,V)
      RETURN
C
 100  DO 2 I=1,7
      U(I)=V(I)
 2    V0(I)=V(I)

C  SEXTUPOLE
      IF (NOP.NE.'SXTP') GO TO 101
      CALL GETFL(M,1,4,PAR)
      INFF(4,N) = INFF(4,M)
      INFF(5,N) = INFF(5,M)
      CALL SXTP(N,V,PAR)
      RETURN
c  Multipole

 101  IF (NOP.NE.'NPOL') GO TO 1
      CALL GETFL(M,1,3,PAR)
      INFF(4,N) = INFF(4,M)
      INFF(5,N) = INFF(5,M)
      CALL NPOL(N,V,PAR)
      RETURN


C  MAGNET DEFINED BY MAG INSTRUCTION
 1    IF (NOP.NE.'MAG') GO TO 7
      CALL GETFL(M,1,6,PAR)
      plgth=par(1)
      GRAD=PAR(2)
      BZ=PAR(4)
      brz=par(3)
      theta=par(1)*par(4)/par(3)
      rp=0
      IRECT=0
      IF (INFF(6,M).EQ.1) IRECT = 1
C      WRITE (3,500) NOP,INFF(6,M),IRECT,GRAD,BZ
 500  FORMAT (5X,'REVMAT--NOP,INFF(6,M),IRECT,GRAD,BZ'/
     1  5X,A5,1X,2I5,1X,2F15.8)
      IF ( (GRAD.NE.0).OR.(IRECT.EQ.0).OR.(BZ.EQ.0) ) GO TO 11
C  RECTANGULAR,ZERO-GRADIENT BENDING MAGNET
C      WRITE (3,501) PAR,V
 501  FORMAT (5X,'BEFORE BEND--PAR,V'/5X,6F15.8/
     1        5X,7F15.8)
      CALL BEND(N,V,PAR,2)
C      WRITE (3,502) PAR,V
 502  FORMAT (5X,'AFTER BEND--PAR,V'/5X,6F15.8/
     1        5X,7F15.8)
      
      GO TO 99
 11   CONTINUE
      IF (BZ.NE.0)  GO TO 111
C   QUADRUPOLE
C      WRITE (3,503) V,W
 503  FORMAT (5X,'BEFORE MODQ--V,W'/5X,7F15.8/
     1        5X,7F15.8)
      CALL MODQ(M,N,V,W)
C      WRITE (3,504) V,W
 504  FORMAT (5X,'AFTER MODQ--V,W'/5X,7F15.8/
     1        5X,7F15.8)
      GO TO 445

 111  CONTINUE
           if(grad.eq.0) then
c      br=brz*(1+v(6))
      CALL MAGNET(N,PAR)
      CALL RTRV7(N,T,RW)
      CALL MXV7(T,V,W)
           end if
C  BENDING MAGNET
      IF (IRECT.EQ.1) GO TO 3
      E1=PAR(5)*RADEG
      E2=PAR(6)*RADEG
      GO TO 4
 3    E1=THETA/2
      E2=E1
 4    continue

      e=e1+e2
      elgth=par(1)
      rho=par(3)/par(4)

      del=v(6)
      g=grad
      rh=rho
      nz=-g*rh/bz 
            if(g.ne.0) then
C find radius where bending is same as for central-momentum magnet:
            if(v(6).eq.0) go to 44
            ph=theta-e
C rp for general bending magnet
            
            ggr=g*rh*theta+ph*bz 
            rp=-(ggr-Sign(
     1       sqrt(ggr**2+4*bz*ph*theta*g*del*rh),ggr))/              
     3       (2*g*ph)
             
 44   continue  
       if(abs(rp).gt.abs(rh)) then
         write(3,444) rp
 444  format('rp excessive ',e10.2)
        stop
      end if
      np=-g*(rh+rp)/(bz+g*rp)
c  Adjust MAG parameters 

        par(4)=bz+g*rp  
        par(3)=brz*(1+del)  
        par(1)=elgth*(1+rp/rh)
        plgth=par(1)
            
      CALL MAGNET(N,PAR)
      CALL RTRV7(N,T,RW)
c set column 7 corresponding to reference radius at r+rp
      DO 12 I=1,5     
 12   t(i,7)=-t(i,1)*rp*(cos(e1))**2-t(i,6)*v(6)
       t(1,7)=t(1,7)+rp*(cos(e2))**2
      CALL  MXV7(T,V,W)
             end if
      E1T=E1+atan(V(2)*(1+del))
      E2T=E2-atan(W(2)*(1+del))
      X1=V(1)-rp
      X2=W(1)-rp
      IF (BZ.GE.0) GO TO 40
      E1T=E1-atan(V(2)*(1+del))
      E2T=E2+atan(W(2)*(1+del))
      X1=-X1
      X2=-X2
 40    continue

      D1=X1*sin(e1)/cos(E1T)
      D2=X2*sin(e2)/cos(E2T)
               if(g.eq.0) then
      PAR(5)=E1T/RADEG
      PAR(6)=E2T/RADEG
      DL=V(5)-W(5)
      PAR(1) = PAR(1) + DL - D1 - D2
      THETA = THETA + atan(V(2)) - atan(W(2))
      RHO = PAR(1)/THETA
      PAR(4) = BR/RHO
                 end if
C Calculation of path length in magnet:
c    Effective field index on rp arc 
      np=-g*(rh+rp)/(bz+g*rp)
C Orbit in magnet : 
c     for F magnets (1-np > 0) x = rp + A cos(Sqrt(1-np)*phi-chi)
C     where phi is angle subtended at magnet arc center;
c         phi goes from zero to phi1=elgth/rh;
C     for D magnets (1-np < 0) x = rp + A cosh(Sqrt(np-1)phi - chi)
C     slope is slope=(dx/phi)/(rh+x)=v(2)/(1+x/rh)
c        rh nominal magnet radius
c     orbit lengthening: dl = Sqrt(1+slope**2)*(rh+x)*dphi-rh;
c 
           if(g.ne.0) then
              phi1=elgth/rh       
              If (1-np.gt.0) then
c  F magnet
                sq =sqrt(1-np)
                ks = sq/(rh+rp)
                a1 =phi1*sq
                sa=sin(a1)
                ca=cos(a1)
                x1=v(1)-rp
                xv=v(2)/ks

               dl1= rp*phi1+(xv*(1-ca)+x1*sa)/sq
               dl2=ks*((x1**2+xv**2)*a1-(x1**2-xv**2)*sa*ca
     1         -2*x1*xv*sa**2)/4
             Else
c   D magnet
               sqd =sqrt(np-1)
               ksd = sqd/(rh+rp)
               x1=v(1)-rp
               xvd=v(2)/ksd
               a1d =phi1*sqd
               sad=sinh(a1d)
               cad=cosh(a1d)
c  sq = i sqd; ks = i ksd; xv = -i xvd;
c  a1 = i asd; sa = i sad; ca = cad;      
c         dl1= rp*phi1+(ixvd*(1-cad)+x1*'-isad')/'-isqd'
c         dl2=iksd*((x1**2-xvd**2)*'ia1d'-(x1**2+xvd**2)*'isad'*cad
c     1   +2*x1*ixvd*'-sad**2')/4

               dl1= rp*phi1+((cad-1)*xvd+x1*sad)/sqd
               dl2=-ksd*((x1**2-xvd**2)*a1d-(x1**2+xvd**2)*sad*cad
     1         -2*x1*xvd*sad**2)/4 

            end if
c........1c........1c........1c........1c........1c........1c........1
cc      DL=V(5)-W(5)
           PAR(1) = elgth + dl1+dl2 - D1 - D2 
c      THETA = THETA + V(2) - W(2)
           RHO = PAR(1)/THETA
           PAR(4) = BR/rho
         end if

      DO 5 I=1,3
 5    ML(I) = MEND - 2 - I
      CALL DRIFT(MEND-3,D1)
      CALL MAGNET(MEND-4,PAR)
      CALL DRIFT(MEND-5,D2)
      CALL MMM(N,3,ML)
      Continue
c End game for general bending magnet
      DO 50 I=1,5
 50   V(I) = W(I)

      CALL RTRV7(N,T,RW)
      CALL MXV7(T,V0,W)

      do 14 i=1,5
 14   t(i,7)=t(i,7)+v(i)-w(i)
      call mxv7(t,v0,v) 
cc      if(g.ne.0) then
c  adjust edge focusing
         e1t=e1+atan(v0(2))
         e2t=e2-atan(v(2))
         IF (BZ.GE.0) GO TO 144         
         E1T=E1-atan(V0(2))
         E2T=E2+atan(v(2))
 144     PAR(5)=E1T/RADEG
         PAR(6)=E2T/RADEG
         CALL MAGNET(MEND-4,PAR)
         call mmm(n,3,ml)
         call rtrv7(n,t,rw)
         rw(2)=rw(2)+atan(v0(2))-atan(v(2))
cc      end if
      call stor7(n,t,rw)
      RETURN

 445   Continue
c   End game with quadrupoles
       DO 450 I=1,5
 450   V(I) = W(I)
 
 99    Continue
c  End game for rectangular zero-gradient magnet
       CALL RTRV7(N,T,RW)
 991   CALL MXV7(T,V0,W)
      DO 912 I=1,5
 912   T(I,7)=V(I)-W(I)
      CALL STOR7(N,T,RW)

      RETURN



C  DRIFT
 7    IF(NOP.NE.'DRF') GO TO 8
      EL = FLDAT(M,1)
      EL=EL*SQRT(1+V(2)*V(2))
      CALL DRIFT(N,EL)
* 11/19/03: STORE STRETCHED DRF TO GET PROPER LENGTH!
      CALL RTRV7(N,T,RW)
      CALL MXV7(T,V,V)
      CALL STOR7(N,T,RW)
      RETURN

C   KICK
 8    IF (NOP.NE.'KICK')  GO TO 82
      NAKICK = CINFF(2,M)
      IF (NAKICK.NE.NACORH)  GO TO 81
      TKH = TH(IIH)
      CALL STOFL(M,3,1,TKH)
      CALL KICK(M)
      IIH = IIH + 1
      IF (IIH.GT.NNH)  IIH = 1
      GO TO 10
 81   IF (NAKICK.NE.NACORV)  GO TO 10
      TKV = TV(IIV)
      CALL STOFL(M,3,1,TKV)
      CALL KICK(M)
      IIV = IIV + 1
      IF (IIV.GT.NNV) IIV=1
      GO TO 10
C  OTHER LINEAR ELEMENTS---MMM,ETC.
 82   CONTINUE
 10   CALL RTRV7(M,T,RW)
      CALL MXV7(T,V,V)
      CALL STOR7(N,T,RW)
      RETURN

      END
