      SUBROUTINE SEEK

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

CC        PERFORMS A ROUGH MINIMIZATION BY MONTE CARLO SEARCH.
CC        EACH TIME A NEW MINIMUM IS FOUND, THE SEARCH AREA IS SHIFTED
CC        TO BE CENTERED AT THE BEST VALUE.   RANDOM POINTS ARE CHOSEN
CC        UNIFORMLY OVER A HYPERCUBE DETERMINED BY CURRENT STEP SIZES.
CC
      include 'ccc/kard.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/deriva.ccc'

      include 'ccc/limits.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/seed.ccc'

      DIMENSION AMID(15) , N(15)
      DATA HALF/ 0.5D0 /

      WRITE (SVOUT,1000)
      NUMBER = INT(WORD7(1) + HALF)
      IF (NUMBER .LE. 0)  NUMBER = 10 * NPAR
      IFLAG = 4
C--       INITIAL VALUES
      DO 100 J= 1, NU
      NI = LCORSP(J)
      IF (NI .LE. 0)  GO TO 100
      N(NI) = J
      AMID(NI) = U(J)
  100 CONTINUE
      NCYCL = 0
C               MONTE CARLO SEARCH OVER ENTIRE VARIABLE PARAMETER SPACE
      DO 650 INUM= 1, NUMBER
      DO 200 I2= 1, NPAR
      I3 = N(I2)
C                                        RANDOM POINTS IN UNIFORM DISTR.
 180  XPLS=2*(RANSYN(NRZZ) - HALF)
      U(I3) = AMID(I2) + XPLS*WERR(I3)
      IF (LCODE(I3) .LE. 1)  GO TO 200
      IF (U(I3) .GT. BLIM(I3) .OR. U(I3) .LT. ALIM(I3))  GO TO 180
  200 CONTINUE
      CALL FCN(NPAR,G,F,U,IFLAG)
      NFCN = NFCN + 1
      IF (F .GE. AMIN)  GO TO 650
      AMIN = F
      DO 500 I= 1, NPAR
      J = N(I)
  500 AMID(I) = U(J)
      NCYCL = NCYCL + 1
      IF (ISW(5) .LT. 2)  GO TO 650
      CALL EXTOIN(X)
      IF (ISW(5).GE. 3 .OR. MOD(NCYCL,10).EQ.1)  CALL MPRINT(0,AMIN)
  650 CONTINUE
C                                  SEARCH FINISHED. SET U TO BEST VALUES
      DO 800 I= 1, NPAR
      NI = N(I)
  800 U(NI) = AMID(I)
      CALL EXTOIN(X)
      WRITE (SVOUT,1005)
      CALL MPRINT(1,AMIN)
      RETURN
 1000 FORMAT (' SEEK -- MONTE CARLO MINIMUM SEARCH ')
 1005 FORMAT ('0BEST VALUE FOUND IN SEEK IS ')
      END
