      SUBROUTINE SMPLXX

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
CC        PERFORMS A MINIMIZATION USING THE SIMPLEX METHOD OF NELDER
CC        AND MEAD (REF. -- COMP. J. 7,308 (1965)).
CC
      include 'ccc/kard.ccc'

      include 'ccc/casc.ccc'

      include 'ccc/conver.ccc'

      include 'ccc/deriva.ccc'

      include 'ccc/minima.ccc'

      include 'ccc/parint.ccc'

      include 'ccc/parext.ccc'

      include 'ccc/simvec.ccc'

      include 'ccc/sfile.ccc'

      include 'ccc/stitle.ccc'

      include 'ccc/varian.ccc'


      DIMENSION XBEST(15)
      LOGICAL CONVER
      DATA ALPHA,BETA,GAMMA,RHOMIN,RHOMAX/1.D0,.5D0,2.D0,4.D0,8.D0/
      IF (NPAR .LE. 0)  RETURN
      NPFN=NFCN
      NPARP1=NPAR+1
      RHO1 = 1 + ALPHA
      RHO2 = RHO1 + ALPHA*GAMMA
      WG = 1
      WG = WG/NPAR
      IFLAG=4
      WRITE(SVOUT,100) EPSI
      DO 2 I= 1, NPAR
      IF (ISW(2) .GE. 1)  DIRIN(I) = SQRT(V(I,I)*UP)
      TMP = 1.0D-10
      TMP1 = 1.0D-8
      IF (ABS(DIRIN(I)) .LT. TMP*ABS(X(I))) DIRIN(I)=TMP1*X(I)
      IF(ITAUR.LT. 1)  V(I,I) =    DIRIN(I)**2/UP
    2 CONTINUE
      IF (ITAUR .LT. 1)  ISW(2) = 1
C**       CHOOSE THE INITIAL SIMPLEX USING SINGLE-PARAMETER SEARCHES
    1 CONTINUE
      CONVER=.TRUE.
      YNPP1 = AMIN
      JL = NPARP1
      Y(NPARP1) = AMIN
      ABSMIN = AMIN
      DO 10 I= 1, NPAR
      AMING = AMIN
      PBAR(I) = X(I)
      BESTX = X(I)
      KG = 0
      NS = 0
      NF = 0
    4 X(I) = BESTX + DIRIN(I)
      CALL INTOEX(X)
      CALL FCN(NPAR,G, F, U, 4)
      NFCN = NFCN + 1
      IF (F .LE. AMING)  GO TO 6
C         FAILURE
      IF (KG .EQ. 1)  GO TO 8
      KG = -1
      NF = NF + 1
      TMP2 = -0.4D0
      DIRIN(I) = DIRIN(I) * TMP2
      IF (NF .LT. 3)  GO TO 4
      NS = 6
C         SUCCESS
    6 BESTX = X(I)
      DIRIN(I) = DIRIN(I) * 3
      AMING = F
      KG = 1
      NS = NS + 1
      IF (NS .LT. 6)  GO TO 4
C         LOCAL MINIMUM FOUND IN ITH DIRECTION
    8 Y(I) = AMING
      IF (AMING .LT. ABSMIN)  JL = I
      IF (AMING .LT. ABSMIN)  ABSMIN = AMING
      X(I) = BESTX
      XBEST(I)=BESTX
      DO 9 K= 1, NPAR
    9 P(K,I) = X(K)
   10 CONTINUE
      JH = NPARP1
      AMIN=Y(JL)
      CALL RAZZIA(YNPP1,PBAR)
      DO 20 I= 1, NPAR
   20 X(I) = P(I,JL)
      CALL INTOEX(X)
      IF (ISW(5) .GE. 1)  CALL MPRINT(0,AMIN)
      SIGMA = SIGMA * 10
      SIG2 = SIGMA
      IGNAL = 0
      NCYCL=0
C                                        . . . . .  START MAIN LOOP
   50 CONTINUE
      IF (IGNAL .GE. 10)  GO TO 1
      IF (SIG2 .LT. EPSI .AND. SIGMA.LT.EPSI)     GO TO 76
      SIG2 = SIGMA
      IF ((NFCN-NPFN) .GT. NFCNMX)  GO TO 78
C         CALCULATE NEW POINT * BY REFLECTION
      DO 60 I= 1, NPAR
      PB = 0
      DO 59 J= 1, NPARP1
   59 PB = PB + WG * P(I,J)
      PBAR(I) = PB - WG * P(I,JH)
   60 PSTAR(I)=(1+ALPHA)*PBAR(I)-ALPHA*P(I,JH)
      CALL INTOEX(PSTAR)
      CALL FCN(NPAR,G,YSTAR,U,4)
      NFCN=NFCN+1
      IF(YSTAR.GE.AMIN) GO TO 70
C         POINT * BETTER THAN JL, CALCULATE NEW POINT **
      DO 61 I=1,NPAR
   61 PSTST(I)=GAMMA*PSTAR(I)+(1-GAMMA)*PBAR(I)
      CALL INTOEX(PSTST)
      CALL FCN(NPAR,G,YSTST,U,4)
      NFCN=NFCN+1
C         TRY A PARABOLA THROUGH PH, PSTAR, PSTST.  MIN = PRHO
      Y1 = (YSTAR-Y(JH)) * RHO2
      Y2 = (YSTST-Y(JH)) * RHO1
      RHO = (RHO2*Y1 -RHO1*Y2) / (2*(Y1 -Y2))
      IF (RHO .LT. RHOMIN)  GO TO 66
      IF (RHO .GT. RHOMAX)  RHO = RHOMAX
      DO 64 I= 1, NPAR
   64 PRHO(I) = RHO*PSTAR(I) + (1 -RHO)*P(I,JH)
      CALL INTOEX(PRHO)
      CALL FCN(NPAR, G, YRHO, U, 4)
      NFCN = NFCN + 1
      IF (YRHO .LT. Y(JL) .AND. YRHO .LT. YSTST)  GO TO 65
      IF (YSTST .LT. Y(JL))  GO TO 67
      IF (YRHO .GT. Y(JL))  GO TO 66
C         ACCEPT MINIMUM POINT OF PARABOLA, PRHO
   65 CALL RAZZIA (YRHO,PRHO)
      IGNAL = MAX0(IGNAL-2, 0)
      GO TO 68
   66 IF (YSTST .LT. Y(JL))  GO TO 67
      IGNAL = MAX0(IGNAL-1, 0)
      CALL RAZZIA(YSTAR,PSTAR)
      GO TO 68
   67 IGNAL = MAX0(IGNAL-2, 0)
  675 CALL RAZZIA(YSTST,PSTST)
   68 NCYCL=NCYCL+1
      IF (ISW(5) .LT. 2)  GO TO 50
      IF (ISW(5) .GE. 3 .OR. MOD(NCYCL, 10) .EQ. 0) CALL MPRINT(0,AMIN)
      GO TO 50
C         POINT * IS NOT AS GOOD AS JL
   70 IF (YSTAR .GE. Y(JH))  GO TO 73
      JHOLD = JH
      CALL RAZZIA(YSTAR,PSTAR)
      IF (JHOLD .NE. JH)  GO TO 50
C         CALCULATE NEW POINT **
   73 DO 74 I=1,NPAR
   74 PSTST(I)=BETA*P(I,JH)+(1-BETA)*PBAR(I)
      CALL INTOEX (PSTST)
      CALL FCN(NPAR,G,YSTST,U,4)
      NFCN=NFCN+1
      IF(YSTST.GT.Y(JH)) GO TO 1
C     POINT ** IS BETTER THAN JH
      IF (YSTST .LT. AMIN)  GO TO 675
      IGNAL = IGNAL + 1
      CALL RAZZIA(YSTST,PSTST)
      GO TO 50
C                                        . . . . . .  END MAIN LOOP
   76 WRITE(SVOUT,120)
      GO TO 80
   78 WRITE(SVOUT,130)
      ISW(1) = 1
      CONVER=.FALSE.
   80 DO 82 I=1,NPAR
      PB = 0
      DO 81 J=1,NPARP1
   81 PB = PB + WG * P(I,J)
   82 PBAR(I) = PB - WG * P(I,JH)
      CALL INTOEX(PBAR)
      CALL FCN(NPAR,G,YPBAR,U,IFLAG)
      NFCN=NFCN+1
      IF (YPBAR .LT. AMIN)  CALL RAZZIA(YPBAR,PBAR)
      CALL INTOEX(X)
      IF (NFCNMX+NPFN-NFCN .LT. 3*NPAR)  GO TO 90
      IF (SIGMA .GT. 2*EPSI)  GO TO 1
 90   IF(CONVER) GO TO 902
      CALL INTOEX(XBEST)
 902  CALL MPRINT(1-ITAUR, AMIN)
      RETURN
  100 FORMAT(' START SIMPLEX MINIMIZATION', 8X,'CONVERGENCE ',
     1 'CRITERION -- ESTIMATED DISTANCE TO MINIMUM (EDM) .LT.',E10.2)
 120  FORMAT(1X, 'SIMPLEX MINIMIZATION HAS CONVERGED')
 130  FORMAT(1X,'SIMPLEX TERMINATES WITHOUT CONVERGENCE')
      END
