      SUBROUTINE SSSR(M,P,KF,KG)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  SETS UP MATRICES FOR A LONG(PI) OR COLLINS(PI/2) STRAIGHT SECTIONS
C   MATRICES GENERATED AS FOLLOWS
C      QF = FOCUSSING MAGNET AT M-1.
C      QD = DEFICUSSING MAGNET AT M-2.
C      QS = END DRIFT SPACE (HALF CENTER DRIFT SPACE) AT M-3 (PI)
C      QS = HALF CENTER DRIFT SPACE AT M-4 (COLLINS), AND THE STRAIGHT
C           SECTION MAGNET Q AT M.
C      QT = DRIFT SPACE BETWEEN F AND D MAGNETS AT M-4 (PI), AND THE
C           STRAIGHT SECTION MAGNET Q AT M.
C      QE = END DRIFT SPACE AT M-3 (COLLINS)

C   Q CAN TAKE EITHER OF TWO FORMS DEPENDING ON VALUE OF KF.
C     IF KF=1, Q = PRODUCT OF  ...QS QD QT QF QS QS QD QT QF QS. (DFDF)
C     IF KF=2, Q = PRODUCT OF  ...QS QF QT QD QS QS QF QT QD QS. (FDFD)
C           FOR LONG (PI) STRAIGHT SECTION
C           FOR COLLINS STRAIGHT SECTION
C     IF KF=1, Q = PRODUCT OF  ...QE QD QS QS QF QE. (DF)
C     IF KF=2, Q = PRODUCT OF  ...QE QF QS QS QD QE. (FD)

      include 'ccc/bmi.ccc'
C BMI.CCC
C      PARAMETER (MISIZ=5000)
C      COMMON /BMI/MI(MISIZ)
C      COMMON/NELS/NELS

      EQUIVALENCE (E,T)
      LOGICAL COLL
      DIMENSION P(6)

      COLL = .FALSE.
      IF (KG.EQ.1)  COLL = .TRUE.
C  SET UP FOR PI SECTION FIRST
      S = P(4)/2
      T = P(5)
      P(2) = ABS(P(2))
      P(4) = 0
      P(5) = 0
      P(6) = 0
C  SET UP QF
      L = M - 1
      CALL STOFL(L,1,6,P)
      CALL MAGNET(L,P)
      MI(4) = L
C  SET UP QD
      L = M - 2
      CALL STOFL(L,1,6,P)
      CALL EXCHM(L+1,L)
      MI(2) = L
C  SET UP QS
      L = M - 3
      CALL DRIFT (L,S)
      MI(1) = L
      MI(5) = L
C  SET UP QT OR QE  (T IS REALLY E IF COLLINS)
      L = M - 4
      CALL DRIFT (L,T)
      MI(3) = L
      IF (KF.EQ.1)  GO TO 2
C   AN FD OR FDFD
      MI(2) = M - 1
      MI(4) = M - 2
 2    IF (COLL)  GO TO 4
C  COMPLETE MI LIST
      DO 3 I=1,5
 3    MI(I+5) = MI(I)
      IM = 10
      GO TO 5
C   MAKE CHANGES FOR COLLINS STRAIGHT SECTION
 4    ISAV = MI(1)
      MI(1) = MI(3)
      MI(3) = ISAV
      ISAV = MI(4)
      MI(4) = MI(5)
      MI(5) = ISAV
      MI(6) = MI(1)
      IM = 6
 5    L = M
      CALL MMM(L,IM,MI)
C  SAVE THE MILIST AS DATA FOR Q
C  PI SECTION HAS ONE PIECE OF INTEGER DATA, SO MILIST BEGINS AT 2.
      DO 6 I=1,IM
 6    CALL STOIN(M,I,1,MI(I))
      RETURN
      END
