      SUBROUTINE STR2(M)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C   DESIGN A COLLINS LONG STRAIGHT SECTION TO MATCH A SPECIFIED CELL.
C  THE MU VALUE OF THE STRAIGHT SECTION MAY BE SPECIFIED BY THE USER.
C  INPUT CARDS...
C  A(M)      STR2    K     A(N)    BZ     BQ    AVAC    MU/2PI
C  M IS THE NUMBER OF THE FIRST CONSTITUENT MATRIX OF STRT. SECTION
C  N IS THE NUMBER OF THE CELL
C  THIS ROUTINE ASSUMES THAT THE CELL MATRICES ARE STORED AS ... CELL,
C  CELL1,CELL2,...,CELL12,AND THAT BETAMAX OCCURS AT CELL POSITION 2.

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=2000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=2000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/bmi.ccc'
C BMI.CCC
C      PARAMETER (MISIZ=5000)
C      COMMON /BMI/MI(MISIZ)
C      COMMON/NELS/NELS

      include 'ccc/grr.ccc'
C GRR.CCC
C      COMMON/GRR/IERR,BSW,VSW,RSW,QSW,XSW
C      LOGICAL IERR,BSW,VSW,RSW,QSW,XSW

      include 'ccc/ags.ccc'
C AGS.CCC
C      COMMON/AGS/ALPHA,BETA,RHO,BZ,AVAC,BMAX

      include 'ccc/str.ccc'
C STR.CCC
C      COMMON/STR/GAM,A,LK,BK,F,LM,BL,FLL,BQ,FLTO,SMUD,CMUD
C      REAL LK,LM,FLL,FLTO

      include 'ccc/const.ccc'
C CONST.CCC
C      COMMON/CONST/PIO2,PI,TPI,PI2,RADEG,M99
C      COMMON/CHCON/ASTRK,IBLNK
C      CHARACTER ASTRK*5,IBLNK*5

      include 'ccc/files.ccc'
C FILES.CCC
C      COMMON/FILES/IN,OUT,IFIL,OFIL,PRFL,PLFL,ORB1,
C     1             JBIS,CYBO,FL11,LFIL,EFIL,SVIN,SVOT,
C     2             SVPU,TK41,TK42,TK75,TK76
C      INTEGER OUT,OFIL,PRFL,PLFL,ORB1,CYBO,FL11,
C     1        EFIL,SVIN,SVOT,SVPU,TK41,TK42,TK75,TK76
C      COMMON/SWFILES/SWIFIL,SWOFIL,SWPRFL,
C     1               SWPLFL,SWORB1,SWJBIS,SWCYBO,SWFL11,
C     2               SWLFIL,SWEFIL,SWSVOT,SWSVPU,
C     3               SWTK41,SWTK42,SWTK75,SWTK76

      DOUBLE PRECISION MUD,LTOT,LK,LM
      EXTERNAL PARSR
      DIMENSION PAR(5),BX(9),BY(9)
      EQUIVALENCE (FLTO,LTOT),(E,PAR,BX)
      INTEGER CI
      CHARACTER(5) C,IOP,CHDAT

C  NAME OF CELL FROM INPUT AND ITS INDEX
      C = CHDAT(M,1)
      CI = JELNUM(C)
      KI = INFF(4,M)
C  RETRIEVE INPUT DATA
      CALL GETFL(M,1,4,PAR)
C  SET BZERO,BQ,AVAC,MUD
      BZ = PAR(1)
      BQ = PAR(2)
      AVAC = PAR(3)
      MUD = TPI*PAR(4)
C  DETERMINE INSERTION POINT, EITHER 4 OR 10
      IF (KI.EQ.2) GO TO 50
      INSP = 4
      GO TO 49
 50   INSP = 10
C  COMPUTE ALPHA, BETA AT INSERTION POINT
 49   L = CI - INSP
      CALL BET(L,BX,BY,0)
      PALPH = BX(3)
      ALPHA = ABS(PALPH)
      BETA = BX(2)
      GAM = BX(4)
C  COMPUTE BMAX FOR THE CELL
      L = CI - 2
      CALL BET(L,BX,BY,0)
      BMAX = BX(2)
C  GET VALUE OF RHO FOR THE CELL
      IOP = CINFF(1,CI)
      IF (IOP.EQ.'CFD')  GO TO 51
C  CELL,ALTC OR DCFD
      I = 3
      GO TO 52
C   CFD
 51   I = 4
 52   RHO = FLDAT(CI,I)
      SMUD = SIN(MUD)
      CMUD = COS(MUD)
      A = AVAC
C  COMPUTE FIRST GUESS FOR THETA
      LK = BQ/(A*BZ)
      BK = SQRT(LK/RHO)
      F = ALPHA/GAM
      LM = 1/(F*(BK*BK))
      THET = BK * LM
C  CALL ROOT FINDING ROUTINE
      CALL GRT (1,THET,1,PARSR)
      IF (IERR)  RETURN
      LTOT = BL+2*FLL+2*LM
      G = BQ/A
      CALL HED
      WRITE(OUT3,1) C,PALPH,BETA,RHO,BZ,BQ,AVAC,LM,LK,BL,FLL,LTOT,A,G
      CALL HED
      PAR(1) = LM
      PAR(2) = LK
      PAR(3) = RHO
      PAR(4) = BL
      PAR(5) = FLL
      CALL SSSR(M,PAR,KI,1)
C  ON RETURNING, THE MI LIST CONTAINS THE LIST FOR THE CELL WITH THE
C  CSS INSETED. I.E., QK, WHETE Q IS THE CELL NAME PREFIX.
C  QK IS COMPUTED AND SAVED.
      J = 2 - KI
      L = CI - 13
      MI(2) = L
      MI(12) = L
      L = CI - 14
      MI(J+5) = L
      MI(J+8) = L
      L = CI -15
      MI(1) = L
      MI(J+6) = L
      MI(J+7) = L
      MI(13) = L
      L = CI - 16
      MI(3) = L
      MI(J+4) = L
      MI(J+9) = L
      MI(11) = L
      IF (KI.EQ.2) GO TO 53
      MI(4) = M
      GO TO 54
 53   MI(10) = M
 54   L = M - 5
      CALL MMM(L,13,MI)
C  STORE THE MI LIST
      E = 0
      J = 0
      DO 55 I =1,13
      J = MI(I)
      CALL  STOIN(L,I,1,J)
 55   CONTINUE
      RETURN
 1    FORMAT (' COLLINS STRAIGHT SECTION IN CELL',A1,' .'/1H0,5X,
     1   'ALPHA=',F12.8,',',7X,'BETA=',F12.8,',',7X,'RHO=',F12.8/
     2   9X,'B0=',F12.8,',',9X,'BQ=',F12.8,',',6X,'AVAC=',F12.8/
     3   6X,' LMAG=',F12.8,',',10X,'K=',F12.8,',',6X,'LDRF=',F12.8,
     4   ',',6X,'LEND=',F12.8/6X,' LTOT=',F12.8,',',9X,'AQ=',F12.8,
     5   ',',6X,'GRAD=',F12.8,'  KG/M')
      END
