      SUBROUTINE STRPI(M)
C  DESIGN A LONG STRAIGHT SECTION TO MATCH A SPECIFIED CELL.
C  INPUT CARDS...
C  A(N)   STRPI    K    A(M)
C                       B0       BQ      AVAC     FLTO    LSEP
C  N IS THE NUMBER OF THE LONG STRAIGHT SECTION.
C  M IS THE NUMBER OF THE CELL.
C  K IS THE STRAIGHT-SECTION TYPE INDICATOR.(K=1 FOR DFDF,K=2 FOR FDFD)
C  J IS THE POINT OF INSERTION INTO THE CELL.
C  THIS ROUTINE ASSUMES THAT THE CELL MATRICES ARE STORED AS ...CELL,
C  CELL1,CELL2,...,CELL12, AND THAT BETAMAX OCCURS AT CELL POSITION S.
C  IF M IS A SYMMETRIC CELL (CELL, ALTC), ITS RHO IS PARAMETER 3.
C  IF M IS ASYMMETRIC (CFD,DCFD), IS RHO IS PARAMETER 4.



      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=2000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=2000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/grr.ccc'
C GRR.CCC
C      COMMON/GRR/IERR,BSW,VSW,RSW,QSW,XSW
C      LOGICAL IERR,BSW,VSW,RSW,QSW,XSW

      include 'ccc/ags.ccc'
C AGS.CCC
C      COMMON/AGS/ALPHA,BETA,RHO,BZ,AVAC,BMAX

      include 'ccc/str.ccc'
C STR.CCC
C      COMMON/STR/GAM,A,FLK,BK,F,FLM,BL,FLL,BQ,FLTO,SMUD,CMUD
C      REAL FLK,FLM,FLL,FLTO

      include 'ccc/files.ccc'
C FILES.CCC
C      COMMON/FILES/IN,OUT,IFIL,OFIL,PRFL,PLFL,ORB1,
C     1             JBIS,CYBO,FL11,LFIL,EFIL,SVIN,SVOT,
C     2             SVPU,TK41,TK42,TK75,TK76
C      INTEGER OUT,OFIL,PRFL,PLFL,ORB1,CYBO,FL11,
C     1        EFIL,SVIN,SVOT,SVPU,TK41,TK42,TK75,TK76
C      COMMON/SWFILES/SWIFIL,SWOFIL,SWPRFL,
C     1               SWPLFL,SWORB1,SWJBIS,SWCYBO,SWFL11,
C     2               SWLFIL,SWEFIL,SWSVOT,SWSVPU,
C     3               SWTK41,SWTK42,SWTK75,SWTK76
      DOUBLE PRECISION LDRF,LSEP
      EXTERNAL LPAR
      INTEGER CI,P
      DIMENSION BX(9),BY(9),PAR(5)
      EQUIVALENCE (PAR,BX)
      CHARACTER(5) C,IOP,CHDAT

C  NAME OF CELL FROM INPUT AND ITS INDEX
      C = CHDAT(M,1)
      CI = JELNUM(C)
      P = INFF(5,M)
      L = CI - P
      KI = INFF(4,M)
C  RETRIEVE INPUT
      CALL GETFL(M,1,5,PAR)
C  SET BZERO,BQ,AVAC,FLTO,LSEP
      B0 = PAR(1)
      BQ = PAR(2)
      AVAC = PAR(3)
      FLTO = PAR(4)
      LSEP = PAR(5)
      CALL BET(L,BX,BY,0)
      ALPHA = BX(3)
      BETA = BX(2)
C  COMPUTE BETMAX FOR THE CELL
      L = CI - 2
      CALL BET(L,BX,BY,0)
      BETMAX = BX(2)
C  GET THE VALUE OF RHO FOR THE CELL
      IOP = CINFF(1,CI)
      IF (IOP.EQ.'CFD')  GO TO 51
C  CELL, ALTC,DCFD
      I = 3
      GO TO 52
C  CFD
 51   I = 4
 52   RHO = FLDAT(CI,I)
      BL = FLTO/2
      F = SQRT(LSEP*BL)
      S = LSEP + BL
      A = AVAC
      AS = A*SQRT((BETA/BETMAX)*((1+ALPHA*S/BETA)**2+(S/BETA)**2))
      FLK = BQ/(AS*B0)
      BK = SQRT(FLK/RHO)
      FLM = 1/(F*BK**2)
      THETA = BK*FLM
      GAM = P
      CALL GRT(1,THETA,1,LPAR)
      IF (IERR)  RETURN
      LDRF = 2*BL
      GRAD = BQ/AS
      CALL HED
      WRITE(OUT3,3) C,ALPHA,BETA,BETMAX,RHO,B0,BQ,AVAC,AS,FLM,FLK,
     1           LDRF,LSEP,FLTO,BL,GRAD
      CALL HED
      PAR(1) = FLM
      PAR(2) = FLK
      PAR(3) = RHO
      PAR(4) = LDRF
      PAR(5) = LSEP
      CALL SSSR(M,PAR,KI,0)
      RETURN
 3    FORMAT(' LONG STRAIGHT SECTION IN CELL ',A1,' .'/1H0,5X,'ALPHA=',
     1      F12.8,',',7X,'BETA=',F12.8,',',4X,'BETMAX=',F12.8,',',7X,
     2      'RHO=',F12.8/9X,'B0=',F12.8,',',9X,'BQ=',F12.8,',',6X,
     3      'AVAC=',F12.8,',',8X,'AS=',F12.8/7X,'LMAG=',F12.8,',',10X,
     4      'K=',F12.8,',',6X,'LDRF=',F12.8,',',6X,'LSEP=',F12.8,/
     5      7X,'LTOT',F12.8,',',7X,'LEND=',F12.8,',',6X,'GRAD=',F12.8,
     6      2X,'KG/M')
      END
