      SUBROUTINE SW4

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  PROCESSES DATA FOR CURRENT INSTR.IF IN MODE 1 OR 2.
C  PROCEEDS WITH CALC.BY CALLING APPROPRIATE ROUTINES IF MODE=1 OR 3.

      include 'ccc/instr.ccc'

      include 'ccc/binff.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/swtch.ccc'

      include 'ccc/grr.ccc'

      include 'ccc/const.ccc'

      include 'ccc/files.ccc'
      include 'ccc/clfil.ccc'

      include 'ccc/slfil.ccc'

       DIMENSION KFIL(20)
       CHARACTER(5) KFIL

      DIMENSION T(49),TTT(7,7),RW(3)
      DIMENSION KREM(100),PAR(100)
      INTEGER PVECS
      INTEGER R7
      CHARACTER(5) NM,NAMOP,CHDAT
      DATA PVECS,MAT,R7/2,3,5/
      DATA ISCL/9/

C   COMMANDS WITH IOP GT 120 ARE
C       SIN,COS,EXP,LOG,SQ,SQRT,TAN,ASIN,ACOS,ATAN,ABS,CALC
      IF (IOP.EQ.132) GO TO 400
      IF (IOP.GT.120) GO TO 300

C  OTHER COMMANDS

      NOP = IOP - 99
*  GO TO PBML,MAT,VEC,PVEC,MXV,CPLX,EQIL,EVEC,PRTV,PRV7,
C       CVEC,LIST,FBLE,FBLI,BMLE,BMLI,MAT7,IOUT,LSTE,
C       OPEN,KEEP

      IF (NOP.EQ. 1) GOTO 100
      IF (NOP.EQ. 2) GOTO 110
      IF (NOP.EQ. 3) GOTO 120
      IF (NOP.EQ. 4) GOTO 130
      IF (NOP.EQ. 5) GOTO 140
      IF (NOP.EQ. 6) GOTO 150
      IF (NOP.EQ. 7) GOTO 160
      IF (NOP.EQ. 8) GOTO 170
      IF (NOP.EQ. 9) GOTO 180
      IF (NOP.EQ.10) GOTO 190
      IF (NOP.EQ.11) GOTO 200
      IF (NOP.EQ.12) GOTO 210
      IF (NOP.EQ.13.OR.NOP.EQ.14) GOTO 220
      IF (NOP.EQ.15) GOTO 240
      IF (NOP.EQ.16) GOTO 250
      IF (NOP.EQ.17) GOTO 260
      IF (NOP.EQ.18) GOTO 270
      IF (NOP.EQ.19) GOTO 280
      IF (NOP.EQ.20) GOTO 285
      IF (NOP.EQ.21) GOTO 287

C   PBML ENTRY     PRINT BEAM LINE
 100  IF (MODE.EQ.3)  GO TO 101
      CALL INP6(M,0,0,1,-2,0)
      IF (MODE.EQ.2)  RETURN
 101  IF (XSW)  RETURN
      CALL PBML(M)
      RETURN

C  MAT ENTRY---MATRIX OF KA ROWS, KB COLS (INPUT BY ROWS)
 110  IF (MODE.EQ.3) GO TO 112
      MN = KA*KB
      COLS = KA
      ROWS = KB
      CALL RESRV6(M,MAT,MN,
     .  MN,1,0)
      DO 111 J=1,KA
 111  CALL LOAD4(M,
     .   KB,1,0)
 112  CALL TRNSPS
      RETURN

C  VEC ENTRY -- KB VECTORS EACH WITH KA COMPONENTS
 120  IF (MODE.EQ.3)  GO TO 123
      IF (KB.NE.0) GO TO 121
      KB = 1
      INFF(5,M) = KB
 121  ROWS = KA
      COLS = KB
      MN = KA*KB
      CALL RESRV6(M,0,MN,
     .    MN,1,0)
      DO 122 J=1,KB
 122  CALL LOAD4(M,KA,1,0)
 123  CALL GETFL(M,1,MN,PAR)
      CALL STOQ(M,1,MN,PAR)
      RETURN
C  PVEC ENTRY.  READ IN KA VECTORS (COL) OF 6 ROWS.  SET 7TH TO 1.0
 130  IF(MODE.EQ.3) GO TO 132
C  PVECS KIND RESERVES 7 X KA
      IF (KA.EQ.0) KA = 1
      INFF(4,M) = KA
      KC = 7*KA
      COLS = KA
      CALL RESRV6(M,PVECS,M99,KC,1,0)
      DO 131 I=1,KA
      CALL LOAD4(M,
     .  6,1,0)
 131  CONTINUE
 132  KC = 7*KA
      IC1 = 1
      IC2 = KC
      NC = KC
      IF (KC.GT.100) IC2 = 100
 133  CALL GETFL(M,IC1,IC2,PAR)
      CALL STOQ(M,IC1,IC2,PAR)
      IF (IC2.EQ.NC) RETURN
      IC1 = IC1 + IC2
      NC = NC -IC2
      IF (NC.LE.IC2) IC2 = NC
      GO TO 133
C  MXV ENTRY.  MATRIX TIMES VECTOR
 140  IF(MODE.EQ.3) GO TO 141
      ROWS = 7
      COLS = 1
      CALL INP6(M,PVECS,7,2,2,0)
      IF (MODE.EQ.2) RETURN
      IF (XSW) RETURN
C  RETRIEVE ELEMENTNUMBER OF INPUT MATRIX AND VECTOR.FIND LQ OF VECTORS
 141  M1 = MDAT(M,1)
      NM = CHDAT(M,2)
      M2 = JELNUM(NM)
      LOC = 1
      IF(.NOT.VCSW) GO TO 143
      READ (NM,142) NUM
 142  FORMAT (1X,I1,3X)
      LOC = (NUM-1)*7+1
 143  CALL GETQ(M2,LOC,7,PAR(8))
      CALL RTRV7(M1,T,RW)
      CALL MXV7(T,PAR(8),PAR(1))
      CALL STOQ(M,1,7,PAR)
      RETURN

C  CPLX ENTRY ----A COMPLEX NUMBER
 150  IF (MODE.EQ.3) RETURN
      TYPE = 'CPLX'
      KN = ISCL
      CALL INP6(M,KN,0,
     .  2,1,0)
      RETURN

C  EQIL ENTRY
 160  IF (MODE.EQ.3) GO TO 161
      KA = 3
      CALL INP6(M,PVECS,M99,
     .  2,2,0)
C  SET KA FOR NUMBER OF COLUMN VECTORS
      IF (MODE.EQ.2) RETURN
      IF (XSW) RETURN
 161  CALL EQIL(M)
      RETURN
C  EVEC ENTRY
 170  IF (MODE.EQ.3) GO TO 171
      CALL INP6(M,0,112,
     .  2,2,0)
      IF (MODE.EQ.2) RETURN
      IF (XSW) RETURN
 171  CALL EVEC(M)
      RETURN

C  PRTV  ---PRINT VECTORS   ANY SIZE
 180  IF(MODE.EQ.3) GO TO 181
      CALL INP6(M,0,0,
     .  1,-2,0)
      KA = INFF(17,M)
      INFF(4,M) = KA
      IF (MODE.EQ.2) RETURN
      IF (XSW) RETURN
 181  CALL PRINTV(M,KA)
      RETURN

C  PRNTV7 --- PRINT PARTICLE VECTORS
 190  IF (MODE.EQ.3) GO TO 191
      CALL INP6(M,0,0,
     .  1,-2,0)
      KA = INFF(17,M)
      INFF(4,M) = KA
      IF (MODE.EQ.2) RETURN
      IF (XSW) RETURN
 191  CALL PRNTV7(M,KA)
      RETURN
C  CVEC ENTRY ----COMPLEX PARTICLE VECTOR,KA, IN NUMBER
C  IF KB=BLANK OR 1, ROW 7 IS 1.  IF KB = 0, ROW7 IS 0.
 200  IF (MODE.EQ.3) RETURN
      V7R = 0
      V7I=0
      IF (KB.EQ.1.OR.KB.EQ.0 ) V7R = 1
      IF(KA.EQ.0) KA=1
      KC = 14*KA
      ROWS = 7
      COLS = KA
      TYPE = 'CPLX'
      CALL RESRV6(M,PVECS,0,
     .  KC,1,0)
      DO 201 I=1,KA
      CALL LOAD4(M,
     .  12,1,0)
      NF = NF + 2
      NPL = 14*(I-1) + 13
      CALL STOFL(M,NPL,1,V7R)
      NPL = NPL + 1
      CALL STOFL (M,NPL,1,V7I)
 201  CONTINUE
      RETURN

C  LIST ENTRY

C   A     LIST   KA    A1   A2    A3     A4   A5

C    THE LIST INSTRUCTION SPECIFIES A SET OF ELEMENTS THAT ARE TO BE
C  USED SUCCESSIVELY.  THE NAME APPEARS IN A BML INSTRUCTION.   EACH
C  TIME THE SAME LIST NAME IS ENCOUNTERED, THE NEXT AI IS USED.

C  EXAMPLE
C----------------------------------------------------------------------
C   QQ      LIST        Q1   Q2   Q3   Q4   Q5
C   L      DRF         3.
C   .S     BML            5(Q    L        )
C-----------------------------------------------------------------------
C   .S IS EQUIVALENT TO
C   .S     BML         Q1   L    Q2   L    Q3   L    Q4   L    Q5   L

 210  IF (MODE.EQ.3) GO TO 211
      CALL INP6(M,0,0,1,-2,0)
 211  IF (KB.NE.0)  RETURN
       KB=1
       INFF(5,M)=1
      RETURN

C    *******************  FBLE AND FBLI ENTRIES *******************
C     FBLE --EXPLICIT BEAM LINE FUNCTION.  WHEN REFERRED TO BY
C       BMLE, A NEW BML STATEMENT IS CREATED.
C  NM  FBLE   K     T         A1   A2   A3   ...  AK
C    NM = NAME OF FUNCTION
C    T  = NAME OF BEAM LINE TO BE CHANGED.
C    K  = NUMBER OF REPLACEMENTS
C    A1,A2,...AK  = ELEMENTS WHICH WILL BE REPLACED.
C      FBLE WILL BE FOLLOWED AT SOME TIME BY ONE OR MORE BMLE STATE-
C  MENTS CONTAINING REPLACEMENT ELEMENTS.
CC
C__________________________________________________________________
C     FBLI --IMPLICIT BEAM LINE FUNCTION.  REPLACEMENTS CALLED FOR
C   BY AN BMLI WILL NOT BE MADE UNTIL TIME FOR CREATING MILIST.
C  NM  FBLI   K     T         A1   A2   A3   ...  AK
C     INPUT IS SAME AS FOR FBLE.
CC
C
 220   IF (MODE.EQ.3) RETURN
      CALL INP8(M,0,0,1,2,KA,2,0)
      RETURN
C
C
C   BMLE  -- REPLACE BEAM LINE ELEMENTS NAMED IN FUNCTION FBLE
C        WITH ONES NAMED HERE AND CREATE A NEW BEAM LINE
C RE   BMLE   K     FN   BNAM B1   B2   B3   ...  BK
C    FN = NAME OF BEAM LINE FUNCTION FBLE
C    BNAM = NAME OF NEW BEAM LINE.  IF BLANK, IT WILL ASSUME NAME OF
C           THE OLD ONE NAMED IN FUNCTION.
C    K = NUMBER OF REPLACEMENTS (MUST BE THE SAME AS K IN FUNCTION FBLE)
C    B1,B2,B3...BK = ELEMENTS THAT REPLACE A1,A2,...NAMED IN FUNCTION.
C
 240  IF (MODE.EQ.3) RETURN
      KT = KA + 2
      CALL INP6(M,0,0,KT,2,0)
      MFN = MDAT(M,1)
      NAMOP = CINFF(1,MFN)
      IF (NAMOP.NE.'FBLE') GO TO 241
      CALL BMLE(M)
      RETURN
 241  WRITE (OUT3,242) NAME,NAMOP
 242  FORMAT (5X,'*** ERROR ***  BMLE STATEMENT ',A5,2X,'REFERS TO ',
     1   A5,' INSTEAD OF AN FBLE.')
      STOP

C   BMLI ENTRY
 250   IF (MODE.EQ.3)  RETURN
C   BMLI --- REPLACE ELEMENTS NAMED IN FBLI INSTRUCTION WITH THOSE
C            INPUT HERE.  DONE AT TIME MILIST IS CREATED.  CHANGES
C            MAY THREAD THROUGH EMBEDDED BEAM LINES, BUT NO OTHER
C            BMLI'S MAY BE INCLUDED.
C BL   BMLI   K     FN        B1   B2   B3   ...  BK
C
C     FN = NAME OF BEAM LINE FUNCTION FBLI
C     K  = NUMBER OF REPLACEMENTS (SAME AS FOR FBLI)
C     B1,B2,...BK ARE CONSTITUTENTS THAT REPLACE A1,A3,... NAMED IN
C     FN (FBLI INSTRUCTION).
C
C .P   BML          A    B    C    C
C .Q   BML          E    F    .P
C FQ   FBLI   2     .Q        A    C
C .QQ  BMLI   2     FQ        A1   C1
C      CYC          .QQ
C
      KT = KA + 1
      CALL RESRV6(M,0,0,KT,2,0)
      CALL LOAD6(M,1,2,KA,2,0)
      MFN = MDAT(M,1)
      NAMOP = CINFF(1,MFN)
      IF (NAMOP.EQ.'FBLI') THEN
        KF = INFF(4,MFN)
        KR = INFF(4,M)
        IF (KF.EQ.KR) RETURN
        WRITE (OUT3,251)
 251    FORMAT (5X,'*** ERROR *** NUMBER OF REPLACEMENT ITEMS DIFFERS ',
     1   'IN FBLI AND BMLI STATEMENTS.')
        STOP
      ELSE
      WRITE (OUT3,252) NAME,NAMOP
 252  FORMAT (5X,'*** ERROR ***  BMLI STATEMENT ',A5,2X,'REFERS TO ',
     1   A5,' INSTEAD OF AN FBLI.')
      STOP
      END IF
      RETURN

C  MAT7 ENTRY --7X7 MATRIX
 260  IF (MODE.EQ.3)  GO TO 262
      CALL RESRV6(M,R7,M99,49,1,0)
      DO 261 J=1,6
 261  CALL LOAD4(M,7,1,0)
      DO 264 J=43,48
 264  PAR(J) = 0
      PAR(49) = 1
      CALL STOFL (M,43,49,PAR(43))
      DO 263 J =1,3
 263  RW(J) = 0
 262  CALL GETFL (M,1,49,PAR)
      CALL TRNSPS7(PAR,TTT)
C  DO SYMPLECTIC OPERATION ON ROW 5
      DO 22 I=1,2
       TTT(5,I) = TTT(1,6)*TTT(2,I) - TTT(2,6)*TTT(1,I)
 22   TTT(5,I+2) = TTT(3,6)*TTT(4,I+2) - TTT(4,6)*TTT(3,I+2)
      CALL STOR7(M,TTT,RW)
      RETURN

C  IOUT ENTRY
 270  IF (MODE.EQ.3) GO TO 271
      CALL INP4(M,0,0,0)
      IF (MODE.EQ.2) RETURN
 271  IF (XSW) RETURN
      CALL IOUT(M)
      RETURN
C   LSTE ENTRY
 280  IF(MODE.EQ.3)  GO TO 281
      CALL INP6(M,0,0,1,2,0)
      IF (MODE.EQ.2) RETURN
 281  IF (XSW) RETURN
      CALL LSTE(M)
      RETURN

C  OPEN ENTRY
 285  IF (MODE.EQ.3) GO TO 2855
        CALL INP6(M,0,0,1,-2,0)
 2855   IF (XSW) RETURN
        NCB = INFF(17,M)
        CALL GETCH (M,1,NCB,KFIL)
        DO 286 I=1,NCB
        IF (KFIL(I).EQ.'  ') GO TO 286
        IF (KFIL(I).EQ.'PLFIL') SWPL = .TRUE.
        IF (KFIL(I).EQ.'FIL11') SW11 = .TRUE.
        IF (KFIL(I).EQ.'FIL41') SW41 = .TRUE.
        IF (KFIL(I).EQ.'FIL42') SW42 = .TRUE.
 286    CONTINUE
        RETURN
C   KEEP ENTRY



C       PARAMETER (ISVMX=4)
C       COMMON/CLFIL/SVFIL(ISVMX),FILNAM(ISVMX)            
C       LOGICAL SVFIL
C       CHARACTER*5 FILNAM


C  KEEP ENTRY
 287    IF (MODE.EQ.3) GO TO 2877
        CALL INP6(M,0,0,1,-2,0)
 2877   IF (XSW) RETURN
        NCB = INFF(17,M)
        CALL GETCH (M,1,NCB,KFIL)
        DO 290 I=1,NCB
        IF (KFIL(I).EQ.'  ') GO TO 290
        IF (KFIL(I).EQ.'SVOUT') SWVOUT = .TRUE.
        IF (KFIL(I).EQ.'ORB1') SWORB1 = .TRUE.
 290    CONTINUE
         RETURN


 300  IF (MODE.EQ.3) GO TO 350
      KN = ISCL
      CALL INP6(M,KN,1,1,1,0)
      IF (MODE.EQ.2.OR.XSW) RETURN
 350  XX = FLDAT(M,1)
      NNOP = IOP - 120
      IF (NNOP.EQ.1) THEN
         YY = SIN(XX)
      ELSE IF (NNOP.EQ.2) THEN
         YY = COS(XX)
      ELSE IF (NNOP.EQ.3) THEN
         YY = EXP(XX)
      ELSE IF (NNOP.EQ.4) THEN
         YY = LOG(XX)
      ELSE IF (NNOP.EQ.5) THEN
         YY = XX*XX
      ELSE IF (NNOP.EQ.6) THEN
         YY = SQRT(XX)
      ELSE IF (NNOP.EQ.7) THEN
         YY = TAN(XX)
      ELSE IF (NNOP.EQ.8) THEN
         YY = ASIN(XX)
      ELSE IF (NNOP.EQ.9) THEN
         YY = ACOS(XX)
      ELSE IF (NNOP.EQ.10) THEN
         YY = ATAN(XX)
      ELSE IF (NNOP.EQ.11) THEN
         YY = ABS(XX)
      ELSE
         STOP
      ENDIF
      CALL STOQ(M,1,1,YY)
      RETURN

C  CALC ENTRY
 400  IF (MODE.EQ.3) GO TO 401
      CALL INP6(M,0,5,1,-2,0)
C  SET LFL AND NFL EQUAL TO LQ AND NQ
      INFF(14,M) = INFF(10,M)
      INFF(15,M) = INFF(11,M)
      IF (MODE.EQ.2.OR.XSW) RETURN
 401  CALL CALC(M)
       RETURN

      END
