      SUBROUTINE SXTP(M,V,PAR)
      IMPLICIT NONE
C    SX   SXTP      KB  L    D2B        BRHO        EXACT
C ---------------------------------------------------------
C     SX IS A SEXTUPOLE THAT ACTS AT A POINT.  IT REPRESENTS THE
C  EFFECT OF A SEXTUPOLE OF LENGTH L, WITH D2B = D2B/DX2.
C  IF L=0 ON INPUT, L IS SET =1.
C     EXACT IS AN OPTION TO CALL FOR AN EXACT CALCULATION, USING
C  ELLIPTIC FUNCTIONS ACCORDING TO A METHOD OF B. AUTIN.  IT IS
C  EXERCISED BY SETTING EXACT TO A NON-ZERO VALUE, BUT IS ONLY
C  OBEYED IF THE RAY IS IN THE HORIZONTAL PLANE AND L IS NOT ZERO.
C ---------------------------------------------------------------
C 8/5/96 (EDC and AAG): Invoke NPOL with N=3; normal if KB=0 and skew if
C KB=1 (unless EXACT option is in effect)


      include 'ccc/dim.ccc'
C DIM.CCC
C      COMMON /DIM/ LEND,MEND,ISAV,ISAV7,M7END,KADD,KADDR,MUNIT,MSYMPL,
C     1             INFMAX,IFLMAX,IMAX,ICHMAX,ISFMAX,IQMAX,IMIN

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=1000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=1000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/const.ccc'
C CONST.CCC
C      COMMON/CONST/PIO2,PI,TPI,PI2,RADEG,M99
C      COMMON/CHCON/ASTRK,IBLNK
C      CHARACTER ASTRK*5,IBLNK*5

      INTEGER M
      DOUBLE PRECISION PAR(*),V(*)
      DOUBLE PRECISION AC,AK,AXM
      DOUBLE PRECISION BR,BRHO
      DOUBLE PRECISION C,C1,CN,CT,CURV,CX
      DOUBLE PRECISION D,D2B,DN,DPP,DT
      DOUBLE PRECISION EPS0,EPS1
      DOUBLE PRECISION F,FAC
      INTEGER I
      DOUBLE PRECISION L,LSX,LH
      DOUBLE PRECISION K,KP
      DOUBLE PRECISION MAG(6)
      DOUBLE PRECISION ONE
      DOUBLE PRECISION P(4),PX,PX1,PY
      DOUBLE PRECISION Q
      DOUBLE PRECISION R(7,7),RW(3)
      DOUBLE PRECISION S1,S13,S23,S3,S32,SC,SK,SN,SN2,SS3,ST,ST2,SU
      DOUBLE PRECISION T,T1,T12,TH3,TH4,THETA,TM
      DOUBLE PRECISION U,UNITY
      DOUBLE PRECISION W(4)
      DOUBLE PRECISION X,X1,X1M,XAV,XK,XK2,XKP,XKPRIM,XM,XT,XX
      DOUBLE PRECISION Y
      DOUBLE PRECISION Z

      EXTERNAL THETA1,THETA2,THETA3,THETA4
      DOUBLE PRECISION THETA1,THETA2,THETA3,THETA4

      EQUIVALENCE (X,W(1)),(PX,W(2)),(Y,W(3)),(PY,W(4)),
     1            (L,P(1)),(D2B,P(2)),(BRHO,P(3))
     2         ,(LSX,MAG(1)),(K,MAG(2)),(ONE,MAG(3)),(CURV,MAG(4)),
     3             (EPS0,MAG(5)),(EPS1,MAG(6))

      PARAMETER( UNITY = 1.D0 )
      PARAMETER (S13=1D0/3D0)
      DATA ONE/1.D0/,S3/1.732050808D0/,S32/0.433012702D0/
      DATA SS3/1.44224957D0/,S23/3.464101616D0/
C
      DO 1 I=1,4
      W(I)=V(I)
   1  P(I)=PAR(I)
      DPP = V(6)
      FAC = 1 + DPP
      BR = FAC * BRHO
      F = D2B / BR
      KP=F
      IF(P(4).NE.0.AND.D2B.NE.0.AND.L.NE.0.AND.Y.EQ.0.AND.PY.EQ.0)
     $     GO TO 5
      CALL NPOL(M,V,PAR)
      RETURN

C  EXACT CALCULATION FOR THICK SEXTUPOLE, H-PLANE ONLY. --- B.AUTIN
 5    CONTINUE
C
C     CONDITIONS INITIALES C
C
      SK=SIGN(UNITY,KP)
      AK=(ABS(KP))**S13
      U=KP*PX
      SU=-SIGN(UNITY,U)
      C=X*X*X*KP/3+PX*PX
      IF(C.EQ.0) GO TO 99
      AC=ABS(C)**S13
      SC=SIGN(UNITY,C)
      AXM=AC*SS3/AK
      XM=SC*SK*AXM
      TM=SQRT(S3*AC)*AK/SS3
C
C     MODULE K2
C
      XK2 = 0.5D0
      XK2=XK2 + SC*S32
      XK=SQRT(XK2)
C
C     LIGNES TRIGONOMETRIQUES DE PHI0
C
      T=ABS(1-X/XM)/S3
      D=1+T
      CT=(1-T)/D
      ST=SU*2*SQRT(T)/D
      ST2=ST*ST
      DT=SQRT(1-XK2*ST2)
C
C     FONCTIONS DE JACOBI
C
      CALL QFUNCT(XK,XKPRIM,Q)
      XK=SQRT(XK)
      XKP=SQRT(XKPRIM)
      Z=TM*L
      TH3 = 0
      TH3 = THETA3(TH3, Q)
      U=Z/(TH3*TH3)
      TH4=THETA4(U,Q)
      XT=XK*TH4
      SN=THETA1(U,Q)/XT
      SN2=SN*SN
      CN=XKP*THETA2(U,Q)/XT
      DN=XKP*THETA3(U,Q)/TH4
C
C     X1
C
      C1=(CT*CN-ST*SN*DT*DN)/(1-XK2*ST2*SN2)
      XX=SC*S3*(1-C1)/(1+C1)
      X1M=1-XX
      X1=X1M*XM
C
C     XPRIME1
C
      S1=ST*CN*DN+CT*SN*DT
      U=KP*S1
      SU=-SIGN(UNITY,U)
      CX=ABS(C*XX)
      PX1=SU*SQRT(CX*(1+X1M+X1M*X1M))
      GO TO 100
C
C     CAS PARTICULIER C=0
C
   99 XM=-SK/AK
      TM=AK/S23
      T=SU*SQRT(X/XM)
      T1=T/(1-TM*T*L)
      T12=T1*T1
      X1=XM*T12
      PX1=-SK*T12*T1/S3
  100 V(1)=X1
      V(2)=PX1

      IF(M.EQ.0) RETURN
C  MAG(I) = LSX,K,1.0,CURV,EPS0,EPS1 --- INPUT TO S/R MAGNET
      LSX=L
      THETA=PX-PX1
      XAV=(X+X1)/2 + (THETA*L)/12
      K=KP*XAV
      CURV=THETA/L
      EPS0=PX/RADEG
      EPS1=-PX1/RADEG
      CALL MAGNET(M,MAG)

      RETURN
      END
