      PROGRAM SYNCH

C     SYNCH--  A COMPUTER SYSTEM FOR SYNCHROTRON DESIGN AND ORBIT
C  ANALYSIS.   BY A.A.GARREN AND A.S.KENNEY, LAWRENCE BERKELEY LAB.

c
c    copyright, 1965, the regents of the university of california.
c
c    this software was produced under a us government  dept. of energy
c    contract (DE-AC03-76SF00098) by the lawrence Berkeley laboratory,
c    which is operated by the university of california for
c    the us department of energy.  the us government is licensed to use,
c    reproduce, and distribute this software.
c    permission is granted to the public to copy and use this software
c    provided that this notice and any statement of authorship are reproduced
c    on all copies.  neither the government nor the university makes any
c    warranty, express or implied, or assumes any liability or responsibility
c    for the use of this software.
c

C      PROGRAMMING QUESTIONS MAY BE DIRECTED TO ARDITH KENNEY AT LBL.
C  PHONE 415-486-6631     FTS 451-6631     VAX LOGIN NAME IS ARDITH

      IMPLICIT NONE

      include 'ccc/binff.ccc'

      include 'ccc/instr.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/grr.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/swtch.ccc'

      include 'ccc/files.ccc'

      INTEGER IC(IFFSIZ)
      CHARACTER(5) CIC(IFCSIZ)
      EQUIVALENCE (IC(1),LSF),(CIC(1),OPNAME)

      CALL INIT
      CALL DUPIN(1)
      CALL RDINST
      IF (OPNAME.EQ.'RUN  ') GO TO 4
      WRITE (OUT3,50) OPNAME
 50   FORMAT (5X,'***** ERROR. ',A5,' IS FIRST STATEMENT.  SYNCH RUN',
     1  ' MUST BEGIN WITH A RUN COMMAND.')
      STOP
C  COME BACK HERE TO PROCEED TO NEW RUN.  MUST BYPASS DUPIN.
 9    CONTINUE
      CALL INIT
 2    CALL RDINST
 4    CALL SWITCH
      IF (IERR.OR.ERROR) THEN
        CALL ERRSR(M)
        IERR = .FALSE.
        ERROR = .FALSE.
        GO TO 9
      END IF
      IF (FIN) GO TO 2
C  CHECK FOR REDEFINITION OF ELEMENT BY NAME
      IF (MODE.EQ.1.OR.MODE.EQ.2) CALL NAMCHK(M)
      IF(MODE.EQ.3) GO TO 3
      IF (.NOT.MSSW) GO TO 7
      CALL RDINF(IC,M)
      CALL RDINFC(CIC,M)
      CALL MESH(M,KA,OPNAME)
      IF (MSSW) GO TO 3
 7    IMIN = IMIN - 1
      NXTM=IMIN
      CALL INFW( IMIN,8,M )
      M=IMIN
      GO TO 2
 3    NXTM = INFF( 8,M )
      M=NXTM
      IF(.NOT.TRASW) GO TO 5
      M=TRA
      TRASW=.FALSE.
 5    CALL RDINF( IC,M )
      CALL RDINFC(CIC,M)
      GO TO 4
      END
