      SUBROUTINE TRK(M)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'ccc/binff.ccc'

      include 'ccc/bmi.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/trkint.ccc'

      include 'ccc/contrl.ccc'

      include 'ccc/cderiv.ccc'

      include 'ccc/const.ccc'

      include 'ccc/psym.ccc'

      include 'ccc/files.ccc'

      include 'ccc/seed.ccc'

      DIMENSION V(7),V0(7),U(56),BX(9),BY(9),VV(7)
      LOGICAL DPRSAV
      DIMENSION R7(7,7),RW(3),U0(7),UP(7),UM(7),UF(7)
      EQUIVALENCE (AXCOS,V(1)), (AYCOS,V(3)), (DPP,U(6))
      DIMENSION SCALE(4)
      CHARACTER(5) CHDAT,NVECS,NBML,NVEC0,NMAT,MATI,MATL

      DATA (RW(I),I=1,3)/3*0.0D0/
      DATA DELP/1.D-08/

C  INSTRUCTION TRK----TRACK PARTICLES  THROUGH LINEAR OR
C  NON-LINEAR TRANSFORMATIONS

C----------------------------------------------------------------------
C  T   TRK  NP IMP//V    BLIN/MAT  V0  /   NR IOF/IVSAV MODT/IPR IPL/NPR
C                 //XMAX     /DXMAX    /YMAX     /DYMAX
C----------------------------------------------------------------------

C  NP=NUMBER PARTICLES.  THESE ARE STORED IN V, A PREVIOUS PVEC.
C  NR = NUMBER OF TRANSITS OF BLIN TO BE MADE BY EACH PARTICLE.
C  V = NAME OF PVEC INSTRUCTION CONTAINING INITIAL COORDINATES OF RAYS.
C  V0 = NAME OF REFERENCE PARTICLE,ALSO DEFINED BY A PVEC.
C  U = V0 + V IS THE PARTICLE VECTOR BEING TRACKED
C  BLIN = NAME OF THE BEAM LINE, DEFINED BY A BML INSTRUCTION.
C     IF BLANK, BEAM LINE CURRENTLY STORED IN MI ARRAY IS USED.
C  MAT = NAME OF MATRIX THAT GIVES BETAS AT PRINT POSITIONS.
C        IF MAT IS PRESENT, OUTPUT SHOWS THE ACTION VARIABLES EX, EY.
C        IF MAT AND V0 ARE NAMED, OUTPUT SHOWS EX,EY AND PHASES PHIX,PHIY.
C  IOF = OUTPUT FREQUENCY =
C                      = 00001, EACH POSITION
C                      = 0R00P, EVERY R'TH TRANSIT AT P'TH POSITION..

C   IMP = INPUT OPTION
C   IMP=0  V=X,DX,Y,DY,DS,DP/P (METERS,RADIANS)
C   IMP=1  V=X,DX,Y,DY,DS,DP/P (MM,MRAD,  DP/P IN 0/00)
C   IMP=2  V=EX(MM-MRAD),PSIX(DEG),EY,PSIY

C  REGARDLESS OF IMP, THE OUTPUT UNITS OF X,DX,Y,DY,DS,DP/P ARE M,RAD,M,RAD,M,1.
C  THE OUTPUT UNITS OF EX,PHIX ARE MM-MRAD, DEGREES AND SIMILARLY FOR EY,PHIY.
C  IF V0 IS LEFT BLANK, V STANDS FOR TOTAL VECTOR U, WITH 6 COMPONENTS
C      U = X,DX,Y,DY,-DS,DP/P  OR  U = EX,PSIX,EY,PSIY,-DS,DP/P
C   IVSAV = 1  SAVE TRACKED VECTORS. (REPLACE ORIGINAL VECTOR WITH
C               NEW ONE IN ITS OWN STORAGE.)

C   STORED VALUES WILL BE V AFTER TRACKING.
C   STORED IN CARTESIAN COORDINATES, X,DX,Y,DY,...
C   FOR SUBSEQUENT RUNS USING V, SET IMP = 0.
C     OTHERWISE, INPUT VECTOR STORAGE REMAINS UNCHANGED.
C    MODT = 0,1  TRACK WITH STORED MATRICES AND MAPS
C          =2     TRACK USING REVMAT AND SAVE CUMULATIVE MATRIX IN
C                 STORAGE OF TRK.
C          =5     CALL REVMAT, DO NOT SAVE MATRIX
C                 (TRANSMITED TO TRKCN AS IOP)

C   IPR = -1  NO PRINT
C   R =  0  DO PRINT
C   IPR =  2  PRINT IF TAGGED # ONLY (4-8 PUNCH)
C   IPL = -1,0  NO PLOT
C   IPL = 1     PLOT
C   NPR = STEP PRINT FREQUENCY.  PRINT EVERY NPR-TH STEP.
C   IF NPR = 1, PRINT EVERY STEP.
C   IXTR = EXTRA INTEGER INPUT FOR FUTURE USE

C   XMAX,DXMAX,YMAX,DYMAX = SCALES FOR PHASE PLOTS (MM,MRAD)
C   (CARD MUST ALWAYS BE INCLUDED)

      DEGRAD = 1/RADEG
      NPARTS=INFF(4,M)
      NRR = IDAT(M,1)
      MVECS=MDAT(M,1)
      NVECS=CHDAT(M,1)
      NBML=CHDAT(M,2)
      NPR = IDAT(M,7)
      IXTR = IDAT(M,8)
      CALL GETFL(M,1,4,SCALE)
      NREF=2
      MR = 4
      NR = 1
      IFLAG = 1
      NV(1) = 1
      NVEC0=CHDAT(M,4)
      IF (NVEC0.NE.IBLNK) GO TO 2
      WRITE (OUT3,1000) NBML
      NREF=1
 1    DO 3 J=1,7
      U(J)=0
 3    V0(J)=0
      GO TO 4
 2    MVEC0=MDAT(M,4)
      CALL GETFL(MVEC0,1,7,V0)
      DO 21 J=1,5
 21   U(J) = 1000*V0(J)
      U(6) = 100*V0(6)
      U(7)=V0(7)
      WRITE (OUT3,1006) NVEC0,NVEC0,(U(J),J=1,7)
 4    CONTINUE
      IMP = INFF(5,M)
      IOF = IDAT(M,2)
      IVSAV = IDAT(M,3)
      MODT = IDAT(M,4)
      IPR = IDAT(M,5)
      IPL = IDAT(M,6)
      IF (MODT.EQ.1)  MODT = 0
      IF (MODT.NE.2)  GO TO 30
      NPARTS = 1
      CALL RTRV7(MUNIT,R7,RW)
      CALL STOR7(M,R7,RW)
 30   IF (NBML.NE.IBLNK)  GO TO 402
      NELS = IABS(NELS)
      GO TO 401
 402  CONTINUE
      MBML=MDAT(M,2)
C  PUT BEAM LIST IN MI ARRAY
      NDAT=INFF(17,MBML)
      CALL MIFILL(MBML,1,NDAT,NELS,MI,MISIZ)
      IF(ERROR) RETURN
C  FIND BETAS FOR REFERENCE MATRIX MAT
 401  NMAT=CHDAT(M,3)
      IF (NMAT.EQ.IBLNK) GO TO 403
      MEL=MDAT(M,3)
      CALL BET(MEL,BX,BY,0)
 403  CONTINUE
      PLT=.FALSE.
      DPR=.FALSE.
      IF (IPR.LT.0)  DPR = .TRUE.
      IF (IPL.GT.0)  PLT = .TRUE.
      KREV = IOF/1000
      KPOS = MOD(IOF,1000)
C      IF (PLT) WRITE(TRK5) NPARTS,NRR,NVECS,NBML,NMAT,KPOS,NVEC0,
C     1                  (U(J),J=1,7)

      DO 250 IP=1,NPARTS
      BEG=.TRUE.
      IPS=IP*7-6
      CALL GETFL(MVECS,IPS,7,V)
      IGO = 0
      IF (MODT.EQ.2)  IGO = 1
 10   IF (IMP.NE.2)  GO TO 9
      EX=V(1) / 1000000
      EY=V(3) / 1000000
      PHIX=V(2)*RADEG
      PHIY=V(4)*RADEG
      AX=SQRT(EX*BX(2))
      AY=SQRT(EY*BY(2))
      C=COS(PHIX)
      S=SIN(PHIX)
      V(1)=AX*C
      V(2)=-AX*(S+BX(3)*C)/BX(2)
      C=COS(PHIY)
      S=SIN(PHIY)
      V(3)=AY*C
      V(4)=-AY*(S+BY(3)*C)/BY(2)
 9    IF (IMP.NE.1)  GO TO 8
      DO 11 I=1,6
 11   V(I) = V(I)/1000
 8    IF (NREF.EQ.1) GO TO 81
      DO 41 I=5,7
 41   V(I) = 0
 81   DO 82 J=1,7
 82   VV(J) = V(J)
 83   DO 5 J=1,7
      U(J) = V0(J) + V(J)
 5    U0(J) = U(J)
C     NM = INFF(2,M)
      IF(IOF.EQ.0) IOF = 1
      IF (NR.EQ.0) NR=1
C  TRACK ONE PARTICLE THROUGH THE BEAM SYSTEM.
C  PRINT HEADING AND INITIAL CONDITIONS
      IF(DPR) GO TO 51
      IF (IOF.NE.1.AND.NMAT.NE.IBLNK) GO TO 551
      WRITE(OUT3,1001)
      GO TO 51
 551  IF(NREF.EQ.1) WRITE(OUT3,1021)
      IF(NREF.EQ.2) WRITE(OUT3,1011)
 51   CONTINUE
      IRV = 1
      IPOS = 1
C  FIND NAME OF PARTICLE
      IF(DPR) GO TO 52
      IF(NREF.EQ.2) WRITE(OUT3,1012) NVECS,IP
      IF(NREF.EQ.1) WRITE(OUT3,1002) NVECS,IP
 52   CONTINUE
C  LOOP OVER REVOLUTIONS
      SLENI = 0
      SLEN = 0
 55   DO 213 IRV = 1,NRR
      IRM=IRV-1
C      IF(.NOT.DPR.AND.IOF.EQ.1) WRITE(OUT3,1005) IRM
C  LOOP THROUGH BEAM SYSTEM
      NELF=NELS
      IF (IRV.EQ.NRR) NELF = NELF + 1
C  RESET RANDOM SEED SO ERRORS REPEAT ON SUCCESSIVE TURNS
      NRN = NRZZ
      DO 212 IBS=1,NELF
      IPOS=IBS-1
C  IF INTEGRATION STEPS ARE BEING PRINTED, OMIT TRK PRINT.
 63   IF (IOF.NE.01000)  GO TO 62
      IF (IBS.NE.1)  GO TO 211
 62   DO 6 J=1,4
 6    V(J) = 1000 * ( U(J) - V0(J) )
      IF(IOF.EQ.1) GO TO 214
 61   IF (IPOS.NE.KPOS)  GO TO 211
      IRVV = IRV - 1
      IF (KREV.EQ.0) GO TO 66
      IF (MOD(IRVV,KREV).NE.0)  GO TO 211
 66   IF (NMAT.EQ.IBLNK) GO TO 214
      WX = BX(2)*V(2)*V(2) + 2*BX(3)*V(1)*V(2) + BX(4)*V(1)*V(1)
      WY = BY(2)*V(4)*V(4) + 2*BY(3)*V(3)*V(4) + BY(4)*V(3)*V(3)
C  TIME FOR OUTPUT
      IF (NREF.NE.1) GO TO 7
      IF(DPR) GO TO 215
      WRITE (OUT3,1005) IRM,IPOS,(U(I),I=1,6),WX,WY
      GO TO 215
 7    CONTINUE
      IF (WX.NE.0) GO TO 71
      PHIX = 0
      GO TO 72
 71   AXSIN = - BX(2)*V(2) - BX(3)*V(1)
      PHIX = ATAN2(AXSIN,AXCOS)*DEGRAD
 72   IF (WY.NE.0) GO TO 73
      PHIY = 0
      GO TO 74
 73   AYSIN = - BY(2)*V(4) - BY(3)*V(3)
      PHIY = ATAN2(AYSIN,AYCOS)*DEGRAD
 74   CONTINUE
      IF(DPR) GO TO 215
      WRITE(OUT3,1014) IRM,IPOS,DPP,WX,PHIX,WY,PHIY,(V(J),J=1,4)
      GO TO 215
214   CONTINUE
      IF (IPR.NE.2)  GO TO 216
C  CHECK FOR SELECTIVE PRINT. IF CKSYMB TURNS ON SBFLG, THEN PRINT.
      MATI=CINFF(2,NEL)
      MATL = MATI(1:1)
      CALL CKSYMB(MATL)
      IF (.NOT.SBFLG) GO TO 215
 216  CONTINUE
      IF (DPR) GO TO 215
      IF (IPOS.EQ.0) THEN
         MATI = IBLNK
         GO TO 219            
       ENDIF
      MATI = CINFF(2,NEL)
      CALL GETQ(NEL,1,1,SLENI)
      SLEN = SLEN + SLENI
 219  WRITE (OUT3,1004) IPOS,MATI,SLEN,(U(J),J=1,6)
 215  CONTINUE
      IF(.NOT.PLT) GO TO 211
C      WRITE(TRK5) (U(J),J=1,4),(V(J),J=1,4),IP,IRM,IPOS
C      WRITE(TRK6) (U(J),J=1,4),(V(J),J=1,4),IP,IRM,IPOS
C ADVANCE THROUGH BEAM SYSTEM
 211  CONTINUE
      IF (IBS.GT.NELS) GO TO 212
      NEL = MI(IBS)
      CALL TRKCN(M,NEL,U,0,MODT)
 212  CONTINUE
      NRZZ = NRN
 213  CONTINUE
      IF (IGO.EQ.0)  GO TO 245
      IF (IGO.EQ.2) GOTO 225
      IF (IGO.GT.2) GOTO 240
      CALL RTRV7(M,R7,RW)
      DPRSAV=DPR
      DPR=.TRUE.
      DLP = -DELP
      DO 222 I=1,7
 222  UF(I) = U(I)
      GO TO 230
 225  DLP = + DELP
      DO 227 I=1,7
 227  UM(I) = U(I)
 230  DO 231 J=1,7
 231  U(J) = V0(J) + VV(J)
      U(6) = U(6) + DLP
      IGO = IGO + 1
      GO TO 55
 240  DO 242 I=1,7
 242  UP(I) = U(I)
      DO 243 I=1,6
 243  R7(I,6) = (UP(I) - UM(I))/(2*DELP)
      CALL MXV7(R7,U0,U0)
      DO 244 I=1,5
 244  R7(I,7) = UF(I) - U0(I)
      CALL STOR7(M,R7,RW)
      CALL MXV7(R7,V0,V0)
      DO 246 J=1,7
 246  V(J) = UF(J) - V0(J)
      DPR=DPRSAV
      GO TO 248
 245  CONTINUE
      DO 247 J=1,4
 247  V(J) = U(J) - V0(J)
 248  IF (IVSAV.EQ.1)  CALL STOFL(MVECS,IPS,7,V)
 250  CONTINUE

      CALL HED
      IF (.NOT.PLT) RETURN
      CALL TRKPLT(SCALE)
      RETURN
 1000 FORMAT (' PARTICLE TRACKING THROUGH ',A5,'.')
 1001 FORMAT (1X,'PARTICLE',2X,'REV',2X,'POS',6X,'ACC.LENGTH',6X,'X',
     1   13X,'DX',12X,'Y',11X,'DY',11X,'DS',10X,'DP/P')
 1002 FORMAT(1X,A5,I5)
 1004 FORMAT (8X,I5,1X,I5,1X,A5,F10.4,6(1X,F12.8))
 1005 FORMAT (14X,I5,4X,I5,5X,6F10.7,2F13.5)
 1006 FORMAT (10X,'TRACKING RELATIVE TO REFERENCE RAY ',A5,
     1 ', ( UNITS(X,DX,Y,DY,DS,DP/P)  = (MM,MRAD,MM,MRAD,MM,0/0) )'/
     2 20X,A5,' = ',7F10.5)
 1011 FORMAT(/'       RAY     REV. POS.  DP/P   EX(MM-MR)     PHIX(DEG
     1) EY(MM-MR)     PHIY(DEG)  X(MM)       DX(MR)      Y(MM)       DY(
     2MR)' )
 1012 FORMAT (1X,A5,I5)
 1014 FORMAT (8X,2I6,F11.3,8F12.5)
 1021 FORMAT(/'      PARTICLE    REV   POSITION',9X,'X',8X,'DX',9X,'Y',
     1 8X,'DY',6X,'DS',6X,'DP/P',7X,'EX(MM-MR)',4X,'EY(MM-MR)')
      END
