      SUBROUTINE TRKB(M)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C BETATRON FUNCTION TRACKING ROUTINE 9-19-85

      include 'ccc/bstore.ccc'

      include 'ccc/binff.ccc'

      include 'ccc/bmi1.ccc'

      DIMENSION MI(MI1SIZ),CHMI(MI1SIZ)
      EQUIVALENCE (MI,MI1),(NELS,NELS1)

      include 'ccc/contrl.ccc'

      include 'ccc/match3.ccc'

      include 'ccc/cderiv.ccc'

      include 'ccc/const.ccc'

      include 'ccc/files.ccc'

      include 'ccc/slfil.ccc'

      include 'ccc/dim.ccc'

      include 'ccc/betpts.ccc'

      DIMENSION BXI(9),BYI(9),V0(7),VI(7),T(49)
      DIMENSION BX(6),BY(6),BX0(6),BY0(6),RX(2,3),RY(2,3),RW(3),BETF(14)
      DIMENSION P(8), V(7), VSC(4)
      EQUIVALENCE(BX,BETF),(BY,BETF(7)), (S,BETF(13)),(TH,BETF(14))
C      EQUIVALENCE (V,VF(7))

      EXTERNAL DER2,DER3,DER4,DELQ
      LOGICAL NOSTOR,MPFLG
      LOGICAL RADFLG
      LOGICAL FLFMT
      CHARACTER(5) ELNAME,CHDAT,ELNAMI,NAMVEC,NAMBET,NAME,NAMOP
      CHARACTER(5) MNAME,CHMI,EL1,EL2
      CHARACTER(5) FMT 

C  INSTRUCTION TRKB----TRACK BETATRON FUNCTIONS

C  T  TRKB  IR1 IR2//BLIN BET0 V0          IT1  IT2  ITBL IRAD S0  TH0

C  RESERV  A TABLE FOR STORAGE OF BETA FUNCTIONS FROM POSITION IR1
C  THROUGH POSITION IR2 OF BET0.

C  TRACK BETA FUNCTIONS DEFINED BY [ BET0  IBET   //...]
C  THROUGH BEAM LINE DEFINED BY [ BLIN  BML   //...] FROM IT1 TO IT2.
C
C  TRACK A PARTICLE VECTOR DEFINED BY [ V0  PVEC  //...]
C  THROUGH THE BEAMLINE.

C  BETA FUNCTION ARRAY IS STORED AT STORE(LQ3), LQ3=INFF(24,M),
C  WHERE B(I,IPOS+1) = QX,BX,AX,GX,X,DX, QY,BY,AY,GY,Y,DY, S,THETAX.

C    ITBL = 1 --- INPUT BETAS FROM TRKB TABLE, AT IT1, EXCEPT
C                    ON 1ST CALL, AND/OR IF IT1=0, FROM IBET INPUT.
C    BET0 = /NAME/ --INITIAL BETAS FROM ARRAY/NAME/,FOR AN IBET,
C                     AND FROM BETA-FUNCTIONS OF /NAME/, IF A MATRIX.
C    IRAD = 1 --- OUTPUT PHASE ADVANCES IN RADIANS
C         = 0 ---                       IN UNITS OF 2PI

C  DEFAULTS ---

C    IF KA = KB = 0 (OR BLANK), A TABLE IS RESERVED SUFFICIENT TO STORE
C                               THE COMPLETE BEAM LINE.
C    IF KA = -1                 NO TABLE IS RESERVED, NO BETAS ARE STORED.

C    IF KT1 = IT2 = 0 (OR BLANK), TRACKING IS DONE THROUGH COMPLETE BEAM-LINE.



      RADFLG = .FALSE.
      IF (MINFLG.EQ.1)  GO TO 23
      IF (MIFLG)  GO TO 152
      GO TO 4
 23   NOSTOR = .FALSE.
      ELNAMI=IBLNK
      KB=INFF(5,M)
      KA=INFF(4,M)
      LQ3 = INFF(24,M)
      NCOL = IDAT(M,5)
      IF (KA.GT.-1) GO TO 151
      NOSTOR = .TRUE.
      GO TO 152
 151  LTAB0 = LQ3 - NCOL*KA - 1
 152  MBML = MDAT(M,1)

      NDAT=INFF(17,MBML)
      CALL MIFILL(MBML,1,NDAT,NELS,MI,MI1SIZ)

      DO 156 IBR=1,NELS
      NELR = MI(IBR)
 156  CHMI(IBR) = MNAME(NELR)
      CALL MMM(M,NELS,MI)
      IF (MINFLG.EQ.4) GO TO 4
      IP1=IDAT(M,1)
      IP2=IDAT(M,2)
      IF (IP1.EQ.0.AND.IP2.EQ.0) THEN
         IP1 = 0
         IP2 = NELS
       ENDIF
      ICALL=IDAT(M,6)
      IRAD = IDAT(M,4)

      SI = FLDAT(M,1)
      TI = FLDAT(M,2)

      FMT = CHDAT(M,4)
      FLFMT = .FALSE.
      IF (FMT.EQ.'EFORM') FLFMT = .TRUE.      
C   SET UP CONSTANTS FOR CALCULATING PSI IN DEGREES OR RADIANS
      IF (IRAD.EQ.1)  RADFLG=.TRUE.
      DNOM = TPI
      CCON = 1
      IF (.NOT.RADFLG)   GO TO 153
      DNOM = 1
      CCON = TPI
 153  CONTINUE

C  GET VECTOR
      NAMVEC = CHDAT(M,3)
      VECFLG = .FALSE.
      IF(NAMVEC.EQ.IBLNK) GO TO 160
      NF = M7END - 5
      VECFLG = .TRUE.
      MVEC = MDAT(M,3)
      CALL GETQ(MVEC,1,7,VI)
 160  CONTINUE

      NAMBET=CHDAT(M,2)
      NAME=CINFF(2,M)

      ITABLE = IDAT(M,3)
      IF(ITABLE.EQ.1.AND..NOT.NOSTOR) GO TO 10
      GO TO 12

C 10   IF ((ICALL.EQ.0).OR.(IP1.EQ.0) ) GO TO 12
 10   CONTINUE
C  INITIAL BETAS FROM BETA FUNCTION TABLE OF TRKB INSTRUCTION,
C  EXCEPT THAT FOR FIRST CALL, OR IF IP1=0, THEY ARE TAKEN FROM IBET OR MTR.
      LOCBET=NCOL*(IP1-KA)+1
      MBET=M
      NTYP=8
      CALL GETQQ(MBET,NTYP,LOCBET+12,1,SI)
      CALL GETQQ(MBET,NTYP,LOCBET+13,1,TI)
CC      IF(VECFLG) CALL GETQQ(MBET,NTYP,LOCBET+14,7,VI)
      GO TO 13

C  INITIAL BETAS FROM ARRAY SPECIFIED BY NAMBET
 12   LOCBET=1
      NTYP=1
      MBET=MDAT(M,2)

      NAMOP = CINFF(1,MBET)

      IF(NAMOP.EQ.'IBET') GO TO 13
C  INITIAL BETAS ARE BETAS OF MATRICES MBET.
      CALL BET(MBET,BXI,BYI,1)
      BXI(1)=0
      BYI(1)=0

      GO TO 16

 13   CALL GETQQ(MBET,NTYP,LOCBET  ,6,BXI)
      CALL GETQQ(MBET,NTYP,LOCBET+6,6,BYI)

 16   CONTINUE


 26   IF (IP1.EQ.0)  GO TO 9
      ELNAMI = CHMI(IP1)
 9    IF(IP1.LT.KA) NOSTOR=.TRUE.
      IF(IP2.GT.KB) NOSTOR=.TRUE.
      ICALL=1
C      CALL STOIN(M,3,1,ICALL)
      CALL STOIN(M,6,1,ICALL)


 4    CONTINUE

      S = SI
      TH = TI
      I1 = IP1 + 1
      I2 = IP2

      DO 3 I=1,6
      BX(I) = BXI(I)
      BY(I) = BYI(I)
      V(I) = VI(I)
 3    CONTINUE
      V(7) = VI(7)

      IF (NOPR) GO TO 7
      CALL DASH1
      LNUM = 0
      IF (I2.GT.45)  WRITE (OUT3,1004)
      IF(.NOT.VECFLG) GO TO 406
      IF (FLFMT) THEN
          WRITE (OUT3,1005)
        ELSE
          WRITE (OUT3,1002)
        ENDIF
      GO TO 407
 406  IF (FLFMT) THEN
          WRITE (OUT3,1007)
        ELSE
          WRITE(OUT3,1000)
        ENDIF
 407  CONTINUE

      ELNAME=ELNAMI
 7    CONTINUE

      IF (BX(4).EQ.0) BX(4)=(1+BX(3)*BX(3))/BX(2)
      IF (BY(4).EQ.0)  BY(4)=(1+BY(3)*BY(3))/BY(2)

      MN = MNAME(M)
      KW = IP2 + 1
      BXX = BX(2)
      BYX = BY(2)

      HX = BX(4)*BX(5)*BX(5) + 2 *BX(3)*BX(5)*BX(6)
     1                       + BX(2)*BX(6)*BX(6) 
      HX = 100 * HX

C   LOOP OVER POSITIONS
 19   DO 1 IBS = I1,I2
      IPOS = IBS - 1
      IF (IBS.NE.I1)  THEN
        ELNAME = CHMI(IPOS)
        IF (ELNAME.NE.CHMI(IPOS))THEN
           WRITE (OUT3,500) IPOS,ELNAME,CHMI(IPOS)
        ENDIF
        ENDIF
 500  FORMAT (5X,'IPOS,ELNAME,CHMI(IPOS)',I4,1X,A5,1X,A5)             
      IF(NOPR) GO TO 6
      IF(.NOT.VECFLG) GO TO 190

      DO 193 I = 1,4
 193  VSC(I) = 1000*V(I)

      IF (MOD(LNUM,45).NE.0.OR.LNUM.EQ.0)  GO TO 191
      WRITE (OUT3,1004)
      IF (FLFMT) THEN
          WRITE (OUT3,1005)
        ELSE
          WRITE (OUT3,1002)
        ENDIF
      LNUM = 0
 191  IF (MOD(LNUM,5).EQ.0.AND.LNUM.NE.0)  WRITE (OUT3,1010)
C----------------------------------------------------------------------
      IF (FLFMT) THEN
          WRITE(OUT3,1008) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1              (BY(I),I=1,3),BY(5),BY(6)
        ELSE
          WRITE(OUT3,1003) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1              (BY(I),I=1,3),BY(5),BY(6),(VSC(I),I=1,4)
        ENDIF
      IF (SW41)
     1     WRITE(IFIL41,2002) ELNAME,S,BX(1),BX(2),BX(5),
     2                      BY(1),BY(2),BY(5)
      IF (SW42)
     1    WRITE(IFIL42,2004) ELNAME,S,V(1),V(2),V(3),V(4)
      GO TO 6
 190  IF (MOD(LNUM,45).NE.0.OR.LNUM.EQ.0)  GO TO 192
      WRITE (OUT3,1004)
      IF (FLFMT) THEN
          WRITE (OUT3,1007)
        ELSE
          WRITE(OUT3,1000)
        ENDIF
      LNUM = 0
 192  IF (MOD(LNUM,5).EQ.0.AND.LNUM.NE.0)  WRITE (OUT3,1010)
      IF (FLFMT) THEN
         WRITE(OUT3,1006) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1             (BY(I),I=1,3),BY(5),BY(6)
        ELSE
         WRITE(OUT3,1001) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1           HX,  (BY(I),I=1,3),BY(5),BY(6)
        ENDIF
      IF (SW41)
     1  WRITE(IFIL41,2002) ELNAME,S,BX(1),BX(2),BX(5),
     2                     BY(1),BY(2),BY(5)

C  FILL IN ARRAYS FOR PLOTTING
 6    XX(IBS) = S
      Y1(IBS) = BX(2)
      Y2(IBS) = BX(5)
      Y3(IBS) = BY(2)
      Y4(IBS) = BY(5)
      Y5(IBS) = BX(3)
      Y6(IBS) = BY(3)
      Y7(IBS) = BX(6)
      Y8(IBS) = BY(6)
      Y9(IBS) = BX(1)
      Y10(IBS) = BY(1)
      LNUM = LNUM + 1
      NEL = MI(IBS)
      IF(NOSTOR) GO TO 8
      J=LTAB0+NCOL*IPOS
      J0=J
      DO 11 I=1,14
 11   QLIB(J+I)=BETF(I)
      IF(.NOT.VECFLG) GO TO 8

      DO 110 I=15,NCOL
 110  QLIB(J+I) = V(I-14)
 8    CONTINUE

      STOT = S

      NELL = NEL
      IF(.NOT.VECFLG) GO TO 180
      NELL = NF

      DO 181 I=1,6
      BX0(I)=BX(I)
      BY0(I)=BY(I)
 181  V0(I) = V(I)

      V0(7) = V(7)
      CALL REVMAT(NF,NEL,V)
      GO TO 18

 180  DO 2 I=1,6
      BX0(I)=BX(I)
 2    BY0(I)=BY(I)

 18   CALL RXY(NELL,RX,RY,RW)  
 182  S = S + RW(1)
      TH = TH + RW(2)

      BX(2)=RX(1,1)*RX(1,1)*BX0(2)-2*RX(1,1)*RX(1,2)*BX0(3)
     1        + RX(1,2)*RX(1,2)*BX0(4)

      BY(2)=RY(1,1)*RY(1,1)*BY0(2)-2*RY(1,1)*RY(1,2)*BY0(3)
     1        + RY(1,2)*RY(1,2)*BY0(4)

      BX(3) = -RX(1,1)*RX(2,1)*BX0(2)
     1        + (RX(1,1)*RX(2,2)+RX(1,2)*RX(2,1))*BX0(3)
     2        - RX(1,2)*RX(2,2)*BX0(4)

      BY(3) = -RY(1,1)*RY(2,1)*BY0(2)
     1        + (RY(1,1)*RY(2,2)+RY(1,2)*RY(2,1))*BY0(3)
     2        - RY(1,2)*RY(2,2)*BY0(4)

      BX(4) = RX(2,1)*RX(2,1)*BX0(2) - 2*RX(2,1)*RX(2,2)*BX0(3)
     1          + RX(2,2)*RX(2,2)*BX0(4)

      BY(4) = RY(2,1)*RY(2,1)*BY0(2) - 2*RY(2,1)*RY(2,2)*BY0(3)
     1          + RY(2,2)*RY(2,2)*BY0(4)

      BX(5) = RX(1,1)*BX0(5) + RX(1,2)*BX0(6) + RX(1,3)

      BY(5) = RY(1,1)*BY0(5) + RY(1,2)*BY0(6) + RY(1,3)

      BX(6) = RX(2,1)*BX0(5) + RX(2,2)*BX0(6) + RX(2,3)

      BY(6) = RY(2,1)*BY0(5) + RY(2,2)*BY0(6) + RY(2,3)

      IF(NONU) GO TO 183

      BETAV=SQRT(BX(2)*BX0(2))
      BERAT=SQRT(BX0(2)/BX(2))
      SINE=RX(1,2)/BETAV
      COSINE=RX(1,1)*BERAT-BX0(3)*SINE
C   DNOM OR CCON SET TO TPI OR 1. DEPENDING ON DEGREES OR RADIANS.
      DNU = ATAN2(SINE,COSINE)/DNOM
      IF (DNU.LT.0)  DNU = DNU + CCON
      BX(1) = BX0(1) + DNU
      BETAV=SQRT(BY(2)*BY0(2))
      BERAT=SQRT(BY0(2)/BY(2))
      SINE=RY(1,2)/BETAV
      COSINE=RY(1,1)*BERAT-BY0(3)*SINE
      DNU = ATAN2(SINE,COSINE)/DNOM
      IF (DNU.LT.0)  DNU = DNU + CCON
      BY(1) = BY0(1) + DNU

 183  CONTINUE

      HX = BX(4)*BX(5)*BX(5) + 2 *BX(3)*BX(5)*BX(6)
     1                       + BX(2)*BX(6)*BX(6) 
      HX = 100 * HX

      CALL MAXMIN (BXX,BXMN,BX(2),MBX,IPOS)
      CALL MAXMIN (BYX,BYMN,BY(2),MBY,IPOS)

 1    CONTINUE
      
 17   IPOS = I2
      MP2FLG = 0
      IF(NOSTOR) GO TO 5

      J = J + NCOL

      DO 14 I=1,14
 14   QLIB(J+I)=BETF(I)

      IF(.NOT.VECFLG) GO TO 5

      DO 140 I=15,NCOL
 140  QLIB(J+I) = V(I-14)

 5    CONTINUE

      IF(NOPR) RETURN

      ELNAME = CHMI(IPOS)
      IF(.NOT.VECFLG) GO TO 150
      DO 155 I = 1,4
 155  VSC(I) = 1000*V(I)
      ICPM = IPOS-1
      ICPP = IPOS + 1
      IF (FLFMT) THEN
          WRITE(OUT3,1008) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1              (BY(I),I=1,3),BY(5),BY(6)
        ELSE
      WRITE(OUT3,1003) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1              (BY(I),I=1,3),BY(5),BY(6),(VSC(I),I=1,4)
        ENDIF
      IF (SW41)
     1    WRITE(IFIL41,2002) ELNAME,S,BX(1),BX(2),BX(5),
     1                      BY(1),BY(2),BY(5)
      IF (SW42)
     1    WRITE(IFIL42,2004) ELNAME,S,V(1),V(2),V(3),V(4)
      GO TO 154
 150  IF (FLFMT) THEN
         WRITE(OUT3,1006) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1             (BY(I),I=1,3),BY(5),BY(6)
        ELSE
         WRITE(OUT3,1001) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1           HX,  (BY(I),I=1,3),BY(5),BY(6)
        ENDIF
      IF (SW41)
     1    WRITE(IFIL41,2002) ELNAME,S,BX(1),BX(2),BX(5),
     2              BY(1),BY(2),BY(5)


 154  IBS = I2 + 1    
      XX(IBS) = S
      Y1(IBS) = BX(2)
      Y2(IBS) = BX(5)
      Y3(IBS) = BY(2)
      Y4(IBS) = BY(5)
      Y5(IBS) = BX(3)
      Y6(IBS) = BY(3)
      Y7(IBS) = BX(6)
      Y8(IBS) = BY(6)
      Y9(IBS) = BX(1)
      Y10(IBS) = BY(1)

      CALL DASH1

      RETURN
 1000 FORMAT ('  POS',11X,'S',7X,'QX', 9X,'BX',8X,'AX',7X,'X',8X,
     1  'DX',9X,'HX(CM)',5X,'QY',9X,'BY',8X,'AY',7X,'Y',8X,'DY'/
     2  130('-') )

 1001 FORMAT (I5,1X,A5,1X,F10.4, F9.5,F11.4,F10.5,F9.5,F9.5, 
     1        F11.5, 2X,            F9.5,F11.4,F10.5,F9.5,F9.5)

 1002 FORMAT (' POS',11X,'S',7X,'QX',7X,'BX',7X,'AX',7X,'X',7X,      
     1  'DX',6X,'QY',7X,'BY',7X,'AY',7X,'Y',7X,'DY',4X,'VX-MM',
     2  1X,'VDX-MR',1X,'VY-MM',1X,'VDY-MR')      


 1003 FORMAT (I5,1X,A5,F10.4,F8.4,2F9.4,2F8.4,1X,F8.4,2F9.4,2F8.4,
     1        2(F6.2,F7.3))


 1004 FORMAT ('1')
 1005 FORMAT (' POS',11X,'S',7X,'QX',11X,'BX',11X,'AX',9X,'X',7X, 
     1  'DX',8X,'QY',9X,'BY',11X,'AY',9X,'Y',8X,'DY')
 1010 FORMAT (' ')
 1006 FORMAT (I5,1X,A5,1X,F10.4, F9.5,((1PG12.5E2),0P),
     1    ((1PG12.5E2),0P),F9.5,F9.5,
     2     2X,F9.5,((1PG12.5E2),0P),((1PG12.5E2),0P),
     3  F9.5,F9.5)
 1007 FORMAT ('  POS',11X,'S',7X,'QX', 10X,'BX',10X,'AX',9X,'X',8X,
     1  'DX',8X,'QY',6X,'BY',11X,'AY',12X,'Y',8X,'DY'/
     2  130('-') )
 1008 FORMAT (I5,1X,A5,F10.4,F8.4,2((1PG12.5E2),0P),
     1   2F8.4,1X,F8.4,2((1PG12.5E2),0P),2F8.4)

 2001 FORMAT (2X,A5,1X,F10.3)
 2002 FORMAT (2X,A5,1X,7(F10.3))
 2003 FORMAT (2X,A5,1X,6(F10.3))
 2004 FORMAT (2X,A5,1X,5(F10.3))

      END
