      SUBROUTINE TRKCN ( MFXPT, NEL, P, NP, IOP )

      IMPLICIT NONE

C  A ROUTINE TO CONTROL TRACKING THROUGH LINEAR-,SINGLE NON-LINEAR-,
C  OR PRD-TYPE PRODUCTS OF TRANSFORMATIONS.
C  MFXPT = INDEX OF FXPT INSTRUCTION.  HERE IT IS USED TO REFERENCE
C  THE 7X7 MATRIX REPRESENTING THE LINEARIZED BEAM SYSTEM RELATIVE TO
C  THE REFERENCE RAY PP.  ON EACH CALL TO TRKCN,  MFXPT = NEL * MFXPT.
C  NEL = INDEX OF ELEMENT OF BEAM SYSTEM
C  PP = PARTICLE VECTOR
C  NP = PARTICLE INDEX

      include 'ccc/dim.ccc'
C DIM.CCC
C      COMMON /DIM/ LEND,MEND,ISAV,ISAV7,M7END,KADD,KADDR,MUNIT,MSYMPL,
C     1             INFMAX,IFLMAX,IMAX,ICHMAX,ISFMAX,IQMAX,IMIN

      include 'ccc/contrl.ccc'
C CONTRL.CCC
C      COMMON/CONTRL/ERROR,MODE,RSRV,STOR,XEQ,TRASW,NFSW,EMPTY,INDEF,
C     1          LDFLG,FIN
C      LOGICAL ERROR,RSRV,STOR,XEQ,TRASW,NFSW,EMPTY,INDEF,LDFLG,FIN

      include 'ccc/binff.ccc'
C BINFF.CCC
C  INFMAX=LNFSIZ INSIDE PROGRAM
C      PARAMETER (LNFSIZ=1000,IFFSIZ=24,IFCSIZ=6)
C      PARAMETER (LNCSIZ=1000,IXFLG=-LNFSIZ-1)
C      COMMON /BINFF/INFF(IFFSIZ,LNFSIZ)
C      COMMON /CINFF/ CINFF(IFCSIZ,LNCSIZ)
C      CHARACTER CINFF*5

      include 'ccc/files.ccc'
C      COMMON/FILES/INFILE,OUT3,IFILE,OFILE,PRFILE,PLFILE,
C     1    ORB1,JBIS,CYBO,FILE11
C      INTEGER OUT3,OFILE,PRFILE,PLFILE,ORB1,CYBO,FILE11

      include 'ccc/mq.ccc'
C      COMMON/MQ/ML

      INTEGER IOP,MFXPT,NEL,NP
      DOUBLE PRECISION P(7,*)
      EXTERNAL DER1,DER2,DER3,DER4,DER5,DER6,DER7,MDAT
      INTEGER MDAT
      DOUBLE PRECISION PAR(25),T(49),RW(3)
      INTEGER I,K,K2,K3,KN,KN3,MM,N2,N3,NF,NFL,NN,NUM,RET
      CHARACTER(5) KIND,OPNAME

      DATA RW/3*0.D0/
C
      NF = 0
      IF (IOP.NE.1)  NF = M7END - 5

      NN = NEL
      KIND = CINFF(4,NN)
      IF (KIND.EQ.'EDRF') GO TO 35
      IF (KIND.EQ.'DKE ') GO TO 36
      IF (KIND.EQ.'SOL ') GO TO 37
      IF (KIND.EQ.'MAP') GO TO 20
      IF (KIND.NE.'PRD') GO TO 30
C  PRD-TYPE PRODUCT
      K = INFF(4,NN)
      RET = 1
      I = 1
      MM = NEL
       GO TO 22

C  SINGLE LINEAR TRANSFORMATION
 30   RET = 3
       GO TO 40

C  SINGLE NON-LINEAR TRANSFORMATION
 20   RET = 3
      IF (IOP.GT.1.AND.IOP.NE.5)  RET = 2
      GO TO 221

C  LOOP OVER PRD FACTORS
 21   I = I + 1
      IF (I.GT.K) GO TO 45
 22   NN = MDAT(MM,I)
      KIND = CINFF(4,NN)
      IF (KIND.NE.'PRD') GO TO 222
      N2 = NN
      K2 = 0
      RET = 4
      KN = INFF(4,N2)
 321  K2 = K2 + 1
      NN = MDAT(N2,K2)
      KIND = CINFF(4,NN)
 322  IF (K2.EQ.KN) RET = 1
      IF (KIND.NE.'PRD') GO TO 222
      N3 = NN
      K3 = 0
      RET = 5
      KN3 = INFF(4,N3)
 421  K3 = K3 + 1
      NN = MDAT(N3,K3)
      KIND = CINFF(4,NN)
      IF (K3.EQ.KN3) RET = 4
      IF (K2.EQ.KN.AND.K3.EQ.KN3) RET = 1
      IF (KIND.NE.'PRD') GO TO 222
      WRITE (OUT3,1000)
 1000 FORMAT (' PRD INSTRUCTIONS NESTED MORE THAN THREE DEEP - ERROR')
      ERROR = .TRUE.
      STOP
 222  IF (KIND.NE.'MAP') GO TO 40

C                  PICK UP SUBROUTINE NAME
 221  OPNAME = CINFF(1,NN)
      IF (OPNAME.NE.'SXTP') GO TO 223
      NUM = 11
      GO TO 9
 223  IF (OPNAME.EQ.'MOVE')  GO TO 27
      IF (OPNAME.NE.'NPOL')  GO TO 25
      NUM=12
      GO TO 9
C                  STRIP OFF MAP SUBROUTINE NUMBER
 25   READ (OPNAME,100) NUM
 100  FORMAT (3X,I1)
      IF (NUM.EQ.0) NUM = + 0
      NUM = NUM + 1

C                  GET DATA OF MAP INSTRUCTION.  TRANSMIT IN ARGUMENT.
 9    NFL = INFF(15,NN)
      CALL GETFL(NN,1,NFL,PAR)
      IF (NUM.EQ.2) THEN
C        MAP1 --- WIGGLER MAGNET
         CALL DIFEQ(NN,P,DER1)
      ELSE IF (NUM.EQ.3) THEN
C        MAP2
         CALL DIFEQ(NN,P,DER2)
      ELSE IF (NUM.EQ.4) THEN
C        MAP3  INTEGRATE TRANSVERSE AND LONGITUDINAL ENVELOPES.
         CALL DIFEQ(NN,P,DER3)
      ELSE IF (NUM.EQ.5) THEN
C        MAP4 --- ENVELOPE INTEGRATION
         CALL DIFEQ(NN,P,DER4)
      ELSE IF (NUM.EQ.6) THEN
C        MAP5 --- SEXTUPOLE INTEGRATION
         CALL DIFEQ(NN,P,DER5)
      ELSE IF (NUM.EQ.7) THEN
         CALL DIFEQ (NN,P,DER6)
      ELSE IF (NUM.EQ.8) THEN
         CALL DIFEQ (NN,P,DER7)
      ELSE IF (NUM.EQ.9) THEN
         CALL MAP8(P,PAR)
      ELSE IF (NUM.EQ.10) THEN
         CALL MAP9(P,PAR)
      ELSE IF (NUM.EQ.11.OR.NUM.EQ.12) THEN
         GOTO 23
      ELSE
         CALL MAP (P,PAR)
      ENDIF
      IF (RET.EQ.1) GOTO 21
      IF (RET.EQ.2) GOTO 43
      IF (RET.EQ.3) GOTO 45
      IF (RET.EQ.4) GOTO 321
      IF (RET.EQ.5) GOTO 421

 43   CALL STOR7(MFXPT,P(1,2),RW)
      RETURN
C
 23   INFF(4,NF)=INFF(4,NN)
      INFF(5,NF)=INFF(5,NN)
      CALL SXTP(NF,P,PAR)
      GO TO 26
C
 27   CALL MOVE(NN,NF,P)
 26   IF (IOP.NE.1.AND.IOP.NE.5)  GO TO 42
      IF (RET.EQ.1) GOTO 21
      IF (RET.EQ.2) GOTO 43
      IF (RET.EQ.3) GOTO 45
      IF (RET.EQ.4) GOTO 321
      IF (RET.EQ.5) GOTO 421

C  CARRY OUT A LINEAR TRANSFORMATION
 40   IF (IOP.NE.1) GO TO 41
      CALL RTRV7(NN,T,RW)
      CALL MXV7(T,P,P)
      IF (RET.EQ.1) GOTO 21
      IF (RET.EQ.2) GOTO 43
      IF (RET.EQ.3) GOTO 45
      IF (RET.EQ.4) GOTO 321
      IF (RET.EQ.5) GOTO 421
 41   CALL REVMAT(NF,NN,P)
      IF (IOP.EQ.5)  GO TO 45
 42   MLTRKC(1) = MFXPT
      MLTRKC(2) = NF
      CALL MMM ( MFXPT, 2, MLTRKC )
      IF (IOP.NE.0)  CALL RTRV7(MFXPT,P(1,2),RW)
      IF (RET.EQ.1) GOTO 21
      IF (RET.EQ.2) GOTO 43
      IF (RET.EQ.3) GOTO 45
      IF (RET.EQ.4) GOTO 321
      IF (RET.EQ.5) GOTO 421
C
 35   CONTINUE
      CALL EDRF(NEL,P,NP)
      GO TO 45
 36   CONTINUE
      CALL DKE(NEL,P,NP)
      GO TO 45
 37   CALL SOL(NEL,P,NP)

 45   RETURN
      END
