      SUBROUTINE TRKE(M)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C ENVELOPE TRACKING ROUTINE 9-19-85
C REVISED 3/90

      include 'ccc/bstore.ccc'

      include 'ccc/binff.ccc'

      include 'ccc/bmi1.ccc'

      DIMENSION MI(MI1SIZ)
      EQUIVALENCE (MI,MI1),(NELS,NELS1)

      include 'ccc/contrl.ccc'

      include 'ccc/match3.ccc'

      include 'ccc/cderiv.ccc'

      include 'ccc/const.ccc'


      include 'ccc/files.ccc'


      DIMENSION BXI(9),BYI(9),V0(7),VI(7),VF(7),T(49)
      DIMENSION BX(6),BY(6),BX0(6),BY0(6),RX(2,3),RY(2,3),RW(3),
     1          BETF(14)      
      DIMENSION P(8), V(7), VSC(4)
      EQUIVALENCE(BX,BETF),(BY,BETF(7)), (S,BETF(13)),
     1           (TH,BETF(14))
      EQUIVALENCE (EPX,P(1)),(EPY,P(2)),(EPL,P(3)),(DPP,P(4)),
     1            (V,VF(7))

      EXTERNAL DER2,DER3,DER4,DELQ
      LOGICAL NOSTOR
      LOGICAL RADFLG
      CHARACTER(5) CHDAT,ELNAMI,NAMVEC,NAMBET,NAME,NAMOP,ELNAME
      CHARACTER(5) MNAME

C  INSTRUCTION TRKE----TRACK BEAM ENVELOPES

C  T  TRKE  IR1 IR2//BLIN BET0 V0   EPS    IT1  IT2  ITBL IADD EXCO     EYCO

C  RESERV  A TABLE FOR STORAGE OF BETA FUNCTIONS FROM POSITION IR1
C  THROUGH POSITION IR2 OF BET0.

C  TRACK BETA FUNCTIONS DEFINED BY [ BET0  IBET   //...]
C  THROUGH BEAM LINE DEFINED BY [ BLIN  BML   //...] FROM IT1 TO IT2,
C  CALCULATE AND DISPLAY BEAM ENVELOPES.
C  THE EMITTANCES ARE DEFINED BY [ EPS  BVAL   //...].
C
C  TRACK A PARTICLE VECTOR DEFINED BY [ V0  PVEC  //...]
C  THROUGH THE BEAMLINE.

C  BETA FUNCTION ARRAY IS STORED AT QLIB(LQ3), LQ3=INFF(24,M),
C  WHERE B(I,IPOS+1) = QX,BX,AX,GX,X,DX, QY,BY,AY,GY,Y,DY, S,THETAX.

C    ITBL = 1 --- INPUT BETAS FROM TRKB TABLE, AT IT1, EXCEPT
C                    ON 1ST CALL, AND/OR IF IT1=0, FROM IBET INPUT.
C    BET0 = /NAME/ --INITIAL BETAS FROM ARRAY/NAME/,FOR AN IBET,
C                     AND FROM BETA-FUNCTIONS OF /NAME/, IF A MATRIX.
C    IADD = 0 --- ADD XB AND XP IN QUADRATURE, ETC.
C    IADD = 1 --- ADD XB AND XP ALGEBRAICALLY, ETC.

C  DEFAULTS ---

C    IF KA = KB = 0 (OR BLANK), A TABLE IS RESERVED SUFFICIENT TO STORE
C                               THE COMPLETE BEAM LINE.
C    IF KA = -1                 NO TABLE IS RESERVED, NO BETAS ARE STORED.

C    IF KT1 = IT2 = 0 (OR BLANK), TRACKING IS DONE THROUGH COMPLETE BEAM-LINE.


      RADFLG = .FALSE.
      IF (MINFLG.NE.4)  GO TO 23
      IF (MIFLG)  GO TO 152
      GO TO 4
 23   NOSTOR = .FALSE.
      ELNAMI=IBLNK
      KB=INFF(5,M)
      KA=INFF(4,M)
      LQ3 = INFF(24,M)
      NCOL = IDAT(M,5)
      IF (KA.GT.-1) GO TO 151
      NOSTOR = .TRUE.
      GO TO 152
 151  LTAB0 = LQ3 - NCOL*KA - 1
 152  MBML = MDAT(M,1)

      NDAT=INFF(17,MBML)
      CALL MIFILL(MBML,1,NDAT,NELS,MI,MI1SIZ)
      CALL MMM(M,NELS,MI)
      IF (MINFLG.EQ.4) GO TO 4
      IP1=IDAT(M,1)
      IP2=IDAT(M,2)
      ICALL=IDAT(M,6)
      IADD = IDAT(M,4)
      SI = 0
      TI = 0
      IG = 1
      IF(IADD.EQ.0) IG = 2
      DNOM = TPI
      CCON = 1

C  GET VECTOR
      NAMVEC = CHDAT(M,3)
      VECFLG = .FALSE.
      IF(NAMVEC.EQ.IBLNK) GO TO 160
      VECFLG = .TRUE.
      MVEC = MDAT(M,3)
      CALL GETFL(MVEC,1,7,VI)
 160  CONTINUE

      MBVAL = MDAT(M,4)
      CALL GETQ(MBVAL,1,4,P)
      NAMBET=CHDAT(M,2)
      NAME=CINFF(2,M)

      ITABLE = IDAT(M,3)
      IF(ITABLE.EQ.1.AND..NOT.NOSTOR) GO TO 10
      GO TO 12

C 10   IF ((ICALL.EQ.0).OR.(IP1.EQ.0) ) GO TO 12
 10   CONTINUE
C  INITIAL BETAS FROM BETA FUNCTION TABLE OF TRKB INSTRUCTION,
C  EXCEPT THAT FOR FIRST CALL, OR IF IP1=0, THEY ARE TAKEN FROM IBET OR MTR.
      LOCBET=NCOL*(IP1-KA)+1
      MBET=M
      NTYP=8
      CALL GETQQ(MBET,NTYP,LOCBET+12,1,SI)
      CALL GETQQ(MBET,NTYP,LOCBET+13,1,TI)
      IF(VECFLG) CALL GETQQ(MBET,NTYP,LOCBET+14,7,VI)
      GO TO 13

C  INITIAL BETAS FROM ARRAY SPECIFIED BY NAMBET
 12   LOCBET=1
      NTYP=1
      MBET=MDAT(M,2)

      NAMOP=CINFF(1,MBET)

      IF(NAMOP.EQ.'IBET') GO TO 13
C  INITIAL BETAS ARE BETAS OF MATRICES MBET.
      CALL BET(MBET,BXI,BYI,1)
      BXI(1)=0
      BYI(1)=0

      GO TO 16

 13   CALL GETQQ(MBET,NTYP,LOCBET  ,6,BXI)
      CALL GETQQ(MBET,NTYP,LOCBET+6,6,BYI)

 16   CONTINUE


C  GET EMITTANCES
      EPXCO = FLDAT(M,1)
      EPYCO = FLDAT(M,2)
      RATX = SQRT(EPXCO/EPX)
      RATY = SQRT(EPYCO/EPY)

 26   IF (IP1.EQ.0)  GO TO 9
      NELI = MI(IP1)
      ELNAMI=MNAME(NELI)
 9    IF(IP1.LT.KA) NOSTOR=.TRUE.
      IF(IP2.GT.KB) NOSTOR=.TRUE.
      ICALL=1
      CALL STOIN(M,3,3,1,ICALL)


 4    CONTINUE

      S = SI
      TH = TI

      DO 3 I=1,6
      BX(I) = BXI(I)
      BY(I) = BYI(I)
      V(I) = VI(I)
 3    CONTINUE
      V(7) = VI(7)

      I1 = IP1 + 1
      I2 = IP2
      IF (NOPR) GO TO 7
      LNUM = 0
      IF (I2.GT.40) WRITE (OUT3,4004)
      CALL DASH1
      WRITE(OUT3,4001) P(1),EPXCO,P(3),P(2),EPYCO,P(4)
      IF (IG.EQ.2) GOTO 405
 404  WRITE (OUT3,4006)
      GO TO 406
 405  WRITE (OUT3,4008)
      IF(.NOT.VECFLG) GO TO 406
      WRITE (OUT3,4011)
      GO TO 407
 406  WRITE(OUT3,4010)
 407  CONTINUE

      ELNAME=ELNAMI
 7    CONTINUE

      IF (BX(4).EQ.0) BX(4)=(1+BX(3)*BX(3))/BX(2)
      IF (BY(4).EQ.0)  BY(4)=(1+BY(3)*BY(3))/BY(2)

C                  COMPUTE AND PRINT BEAM ENVELOPES
      X=SQRT(EPX*BX(2))
      Y=SQRT(EPY*BY(2))
      XP=BX(5)*DPP
      YP=BY(5)*DPP
      XCO=RATX*X
      YCO=RATY*Y
      XPR=SQRT(EPX*BX(4))
      YPR=SQRT(EPY*BY(4))
      XPPR=BX(6)*DPP
      YPPR=BY(6)*DPP
      XCOPR=RATX*XPR
      YCOPR=RATY*YPR
      IF (IG.EQ.2) GOTO 4117
 4116 XTOT = X + ABS(XP)
      XPRTOT = XPR + ABS(XPPR)
      YTOT = Y + ABS(YP)
      YPRTOT = YPR + ABS(YPPR)
      GO TO 4118
 4117 CONTINUE
      XTOT = SQRT( X * X + XP * XP )
      XPRTOT = SQRT( XPR*XPR + XPPR*XPPR)
      YTOT = SQRT(Y*Y + YP*YP)
      YPRTOT = SQRT(YPR*YPR + YPPR*YPPR)
 4118 CONTINUE
      XTOT=XTOT+XCO
      YTOT=YTOT+YCO
      XPRTOT=XPRTOT+XCOPR
      YPRTOT=YPRTOT+YCOPR

C   LOOP OVER POSITIONS
 19   DO 1 IBS = I1,I2
      IPOS = IBS - 1
      IF(NOPR) GO TO 6
      IF(.NOT.VECFLG) GO TO 190
      IF (MOD(LNUM,40).NE.0.OR.LNUM.EQ.0)  GO TO 191
      WRITE (OUT3,4004)
      WRITE (OUT3,4011)
      LNUM = 0
 191  IF (MOD(LNUM,40).NE.0.OR.LNUM.NE.0) WRITE (OUT3,4040)
      DO 193 I = 1,4
 193  VSC(I) = 1000*V(I)
      WRITE(OUT3,4012) IPOS,ELNAME,S,X,XP,XCO,XTOT,Y,YP,YCO,YTOT,
     1              XPRTOT,YPRTOT,(VSC(I),I=1,4)
      LNUM = LNUM + 1
      GO TO 6
 190  IF (MOD(LNUM,40).NE.0.OR.LNUM.EQ.0)  GO TO 192
      WRITE (OUT3,4004)
      WRITE (OUT3,4010)
      LNUM = 0
 192  IF (MOD(LNUM,5).EQ.0.AND.LNUM.NE.0)  WRITE (OUT3,4040)
      WRITE(OUT3,4012) IPOS,ELNAME,S,X,XP,XCO,XTOT,Y,YP,YCO,YTOT,
     1              XPR,XPPR,XPRTOT,YPR,YPPR,YPRTOT
      LNUM = LNUM + 1
 6    NEL = MI(IBS)
      IF(NOSTOR) GO TO 8
      J=LTAB0+NCOL*IPOS
      DO 11 I=1,14
 11   QLIB(J+I)=BETF(I)
      IF(.NOT.VECFLG) GO TO 8
      DO 110 I=15,21
 110  QLIB(J+I) = VF(I)
 8    CONTINUE

      ELNAME=MNAME(NEL)
      STOT = S

 18   CALL RXY(NEL,RX,RY,RW)

      IF(.NOT.VECFLG) GO TO 180
      DO 181 I=1,6
      BX0(I)=BX(I)
      BY0(I)=BY(I)
 181  V0(I) = V(I)
      V0(7) = V(7)
      GO TO 182

 180  DO 2 I=1,6
      BX0(I)=BX(I)
 2    BY0(I)=BY(I)

 182  S = S + RW(1)
      TH = TH + RW(2)

      BX(2)=RX(1,1)*RX(1,1)*BX0(2)-2*RX(1,1)*RX(1,2)*BX0(3)
     1        + RX(1,2)*RX(1,2)*BX0(4)

      BY(2)=RY(1,1)*RY(1,1)*BY0(2)-2*RY(1,1)*RY(1,2)*BY0(3)
     1        + RY(1,2)*RY(1,2)*BY0(4)

      BX(3) = -RX(1,1)*RX(2,1)*BX0(2)
     1        + (RX(1,1)*RX(2,2)+RX(1,2)*RX(2,1))*BX0(3)
     2        - RX(1,2)*RX(2,2)*BX0(4)

      BY(3) = -RY(1,1)*RY(2,1)*BY0(2)
     1        + (RY(1,1)*RY(2,2)+RY(1,2)*RY(2,1))*BY0(3)
     2        - RY(1,2)*RY(2,2)*BY0(4)

      BX(4) = RX(2,1)*RX(2,1)*BX0(2) - 2*RX(2,1)*RX(2,2)*BX0(3)
     1          + RX(2,2)*RX(2,2)*BX0(4)

      BY(4) = RY(2,1)*RY(2,1)*BY0(2) - 2*RY(2,1)*RY(2,2)*BY0(3)
     1          + RY(2,2)*RY(2,2)*BY0(4)

      BX(5) = RX(1,1)*BX0(5) + RX(1,2)*BX0(6) + RX(1,3)

      BY(5) = RY(1,1)*BY0(5) + RY(1,2)*BY0(6) + RY(1,3)

      BX(6) = RX(2,1)*BX0(5) + RX(2,2)*BX0(6) + RX(2,3)

      BY(6) = RY(2,1)*BY0(5) + RY(2,2)*BY0(6) + RY(2,3)

      IF(NONU) GO TO 183

      BETAV=SQRT(BX(2)*BX0(2))
      BERAT=SQRT(BX0(2)/BX(2))
      SINE=RX(1,2)/BETAV
      COSINE=RX(1,1)*BERAT-BX0(3)*SINE
C   DNOM OR CCON SET TO TPI OR 1. DEPENDING ON DEGREES OR RADIANS.
      DNU = ATAN2(SINE,COSINE)/DNOM
      IF (DNU.LT.0)  DNU = DNU + CCON
      BX(1) = BX0(1) + DNU
      BETAV=SQRT(BY(2)*BY0(2))
      BERAT=SQRT(BY0(2)/BY(2))
      SINE=RY(1,2)/BETAV
      COSINE=RY(1,1)*BERAT-BY0(3)*SINE
      DNU = ATAN2(SINE,COSINE)/DNOM
      IF (DNU.LT.0)  DNU = DNU + CCON
      BY(1) = BY0(1) + DNU

 183  CONTINUE

      IF(.NOT.VECFLG) GO TO 184
      CALL RTRV7(NEL,T,RW)
      CALL MXV7(T,V0,V)

 184  CONTINUE

C                  COMPUTE AND PRINT BEAM ENVELOPES
      X=SQRT(EPX*BX(2))
      Y=SQRT(EPY*BY(2))
      XP=BX(5)*DPP
      YP=BY(5)*DPP
      XCO=RATX*X
      YCO=RATY*Y
      XPR=SQRT(EPX*BX(4))
      YPR=SQRT(EPY*BY(4))
      XPPR=BX(6)*DPP
      YPPR=BY(6)*DPP
      XCOPR=RATX*XPR
      YCOPR=RATY*YPR
      IF (IG.EQ.2) GOTO 5117
 5116 XTOT = X + ABS(XP)
      XPRTOT = XPR + ABS(XPPR)
      YTOT = Y + ABS(YP)
      YPRTOT = YPR + ABS(YPPR)
      GO TO 5118
 5117 CONTINUE
      XTOT = SQRT( X * X + XP * XP )
      XPRTOT = SQRT( XPR*XPR + XPPR*XPPR)
      YTOT = SQRT(Y*Y + YP*YP)
      YPRTOT = SQRT(YPR*YPR + YPPR*YPPR)
 5118 CONTINUE
      XTOT=XTOT+XCO
      YTOT=YTOT+YCO
      XPRTOT=XPRTOT+XCOPR
      YPRTOT=YPRTOT+YCOPR


 1    CONTINUE

 17   IPOS = I2
      MP2FLG = 0
      IF(NOSTOR) GO TO 5

      J = J + NCOL
      DO 14 I=1,14
 14   QLIB(J+I)=BETF(I)
      IF(.NOT.VECFLG) GO TO 5
      DO 140 I=15,21
 140  QLIB(J+I) = VF(I)

 5    CONTINUE

      IF(NOPR) RETURN

      IF(.NOT.VECFLG) GO TO 150

      DO 155 I = 1,4
 155  VSC(I) = 1000*V(I)
      WRITE(OUT3,4012) IPOS,ELNAME,S,X,XP,XCO,XTOT,Y,YP,YCO,YTOT,
     1              XPRTOT,YPRTOT,(VSC(I),I=1,4)
C      WRITE(OUT3,4012) IPOS,ELNAME,S,X,XP,XCO,XTOT,Y,YP,YCO,YTOT,
C     1              XPRTOT,YPRTOT,(V(I),I=1,4)
      GO TO 153
 150  WRITE(OUT3,4012) IPOS,ELNAME,S,X,XP,XCO,XTOT,Y,YP,YCO,YTOT,
     1              XPR,XPPR,XPRTOT,YPR,YPPR,YPRTOT
 153  CALL DASH1

      RETURN

 4001   FORMAT (3X,'BEAM ENVELOPES (MM,MRAD)'/
     1  5X,'EMITTANCES (MM-MRAD) --- EPSX = ',F10.6,5X,'EPSXCO = ',
     2  F10.6,5X,'EPSL = ',F13.6/30X,'EPSY = ',F10.6,5X,'EPSYCO = ',
     3  F10.6,5X,'SIGP = ',F10.6,' (0/00)')

 4002 FORMAT('+',99X,'DISPLACEMENT = ',F5.2,'*','SIGMA')
 4006 FORMAT (5X,'SIGX = XB + XP + XCO,   ETC.'/)
 4008 FORMAT (5X,'SIGX = SQRT(XB*XB + XP*XP) + XCO,   ETC.'/)

 4010 FORMAT('  POS',12X,'S',6X,'XB',6X,'XP',5X,'XCO',4X,'SIGX',3X,
     1         'YB',6X,'YP',5X,'YCO',4X,'SIGY',4X,
     2         'DXB',5X,'DXP',5X,'DSIGX',3X,'DYB',5X,'DYP',5X,'DSIGY')

 4011 FORMAT('  POS',12X,'S',6X,'XB',6X,'XP',5X,'XCO',4X,'SIGX',3X,
     1         'YB',6X,'YP',5X,'YCO',4X,'SIGY',4X,'DSIGX',3X,'DSIGY',
     2         3X,'XCEN',4X,'DXCEN',3X,'YCEN',4X,'DYCEN')

 4012 FORMAT(1X,I5,1X,A5,F10.4,2(F7.3,F8.3,2F7.3),6F8.3)
 4004  FORMAT ('1')
 4040 FORMAT (/ )
      END
