      SUBROUTINE TRKM(M)
C MAP-TYPE ELEMENT TRACKING ROUTINE 9-19-85

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'ccc/bstore.ccc'

      include 'ccc/binff.ccc'

      include 'ccc/bmi1.ccc'

      DIMENSION MI(MI1SIZ)
      EQUIVALENCE (MI,MI1),(NELS,NELS1)

      include 'ccc/contrl.ccc'

      include 'ccc/match3.ccc'

      include 'ccc/cderiv.ccc'

      include 'ccc/const.ccc'


      include 'ccc/files.ccc'


      DIMENSION BXI(9),BYI(9),VF(7)
      DIMENSION BX(6),BY(6),BETF(14)
      DIMENSION P(8), V(7)
      EQUIVALENCE(BX,BETF),(BY,BETF(7)), (S,BETF(13)),(TH,BETF(14))
      EQUIVALENCE (V,VF(7))

      EXTERNAL DER2,DER3,DER4,DELQ
      LOGICAL NOSTOR
      LOGICAL RADFLG
      CHARACTER(5) CHDAT,ELNAMI,NAMVEC,NAMBET,NAME,NAMOP,ELNAME
      CHARACTER(5) MNAME,MAPK,MAPK2,NAMPAR
      CHARACTER(256) FFORM,F1000,F1006
      DATA F1000/'(3X,''POS'',12X,''S'',7X,''QX'',10X,''BX'',8X,
     $''AX'',8X,''X'',9X,''DX'',14X,''QY'',10X,''BY'',8X,''AY'',8X,
     $''Y'',9X,''DY'')'/
      DATA F1006/'(''   POS'',13X,''S'',20X,''RX'',7X,''DRX'',20X,
     $''RY'',7X,''DRY'')'/
C  INSTRUCTION TRKM----TRACK THROUGH ELEMENTS DEFINED BY MAP STATEMENTS

C  T  TRKM  IR1 IR2//BLIN BET0 MAPK PAR     IT1  IT2  ITBL IRAD HSTEP

C  RESERV  A TABLE FOR STORAGE OF BETA FUNCTIONS FROM POSITION IR1
C  THROUGH POSITION IR2 OF BET0.

C  TRACK BETA FUNCTIONS DEFINED BY [ BET0  IBET   //...]
C  THROUGH BEAM LINE DEFINED BY [ BLIN  BML   //...] FROM IT1 TO IT2.
C
C  TRACK A PARTICLE VECTOR DEFINED BY [ V0  PVEC  //...]
C  THROUGH THE BEAMLINE.

C  BETA FUNCTION ARRAY IS STORED AT STORE(LQ3), LQ3=INFF(24,M),
C  WHERE B(I,IPOS+1) = QX,BX,AX,GX,X,DX, QY,BY,AY,GY,Y,DY, S,THETAX.

C    ITBL = 1 --- INPUT BETAS FROM TRKB TABLE, AT IT1, EXCEPT
C                    ON 1ST CALL, AND/OR IF IT1=0, FROM IBET INPUT.
C    BET0 = /NAME/ --INITIAL BETAS FROM ARRAY/NAME/,FOR AN IBET,
C                     AND FROM BETA-FUNCTIONS OF /NAME/, IF A MATRIX.
C    IRAD = 1 --- OUTPUT PHASE ADVANCES IN RADIANS
C         = 0 ---                       IN UNITS OF 2PI

C  DEFAULTS ---

C    IF KA = KB = 0 (OR BLANK), A TABLE IS RESERVED SUFFICIENT TO STORE
C                               THE COMPLETE BEAM LINE.
C    IF KA = -1                 NO TABLE IS RESERVED, NO BETAS ARE STORED.

C    IF KT1 = IT2 = 0 (OR BLANK), TRACKING IS DONE THROUGH COMPLETE BEAM-LINE.


      FFORM = F1000
      RADFLG = .FALSE.
      IF (MINFLG.NE.4)  GO TO 23
      IF (MIFLG)  GO TO 152
      GO TO 4
 23   NOSTOR = .FALSE.
      ELNAMI=IBLNK
      KB=INFF(5,M)
      KA=INFF(4,M)
      LQ3 = INFF(24,M)
      NCOL = IDAT(M,5)
      IF (KA.GT.-1) GO TO 151
      NOSTOR = .TRUE.
      GO TO 152
 151  LTAB0 = LQ3 - NCOL*KA - 1
 152  MBML = MDAT(M,1)

      NDAT=INFF(17,MBML)
      CALL MIFILL(MBML,1,NDAT,NELS,MI,MI1SIZ)
      CALL MMM(M,NELS,MI)
      IF (MINFLG.EQ.4) GO TO 4
      IP1=IDAT(M,1)
      IP2=IDAT(M,2)
      ICALL=IDAT(M,6)
      SI = FLDAT(M,2)
      TI = 0
      H0 = FLDAT(M,1)
      DAT2(7) = H0
      MAPK = CHDAT(M,3)
      IRAD = IDAT(M,4)
C   SET UP CONSTANTS FOR CALCULATING PSI IN DEGREES OR RADIANS
      IF (IRAD.EQ.1)  RADFLG=.TRUE.
      DNOM = TPI
      CCON = 1
      IF (.NOT.RADFLG)   GO TO 153
      DNOM = 1
      CCON = TPI
 153  CONTINUE

      NAMBET=CHDAT(M,2)
      NAMVEC = CHDAT(M,3)
      NAMPAR = CHDAT(M,4)
      NAME=CINFF(2,M)

      ITABLE = IDAT(M,3)
      IF(ITABLE.EQ.1.AND..NOT.NOSTOR) GO TO 10
      GO TO 12

C 10   IF ((ICALL.EQ.0).OR.(IP1.EQ.0) ) GO TO 12
 10   CONTINUE
C  INITIAL BETAS FROM BETA FUNCTION TABLE OF TRKB INSTRUCTION,
C  EXCEPT THAT FOR FIRST CALL, OR IF IP1=0, THEY ARE TAKEN FROM IBET OR MTR.
      LOCBET=NCOL*(IP1-KA)+1
      MBET=M
      NTYP=8
      CALL GETQQ(MBET,NTYP,LOCBET+12,1,SI)
      CALL GETQQ(MBET,NTYP,LOCBET+13,1,TI)
      GO TO 13

C  INITIAL BETAS FROM ARRAY SPECIFIED BY NAMBET
 12   LOCBET=1
      NTYP=1
      MBET=MDAT(M,2)

      NAMOP=CINFF(1,MBET)

      IF(NAMOP.EQ.'IBET') GO TO 13
C  INITIAL BETAS ARE BETAS OF MATRICES MBET.
      CALL BET(MBET,BXI,BYI,1)
      BXI(1)=0
      BYI(1)=0

      GO TO 16

 13   CALL GETQQ(MBET,NTYP,LOCBET  ,6,BXI)
      CALL GETQQ(MBET,NTYP,LOCBET+6,6,BYI)

 16   CONTINUE

      IF (MAPK.EQ.'MAP2') MP2FLG=1
      IF (MAPK.EQ.'MAP4') FFORM = F1006

      IF (MAPK.NE.'ELQ') GO TO 34
      NUM = 7
      GO TO 35
 34   READ (MAPK,1002) NUM
 1002 FORMAT (3X,I1)
 35   IF (NAMPAR.EQ.IBLNK) GO TO 26
      MPAR = MDAT(M,4)
      CALL GETFL(MPAR,1,6,DAT2)

 26   IF (IP1.EQ.0)  GO TO 9
      NELI = MI(IP1)
      ELNAMI=MNAME(NELI)
 9    IF(IP1.LT.KA) NOSTOR=.TRUE.
      IF(IP2.GT.KB) NOSTOR=.TRUE.
      ICALL=1
      CALL STOIN(M,3,1,ICALL)

 4    CONTINUE
      S = SI
      TH = TI

      DO 3 I=1,6
      BX(I) = BXI(I)
      BY(I) = BYI(I)
 3    CONTINUE
      I1 = IP1 + 1
      I2 = IP2

      IF (NOPR) GO TO 7
      IF (I2.GT.45)  WRITE (OUT3,1004)
      LNUM = 0
      CALL DASH1
 406  WRITE(OUT3,FFORM)

      ELNAME=ELNAMI
 7    CONTINUE

C  ALL ELEMENTS ARE DEFINED BY MAPS
 21   NR = 1
      IFLAG = 1
      NV(1) = 1
      S = 0
      TH = 0
      IF (NUM.EQ.3) GO TO 28
      IF (NUM.GT.3) GO TO 29

C  MAP2
 27   MR = 8
      GO TO 19

C  MAP3 -- TRANSVERSE AND LONGITUDINAL ENVELOPES
 28   MR = 6
      GO TO 19

C  MAP4 -- TRANSVERSE ENVELOPES
 29   MR = 4
      FFORM = F1006

C   LOOP OVER POSITIONS
 19   DO 1 IBS = I1,I2
      IPOS = IBS - 1
      IF(NOPR) GO TO 6

 190  IF (MOD(LNUM,45).NE.0.OR.LNUM.EQ.0)  GO TO 191
      WRITE (OUT3,1004)
      WRITE (OUT3,FFORM)
      LNUM = 0
 191  IF (MOD(LNUM,5).EQ.0.AND.LNUM.NE.0)  WRITE (OUT3,1003)
      IF (NUM.EQ.4) GO TO 192
      WRITE(OUT3,1001) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1              (BY(I),I=1,3),BY(5),BY(6)
      GO TO 193
 192  WRITE (3,1005) IPOS,ELNAME,S,BX(2),BX(3),BY(2),BY(3)

 193  LNUM = LNUM + 1
 6    NEL = MI(IBS)
      IF(NOSTOR) GO TO 8
      J=LTAB0+NCOL*IPOS
      DO 11 I=1,14
 11   QLIB(J+I)=BETF(I)
 8    CONTINUE

      ELNAME=MNAME(NEL)
      STOT = S

      MAPK2=CINFF(1,NEL)
      IF (MAPK2.EQ.MAPK) GO TO 20
      MAPK=MAPK2
      IF (MAPK.EQ.'ELQ') GO TO 22
      NUM=4
      GO TO 32
  22  NUM=7
      GO TO 36
  20  IF (NUM.EQ.7)  GO TO 36
      IF (NUM.EQ.3) GO TO 31
      IF (NUM.GT.3) GO TO 32

C   MAP2
 30   P(1) = BX(2)
      P(2) = BX(3)
      P(3) = BX(5)
      P(4) = BX(6)
      P(5) = BY(2)
      P(6) = BY(3)
      P(7) = BY(5)
      P(8) = BY(6)
      CALL DIFEQ(NEL,P,DER2)
      BX(2) = P(1)
      BX(3) = P(2)
      BX(5) = P(3)
      BX(6) = P(4)
      BY(2) = P(5)
      BY(3) = P(6)
      BY(5) = P(7)
      BY(6) = P(8)
      GO TO 33

C   MAP3
 31   P(1) = BX(2)
      P(2) = BX(3)
      P(3) = BY(2)
      P(4) = BY(3)
      P(5) = BX(5)
      P(6) = BX(6)
      P(7) = 0
      CALL DIFEQ(NEL,P,DER3)
      BX(2) = P(1)
      BX(3) = P(2)
      BY(2) = P(3)
      BY(3) = P(4)
      BX(5) = P(5)
      BX(6) = P(6)
      GO TO 33

C   ELQ
 36   P(1) = BX(2)
      P(2) = BX(3)
      P(3) = BY(2)
      P(4) = BY(3)
      CALL DIFEQ(NEL,P,DELQ)
      GO TO 37

C  MAP4
 32   P(1) = BX(2)
      P(2) = BX(3)
      P(3) = BY(2)
      P(4) = BY(3)
      P(5) = 0
      P(6) = 0
      CALL DIFEQ(NEL,P,DER4)
 37   BX(2) = P(1)
      BX(3) = P(2)
      BY(2) = P(3)
      BY(3) = P(4)
 33   S = S + DAT(1)

 1    CONTINUE

 17   IPOS = I2
      MP2FLG = 0
      IF(NOSTOR) GO TO 5

      J = J + NCOL
      DO 14 I=1,14
 14   QLIB(J+I)=BETF(I)

 5    CONTINUE

      IF(NOPR) RETURN

 150  IF (NUM.EQ.4) GO TO 194
      WRITE(OUT3,1001) IPOS,ELNAME,S,(BX(I),I=1,3),BX(5),BX(6),
     1              (BY(I),I=1,3),BY(5),BY(6)
      GO TO 154
 194  WRITE (3,1005) IPOS,ELNAME,S,BX(2),BX(3),BY(2),BY(3)
 154  CALL DASH1

      RETURN

 1001 FORMAT (1X,I5,1X,A5,1X,F10.4,2(F10.6,F11.4,F11.6,F10.6,
     1        F10.6,5X))
 1003 FORMAT (/)
 1004 FORMAT ('1')
 1005 FORMAT (1X,I5,2X,A5,1X,F10.4,2(10X,F11.4,F11.6))
      END
